diff -pruN 134+dfsg-1/.github/workflows/python-app_windows.yml 137+dfsg-1/.github/workflows/python-app_windows.yml
--- 134+dfsg-1/.github/workflows/python-app_windows.yml	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/.github/workflows/python-app_windows.yml	2024-04-19 19:04:23.000000000 +0000
@@ -35,9 +35,9 @@ jobs:
             path: ~\AppData\Local\pip\Cache
 
     steps:
-      - uses: actions/checkout@v3
+      - uses: actions/checkout@v4
       - name: Set up Python ${{ matrix.python-version }}
-        uses: actions/setup-python@v4
+        uses: actions/setup-python@v5
         with:
           python-version: ${{ matrix.python-version }}
           architecture: x64
diff -pruN 134+dfsg-1/.github/workflows/python-dist.yml 137+dfsg-1/.github/workflows/python-dist.yml
--- 134+dfsg-1/.github/workflows/python-dist.yml	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/.github/workflows/python-dist.yml	2024-04-19 19:04:23.000000000 +0000
@@ -7,9 +7,9 @@ jobs:
   build:
     runs-on: ubuntu-latest
     steps:
-      - uses: actions/checkout@v3
+      - uses: actions/checkout@v4
 
-      - uses: actions/setup-python@v3
+      - uses: actions/setup-python@v5
         with:
           python-version: 3.11
 
@@ -21,7 +21,7 @@ jobs:
           pip install --upgrade build
           python -m build
 
-      - uses: actions/upload-artifact@v3
+      - uses: actions/upload-artifact@v4
         with:
           path: ./dist
 
@@ -35,7 +35,7 @@ jobs:
       # IMPORTANT: this permission is mandatory for trusted publishing
       id-token: write
     steps:
-      - uses: actions/download-artifact@v3
+      - uses: actions/download-artifact@v4
 
       - name: Publish package distributions to PyPI
         uses: pypa/gh-action-pypi-publish@release/v1
diff -pruN 134+dfsg-1/.gitignore 137+dfsg-1/.gitignore
--- 134+dfsg-1/.gitignore	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/.gitignore	2024-04-19 19:04:23.000000000 +0000
@@ -217,3 +217,5 @@ olex2
 x64
 test-data/1000007-multi-multitable.docx
 test-data/report_1000007-multi-finalcif.docx
+test.html
+
diff -pruN 134+dfsg-1/Hydrogen_solution_type.cif 137+dfsg-1/Hydrogen_solution_type.cif
--- 134+dfsg-1/Hydrogen_solution_type.cif	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/Hydrogen_solution_type.cif	2024-04-19 19:04:23.000000000 +0000
@@ -0,0 +1,14 @@
+data_Hydrogen__solution__type
+loop_
+_atom_sites_solution_hydrogens
+direct
+vecmap
+heavy
+difmap
+geom
+disper
+isomor
+notdet
+dual
+iterative
+other
diff -pruN 134+dfsg-1/debian/changelog 137+dfsg-1/debian/changelog
--- 134+dfsg-1/debian/changelog	2024-02-22 15:16:08.000000000 +0000
+++ 137+dfsg-1/debian/changelog	2024-05-21 06:11:39.000000000 +0000
@@ -1,3 +1,9 @@
+finalcif (137+dfsg-1) unstable; urgency=medium
+
+  * New upstream version 137+dfsg
+
+ -- Andrius Merkys <merkys@debian.org>  Tue, 21 May 2024 02:11:39 -0400
+
 finalcif (134+dfsg-1) unstable; urgency=medium
 
   * New upstream version 134+dfsg
diff -pruN 134+dfsg-1/debian/control 137+dfsg-1/debian/control
--- 134+dfsg-1/debian/control	2024-02-22 15:08:37.000000000 +0000
+++ 137+dfsg-1/debian/control	2024-05-21 06:02:57.000000000 +0000
@@ -7,6 +7,7 @@ Uploaders:
 Build-Depends:
  debhelper-compat (= 13),
  dh-python,
+ libjs-bootstrap5 <!nocheck>,
  pybuild-plugin-pyproject,
  python3,
  python3-crossrefapi <!nocheck>,
@@ -33,6 +34,7 @@ Rules-Requires-Root: no
 Package: finalcif
 Architecture: all
 Depends:
+ libjs-bootstrap5,
  python3-crossrefapi,
  python3-docx,
  python3-docxtpl,
diff -pruN 134+dfsg-1/debian/copyright 137+dfsg-1/debian/copyright
--- 134+dfsg-1/debian/copyright	2024-02-22 15:14:58.000000000 +0000
+++ 137+dfsg-1/debian/copyright	2024-05-21 05:50:02.000000000 +0000
@@ -3,6 +3,7 @@ Upstream-Name: FinalCif
 Upstream-Contact: https://github.com/dkratzert/FinalCif/issues
 Source: https://github.com/dkratzert/FinalCif
 Files-Excluded:
+ finalcif/template/bootstrap
  test-data/1923_Aminoff*.cif
  *.exe
 
diff -pruN 134+dfsg-1/debian/patches/series 137+dfsg-1/debian/patches/series
--- 134+dfsg-1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/debian/patches/series	2024-05-21 06:01:29.000000000 +0000
@@ -0,0 +1 @@
+system-bootstrap.patch
diff -pruN 134+dfsg-1/debian/patches/system-bootstrap.patch 137+dfsg-1/debian/patches/system-bootstrap.patch
--- 134+dfsg-1/debian/patches/system-bootstrap.patch	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/debian/patches/system-bootstrap.patch	2024-05-21 06:11:07.000000000 +0000
@@ -0,0 +1,14 @@
+Description: Use system-provided bootstrap, as the embedded file is excluded.
+Author: Andrius Merkys <merkys@debian.org>
+Forwarded: not-needed
+--- a/finalcif/report/templated_report.py
++++ b/finalcif/report/templated_report.py
+@@ -844,7 +844,7 @@
+                    'hydrogen_bonds'         : self.text_formatter.get_hydrogen_bonds(),
+                    'hydrogen_symminfo'      : self.text_formatter.get_hydrogen_symminfo(),
+                    'literature'             : self.text_formatter.literature,
+-                   'bootstrap_css'          : Path('finalcif/template/bootstrap/bootstrap.min.css').read_text(
++                   'bootstrap_css'          : Path('/usr/share/javascript/bootstrap5/css/bootstrap.min.css').read_text(
+                        encoding='utf-8'),
+                    }
+         return context
diff -pruN 134+dfsg-1/docs/changelog.txt 137+dfsg-1/docs/changelog.txt
--- 134+dfsg-1/docs/changelog.txt	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/docs/changelog.txt	2024-04-19 19:04:23.000000000 +0000
@@ -1,5 +1,9 @@
 FinalCif recent changes
 -----------------------
+* v137 Validators for manually inserted numerical values were added. HTML templates are now possible for reports.
+       Local CheckCif does not crash FinalCif anymore if the platon executable isn't found.
+* v136 Fix crash when adding authors to the CIF.
+* v135 Fix crash if templates are exported with no CIF loaded.
 * v134 No symmetry codes for atoms were displayed in the table with the bond angles. This has been fixed.
 * v133 Improved handling of wrong passwords in COD deposition page. Possible crash fixed.
 * v132 Startup speed improved a bit. Selection of main table rows improved.
diff -pruN 134+dfsg-1/finalcif/__init__.py 137+dfsg-1/finalcif/__init__.py
--- 134+dfsg-1/finalcif/__init__.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/__init__.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,2 +1,2 @@
 
-VERSION = 134
\ No newline at end of file
+VERSION = 137
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/app_path.py 137+dfsg-1/finalcif/app_path.py
--- 134+dfsg-1/finalcif/app_path.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/app_path.py	2024-04-19 19:04:23.000000000 +0000
@@ -15,6 +15,6 @@ if getattr(sys, 'frozen', False):
     # path into variable _MEIPASS'.
     # noinspection PyProtectedMember
     os.environ['PATH'] = sys._MEIPASS + os.pathsep + os.environ['PATH']
-    application_path = sys._MEIPASS
+    application_path = Path(sys._MEIPASS)
 else:
     application_path = Path(os.path.abspath(__file__)).parent
diff -pruN 134+dfsg-1/finalcif/appwindow.py 137+dfsg-1/finalcif/appwindow.py
--- 134+dfsg-1/finalcif/appwindow.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/appwindow.py	2024-04-19 19:04:23.000000000 +0000
@@ -13,15 +13,14 @@ from contextlib import suppress
 from datetime import datetime
 from math import sin, radians
 from pathlib import Path, WindowsPath
-from shutil import which
 from typing import Union, Dict, Tuple, List, Optional
 
 import gemmi.cif
 import requests  # type: ignore
-from PyQt5 import QtCore, QtGui, QtWebEngineWidgets
+from PyQt5 import QtCore, QtGui, QtWebEngineWidgets, QtWidgets
 from PyQt5.QtCore import Qt, QEvent
 from PyQt5.QtWidgets import QMainWindow, QShortcut, QCheckBox, QListWidgetItem, QApplication, \
-    QPlainTextEdit, QFileDialog, QMessageBox
+    QPlainTextEdit, QFileDialog, QMessageBox, QScrollBar
 from gemmi import cif
 
 from finalcif import VERSION
@@ -47,6 +46,7 @@ from finalcif.gui.loops import Loop, Loo
 from finalcif.gui.plaintextedit import MyQPlainTextEdit
 from finalcif.gui.text_value_editor import MyTextTemplateEdit, TextEditItem
 from finalcif.gui.vrf_classes import MyVRFContainer, VREF
+from finalcif.report.templated_report import ReportFormat
 from finalcif.template.templates import ReportTemplates
 from finalcif.tools.download import MyDownloader
 from finalcif.tools.dsrmath import my_isnumeric
@@ -60,6 +60,8 @@ from finalcif.tools.space_groups import
 from finalcif.tools.statusbar import StatusBar
 from finalcif.tools.sumformula import formula_str_to_dict, sum_formula_to_html
 
+# QtCore.QCoreApplication.setAttribute(QtCore.Qt.AA_EnableHighDpiScaling)
+
 DEBUG = False
 app = QApplication.instance()
 if app is None:
@@ -100,7 +102,7 @@ class AppWindow(QMainWindow):
         self.properties = Properties(parent=self, settings=self.settings)
         self.status_bar = StatusBar(ui=self.ui)
         self.status_bar.show_message('FinalCif version {}'.format(VERSION))
-        self.authors: Optional[AuthorLoops] = None
+        self.authors: Union[AuthorLoops, None] = None
         self.set_window_size_and_position()
         self.ui.cif_main_table.installEventFilter(self)
         # Sorting desynchronized header and columns:
@@ -153,12 +155,13 @@ class AppWindow(QMainWindow):
         self.ui.ExploreDirButton.setDisabled(True)
         self.ui.DetailsPushButton.setDisabled(True)
         self.ui.SourcesPushButton.setDisabled(True)
-        self.ui.OptionsPushButton.setEnabled(True)
         self.ui.ImportCifPushButton.setDisabled(True)
         self.ui.CODpushButton.setDisabled(True)
         self.ui.CCDCpushButton.setDisabled(True)
         self.ui.ShredCifButton.setDisabled(True)
         self.ui.LoopsPushButton.setDisabled(True)
+        self.ui.OptionsPushButton.setDisabled(True)
+        self.ui.AuthorEditPushButton.setDisabled(True)
 
     def enable_buttons(self):
         self.ui.appendCifPushButton.setEnabled(True)
@@ -177,12 +180,13 @@ class AppWindow(QMainWindow):
         self.ui.CODpushButton.setEnabled(True)
         self.ui.CCDCpushButton.setEnabled(True)
         self.ui.LoopsPushButton.setEnabled(True)
+        self.ui.AuthorEditPushButton.setEnabled(True)
         if self.cif.is_multi_cif:
             self.ui.CODpushButton.setDisabled(True)
         else:
             self.ui.CODpushButton.setEnabled(True)
 
-    def set_font_sizes(self):
+    def set_font_sizes(self) -> None:
         large_font = QtGui.QFont()
         ps = large_font.pointSize()
         large_font.setPointSize(int(ps + ps * 0.38))
@@ -198,6 +202,7 @@ class AppWindow(QMainWindow):
             self.ui.docxTemplatesListWidget.setFont(mid_font)
             self.ui.PropertiesTemplatesListWidget.setFont(mid_font)
             self.ui.depositOutputTextBrowser.setFont(mid_font)
+        self.setTextEditSizes()
 
     def set_window_size_and_position(self) -> None:
         wsettings = self.settings.load_window_position()
@@ -478,7 +483,10 @@ class AppWindow(QMainWindow):
                     loop_column_name = i.loop.tags[0]
                     self.textedit.ui.cifKeyLineEdit.setText(loop_column_name)
                 for n in range(i.loop.length()):
-                    value = i.loop.val(n, 0)
+                    try:
+                        value = i.loop.val(n, 0)
+                    except AttributeError:
+                        value = i.loop[n, 0]
                     text_list.append(gemmi.cif.as_string(value))
         self.textedit.add_textfields(text_list)
 
@@ -622,6 +630,14 @@ class AppWindow(QMainWindow):
         # Not necessary here, it is done in MyCifTable
         # threading.Thread(target=self.ui.cif_main_table.resizeRowsToContents).start()
         # QtCore.QTimer(self).singleShot(0, self.ui.cif_main_table.resizeRowsToContents)
+        self.setTextEditSizes()
+
+    def setTextEditSizes(self):
+        for ui in [self.ui.Spacegroup_top_LineEdit, self.ui.CCDCNumLineEdit, self.ui.SumFormMainLineEdit]:
+            ui.setFixedHeight(self.ui.appendCifPushButton.height())
+            vScrollBar = ui.verticalScrollBar()
+            # Scroll down a bit, or text will not be in the vertical center:
+            vScrollBar.triggerAction(QScrollBar.SliderSingleStepAdd)
 
     def moveEvent(self, a0: QtGui.QMoveEvent) -> None:
         """Is called when the main window moves."""
@@ -815,8 +831,7 @@ class AppWindow(QMainWindow):
         self.ui.cif_main_table.scrollToTop()
         self.ui.TemplatesStackedWidget.setCurrentIndex(0)
         self.ui.cif_main_table.resizeRowsToContents()
-        self.ui.revertLoopsPushButton.show()
-        self.ui.newLoopPushButton.show()
+        self._show_loop_buttons()
 
     def back_to_main_noload(self) -> None:
         """
@@ -825,8 +840,12 @@ class AppWindow(QMainWindow):
         self.status_bar.show_message('')
         self.ui.TemplatesStackedWidget.setCurrentIndex(0)
         self.ui.MainStackedWidget.got_to_main_page()
+        self._show_loop_buttons()
+
+    def _show_loop_buttons(self):
         self.ui.revertLoopsPushButton.show()
         self.ui.newLoopPushButton.show()
+        self.ui.deleteLoopButton.show()
 
     def _checkcif_failed(self, txt: str):
         self.ui.CheckCifLogPlainTextEdit.appendHtml('<b>{}</b>'.format(txt))
@@ -1016,7 +1035,7 @@ class AppWindow(QMainWindow):
                               log_widget=self.ui.CheckCifLogPlainTextEdit,
                               output_widget=self.ui.CheckcifPlaintextEdit,
                               cif_file=self.cif.fileobj)
-        if not Path(which(runner.platon_exe)).exists():
+        if runner.platon_exe is not None and not Path(runner.platon_exe).exists():
             self.ui.CheckCifLogPlainTextEdit.setPlainText('\nPlaton executable not found!')
             self.ui.CheckCifLogPlainTextEdit.appendPlainText(
                 'You can download Platon at http://www.platonsoft.nl/platon/\n')
@@ -1116,10 +1135,20 @@ class AppWindow(QMainWindow):
                     make_multi_tables(cif=self.cif, output_filename=str(multi_table_document))
             else:
                 print('Report with templates')
-                t = TemplatedReport()
-                ok = t.make_templated_report(options=self.options, cif=self.cif,
-                                             output_filename=str(report_filename), picfile=picfile,
-                                             template_path=Path(self.get_checked_templates_list_text()))
+                template_path = Path(self.get_checked_templates_list_text())
+                ok = False
+                if template_path.suffix in ('.docx',):
+                    t = TemplatedReport(format=ReportFormat.RICHTEXT, options=self.options, cif=self.cif)
+                    ok = t.make_templated_docx_report(output_filename=str(report_filename),
+                                                      picfile=picfile,
+                                                      template_path=Path(self.get_checked_templates_list_text()))
+                elif template_path.suffix in ('.html', '.tmpl'):
+                    t = TemplatedReport(format=ReportFormat.HTML, options=self.options, cif=self.cif)
+                    report_filename = report_filename.with_suffix('.html')
+                    ok = t.make_templated_html_report(output_filename=str(report_filename),
+                                                      picfile=picfile,
+                                                      template_path=template_path.parent,
+                                                      template_file=template_path.name)
                 if not ok:
                     return None
         except FileNotFoundError as e:
@@ -1492,6 +1521,7 @@ class AppWindow(QMainWindow):
             raise
             # unable_to_open_message(Path(self.cif.filename), not_ok)
         self.load_recent_cifs_list()
+        self.set_vertical_header_width()
         if self.options.track_changes and load_changes:
             changes_exist = False
             if self.changes_cif_has_zero_size():
@@ -1536,6 +1566,16 @@ class AppWindow(QMainWindow):
             t = QtCore.QTimer(self)
             t.singleShot(1000, self.check_cecksums)
 
+    def set_vertical_header_width(self):
+        """
+        Sets the width of the vertical header to the length of the longest string in the list.
+        """
+        vheader: QtWidgets.QHeaderView = self.ui.cif_main_table.verticalHeader()
+        fm = QtGui.QFontMetrics(vheader.font(), self)
+        # noinspection PyTypeChecker
+        longest_string: str = max(self.ui.cif_main_table.vheaderitems, key=len)
+        vheader.setMaximumWidth(fm.width(longest_string + 'O'))
+
     def changes_cif_has_values(self) -> bool:
         try:
             return not self.get_changes_cif(self.finalcif_changes_filename).is_empty()
@@ -1690,14 +1730,29 @@ class AppWindow(QMainWindow):
         peak = self.cif['_refine_diff_density_max']
         if peak:
             self.ui.peakLineEdit.setText("{} / {}".format(peak, self.cif['_refine_diff_density_min']))
-        if self.cif.res_file_data:
-            self.ui.shelx_TextEdit.setPlainText(cif.as_string(self.cif.res_file_data))
+        self._show_shelx_file()
         try:
             QtCore.QTimer(self).singleShot(0, self.view_molecule)
             # threading.Thread(target=self.view_molecule).start()
         except Exception:
             print('Molecule view crashed!')
 
+    def _show_shelx_file(self):
+        if self.cif.res_file_data:
+            self.ui.shelx_warn_TextEdit.clear()
+            if hasattr(self.cif.shx, 'restraint_errors') and self.cif.shx.restraint_errors:
+                self.ui.shelx_warn_TextEdit.show()
+                self.ui.shelx_warn_TextEdit.setPlainText('Errors were found in the SHELX file:\n')
+                self.ui.shelx_warn_TextEdit.appendPlainText('\n'.join(self.cif.shx.restraint_errors))
+                vScrollBar = self.ui.shelx_warn_TextEdit.verticalScrollBar()
+                vScrollBar.triggerAction(QScrollBar.SliderToMinimum)
+            else:
+                self.ui.shelx_warn_TextEdit.hide()
+            self.ui.shelx_TextEdit.setPlainText(cif.as_string(self.cif.res_file_data))
+        else:
+            self.ui.shelx_TextEdit.setPlainText("No Shelx file available")
+            self.ui.shelx_warn_TextEdit.hide()
+
     def view_molecule(self) -> None:
         if self.ui.growCheckBox.isChecked():
             self.ui.molGroupBox.setTitle('Completed Molecule')
@@ -1914,6 +1969,7 @@ class AppWindow(QMainWindow):
         self.ui.LoopsTabWidget.setCurrentIndex(self.ui.LoopsTabWidget.count() - 1)
         self.ui.revertLoopsPushButton.hide()
         self.ui.newLoopPushButton.hide()
+        self.ui.deleteLoopButton.hide()
         self.loopcreate.saveLoopPushButton.clicked.connect(self.save_new_loop_to_cif)
 
     def _on_delete_current_loop(self):
diff -pruN 134+dfsg-1/finalcif/cif/cif_dict_foo.py 137+dfsg-1/finalcif/cif/cif_dict_foo.py
--- 134+dfsg-1/finalcif/cif/cif_dict_foo.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/cif_dict_foo.py	2024-04-19 19:04:23.000000000 +0000
@@ -21,6 +21,15 @@ def format_definition(definition: str):
     return newdef
 
 
+formats = {
+    'char' : 'string',
+    'uchar': 'case-insensitive string',
+    'numb' : 'number (int or float)',
+    'null' : '? (unknown)' or '. (not applicable)',
+    ''     : '--'
+}
+
+
 def process_cif_dict(cdic):
     """
     Creates a dictionary with cif keywords as key and help text as value.
@@ -36,6 +45,7 @@ def process_cif_dict(cdic):
                 example_detail = item.get('_example_detail', '')
                 enumeration = item.get('_enumeration', '')
                 enumeration_detail = item.get('_enumeration_detail', '')
+                default = item.get('_enumeration_default', '')
                 if example:
                     if isinstance(example, list) and not enumeration_detail:
                         example = '\n'.join([str(x) for x in example])
@@ -52,15 +62,29 @@ def process_cif_dict(cdic):
                             ["{}\n\t{}\n".format(str(x), str(y)) for x, y in zip(enumeration, enumeration_detail)])
                     enumeration = format_definition(escape(str(enumeration)))
                     definition = '{}\n\n<h3>Example:</h3>\n{}'.format(definition, enumeration)
+                type_format = item.get("_type", "")
+                enum_range = item.get('_enumeration_range', '')
                 if isinstance(name, list):
                     for n in name:
                         # For keys like 'atom_site_aniso_b_[]' where the name has several subnames:
-                        alldic[n] = '<pre><h2>{}</h2>{}</pre>'.format(n, format_definition(definition))
+                        alldic[n] = help_text(definition, n, type_format, enum_range, default)
                 else:
-                    alldic[name] = '<pre><h2>{}</h2>{}</pre>'.format(name, format_definition(definition))
+                    alldic[name] = help_text(definition, name, type_format, enum_range, default)
     return alldic
 
 
+def help_text(definition: str, name: str, type_format: str, enum_range: str, enum_default) -> str:
+    if enum_range.endswith(':'):
+        enum_range = enum_range + '∞'
+    limits = f'\n<br><p><h4>Limits:</h4> {enum_range} </p>'
+    default = f'\n<br><p><h4>Default:</h4> {enum_default} </p>'
+    return (f'<pre><h2>{name}</h2>{format_definition(definition)}</pre>'
+            f'\n<br><p><h4>Type:</h4> {formats.get(type_format, "")}</p>'
+            f'{limits if enum_range else ""}'
+            f'{default if enum_default else ""}'
+            )
+
+
 def load_cif_as_dictionary(link, path_to_cif):
     if not path_to_cif.exists():
         get_dictionary_cif(link, path_to_cif)
diff -pruN 134+dfsg-1/finalcif/cif/cif_file_io.py 137+dfsg-1/finalcif/cif/cif_file_io.py
--- 134+dfsg-1/finalcif/cif/cif_file_io.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/cif_file_io.py	2024-04-19 19:04:23.000000000 +0000
@@ -94,7 +94,7 @@ class CifContainer():
         The suffix needs '-finalcif' in order to contain the finalcif ending.
         "foo/bar/baz-finalcif.cif"
 
-        :param forece_strip: Forces to strip the filename also after the '-finalcif' string.
+        :param force_strip: Forces to strip the filename also after the '-finalcif' string.
         """
         file_witout_finalcif = strip_finalcif_of_name(Path(self.filename).stem, till_name_ends=force_strip)
         filename = self.path_base.joinpath(Path(prefix + file_witout_finalcif + suffix))
diff -pruN 134+dfsg-1/finalcif/cif/cif_order.py 137+dfsg-1/finalcif/cif/cif_order.py
--- 134+dfsg-1/finalcif/cif/cif_order.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/cif_order.py	2024-04-19 19:04:23.000000000 +0000
@@ -17,6 +17,13 @@ special_keys = ['_iucr_refine_instructio
                 ]
 
 order = [
+    '_audit_update_record',
+    '_audit_contact_author',
+    '_audit_contact_author_name',
+    '_audit_contact_author_phone',
+    '_audit_contact_author_email',
+    '_audit_contact_author_fax',
+    '_audit_contact_author_address',
     '_audit_author_id',
     '_audit_author_id_audit',
     '_audit_author_name',
@@ -128,7 +135,6 @@ order = [
     '_publ_contact_author_id_orcid',
     '_publ_contact_author_footnote',
 
-
     '_shelx_SHELXL_version_number',
     '_chemical_name_systematic',
     '_chemical_name_common',
@@ -341,4 +347,17 @@ order = [
     '_geom_details',
     '_geom_special_details',
 
+    '_bruker_diffrn_runs_wavelength',
+    '_bruker_diffrn_runs_temperature',
+    '_bruker_diffrn_runs_current',
+    '_bruker_diffrn_runs_voltage',
+    '_bruker_diffrn_runs_images',
+    '_bruker_diffrn_runs_time',
+    '_bruker_diffrn_runs_width',
+    '_bruker_diffrn_runs_axis',
+    '_bruker_diffrn_runs_chi',
+    '_bruker_diffrn_runs_phi',
+    '_bruker_diffrn_runs_omega',
+    '_bruker_diffrn_runs_theta',
+    '_bruker_diffrn_runs_distance',
 ]
diff -pruN 134+dfsg-1/finalcif/cif/core_dict.py 137+dfsg-1/finalcif/cif/core_dict.py
--- 134+dfsg-1/finalcif/cif/core_dict.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/core_dict.py	2024-04-19 19:04:23.000000000 +0000
@@ -9,7 +9,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  ' The IUCr Commission on Nomenclature recommends against the use\n'
                                  ' of B for reporting atomic displacement parameters. U, being\n'
-                                 ' directly proportional to B, is preferred.</pre>',
+                                 ' directly proportional to B, is preferred.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_B_iso_or_equiv': '<pre><h2>_atom_site_B_iso_or_equiv</h2> Isotropic atomic '
                               'displacement parameter, or equivalent isotropic\n'
                               ' atomic displacement parameter, B(equiv), in angstroms squared,\n'
@@ -26,19 +28,24 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '\n'
                               ' The IUCr Commission on Nomenclature recommends against the use\n'
                               ' of B for reporting atomic displacement parameters. U, being\n'
-                              ' directly proportional to B, is preferred.</pre>',
+                              ' directly proportional to B, is preferred.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_Cartn_x': '<pre><h2>_atom_site_Cartn_x</h2> The atom-site coordinates in angstroms '
                        'specified according to a\n'
                        ' set of orthogonal Cartesian axes related to the cell axes as\n'
-                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>',
+                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_Cartn_y': '<pre><h2>_atom_site_Cartn_y</h2> The atom-site coordinates in angstroms '
                        'specified according to a\n'
                        ' set of orthogonal Cartesian axes related to the cell axes as\n'
-                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>',
+                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_Cartn_z': '<pre><h2>_atom_site_Cartn_z</h2> The atom-site coordinates in angstroms '
                        'specified according to a\n'
                        ' set of orthogonal Cartesian axes related to the cell axes as\n'
-                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>',
+                       ' specified by the _atom_sites_Cartn_transform_axes description.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_U_equiv_geom_mean': '<pre><h2>_atom_site_U_equiv_geom_mean</h2> Equivalent isotropic '
                                  'atomic displacement parameter, U(equiv),\n'
                                  ' in angstroms squared, calculated as the geometric mean of\n'
@@ -47,7 +54,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' U(equiv) = (U~i~ U~j~ U~k~)^1/3^\n'
                                  '\n'
                                  ' U~n~  = the principal components of the orthogonalized '
-                                 'U^ij^</pre>',
+                                 'U^ij^</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_U_iso_or_equiv': '<pre><h2>_atom_site_U_iso_or_equiv</h2> Isotropic atomic '
                               'displacement parameter, or equivalent isotropic\n'
                               ' atomic  displacement parameter, U(equiv), in angstroms squared,\n'
@@ -59,10 +68,13 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               ' a*    = the reciprocal-space cell lengths\n'
                               '\n'
                               ' Ref: Fischer, R. X. &amp; Tillmanns, E. (1988). Acta Cryst. C44,\n'
-                              '      775-776.</pre>',
+                              '      775-776.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_Wyckoff_symbol': '<pre><h2>_atom_site_Wyckoff_symbol</h2> The Wyckoff symbol (letter) '
                               'as listed in the space-group tables\n'
-                              ' of International Tables for Crystallography Vol. A (2002).</pre>',
+                              ' of International Tables for Crystallography Vol. A (2002).</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_adp_type': '<pre><h2>_atom_site_adp_type</h2> A standard code used to describe the '
                         'type of atomic displacement\n'
                         ' parameters used for the site.\n'
@@ -88,7 +100,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                         '\n'
                         'Bovl\n'
                         '\toverall B\n'
-                        '</pre>',
+                        '</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_aniso_B_11': '<pre><h2>_atom_site_aniso_B_11</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -104,7 +117,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_B_12': '<pre><h2>_atom_site_aniso_B_12</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -120,7 +134,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_B_13': '<pre><h2>_atom_site_aniso_B_13</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -136,7 +151,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_B_22': '<pre><h2>_atom_site_aniso_B_22</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -152,7 +168,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_B_23': '<pre><h2>_atom_site_aniso_B_23</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -168,7 +185,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_B_33': '<pre><h2>_atom_site_aniso_B_33</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the \n'
@@ -184,7 +202,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           ' The IUCr Commission on Nomenclature recommends against the use\n'
                           ' of B for reporting atomic displacement parameters. U, being\n'
-                          ' directly proportional to B, is preferred.</pre>',
+                          ' directly proportional to B, is preferred.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_11': '<pre><h2>_atom_site_aniso_U_11</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -196,7 +215,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_12': '<pre><h2>_atom_site_aniso_U_12</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -208,7 +228,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_13': '<pre><h2>_atom_site_aniso_U_13</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -220,7 +241,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_22': '<pre><h2>_atom_site_aniso_U_22</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -232,7 +254,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_23': '<pre><h2>_atom_site_aniso_U_23</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -244,7 +267,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_U_33': '<pre><h2>_atom_site_aniso_U_33</h2> These are the standard anisotropic '
                           'atomic displacement\n'
                           ' components in angstroms squared which appear in the\n'
@@ -256,21 +280,26 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' a* = the reciprocal-space cell lengths\n'
                           '\n'
                           ' The unique elements of the real symmetric matrix are\n'
-                          ' entered by row.</pre>',
+                          ' entered by row.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_aniso_label': '<pre><h2>_atom_site_aniso_label</h2> Anisotropic atomic displacement '
                            'parameters are usually looped in\n'
                            ' a separate list. If this is the case, this code must match the\n'
                            ' _atom_site_label of the associated atom in the atom coordinate\n'
                            ' list and conform with the same rules described in\n'
-                           ' _atom_site_label.</pre>',
+                           ' _atom_site_label.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_aniso_ratio': '<pre><h2>_atom_site_aniso_ratio</h2> Ratio of the maximum to minimum '
                            'principal axes of\n'
-                           ' displacement (thermal) ellipsoids.</pre>',
+                           ' displacement (thermal) ellipsoids.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 1.0:∞ </p>',
  '_atom_site_aniso_type_symbol': '<pre><h2>_atom_site_aniso_type_symbol</h2> This '
                                  '_atom_type_symbol code links the anisotropic atom\n'
                                  ' parameters to the atom-type data associated with this site and\n'
                                  ' must match one of the _atom_type_symbol codes in this '
-                                 'list.</pre>',
+                                 'list.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_attached_hydrogens': '<pre><h2>_atom_site_attached_hydrogens</h2> The number of '
                                   'hydrogen atoms attached to the atom at this site\n'
                                   ' excluding any hydrogen atoms for which coordinates (measured '
@@ -280,10 +309,14 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   '2\n'
                                   '1\n'
-                                  '4</pre>',
+                                  '4</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:8 </p>',
  '_atom_site_calc_attached_atom': '<pre><h2>_atom_site_calc_attached_atom</h2> The '
                                   "_atom_site_label of the atom site to which the 'geometry-\n"
-                                  " calculated' atom site is attached.</pre>",
+                                  " calculated' atom site is attached.</pre>\n"
+                                  '<br><p><h4>Type:</h4> string</p>\n'
+                                  '<br><p><h4>Default:</h4> . </p>',
  '_atom_site_calc_flag': '<pre><h2>_atom_site_calc_flag</h2> A standard code to signal whether the '
                          'site coordinates have been\n'
                          ' determined from the intensities or calculated from the geometry\n'
@@ -302,24 +335,31 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          '\n'
                          'dum\n'
                          '\tdummy site with meaningless coordinates\n'
-                         '</pre>',
+                         '</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>\n'
+                         '<br><p><h4>Default:</h4> d </p>',
  '_atom_site_chemical_conn_number': '<pre><h2>_atom_site_chemical_conn_number</h2> This number '
                                     'links an atom site to the chemical connectivity list.\n'
                                     ' It must match a number specified by '
-                                    '_chemical_conn_atom_number.</pre>',
+                                    '_chemical_conn_atom_number.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_atom_site_constraints': '<pre><h2>_atom_site_constraints</h2> A description of the constraints '
                            'applied to parameters at this\n'
                            ' site during refinement. See also _atom_site_refinement_flags\n'
                            ' and _refine_ls_number_constraints.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'pop=1.0-pop(Zn3)</pre>',
+                           'pop=1.0-pop(Zn3)</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>\n'
+                           '<br><p><h4>Default:</h4> . </p>',
  '_atom_site_description': '<pre><h2>_atom_site_description</h2> A description of special aspects '
                            'of this site. See also\n'
                            ' _atom_site_refinement_flags.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'Ag/Si disordered</pre>',
+                           'Ag/Si disordered</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_disorder_assembly': '<pre><h2>_atom_site_disorder_assembly</h2> A code which '
                                  'identifies a cluster of atoms that show long-range\n'
                                  ' positional disorder but are locally ordered. Within each such\n'
@@ -332,7 +372,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '<h3>Example:</h3>\n'
                                  'A\n'
                                  'B\n'
-                                 'S</pre>',
+                                 'S</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_disorder_group': '<pre><h2>_atom_site_disorder_group</h2> A code which identifies a '
                               'group of positionally disordered atom\n'
                               ' sites that are locally simultaneously occupied. Atoms that are\n'
@@ -346,13 +387,17 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '<h3>Example:</h3>\n'
                               '1\n'
                               '2\n'
-                              '-1</pre>',
+                              '-1</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_fract_x': '<pre><h2>_atom_site_fract_x</h2> Atom-site coordinates as fractions of the '
-                       '_cell_length_ values.</pre>',
+                       '_cell_length_ values.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_fract_y': '<pre><h2>_atom_site_fract_y</h2> Atom-site coordinates as fractions of the '
-                       '_cell_length_ values.</pre>',
+                       '_cell_length_ values.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_fract_z': '<pre><h2>_atom_site_fract_z</h2> Atom-site coordinates as fractions of the '
-                       '_cell_length_ values.</pre>',
+                       '_cell_length_ values.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_label': '<pre><h2>_atom_site_label</h2> The _atom_site_label is a unique identifier '
                      'for a particular site\n'
                      ' in the crystal. This code is made up of a sequence of up to seven\n'
@@ -379,7 +424,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                      'H*251\n'
                      'boron2a\n'
                      'C_a_phe_83_a_0\n'
-                     'Zn_Zn_301_A_0</pre>',
+                     'Zn_Zn_301_A_0</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_0': '<pre><h2>_atom_site_label_component_0</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -400,7 +446,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_1': '<pre><h2>_atom_site_label_component_1</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -421,7 +468,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_2': '<pre><h2>_atom_site_label_component_2</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -442,7 +490,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_3': '<pre><h2>_atom_site_label_component_3</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -463,7 +512,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_4': '<pre><h2>_atom_site_label_component_4</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -484,7 +534,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_5': '<pre><h2>_atom_site_label_component_5</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -505,7 +556,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_label_component_6': '<pre><h2>_atom_site_label_component_6</h2> Component 0 is '
                                  'normally a code which matches identically with\n'
                                  ' one of the _atom_type_symbol codes. If this is the case, then '
@@ -526,7 +578,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' Components 2 to 6 contain the identifier, residue, sequence,\n'
                                  ' asymmetry identifier and alternate codes, respectively. These\n'
                                  ' codes may be composed of any characters except an '
-                                 'underscore.</pre>',
+                                 'underscore.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_occupancy': '<pre><h2>_atom_site_occupancy</h2> The fraction of the atom type present '
                          'at this site.\n'
                          ' The sum of the occupancies of all the atom types at this site\n'
@@ -534,7 +587,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          ' value must lie in the 99.97% Gaussian confidence interval\n'
                          ' -3u =&lt; x =&lt; 1 + 3u. The _enumeration_range of 0.0:1.0 is thus\n'
                          ' correctly interpreted as meaning (0.0 - 3u) =&lt; x =&lt; (1.0 + '
-                         '3u).</pre>',
+                         '3u).</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:1.0 </p>\n'
+                         '<br><p><h4>Default:</h4> 1.0 </p>',
  '_atom_site_refinement_flags': '<pre><h2>_atom_site_refinement_flags</h2>           A '
                                 'concatenated series of single-letter codes which indicate the\n'
                                 '            refinement restraints or constraints applied to this '
@@ -570,7 +626,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '\n'
                                 'P\n'
                                 '\tpartial occupancy constraint\n'
-                                '</pre>',
+                                '</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_refinement_flags_adp': '<pre><h2>_atom_site_refinement_flags_adp</h2> A code which '
                                     'indicates the refinement restraints or constraints\n'
                                     ' applied to the atomic displacement parameters of this site.\n'
@@ -588,7 +645,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     '\n'
                                     'TU\n'
                                     '\tboth constraints applied\n'
-                                    '</pre>',
+                                    '</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_refinement_flags_occupancy': '<pre><h2>_atom_site_refinement_flags_occupancy</h2> A '
                                           'code which indicates that refinement restraints or\n'
                                           ' constraints were applied to the occupancy of this '
@@ -600,7 +658,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                           '\n'
                                           'P\n'
                                           '\tsite-occupancy constraint\n'
-                                          '</pre>',
+                                          '</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_refinement_flags_posn': '<pre><h2>_atom_site_refinement_flags_posn</h2> A code which '
                                      'indicates the refinement restraints or constraints\n'
                                      ' applied to the positional coordinates of this site.\n'
@@ -653,14 +712,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '\n'
                                      'DGRS\n'
                                      '\tcombination of the above constraints\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_restraints': '<pre><h2>_atom_site_restraints</h2> A description of restraints applied '
                           'to specific parameters at\n'
                           ' this site during refinement. See also _atom_site_refinement_flags\n'
                           ' and _refine_ls_number_restraints.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          'restrained to planar ring</pre>',
+                          'restrained to planar ring</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_site_symmetry_multiplicity': '<pre><h2>_atom_site_site_symmetry_multiplicity</h2> The '
                                           'number of different sites that are generated by the\n'
                                           ' application of the space-group symmetry to the\n'
@@ -671,7 +732,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                           ' It is equal to the multiplicity of the general '
                                           'position\n'
                                           ' divided by the order of the site symmetry given in\n'
-                                          ' _atom_site_site_symmetry_order.</pre>',
+                                          ' _atom_site_site_symmetry_order.</pre>\n'
+                                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                          '<br><p><h4>Limits:</h4> 1:192 </p>',
  '_atom_site_site_symmetry_order': '<pre><h2>_atom_site_site_symmetry_order</h2> The order of the '
                                    'site symmetry of the site identified by\n'
                                    ' _atom_site_label.\n'
@@ -686,7 +749,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '                multiplicity of this site\n'
                                    '\n'
                                    "  where 'multiplicity of this site' is\n"
-                                   '  given in _atom_site_site_symmetry_multiplicity.</pre>',
+                                   '  given in _atom_site_site_symmetry_multiplicity.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 1:48 </p>',
  '_atom_site_symmetry_multiplicity': '<pre><h2>_atom_site_symmetry_multiplicity</h2> The '
                                      'multiplicity of a site due to the space-group symmetry as\n'
                                      ' given in International Tables for Crystallography Vol. A '
@@ -700,7 +765,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      ' using the data name _atom_site_site_symmetry_multiplicity.\n'
                                      ' In the historic archive some CIFs use this item to give '
                                      'values\n'
-                                     ' that belong in _atom_site_site_symmetry_order.</pre>',
+                                     ' that belong in _atom_site_site_symmetry_order.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 1:192 </p>',
  '_atom_site_thermal_displace_type': '<pre><h2>_atom_site_thermal_displace_type</h2> A standard '
                                      'code used to describe the type of atomic displacement\n'
                                      ' parameters used for the site.\n'
@@ -726,7 +793,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '\n'
                                      'Bovl\n'
                                      '\toverall B\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_type_symbol': '<pre><h2>_atom_site_type_symbol</h2> A code to identify the atom '
                            'species (singular or plural)\n'
                            ' occupying this site.\n'
@@ -741,7 +809,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            'Fe3+Ni2+\n'
                            'S-\n'
                            'H*\n'
-                           'H(SDS)</pre>',
+                           'H(SDS)</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_Cartn_tran_matrix_11': '<pre><h2>_atom_sites_Cartn_tran_matrix_11</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -754,7 +823,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_12': '<pre><h2>_atom_sites_Cartn_tran_matrix_12</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -767,7 +837,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_13': '<pre><h2>_atom_sites_Cartn_tran_matrix_13</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -780,7 +851,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_21': '<pre><h2>_atom_sites_Cartn_tran_matrix_21</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -793,7 +865,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_22': '<pre><h2>_atom_sites_Cartn_tran_matrix_22</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -806,7 +879,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_23': '<pre><h2>_atom_sites_Cartn_tran_matrix_23</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -819,7 +893,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_31': '<pre><h2>_atom_sites_Cartn_tran_matrix_31</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -832,7 +907,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_32': '<pre><h2>_atom_sites_Cartn_tran_matrix_32</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -845,7 +921,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_matrix_33': '<pre><h2>_atom_sites_Cartn_tran_matrix_33</h2> Matrix '
                                      'elements used to transform fractional coordinates in\n'
                                      ' the ATOM_SITE category to Cartesian  coordinates. The '
@@ -858,7 +935,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                  | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_vector_1': '<pre><h2>_atom_sites_Cartn_tran_vector_1</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of fractional coordinates in the\n'
@@ -870,7 +948,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                     '2 |\n'
                                     "   z'                   |31 32 33|      z                  | "
-                                    '3 |</pre>',
+                                    '3 |</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_vector_2': '<pre><h2>_atom_sites_Cartn_tran_vector_2</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of fractional coordinates in the\n'
@@ -882,7 +961,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                     '2 |\n'
                                     "   z'                   |31 32 33|      z                  | "
-                                    '3 |</pre>',
+                                    '3 |</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_tran_vector_3': '<pre><h2>_atom_sites_Cartn_tran_vector_3</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of fractional coordinates in the\n'
@@ -894,14 +974,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) Cartesian   =   |21 22 23|    ( y ) fractional  +  | "
                                     '2 |\n'
                                     "   z'                   |31 32 33|      z                  | "
-                                    '3 |</pre>',
+                                    '3 |</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_Cartn_transform_axes': '<pre><h2>_atom_sites_Cartn_transform_axes</h2> A description '
                                      'of the relative alignment of the crystal cell\n'
                                      ' axes to the  Cartesian orthogonal axes as applied in the\n'
                                      ' transformation matrix _atom_sites_Cartn_tran_matrix_.\n'
                                      '\n'
                                      '<h3>Example:</h3>\n'
-                                     'a parallel to x; b in the plane of y and z</pre>',
+                                     'a parallel to x; b in the plane of y and z</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_fract_tran_matrix_11': '<pre><h2>_atom_sites_fract_tran_matrix_11</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -914,7 +996,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_12': '<pre><h2>_atom_sites_fract_tran_matrix_12</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -927,7 +1010,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_13': '<pre><h2>_atom_sites_fract_tran_matrix_13</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -940,7 +1024,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_21': '<pre><h2>_atom_sites_fract_tran_matrix_21</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -953,7 +1038,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_22': '<pre><h2>_atom_sites_fract_tran_matrix_22</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -966,7 +1052,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_23': '<pre><h2>_atom_sites_fract_tran_matrix_23</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -979,7 +1066,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_31': '<pre><h2>_atom_sites_fract_tran_matrix_31</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -992,7 +1080,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_32': '<pre><h2>_atom_sites_fract_tran_matrix_32</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -1005,7 +1094,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_matrix_33': '<pre><h2>_atom_sites_fract_tran_matrix_33</h2> Matrix '
                                      'elements used to transform Cartesian coordinates in\n'
                                      ' the ATOM_SITE category to fractional coordinates. The '
@@ -1018,7 +1108,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | "
                                      '2 |\n'
                                      "   z'                   |31 32 33|      z                 | "
-                                     '3 |</pre>',
+                                     '3 |</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_vector_1': '<pre><h2>_atom_sites_fract_tran_vector_1</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of Cartesian coordinates in the\n'
@@ -1030,7 +1121,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | 2 "
                                     '|\n'
                                     "   z'                   |31 32 33|      z                 | 3 "
-                                    '|</pre>',
+                                    '|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_vector_2': '<pre><h2>_atom_sites_fract_tran_vector_2</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of Cartesian coordinates in the\n'
@@ -1042,7 +1134,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | 2 "
                                     '|\n'
                                     "   z'                   |31 32 33|      z                 | 3 "
-                                    '|</pre>',
+                                    '|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_fract_tran_vector_3': '<pre><h2>_atom_sites_fract_tran_vector_3</h2> Elements of a 3 '
                                     'x 1 translation vector used in the\n'
                                     ' transformation of Cartesian coordinates in the\n'
@@ -1054,7 +1147,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     " ( y' ) fractional  =   |21 22 23|    ( y ) Cartesian  +  | 2 "
                                     '|\n'
                                     "   z'                   |31 32 33|      z                 | 3 "
-                                    '|</pre>',
+                                    '|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_sites_solution_hydrogens': '<pre><h2>_atom_sites_solution_hydrogens</h2> Codes which '
                                    'identify the methods used to locate the initial\n'
                                    ' atom sites. The *_primary code identifies how the first\n'
@@ -1108,7 +1202,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    'other\n'
                                    '\ta method not included elsewhere in this list\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_solution_primary': '<pre><h2>_atom_sites_solution_primary</h2> Codes which identify '
                                  'the methods used to locate the initial\n'
                                  ' atom sites. The *_primary code identifies how the first\n'
@@ -1159,7 +1254,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  'other\n'
                                  '\ta method not included elsewhere in this list\n'
-                                 '</pre>',
+                                 '</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_solution_secondary': '<pre><h2>_atom_sites_solution_secondary</h2> Codes which '
                                    'identify the methods used to locate the initial\n'
                                    ' atom sites. The *_primary code identifies how the first\n'
@@ -1210,12 +1306,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    'other\n'
                                    '\ta method not included elsewhere in this list\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_special_details': '<pre><h2>_atom_sites_special_details</h2> Additional information '
                                 'about the atomic coordinates not coded\n'
-                                ' elsewhere in the CIF.</pre>',
+                                ' elsewhere in the CIF.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_atom_type_analytical_mass_%': '<pre><h2>_atom_type_analytical_mass_%</h2> Mass percentage of '
-                                 'this atom type derived from chemical analysis.</pre>',
+                                 'this atom type derived from chemical analysis.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_atom_type_description': '<pre><h2>_atom_type_description</h2> A description of the atom(s) '
                            'designated by this atom type. In\n'
                            ' most cases, this will be the element name and oxidation state of\n'
@@ -1224,17 +1324,26 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            '\n'
                            '<h3>Example:</h3>\n'
                            'deuterium\n'
-                           '0.34Fe+0.66Ni</pre>',
+                           '0.34Fe+0.66Ni</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_type_number_in_cell': '<pre><h2>_atom_type_number_in_cell</h2> Total number of atoms of '
-                              'this atom type in the unit cell.</pre>',
+                              'this atom type in the unit cell.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_atom_type_oxidation_number': '<pre><h2>_atom_type_oxidation_number</h2> Formal oxidation state '
-                                'of this atom type in the structure.</pre>',
+                                'of this atom type in the structure.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> -8:8 </p>',
  '_atom_type_radius_bond': '<pre><h2>_atom_type_radius_bond</h2> The effective intra- and '
                            'intermolecular bonding radii in\n'
-                           ' angstroms of this atom type.</pre>',
+                           ' angstroms of this atom type.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:5.0 </p>',
  '_atom_type_radius_contact': '<pre><h2>_atom_type_radius_contact</h2> The effective intra- and '
                               'intermolecular bonding radii in\n'
-                              ' angstroms of this atom type.</pre>',
+                              ' angstroms of this atom type.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:5.0 </p>',
  '_atom_type_scat_Cromer_Mann_a1': '<pre><h2>_atom_type_scat_Cromer_Mann_a1</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1243,7 +1352,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_a2': '<pre><h2>_atom_type_scat_Cromer_Mann_a2</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1252,7 +1362,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_a3': '<pre><h2>_atom_type_scat_Cromer_Mann_a3</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1261,7 +1372,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_a4': '<pre><h2>_atom_type_scat_Cromer_Mann_a4</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1270,7 +1382,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_b1': '<pre><h2>_atom_type_scat_Cromer_Mann_b1</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1279,7 +1392,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_b2': '<pre><h2>_atom_type_scat_Cromer_Mann_b2</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1288,7 +1402,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_b3': '<pre><h2>_atom_type_scat_Cromer_Mann_b3</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1297,7 +1412,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_b4': '<pre><h2>_atom_type_scat_Cromer_Mann_b4</h2> The Cromer-Mann '
                                    'scattering-factor coefficients used to calculate\n'
                                    ' the scattering factors for this atom type.\n'
@@ -1306,7 +1422,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '       Vol. IV, Table 2.2B\n'
                                    ' or   International Tables for Crystallography (2004). Vol. '
                                    'C,\n'
-                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                   '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_Cromer_Mann_c': '<pre><h2>_atom_type_scat_Cromer_Mann_c</h2> The Cromer-Mann '
                                   'scattering-factor coefficients used to calculate\n'
                                   ' the scattering factors for this atom type.\n'
@@ -1314,43 +1431,50 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' Ref: International Tables for X-ray Crystallography (1974). \n'
                                   '       Vol. IV, Table 2.2B\n'
                                   ' or   International Tables for Crystallography (2004). Vol. C,\n'
-                                  '      Tables 6.1.1.4 and 6.1.1.5</pre>',
+                                  '      Tables 6.1.1.4 and 6.1.1.5</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_dispersion_imag': '<pre><h2>_atom_type_scat_dispersion_imag</h2> The imaginary '
                                     'and real components of the anomalous-dispersion\n'
                                     " scattering factor, f'' and f', in electrons for this atom "
                                     'type\n'
                                     ' and the radiation given in '
-                                    '_diffrn_radiation_wavelength.</pre>',
+                                    '_diffrn_radiation_wavelength.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_dispersion_real': '<pre><h2>_atom_type_scat_dispersion_real</h2> The imaginary '
                                     'and real components of the anomalous-dispersion\n'
                                     " scattering factor, f'' and f', in electrons for this atom "
                                     'type\n'
                                     ' and the radiation given in '
-                                    '_diffrn_radiation_wavelength.</pre>',
+                                    '_diffrn_radiation_wavelength.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_dispersion_source': '<pre><h2>_atom_type_scat_dispersion_source</h2> Reference '
                                       'to source of real and imaginary dispersion\n'
                                       ' corrections for scattering factors used for this atom '
                                       'type.\n'
                                       '\n'
                                       '<h3>Example:</h3>\n'
-                                      'International Tables Vol. IV Table 2.3.1</pre>',
+                                      'International Tables Vol. IV Table 2.3.1</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_atom_type_scat_length_neutron': '<pre><h2>_atom_type_scat_length_neutron</h2> The bound '
                                    'coherent scattering length in femtometres for the\n'
                                    ' atom type at the isotopic composition used for the '
                                    'diffraction\n'
-                                   ' experiment.</pre>',
+                                   ' experiment.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_type_scat_source': '<pre><h2>_atom_type_scat_source</h2> Reference to source of scattering '
                            'factors or scattering lengths\n'
                            ' used for this atom type.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'International Tables Vol. IV Table 2.4.6B</pre>',
+                           'International Tables Vol. IV Table 2.4.6B</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_type_scat_versus_stol_list': '<pre><h2>_atom_type_scat_versus_stol_list</h2> A table of '
                                      'scattering factors as a function of sin theta over\n'
                                      ' lambda. This table should be well commented to indicate '
                                      'the\n'
                                      ' items present. Regularly formatted lists are strongly\n'
-                                     ' recommended.</pre>',
+                                     ' recommended.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_type_symbol': '<pre><h2>_atom_type_symbol</h2> The code used to identify the atom species '
                       '(singular or plural)\n'
                       ' representing this atom type. Normally this code is the element\n'
@@ -1363,7 +1487,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       'Cu2+\n'
                       'H(SDS)\n'
                       'dummy\n'
-                      'FeNi</pre>',
+                      'FeNi</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_audit_author_address': '<pre><h2>_audit_author_address</h2> The address of an author of this '
                           'data block. If there are\n'
                           ' multiple authors, _audit_author_address is looped with\n'
@@ -1374,7 +1499,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '          Institute\n'
                           '          Street\n'
                           '          City and postcode\n'
-                          '          COUNTRY</pre>',
+                          '          COUNTRY</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_audit_author_name': '<pre><h2>_audit_author_name</h2> The name of an author of this data block. '
                        'If there are multiple\n'
                        ' authors, _audit_author_name is looped with _audit_author_address.\n'
@@ -1388,12 +1514,14 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        'Yang, D.-L.\n'
                        'Simonov, Yu.A.\n'
                        'M\\"uller, H.A.\n'
-                       'Ross II, C.R.</pre>',
+                       'Ross II, C.R.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_audit_block_code': '<pre><h2>_audit_block_code</h2> A code intended to identify uniquely the '
                       'current data block.\n'
                       '\n'
                       '<h3>Example:</h3>\n'
-                      'TOZ_1991-03-20</pre>',
+                      'TOZ_1991-03-20</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_audit_block_doi': '<pre><h2>_audit_block_doi</h2> The digital object identifier (DOI) '
                      'registered to identify\n'
                      ' the data set publication represented by the current\n'
@@ -1415,16 +1543,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                      ' http://www.doi.org).\n'
                      '\n'
                      '<h3>Example:</h3>\n'
-                     '10.5517/CC6V9DQ</pre>',
+                     '10.5517/CC6V9DQ</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_audit_conform_dict_location': '<pre><h2>_audit_conform_dict_location</h2> A file name or '
                                  'uniform resource locator (URL) for the\n'
-                                 ' dictionary to which the current data block conforms.</pre>',
+                                 ' dictionary to which the current data block conforms.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_audit_conform_dict_name': '<pre><h2>_audit_conform_dict_name</h2> The string identifying the '
                              'highest-level dictionary defining\n'
-                             ' data names used in this file.</pre>',
+                             ' data names used in this file.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_audit_conform_dict_version': '<pre><h2>_audit_conform_dict_version</h2> The version number of '
                                 'the dictionary to which the\n'
-                                ' current data block conforms.</pre>',
+                                ' current data block conforms.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_audit_contact_author_address': '<pre><h2>_audit_contact_author_address</h2> The mailing address '
                                   'of the author of the data block to whom\n'
                                   ' correspondence should be addressed.\n'
@@ -1434,7 +1566,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '          Institute\n'
                                   '          Street\n'
                                   '          City and postcode\n'
-                                  '          COUNTRY</pre>',
+                                  '          COUNTRY</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_audit_contact_author_email': '<pre><h2>_audit_contact_author_email</h2> The electronic mail '
                                 'address of the author of the data block\n'
                                 ' to whom correspondence should be addressed, in a form\n'
@@ -1445,7 +1578,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '\n'
                                 '<h3>Example:</h3>\n'
                                 'name@host.domain.country\n'
-                                'bm@iucr.org</pre>',
+                                'bm@iucr.org</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_audit_contact_author_fax': '<pre><h2>_audit_contact_author_fax</h2> The facsimile telephone '
                               'number of the author of the data\n'
                               ' block to whom correspondence should be addressed.\n'
@@ -1456,7 +1590,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '\n'
                               '<h3>Example:</h3>\n'
                               '12(34)9477334\n'
-                              '12()349477334</pre>',
+                              '12()349477334</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_audit_contact_author_name': '<pre><h2>_audit_contact_author_name</h2> The name of the author of '
                                'the data block to whom correspondence\n'
                                ' should be addressed.\n'
@@ -1471,7 +1606,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                'Yang, D.-L.\n'
                                'Simonov, Yu.A.\n'
                                'M\\"uller, H.A.\n'
-                               'Ross II, C.R.</pre>',
+                               'Ross II, C.R.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_audit_contact_author_phone': '<pre><h2>_audit_contact_author_phone</h2> The telephone number of '
                                 'the author of the data block to whom\n'
                                 ' correspondence should be addressed.\n'
@@ -1485,26 +1621,31 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 '12(34)9477330\n'
                                 '12()349477330\n'
-                                '12(34)9477330x5543</pre>',
+                                '12(34)9477330x5543</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_audit_creation_date': '<pre><h2>_audit_creation_date</h2> The date that the data block was '
                          'created. The date format\n'
                          ' is yyyy-mm-dd.\n'
                          '\n'
                          '<h3>Example:</h3>\n'
-                         '1990-07-12</pre>',
+                         '1990-07-12</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_audit_creation_method': '<pre><h2>_audit_creation_method</h2> A description of how data were '
                            'entered into the data block.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'spawned by the program QBEE</pre>',
+                           'spawned by the program QBEE</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_audit_link_block_code': '<pre><h2>_audit_link_block_code</h2> The value of _audit_block_code '
                            'associated with a data block\n'
                            ' in the current file related to the current data block. The\n'
                            " special value '.' may be used to refer to the current data\n"
-                           ' block for completeness.</pre>',
+                           ' block for completeness.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_audit_link_block_description': '<pre><h2>_audit_link_block_description</h2> A textual '
                                   'description of the relationship of the referenced\n'
-                                  ' data block to the current one.</pre>',
+                                  ' data block to the current one.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_audit_update_record': '<pre><h2>_audit_update_record</h2> A record of any changes to the data '
                          'block. The update format\n'
                          ' is a date (yyyy-mm-dd) followed by a description of the\n'
@@ -1512,7 +1653,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          ' this record.\n'
                          '\n'
                          '<h3>Example:</h3>\n'
-                         '1990-07-15   Updated by the Co-editor</pre>',
+                         '1990-07-15   Updated by the Co-editor</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_cell_angle_alpha': '<pre><h2>_cell_angle_alpha</h2> Unit-cell angles of the reported structure '
                       'in degrees.\n'
                       ' The values of _refln_index_h, *_k, *_l must correspond to the\n'
@@ -1520,7 +1662,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       ' The values of _diffrn_refln_index_h, *_k, *_l may not correspond\n'
                       ' to these values if a cell transformation took place following\n'
                       ' the measurement of the diffraction intensities. See also\n'
-                      ' _diffrn_reflns_transf_matrix_.</pre>',
+                      ' _diffrn_reflns_transf_matrix_.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                      '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_angle_beta': '<pre><h2>_cell_angle_beta</h2> Unit-cell angles of the reported structure in '
                      'degrees.\n'
                      ' The values of _refln_index_h, *_k, *_l must correspond to the\n'
@@ -1528,7 +1673,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                      ' The values of _diffrn_refln_index_h, *_k, *_l may not correspond\n'
                      ' to these values if a cell transformation took place following\n'
                      ' the measurement of the diffraction intensities. See also\n'
-                     ' _diffrn_reflns_transf_matrix_.</pre>',
+                     ' _diffrn_reflns_transf_matrix_.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                     '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                     '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_angle_gamma': '<pre><h2>_cell_angle_gamma</h2> Unit-cell angles of the reported structure '
                       'in degrees.\n'
                       ' The values of _refln_index_h, *_k, *_l must correspond to the\n'
@@ -1536,11 +1684,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       ' The values of _diffrn_refln_index_h, *_k, *_l may not correspond\n'
                       ' to these values if a cell transformation took place following\n'
                       ' the measurement of the diffraction intensities. See also\n'
-                      ' _diffrn_reflns_transf_matrix_.</pre>',
+                      ' _diffrn_reflns_transf_matrix_.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                      '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_formula_units_Z': '<pre><h2>_cell_formula_units_Z</h2> The number of the formula units in '
                           'the unit cell as specified\n'
                           ' by _chemical_formula_structural, _chemical_formula_moiety or\n'
-                          ' _chemical_formula_sum.</pre>',
+                          ' _chemical_formula_sum.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_cell_length_a': '<pre><h2>_cell_length_a</h2> Unit-cell lengths in angstroms corresponding to '
                    'the structure\n'
                    ' reported. The values of _refln_index_h, *_k, *_l must\n'
@@ -1548,7 +1701,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                    ' values. The values of _diffrn_refln_index_h, *_k, *_l may not\n'
                    ' correspond to these values if a cell transformation took place\n'
                    ' following the measurement of the diffraction intensities. See\n'
-                   ' also _diffrn_reflns_transf_matrix_.</pre>',
+                   ' also _diffrn_reflns_transf_matrix_.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_length_b': '<pre><h2>_cell_length_b</h2> Unit-cell lengths in angstroms corresponding to '
                    'the structure\n'
                    ' reported. The values of _refln_index_h, *_k, *_l must\n'
@@ -1556,7 +1711,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                    ' values. The values of _diffrn_refln_index_h, *_k, *_l may not\n'
                    ' correspond to these values if a cell transformation took place\n'
                    ' following the measurement of the diffraction intensities. See\n'
-                   ' also _diffrn_reflns_transf_matrix_.</pre>',
+                   ' also _diffrn_reflns_transf_matrix_.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_length_c': '<pre><h2>_cell_length_c</h2> Unit-cell lengths in angstroms corresponding to '
                    'the structure\n'
                    ' reported. The values of _refln_index_h, *_k, *_l must\n'
@@ -1564,11 +1721,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                    ' values. The values of _diffrn_refln_index_h, *_k, *_l may not\n'
                    ' correspond to these values if a cell transformation took place\n'
                    ' following the measurement of the diffraction intensities. See\n'
-                   ' also _diffrn_reflns_transf_matrix_.</pre>',
+                   ' also _diffrn_reflns_transf_matrix_.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_measurement_pressure': '<pre><h2>_cell_measurement_pressure</h2> The pressure in '
                                'kilopascals at which the unit-cell parameters\n'
                                ' were measured (not the pressure at which the sample was\n'
-                               ' synthesized).</pre>',
+                               ' synthesized).</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_measurement_radiation': '<pre><h2>_cell_measurement_radiation</h2> Description of the '
                                 'radiation used to measure the unit-cell data.\n'
                                 ' See also  _cell_measurement_wavelength.\n'
@@ -1576,39 +1737,54 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'neutron\n'
                                 'Cu K\\a\n'
-                                'synchrotron</pre>',
+                                'synchrotron</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_cell_measurement_refln_index_h': '<pre><h2>_cell_measurement_refln_index_h</h2> Miller indices '
                                     'of a reflection used for measurement of\n'
-                                    ' the unit cell.</pre>',
+                                    ' the unit cell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_measurement_refln_index_k': '<pre><h2>_cell_measurement_refln_index_k</h2> Miller indices '
                                     'of a reflection used for measurement of\n'
-                                    ' the unit cell.</pre>',
+                                    ' the unit cell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_measurement_refln_index_l': '<pre><h2>_cell_measurement_refln_index_l</h2> Miller indices '
                                     'of a reflection used for measurement of\n'
-                                    ' the unit cell.</pre>',
+                                    ' the unit cell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_measurement_refln_theta': '<pre><h2>_cell_measurement_refln_theta</h2> Theta angle in '
                                   'degrees for the reflection used for\n'
                                   ' measurement of the unit cell with the indices\n'
-                                  ' _cell_measurement_refln_index_.</pre>',
+                                  ' _cell_measurement_refln_index_.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_cell_measurement_reflns_used': '<pre><h2>_cell_measurement_reflns_used</h2> The total number of '
                                   'reflections used to determine the unit cell.\n'
                                   ' These reflections may be specified as '
                                   '_cell_measurement_refln_\n'
-                                  ' data items.</pre>',
+                                  ' data items.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_measurement_temperature': '<pre><h2>_cell_measurement_temperature</h2> The temperature in '
                                   'kelvins at which the unit-cell parameters\n'
-                                  ' were measured (not the temperature of synthesis).</pre>',
+                                  ' were measured (not the temperature of synthesis).</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_measurement_theta_max': '<pre><h2>_cell_measurement_theta_max</h2> The maximum and minimum '
                                 'theta angles of reflections\n'
-                                ' used to measure the unit cell in degrees.</pre>',
+                                ' used to measure the unit cell in degrees.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_cell_measurement_theta_min': '<pre><h2>_cell_measurement_theta_min</h2> The maximum and minimum '
                                 'theta angles of reflections\n'
-                                ' used to measure the unit cell in degrees.</pre>',
+                                ' used to measure the unit cell in degrees.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_cell_measurement_wavelength': '<pre><h2>_cell_measurement_wavelength</h2> The wavelength in '
                                  'angstroms of the radiation used to measure\n'
                                  ' the unit cell. If this is not specified, the wavelength is\n'
                                  ' assumed to be the same as that given in\n'
-                                 ' _diffrn_radiation_wavelength.</pre>',
+                                 ' _diffrn_radiation_wavelength.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_reciprocal_angle_alpha': '<pre><h2>_cell_reciprocal_angle_alpha</h2> The angles defining '
                                  'the reciprocal cell in degrees. These\n'
                                  ' are related to those in the real cell by:\n'
@@ -1626,7 +1802,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  'cos(gamma)]/[sin(alpha)*sin(beta)]\n'
                                  '\n'
                                  ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                                 '         New York: John Wiley &amp; Sons Inc.</pre>',
+                                 '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                                 '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_reciprocal_angle_beta': '<pre><h2>_cell_reciprocal_angle_beta</h2> The angles defining the '
                                 'reciprocal cell in degrees. These\n'
                                 ' are related to those in the real cell by:\n'
@@ -1644,7 +1823,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 'cos(gamma)]/[sin(alpha)*sin(beta)]\n'
                                 '\n'
                                 ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                                '         New York: John Wiley &amp; Sons Inc.</pre>',
+                                '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                                '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_reciprocal_angle_gamma': '<pre><h2>_cell_reciprocal_angle_gamma</h2> The angles defining '
                                  'the reciprocal cell in degrees. These\n'
                                  ' are related to those in the real cell by:\n'
@@ -1662,7 +1844,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  'cos(gamma)]/[sin(alpha)*sin(beta)]\n'
                                  '\n'
                                  ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                                 '         New York: John Wiley &amp; Sons Inc.</pre>',
+                                 '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:180.0 </p>\n'
+                                 '<br><p><h4>Default:</h4> 90.0 </p>',
  '_cell_reciprocal_length_a': '<pre><h2>_cell_reciprocal_length_a</h2> The reciprocal-cell lengths '
                               'in inverse angstroms.  These are\n'
                               ' related to the real cell by:\n'
@@ -1676,7 +1861,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               ' where V is the cell volume.\n'
                               '\n'
                               ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                              '         New York: John Wiley &amp; Sons Inc.</pre>',
+                              '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_reciprocal_length_b': '<pre><h2>_cell_reciprocal_length_b</h2> The reciprocal-cell lengths '
                               'in inverse angstroms.  These are\n'
                               ' related to the real cell by:\n'
@@ -1690,7 +1877,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               ' where V is the cell volume.\n'
                               '\n'
                               ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                              '         New York: John Wiley &amp; Sons Inc.</pre>',
+                              '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_reciprocal_length_c': '<pre><h2>_cell_reciprocal_length_c</h2> The reciprocal-cell lengths '
                               'in inverse angstroms.  These are\n'
                               ' related to the real cell by:\n'
@@ -1704,14 +1893,17 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               ' where V is the cell volume.\n'
                               '\n'
                               ' Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n'
-                              '         New York: John Wiley &amp; Sons Inc.</pre>',
+                              '         New York: John Wiley &amp; Sons Inc.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_special_details': '<pre><h2>_cell_special_details</h2> A description of special aspects of '
                           'the cell choice, noting\n'
                           ' possible alternative settings.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
                           'pseudo-orthorhombic\n'
-                          'standard setting from 45 deg rotation around c</pre>',
+                          'standard setting from 45 deg rotation around c</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_cell_volume': '<pre><h2>_cell_volume</h2> Cell volume V in angstroms cubed.\n'
                  '\n'
                  ' V = a b c [1 - cos^2^(alpha) - cos^2^(beta) - cos^2^(gamma)\n'
@@ -1722,7 +1914,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                  ' c     = _cell_length_c\n'
                  ' alpha = _cell_angle_alpha\n'
                  ' beta  = _cell_angle_beta\n'
-                 ' gamma = _cell_angle_gamma</pre>',
+                 ' gamma = _cell_angle_gamma</pre>\n'
+                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_absolute_configuration': '<pre><h2>_chemical_absolute_configuration</h2> Necessary '
                                      'conditions for the assignment of\n'
                                      ' _chemical_absolute_configuration are given by H. D. Flack '
@@ -1781,7 +1975,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '\n'
                                      'None\n'
                                      '\tInapplicable.\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_chemical_compound_source': '<pre><h2>_chemical_compound_source</h2> Description of the source '
                               'of the compound under study, or of the\n'
                               ' parent  molecule if a simple derivative is studied. This includes\n'
@@ -1790,22 +1985,29 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '\n'
                               '<h3>Example:</h3>\n'
                               'From Norilsk (USSR)\n'
-                              'Extracted from the bark of Cinchona Naturalis</pre>',
+                              'Extracted from the bark of Cinchona Naturalis</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_chemical_conn_atom_NCA': '<pre><h2>_chemical_conn_atom_NCA</h2> The number of connected atoms '
-                            'excluding terminal hydrogen atoms.</pre>',
+                            'excluding terminal hydrogen atoms.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_chemical_conn_atom_NH': '<pre><h2>_chemical_conn_atom_NH</h2> The total number of hydrogen '
                            'atoms attached to this atom,\n'
                            ' regardless of whether they are included in the refinement or\n'
                            ' the _atom_site_ list. This number will be the same as\n'
                            ' _atom_site_attached_hydrogens only if none of the hydrogen\n'
-                           ' atoms appear in the _atom_site_ list.</pre>',
+                           ' atoms appear in the _atom_site_ list.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_chemical_conn_atom_charge': '<pre><h2>_chemical_conn_atom_charge</h2>  The net integer charge '
                                'assigned to this atom. This is the\n'
                                ' formal charge assignment normally found in chemical diagrams.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
                                '1\n'
-                               '-1</pre>',
+                               '-1</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> -6:6 </p>',
  '_chemical_conn_atom_display_x': '<pre><h2>_chemical_conn_atom_display_x</h2> The 2D Cartesian '
                                   'coordinates (x,y) of the position of this atom\n'
                                   ' in a recognizable chemical diagram. The coordinate origin is '
@@ -1815,7 +2017,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' vertical. The coordinates must lie in the range 0.0 to 1.0. '
                                   'These\n'
                                   ' coordinates can be obtained from projections of a suitable\n'
-                                  ' uncluttered view of the molecular structure.</pre>',
+                                  ' uncluttered view of the molecular structure.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_chemical_conn_atom_display_y': '<pre><h2>_chemical_conn_atom_display_y</h2> The 2D Cartesian '
                                   'coordinates (x,y) of the position of this atom\n'
                                   ' in a recognizable chemical diagram. The coordinate origin is '
@@ -1825,21 +2029,30 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' vertical. The coordinates must lie in the range 0.0 to 1.0. '
                                   'These\n'
                                   ' coordinates can be obtained from projections of a suitable\n'
-                                  ' uncluttered view of the molecular structure.</pre>',
+                                  ' uncluttered view of the molecular structure.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_chemical_conn_atom_number': '<pre><h2>_chemical_conn_atom_number</h2> The chemical sequence '
-                               'number to be associated with this atom.</pre>',
+                               'number to be associated with this atom.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_chemical_conn_atom_type_symbol': '<pre><h2>_chemical_conn_atom_type_symbol</h2> A code '
                                     'identifying the atom type. This code must match an\n'
                                     ' _atom_type_symbol code in the _atom_type_ list or be a\n'
-                                    ' recognizable element symbol.</pre>',
+                                    ' recognizable element symbol.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_chemical_conn_bond_atom_1': '<pre><h2>_chemical_conn_bond_atom_1</h2> Atom numbers which must '
                                'match with chemical sequence numbers\n'
                                ' specified as _chemical_conn_atom_number values. These link the\n'
-                               ' bond connection to the chemical numbering and atom sites.</pre>',
+                               ' bond connection to the chemical numbering and atom sites.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_chemical_conn_bond_atom_2': '<pre><h2>_chemical_conn_bond_atom_2</h2> Atom numbers which must '
                                'match with chemical sequence numbers\n'
                                ' specified as _chemical_conn_atom_number values. These link the\n'
-                               ' bond connection to the chemical numbering and atom sites.</pre>',
+                               ' bond connection to the chemical numbering and atom sites.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_chemical_conn_bond_type': '<pre><h2>_chemical_conn_bond_type</h2> The chemical bond type '
                              'associated with the connection between\n'
                              ' the two sites _chemical_conn_bond_atom_1 and *_2.\n'
@@ -1868,7 +2081,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '\n'
                              'pi\n'
                              '\tpi bond\n'
-                             '</pre>',
+                             '</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>\n'
+                             '<br><p><h4>Default:</h4> sing </p>',
  '_chemical_enantioexcess_bulk': '<pre><h2>_chemical_enantioexcess_bulk</h2> The enantioexcess of '
                                  'the bulk material from which the \n'
                                  ' crystals were grown. A value of 0.0 indicates the\n'
@@ -1881,7 +2096,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  ' Ref: Moss G. P. et al. (1996). Basic Terminology of\n'
                                  '      Stereochemistry. Pure Appl. Chem., 68, 2193-2222.\n'
-                                 '      http://www.chem.qmul.ac.uk/iupac/stereo/index.html </pre>',
+                                 '      http://www.chem.qmul.ac.uk/iupac/stereo/index.html </pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_chemical_enantioexcess_bulk_technique': '<pre><h2>_chemical_enantioexcess_bulk_technique</h2> '
                                            'The experimental technique used to determine the\n'
                                            ' enantioexcess of the bulk compound.\n'
@@ -1908,7 +2125,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                            '          Enantioexcess determined by \n'
                                            '          a technique not included elsewhere\n'
                                            '          in this list.\n'
-                                           '</pre>',
+                                           '</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_chemical_enantioexcess_crystal': '<pre><h2>_chemical_enantioexcess_crystal</h2> The '
                                     'enantioexcess of the crystal used for the diffraction\n'
                                     ' study. A value of 0.0 indicates the racemate. A value of\n'
@@ -1920,7 +2138,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' Ref: Moss G. P. et al. (1996). Basic Terminology of\n'
                                     '      Stereochemistry. Pure Appl. Chem., 68, 2193-2222.\n'
                                     '      http://www.chem.qmul.ac.uk/iupac/stereo/index.html '
-                                    '</pre>',
+                                    '</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_chemical_enantioexcess_crystal_technique': '<pre><h2>_chemical_enantioexcess_crystal_technique</h2> '
                                               'The experimental technique used to determine the\n'
                                               ' enantioexcess of the crystal.\n'
@@ -1941,7 +2161,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                               '          Enantioexcess determined by \n'
                                               '          a technique not included elsewhere\n'
                                               '          in this list.\n'
-                                              '</pre>',
+                                              '</pre>\n'
+                                              '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_analytical': '<pre><h2>_chemical_formula_analytical</h2> Formula determined by '
                                  'standard chemical analysis including trace\n'
                                  ' elements. See the _chemical_formula_[] category description '
@@ -1951,7 +2172,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  " for standard uncertainties (e.s.d.'s).\n"
                                  '\n'
                                  '<h3>Example:</h3>\n'
-                                 'Fe2.45(2)  Ni1.60(3)  S4</pre>',
+                                 'Fe2.45(2)  Ni1.60(3)  S4</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_iupac': '<pre><h2>_chemical_formula_iupac</h2> Formula expressed in '
                             'conformance with IUPAC rules for inorganic\n'
                             ' and metal-organic compounds where these conflict with the rules\n'
@@ -1964,7 +2186,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '      Oxford: Blackwell Scientific Publications.\n'
                             '\n'
                             '<h3>Example:</h3>\n'
-                            '[Co Re (C12 H22 P)2 (C O)6].0.5C H3 O H</pre>',
+                            '[Co Re (C12 H22 P)2 (C O)6].0.5C H3 O H</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_moiety': '<pre><h2>_chemical_formula_moiety</h2> Formula with each discrete '
                              'bonded residue or ion shown as a\n'
                              ' separate moiety. See the _chemical_formula_[] category \n'
@@ -1985,7 +2208,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              'C7 H4 Cl Hg N O3 S\n'
                              'C12 H17 N4 O S 1+, C6 H2 N3 O7 1-\n'
                              'C12 H16 N2 O6, 5(H2 O1)\n'
-                             '(Cd 2+)3, (C6 N6 Cr 3-)2, 2(H2 O)</pre>',
+                             '(Cd 2+)3, (C6 N6 Cr 3-)2, 2(H2 O)</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_structural': '<pre><h2>_chemical_formula_structural</h2> See the '
                                  '_chemical_formula_[] category description for the rules \n'
                                  ' for writing chemical formulae for inorganics, '
@@ -2002,7 +2226,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  '<h3>Example:</h3>\n'
                                  'Ca ((Cl O3)2 O)2 (H2 O)6\n'
-                                 '(Pt (N H3)2 (C5 H7 N3 O)2) (Cl O4)2</pre>',
+                                 '(Pt (N H3)2 (C5 H7 N3 O)2) (Cl O4)2</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_sum': '<pre><h2>_chemical_formula_sum</h2> See the _chemical_formula_[] '
                           'category description for the rules \n'
                           ' for writing chemical formulae in which all discrete bonded \n'
@@ -2012,15 +2237,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' normally used.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          'C18 H19 N7 O8 S</pre>',
+                          'C18 H19 N7 O8 S</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_chemical_formula_weight': '<pre><h2>_chemical_formula_weight</h2> Formula mass in daltons. This '
                              'mass should correspond to the\n'
                              ' formulae given under _chemical_formula_structural, *_iupac,\n'
                              ' *_moiety or *_sum and, together with the Z value and cell\n'
                              ' parameters, should yield the density given as\n'
-                             ' _exptl_crystal_density_diffrn.</pre>',
+                             ' _exptl_crystal_density_diffrn.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 1.0:∞ </p>',
  '_chemical_formula_weight_meas': '<pre><h2>_chemical_formula_weight_meas</h2> Formula mass in '
-                                  'daltons measured by a non-diffraction experiment.</pre>',
+                                  'daltons measured by a non-diffraction experiment.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 1.0:∞ </p>',
  '_chemical_identifier_inchi': '<pre><h2>_chemical_identifier_inchi</h2> The IUPAC International '
                                'Chemical Identifier (InChI) is\n'
                                ' a textual identifier  for chemical substances, designed \n'
@@ -2033,7 +2263,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '      http://www.iupac.org/inchi/\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               'InChI=1/C10H8/c1-2-6-10-8-4-3-7-9(10)5-1/h1-8H</pre>',
+                               'InChI=1/C10H8/c1-2-6-10-8-4-3-7-9(10)5-1/h1-8H</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_chemical_identifier_inchi_key': '<pre><h2>_chemical_identifier_inchi_key</h2> The InChIKey is a '
                                    'compact hashed version of the full InChI\n'
                                    ' (IUPAC International Chemical Identifier), designed to allow\n'
@@ -2041,16 +2272,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' http://www.iupac.org/inchi/\n'
                                    '\n'
                                    '<h3>Example:</h3>\n'
-                                   'InChIKey=OROGSEYTTFOCAN-DNJOTXNNBG</pre>',
+                                   'InChIKey=OROGSEYTTFOCAN-DNJOTXNNBG</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_chemical_identifier_inchi_version': '<pre><h2>_chemical_identifier_inchi_version</h2> The '
                                        'version number of the InChI standard to which the\n'
                                        ' associated chemical identifier string applies.\n'
                                        '\n'
                                        '<h3>Example:</h3>\n'
-                                       '1.03</pre>',
+                                       '1.03</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_chemical_melting_point': '<pre><h2>_chemical_melting_point</h2> The temperature in kelvins at '
                             'which the crystalline solid changes\n'
-                            ' to a liquid.</pre>',
+                            ' to a liquid.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_melting_point_gt': '<pre><h2>_chemical_melting_point_gt</h2> A temperature in kelvins '
                                'below which (*_lt) or above\n'
                                ' which (*_gt) the melting point (the temperature at which the\n'
@@ -2058,7 +2293,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' range of temperatures to be given.\n'
                                '\n'
                                ' _chemical_melting_point should always be used in preference\n'
-                               ' to these items whenever possible.</pre>',
+                               ' to these items whenever possible.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_melting_point_lt': '<pre><h2>_chemical_melting_point_lt</h2> A temperature in kelvins '
                                'below which (*_lt) or above\n'
                                ' which (*_gt) the melting point (the temperature at which the\n'
@@ -2066,19 +2303,23 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' range of temperatures to be given.\n'
                                '\n'
                                ' _chemical_melting_point should always be used in preference\n'
-                               ' to these items whenever possible.</pre>',
+                               ' to these items whenever possible.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_name_common': '<pre><h2>_chemical_name_common</h2> Trivial name by which the compound '
                           'is commonly known.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          '1-bromoestradiol</pre>',
+                          '1-bromoestradiol</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_chemical_name_mineral': '<pre><h2>_chemical_name_mineral</h2> Mineral name accepted by the '
                            'International Mineralogical\n'
                            ' Association. Use only for natural minerals. See also\n'
                            ' _chemical_compound_source.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'chalcopyrite</pre>',
+                           'chalcopyrite</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_chemical_name_structure_type': '<pre><h2>_chemical_name_structure_type</h2> Commonly used '
                                   'structure-type name. Usually only applied to\n'
                                   ' minerals or inorganic compounds.\n'
@@ -2086,12 +2327,14 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'perovskite\n'
                                   'sphalerite\n'
-                                  'A15</pre>',
+                                  'A15</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_chemical_name_systematic': '<pre><h2>_chemical_name_systematic</h2> IUPAC or Chemical Abstracts '
                               'full name of the compound.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              '1-bromoestra-1,3,5(10)-triene-3,17\\b-diol</pre>',
+                              '1-bromoestra-1,3,5(10)-triene-3,17\\b-diol</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_chemical_optical_rotation': '<pre><h2>_chemical_optical_rotation</h2> The optical rotation in '
                                'solution of the compound is\n'
                                ' specified in the following format:\n'
@@ -2110,7 +2353,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '   SOLV is the chemical formula of the solvent.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               '[\\a]^25^~D~ = +108 (c = 3.42, CHCl~3~)</pre>',
+                               '[\\a]^25^~D~ = +108 (c = 3.42, CHCl~3~)</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_chemical_properties_biological': '<pre><h2>_chemical_properties_biological</h2> A free-text '
                                     'description of the biological properties of the\n'
                                     ' material.\n'
@@ -2128,7 +2372,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     'weakly potent lipoxygenase nonredox inhibitor\n'
                                     'no influenza A virus sialidase inhibitory and\n'
                                     ' plaque reduction activities\n'
-                                    'low toxicity against Drosophila melanogaster</pre>',
+                                    'low toxicity against Drosophila melanogaster</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_chemical_properties_physical': '<pre><h2>_chemical_properties_physical</h2> A free-text '
                                   'description of the physical properties of the\n'
                                   ' material.\n'
@@ -2143,12 +2388,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   'pyrophoric\n'
                                   'semiconductor\n'
                                   'ferromagnetic at low temperature\n'
-                                  'paramagnetic and thermochromic</pre>',
+                                  'paramagnetic and thermochromic</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_chemical_temperature_decomposition': '<pre><h2>_chemical_temperature_decomposition</h2> The '
                                         'temperature in kelvins at which the solid decomposes.\n'
                                         '\n'
                                         '<h3>Example:</h3>\n'
-                                        '350</pre>',
+                                        '350</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_temperature_decomposition_gt': '<pre><h2>_chemical_temperature_decomposition_gt</h2> A '
                                            'temperature in kelvins below which (*_lt) or above '
                                            'which\n'
@@ -2161,7 +2409,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                            ' preference to these items whenever possible.\n'
                                            '\n'
                                            '<h3>Example:</h3>\n'
-                                           '350</pre>',
+                                           '350</pre>\n'
+                                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_temperature_decomposition_lt': '<pre><h2>_chemical_temperature_decomposition_lt</h2> A '
                                            'temperature in kelvins below which (*_lt) or above '
                                            'which\n'
@@ -2174,12 +2424,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                            ' preference to these items whenever possible.\n'
                                            '\n'
                                            '<h3>Example:</h3>\n'
-                                           '350</pre>',
+                                           '350</pre>\n'
+                                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_temperature_sublimation': '<pre><h2>_chemical_temperature_sublimation</h2> The '
                                       'temperature in kelvins at which the solid sublimes.\n'
                                       '\n'
                                       '<h3>Example:</h3>\n'
-                                      '350</pre>',
+                                      '350</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_temperature_sublimation_gt': '<pre><h2>_chemical_temperature_sublimation_gt</h2>A '
                                          'temperature in kelvins below which (*_lt) or above '
                                          'which\n'
@@ -2192,7 +2446,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                          'preference to these items whenever possible.\n'
                                          '\n'
                                          '<h3>Example:</h3>\n'
-                                         '350</pre>',
+                                         '350</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_chemical_temperature_sublimation_lt': '<pre><h2>_chemical_temperature_sublimation_lt</h2>A '
                                          'temperature in kelvins below which (*_lt) or above '
                                          'which\n'
@@ -2205,18 +2461,23 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                          'preference to these items whenever possible.\n'
                                          '\n'
                                          '<h3>Example:</h3>\n'
-                                         '350</pre>',
+                                         '350</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_citation_abstract': '<pre><h2>_citation_abstract</h2> Abstract for the citation. This is used '
                        'most when the\n'
                        ' citation is extracted from a bibliographic database that\n'
-                       ' contains full text or abstract information.</pre>',
+                       ' contains full text or abstract information.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_citation_abstract_id_CAS': '<pre><h2>_citation_abstract_id_CAS</h2> The Chemical Abstracts '
                               'Service (CAS) abstract identifier;\n'
-                              ' relevant for journal articles.</pre>',
+                              ' relevant for journal articles.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_citation_author_citation_id': '<pre><h2>_citation_author_citation_id</h2> The value of '
                                  '_citation_author_citation_id must match an\n'
                                  ' identifier specified by _citation_id in the _citation_ '
-                                 'list.</pre>',
+                                 'list.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_citation_author_name': '<pre><h2>_citation_author_name</h2> Name of an author of the citation; '
                           'relevant for journal\n'
                           ' articles, books and book chapters.\n'
@@ -2231,28 +2492,34 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           'Yang, D.-L.\n'
                           'Simonov, Yu.A.\n'
                           'M\\"uller, H.A.\n'
-                          'Ross II, C.R.</pre>',
+                          'Ross II, C.R.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_citation_author_ordinal': '<pre><h2>_citation_author_ordinal</h2> This data name defines the '
                              "order of the author's name in the\n"
-                             ' list of authors of a citation.</pre>',
+                             ' list of authors of a citation.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_book_id_ISBN': '<pre><h2>_citation_book_id_ISBN</h2> The International Standard Book '
                            'Number (ISBN) code assigned to\n'
-                           ' the book cited;  relevant for books or book chapters.</pre>',
+                           ' the book cited;  relevant for books or book chapters.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_citation_book_publisher': '<pre><h2>_citation_book_publisher</h2> The name of the publisher of '
                              'the citation; relevant\n'
                              ' for books or book chapters.\n'
                              '\n'
                              '<h3>Example:</h3>\n'
-                             'John Wiley</pre>',
+                             'John Wiley</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_book_publisher_city': '<pre><h2>_citation_book_publisher_city</h2> The location of the '
                                   'publisher of the citation; relevant\n'
                                   ' for books or book chapters.\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
-                                  'New York</pre>',
+                                  'New York</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_citation_book_title': '<pre><h2>_citation_book_title</h2> The title of the book in which the '
                          'citation appeared;  relevant\n'
-                         ' for books or book chapters.</pre>',
+                         ' for books or book chapters.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_citation_coordinate_linkage': '<pre><h2>_citation_coordinate_linkage</h2> '
                                  '_citation_coordinate_linkage states whether or not this '
                                  'citation\n'
@@ -2278,23 +2545,28 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  'y\n'
                                  '\tabbreviation for "yes"\n'
-                                 '</pre>',
+                                 '</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_citation_country': '<pre><h2>_citation_country</h2> The country of publication;  relevant for '
                       'books and book\n'
-                      ' chapters.</pre>',
+                      ' chapters.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_citation_database_id_CSD': '<pre><h2>_citation_database_id_CSD</h2>           Identifier '
                               "('refcode') of the database record in the Cambridge\n"
                               '            Structural Database that contains details of the cited '
                               'structure.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              'LEKKUH</pre>',
+                              'LEKKUH</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_citation_database_id_Medline': '<pre><h2>_citation_database_id_Medline</h2> Accession number '
                                   'used by Medline to categorize a specific\n'
                                   ' bibliographic entry.\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
-                                  '89064067</pre>',
+                                  '89064067</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_citation_doi': '<pre><h2>_citation_doi</h2> The Digital Object Identifier (DOI) of the cited '
                   'work.\n'
                   '\n'
@@ -2309,11 +2581,13 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                   ' http://www.doi.org).\n'
                   '\n'
                   '<h3>Example:</h3>\n'
-                  '10.5517/CC6V9DQ</pre>',
+                  '10.5517/CC6V9DQ</pre>\n'
+                  '<br><p><h4>Type:</h4> string</p>',
  '_citation_editor_citation_id': '<pre><h2>_citation_editor_citation_id</h2> The value of '
                                  '_citation_editor_citation_id must match an\n'
                                  ' identifier specified by _citation_id in the _citation_ '
-                                 'list.</pre>',
+                                 'list.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_citation_editor_name': '<pre><h2>_citation_editor_name</h2> Name of an editor of the citation;  '
                           'relevant for books and\n'
                           ' book chapters.\n'
@@ -2328,10 +2602,12 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           'Yang, D.-L.\n'
                           'Simonov, Yu.A.\n'
                           'M\\"uller, H.A.\n'
-                          'Ross II, C.R.</pre>',
+                          'Ross II, C.R.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_citation_editor_ordinal': '<pre><h2>_citation_editor_ordinal</h2> This data name defines the '
                              "order of the editor's name in the\n"
-                             ' list of editors of a citation.</pre>',
+                             ' list of editors of a citation.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_id': '<pre><h2>_citation_id</h2> The value of _citation_id must uniquely identify a '
                  'record in the\n'
                  ' _citation_ list.\n'
@@ -2347,56 +2623,67 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                  'primary\n'
                  '1\n'
                  '2\n'
-                 '3</pre>',
+                 '3</pre>\n'
+                 '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_abbrev': '<pre><h2>_citation_journal_abbrev</h2> Abbreviated name of the '
                              'journal cited as given in the Chemical\n'
                              ' Abstracts Service Source Index.\n'
                              '\n'
                              '<h3>Example:</h3>\n'
-                             'J. Mol. Biol.</pre>',
+                             'J. Mol. Biol.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_full': '<pre><h2>_citation_journal_full</h2> Full name of the journal cited; '
                            'relevant for journal articles.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           'Journal of Molecular Biology</pre>',
+                           'Journal of Molecular Biology</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_id_ASTM': '<pre><h2>_citation_journal_id_ASTM</h2> The American Society for '
                               'Testing and Materials (ASTM) code\n'
                               ' assigned to the journal cited (also referred to as the CODEN\n'
                               ' designator of the Chemical Abstracts Service); relevant for\n'
-                              ' journal articles.</pre>',
+                              ' journal articles.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_id_CSD': '<pre><h2>_citation_journal_id_CSD</h2> The Cambridge Structural '
                              'Database (CSD) code assigned to the\n'
                              ' journal cited; relevant for journal articles. This is also the\n'
                              ' system used at the Protein Data Bank (PDB).\n'
                              '\n'
                              '<h3>Example:</h3>\n'
-                             '0070</pre>',
+                             '0070</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_id_ISSN': '<pre><h2>_citation_journal_id_ISSN</h2> The International Standard '
                               'Serial Number (ISSN) code assigned to\n'
-                              ' the journal cited;  relevant for journal articles.</pre>',
+                              ' the journal cited;  relevant for journal articles.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_issue': '<pre><h2>_citation_journal_issue</h2> Issue number of the journal '
                             'cited;  relevant for journal\n'
                             ' articles.\n'
                             '\n'
                             '<h3>Example:</h3>\n'
-                            '2</pre>',
+                            '2</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_citation_journal_volume': '<pre><h2>_citation_journal_volume</h2> Volume number of the journal '
                              'cited;  relevant for journal\n'
                              ' articles.\n'
                              '\n'
                              '<h3>Example:</h3>\n'
-                             '174</pre>',
+                             '174</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_citation_language': '<pre><h2>_citation_language</h2> Language in which the cited article is '
                        'written.\n'
                        '\n'
                        '<h3>Example:</h3>\n'
-                       'German</pre>',
+                       'German</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_citation_page_first': '<pre><h2>_citation_page_first</h2> The first and last pages of the '
                          'citation;  relevant for\n'
-                         ' journal articles, books and book chapters.</pre>',
+                         ' journal articles, books and book chapters.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_citation_page_last': '<pre><h2>_citation_page_last</h2> The first and last pages of the '
                         'citation;  relevant for\n'
-                        ' journal articles, books and book chapters.</pre>',
+                        ' journal articles, books and book chapters.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_citation_publisher': '<pre><h2>_citation_publisher</h2> The name of the publisher of the cited '
                         'work. This\n'
                         ' should be used for citations of journal articles or\n'
@@ -2405,7 +2692,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                         ' _citation_book_publisher.\n'
                         '\n'
                         '<h3>Example:</h3>\n'
-                        'Cambridge Crystallographic Data Centre</pre>',
+                        'Cambridge Crystallographic Data Centre</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_citation_special_details': '<pre><h2>_citation_special_details</h2> A description of special '
                               'aspects of the relationship\n'
                               ' of the contents of the data block to the literature item cited.\n'
@@ -2414,20 +2702,23 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '          citation relates to this precise coordinate set\n'
                               '         citation relates to earlier low-resolution structure\n'
                               '         citation relates to further refinement of structure\n'
-                              '          reported in citation 2</pre>',
+                              '          reported in citation 2</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_citation_title': '<pre><h2>_citation_title</h2> The title of the citation;  relevant for '
                     'journal articles, books\n'
                     ' and book chapters.\n'
                     '\n'
                     '<h3>Example:</h3>\n'
                     '          Structure of diferric duck ovotransferrin at 2.35 \\%A\n'
-                    '          resolution.</pre>',
+                    '          resolution.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
  '_citation_year': '<pre><h2>_citation_year</h2> The year of the citation;  relevant for journal '
                    'articles, books\n'
                    ' and book chapters.\n'
                    '\n'
                    '<h3>Example:</h3>\n'
-                   '1984</pre>',
+                   '1984</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_computing_cell_refinement': '<pre><h2>_computing_cell_refinement</h2> Software used in the '
                                'processing of the data. Give the program\n'
                                ' or package name and a brief reference.\n'
@@ -2437,7 +2728,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                'CRYSTALS (Watkin, 1988)\n'
-                               'SHELX85 (Sheldrick, 1985)</pre>',
+                               'SHELX85 (Sheldrick, 1985)</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_computing_data_collection': '<pre><h2>_computing_data_collection</h2> Software used in the '
                                'processing of the data. Give the program\n'
                                ' or package name and a brief reference.\n'
@@ -2447,7 +2739,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                'CRYSTALS (Watkin, 1988)\n'
-                               'SHELX85 (Sheldrick, 1985)</pre>',
+                               'SHELX85 (Sheldrick, 1985)</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_computing_data_reduction': '<pre><h2>_computing_data_reduction</h2> Software used in the '
                               'processing of the data. Give the program\n'
                               ' or package name and a brief reference.\n'
@@ -2457,7 +2750,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                               'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                               'CRYSTALS (Watkin, 1988)\n'
-                              'SHELX85 (Sheldrick, 1985)</pre>',
+                              'SHELX85 (Sheldrick, 1985)</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_computing_molecular_graphics': '<pre><h2>_computing_molecular_graphics</h2> Software used in '
                                   'the processing of the data. Give the program\n'
                                   ' or package name and a brief reference.\n'
@@ -2467,7 +2761,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                   'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                   'CRYSTALS (Watkin, 1988)\n'
-                                  'SHELX85 (Sheldrick, 1985)</pre>',
+                                  'SHELX85 (Sheldrick, 1985)</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_computing_publication_material': '<pre><h2>_computing_publication_material</h2> Software used '
                                     'in the processing of the data. Give the program\n'
                                     ' or package name and a brief reference.\n'
@@ -2477,7 +2772,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                     'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                     'CRYSTALS (Watkin, 1988)\n'
-                                    'SHELX85 (Sheldrick, 1985)</pre>',
+                                    'SHELX85 (Sheldrick, 1985)</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_computing_structure_refinement': '<pre><h2>_computing_structure_refinement</h2> Software used '
                                     'in the processing of the data. Give the program\n'
                                     ' or package name and a brief reference.\n'
@@ -2487,7 +2783,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                     'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                     'CRYSTALS (Watkin, 1988)\n'
-                                    'SHELX85 (Sheldrick, 1985)</pre>',
+                                    'SHELX85 (Sheldrick, 1985)</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_computing_structure_solution': '<pre><h2>_computing_structure_solution</h2> Software used in '
                                   'the processing of the data. Give the program\n'
                                   ' or package name and a brief reference.\n'
@@ -2497,11 +2794,13 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   'DIFDAT, SORTRF, ADDREF (Hall &amp; Stewart, 1990)\n'
                                   'FRODO (Jones, 1986), ORTEP (Johnson, 1965)\n'
                                   'CRYSTALS (Watkin, 1988)\n'
-                                  'SHELX85 (Sheldrick, 1985)</pre>',
+                                  'SHELX85 (Sheldrick, 1985)</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_database_CSD_history': '<pre><h2>_database_CSD_history</h2> A history of changes made by the '
                           'Cambridge Crystallographic Data\n'
                           ' Centre and incorporated into the Cambridge Structural Database\n'
-                          ' (CSD).</pre>',
+                          ' (CSD).</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_database_code_CAS': '<pre><h2>_database_code_CAS</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2509,7 +2808,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_COD': '<pre><h2>_database_code_COD</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2517,7 +2817,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_CSD': '<pre><h2>_database_code_CSD</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2525,7 +2826,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_ICSD': '<pre><h2>_database_code_ICSD</h2> The codes are assigned by databases: '
                         'Chemical Abstracts;\n'
                         ' Crystallography Open Database (COD);\n'
@@ -2533,7 +2835,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                         ' compounds); Inorganic Crystal Structure Database; Metals\n'
                         ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                         ' Database (lattice parameters); Protein Data Bank; and the\n'
-                        ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                        ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_database_code_MDF': '<pre><h2>_database_code_MDF</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2541,7 +2844,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_NBS': '<pre><h2>_database_code_NBS</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2549,7 +2853,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_PDB': '<pre><h2>_database_code_PDB</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2557,7 +2862,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_PDF': '<pre><h2>_database_code_PDF</h2> The codes are assigned by databases: '
                        'Chemical Abstracts;\n'
                        ' Crystallography Open Database (COD);\n'
@@ -2565,23 +2871,27 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        ' compounds); Inorganic Crystal Structure Database; Metals\n'
                        ' Data File (metal structures); NBS (NIST) Crystal Data\n'
                        ' Database (lattice parameters); Protein Data Bank; and the\n'
-                       ' Powder Diffraction File (JCPDS/ICDD).</pre>',
+                       ' Powder Diffraction File (JCPDS/ICDD).</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_depnum_ccdc_archive': '<pre><h2>_database_code_depnum_ccdc_archive</h2> '
                                        'Deposition numbers assigned by the Cambridge '
                                        'Crystallographic\n'
                                        ' Data Centre (CCDC) to files containing structural '
                                        'information\n'
-                                       ' archived by the CCDC.</pre>',
+                                       ' archived by the CCDC.</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_database_code_depnum_ccdc_fiz': '<pre><h2>_database_code_depnum_ccdc_fiz</h2> Deposition '
                                    'numbers assigned by the Fachinformationszentrum\n'
                                    ' Karlsruhe (FIZ) to files containing structural information\n'
                                    ' archived by the Cambridge Crystallographic Data Centre '
-                                   '(CCDC).</pre>',
+                                   '(CCDC).</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_database_code_depnum_ccdc_journal': '<pre><h2>_database_code_depnum_ccdc_journal</h2> '
                                        'Deposition numbers assigned by various journals to files\n'
                                        ' containing structural information archived by the '
                                        'Cambridge\n'
-                                       ' Crystallographic Data Centre (CCDC).</pre>',
+                                       ' Crystallographic Data Centre (CCDC).</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_database_dataset_doi': '<pre><h2>_database_dataset_doi</h2> The digital object identifier (DOI) '
                           'registered to identify\n'
                           ' a data set publication associated with the structure\n'
@@ -2600,44 +2910,56 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' http://www.doi.org).\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          '10.2210/pdb4hhb/pdb</pre>',
+                          '10.2210/pdb4hhb/pdb</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_database_journal_ASTM': '<pre><h2>_database_journal_ASTM</h2> The ASTM CODEN designator for a '
                            'journal as given in the\n'
                            ' Chemical Source List maintained by the Chemical Abstracts\n'
                            ' Service, and the journal code used in the Cambridge Structural\n'
-                           ' Database.</pre>',
+                           ' Database.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_database_journal_CSD': '<pre><h2>_database_journal_CSD</h2> The ASTM CODEN designator for a '
                           'journal as given in the\n'
                           ' Chemical Source List maintained by the Chemical Abstracts\n'
                           ' Service, and the journal code used in the Cambridge Structural\n'
-                          ' Database.</pre>',
+                          ' Database.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_ambient_environment': '<pre><h2>_diffrn_ambient_environment</h2> The gas or liquid '
                                 'surrounding the sample, if not air.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
                                 'He\n'
                                 'vacuum\n'
-                                'mother liquor</pre>',
+                                'mother liquor</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_ambient_pressure': '<pre><h2>_diffrn_ambient_pressure</h2> The mean hydrostatic pressure '
                              'in kilopascals at which the\n'
-                             ' intensities were measured.</pre>',
+                             ' intensities were measured.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_ambient_pressure_gt': '<pre><h2>_diffrn_ambient_pressure_gt</h2> The mean hydrostatic '
                                 'pressure in kilopascals above which (*_gt)\n'
                                 ' or below which (*_lt) the intensities were measured. These\n'
                                 ' items allow for a pressure range to be given.\n'
                                 '\n'
                                 ' _diffrn_ambient_pressure should always be used in\n'
-                                ' preference to these items whenever possible.</pre>',
+                                ' preference to these items whenever possible.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_ambient_pressure_lt': '<pre><h2>_diffrn_ambient_pressure_lt</h2> The mean hydrostatic '
                                 'pressure in kilopascals above which (*_gt)\n'
                                 ' or below which (*_lt) the intensities were measured. These\n'
                                 ' items allow for a pressure range to be given.\n'
                                 '\n'
                                 ' _diffrn_ambient_pressure should always be used in\n'
-                                ' preference to these items whenever possible.</pre>',
+                                ' preference to these items whenever possible.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_ambient_temperature': '<pre><h2>_diffrn_ambient_temperature</h2>The mean temperature in '
                                 'kelvins at which the intensities\n'
-                                'were measured.</pre>',
+                                'were measured.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_ambient_temperature_gt': '<pre><h2>_diffrn_ambient_temperature_gt</h2>The mean '
                                    'temperature in kelvins above which (*_gt) or below\n'
                                    'which (*_lt) the intensities were measured.  These items '
@@ -2646,7 +2968,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    '_diffrn_ambient_temperature should always be used in '
                                    'preference\n'
-                                   'to these items whenever possible.</pre>',
+                                   'to these items whenever possible.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_ambient_temperature_lt': '<pre><h2>_diffrn_ambient_temperature_lt</h2>The mean '
                                    'temperature in kelvins above which (*_gt) or below\n'
                                    'which (*_lt) the intensities were measured.  These items '
@@ -2655,18 +2979,24 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    '_diffrn_ambient_temperature should always be used in '
                                    'preference\n'
-                                   'to these items whenever possible.</pre>',
+                                   'to these items whenever possible.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_attenuator_code': '<pre><h2>_diffrn_attenuator_code</h2> A code associated with a '
                             'particular attenuator setting. This code\n'
                             ' is referenced by the _diffrn_refln_attenuator_code which is\n'
-                            ' stored with the intensities. See _diffrn_attenuator_scale.</pre>',
+                            ' stored with the intensities. See _diffrn_attenuator_scale.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_attenuator_material': '<pre><h2>_diffrn_attenuator_material</h2> Material from which the '
-                                'attenuator is made.</pre>',
+                                'attenuator is made.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_attenuator_scale': '<pre><h2>_diffrn_attenuator_scale</h2>  The scale factor applied '
                              'when an intensity measurement is\n'
                              '  reduced by an attenuator identified by _diffrn_attenuator_code.\n'
                              '  The measured intensity must be multiplied by this scale to\n'
-                             '  convert it to the same scale as unattenuated intensities.</pre>',
+                             '  convert it to the same scale as unattenuated intensities.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 1.0:∞ </p>',
  '_diffrn_crystal_treatment': '<pre><h2>_diffrn_crystal_treatment</h2> Remarks about how the '
                               'crystal was treated prior to the intensity\n'
                               ' measurements. Particularly relevant when intensities were\n'
@@ -2675,36 +3005,49 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '<h3>Example:</h3>\n'
                               'equilibrated in hutch for 24 hours\n'
                               'flash frozen in liquid nitrogen\n'
-                              'slow cooled with direct air stream</pre>',
+                              'slow cooled with direct air stream</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_detector': '<pre><h2>_diffrn_detector</h2> The general class of the radiation detector.\n'
                      '\n'
                      '<h3>Example:</h3>\n'
                      'photographic film\n'
                      'scintillation counter\n'
                      'CCD plate\n'
-                     'BF~3~ counter</pre>',
+                     'BF~3~ counter</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_detector_area_resol_mean': '<pre><h2>_diffrn_detector_area_resol_mean</h2> The '
-                                     'resolution of an area detector, in pixels/mm.</pre>',
+                                     'resolution of an area detector, in pixels/mm.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_detector_details': '<pre><h2>_diffrn_detector_details</h2> A description of special '
-                             'aspects of the radiation detector.</pre>',
+                             'aspects of the radiation detector.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_detector_dtime': '<pre><h2>_diffrn_detector_dtime</h2> The deadtime in microseconds of '
                            'the detector used to measure\n'
-                           ' the diffraction intensities.</pre>',
+                           ' the diffraction intensities.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_detector_type': '<pre><h2>_diffrn_detector_type</h2> The make, model or name of the '
-                          'detector device used.</pre>',
+                          'detector device used.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measured_fraction_theta_full': '<pre><h2>_diffrn_measured_fraction_theta_full</h2>         '
                                          'Fraction of unique (symmetry-independent) reflections '
                                          'measured\n'
-                                         '          out to _diffrn_reflns_theta_full.</pre>',
+                                         '          out to _diffrn_reflns_theta_full.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0:1.0 </p>',
  '_diffrn_measured_fraction_theta_max': '<pre><h2>_diffrn_measured_fraction_theta_max</h2>         '
                                         'Fraction of unique (symmetry-independent) reflections '
                                         'measured\n'
-                                        '          out to _diffrn_reflns_theta_max.</pre>',
+                                        '          out to _diffrn_reflns_theta_max.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0:1.0 </p>',
  '_diffrn_measurement_details': '<pre><h2>_diffrn_measurement_details</h2> A description of '
                                 'special aspects of the intensity measurement.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
-                                '440 frames of 0.25\\%</pre>',
+                                '440 frames of 0.25\\%</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measurement_device': '<pre><h2>_diffrn_measurement_device</h2> The general class of '
                                'goniometer or device used to support\n'
                                ' and orient the specimen.\n'
@@ -2714,7 +3057,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                'four-circle diffractometer\n'
                                '\\k-geometry diffractometer\n'
                                'oscillation camera\n'
-                               'precession camera</pre>',
+                               'precession camera</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measurement_device_details': '<pre><h2>_diffrn_measurement_device_details</h2> A '
                                        'description of special aspects of the device used to '
                                        'measure\n'
@@ -2722,15 +3066,18 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                        '\n'
                                        '<h3>Example:</h3>\n'
                                        '     commercial goniometer modified locally to\n'
-                                       '     allow for 90\\% \\t arc</pre>',
+                                       '     allow for 90\\% \\t arc</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measurement_device_type': '<pre><h2>_diffrn_measurement_device_type</h2> The make, model '
                                     'or name of the measurement device\n'
-                                    ' (goniometer) used.</pre>',
+                                    ' (goniometer) used.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measurement_method': '<pre><h2>_diffrn_measurement_method</h2> Method used to measure '
                                'the intensities.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               'profile data from \\q/2\\q scans</pre>',
+                               'profile data from \\q/2\\q scans</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_measurement_specimen_support': '<pre><h2>_diffrn_measurement_specimen_support</h2> The '
                                          'physical device used to support the crystal during data\n'
                                          ' collection.\n'
@@ -2739,121 +3086,149 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                          'glass capillary\n'
                                          'quartz capillary\n'
                                          'fiber\n'
-                                         'metal loop</pre>',
+                                         'metal loop</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_orient_matrix_UB_11': '<pre><h2>_diffrn_orient_matrix_UB_11</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_12': '<pre><h2>_diffrn_orient_matrix_UB_12</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_13': '<pre><h2>_diffrn_orient_matrix_UB_13</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_21': '<pre><h2>_diffrn_orient_matrix_UB_21</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_22': '<pre><h2>_diffrn_orient_matrix_UB_22</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_23': '<pre><h2>_diffrn_orient_matrix_UB_23</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_31': '<pre><h2>_diffrn_orient_matrix_UB_31</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_32': '<pre><h2>_diffrn_orient_matrix_UB_32</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_UB_33': '<pre><h2>_diffrn_orient_matrix_UB_33</h2> The elements of the '
                                 'diffractometer orientation matrix. These\n'
                                 ' define the dimensions of the reciprocal cell and its '
                                 'orientation\n'
                                 ' to the local diffractometer axes. See '
-                                '_diffrn_orient_matrix_type.</pre>',
+                                '_diffrn_orient_matrix_type.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_matrix_type': '<pre><h2>_diffrn_orient_matrix_type</h2> A description of the '
                                'orientation matrix type and how it should\n'
                                ' be applied to define the orientation of the crystal precisely\n'
-                               ' with respect to the diffractometer axes.</pre>',
+                               ' with respect to the diffractometer axes.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_orient_refln_angle_chi': '<pre><h2>_diffrn_orient_refln_angle_chi</h2> Diffractometer '
                                    'angles of a reflection used to define\n'
                                    ' the orientation matrix in degrees. See\n'
                                    ' _diffrn_orient_matrix_UB_ and\n'
-                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_angle_kappa': '<pre><h2>_diffrn_orient_refln_angle_kappa</h2> '
                                      'Diffractometer angles of a reflection used to define\n'
                                      ' the orientation matrix in degrees. See\n'
                                      ' _diffrn_orient_matrix_UB_ and\n'
-                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_angle_omega': '<pre><h2>_diffrn_orient_refln_angle_omega</h2> '
                                      'Diffractometer angles of a reflection used to define\n'
                                      ' the orientation matrix in degrees. See\n'
                                      ' _diffrn_orient_matrix_UB_ and\n'
-                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_angle_phi': '<pre><h2>_diffrn_orient_refln_angle_phi</h2> Diffractometer '
                                    'angles of a reflection used to define\n'
                                    ' the orientation matrix in degrees. See\n'
                                    ' _diffrn_orient_matrix_UB_ and\n'
-                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_angle_psi': '<pre><h2>_diffrn_orient_refln_angle_psi</h2> Diffractometer '
                                    'angles of a reflection used to define\n'
                                    ' the orientation matrix in degrees. See\n'
                                    ' _diffrn_orient_matrix_UB_ and\n'
-                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                   ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_angle_theta': '<pre><h2>_diffrn_orient_refln_angle_theta</h2> '
                                      'Diffractometer angles of a reflection used to define\n'
                                      ' the orientation matrix in degrees. See\n'
                                      ' _diffrn_orient_matrix_UB_ and\n'
-                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>',
+                                     ' _diffrn_orient_refln_index_h, *_k and *_l.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_index_h': '<pre><h2>_diffrn_orient_refln_index_h</h2> The indices of a '
                                  'reflection used to define the orientation\n'
-                                 ' matrix. See _diffrn_orient_matrix_.</pre>',
+                                 ' matrix. See _diffrn_orient_matrix_.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_index_k': '<pre><h2>_diffrn_orient_refln_index_k</h2> The indices of a '
                                  'reflection used to define the orientation\n'
-                                 ' matrix. See _diffrn_orient_matrix_.</pre>',
+                                 ' matrix. See _diffrn_orient_matrix_.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_orient_refln_index_l': '<pre><h2>_diffrn_orient_refln_index_l</h2> The indices of a '
                                  'reflection used to define the orientation\n'
-                                 ' matrix. See _diffrn_orient_matrix_.</pre>',
+                                 ' matrix. See _diffrn_orient_matrix_.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_radiation_collimation': '<pre><h2>_diffrn_radiation_collimation</h2> The collimation or '
                                   'focusing applied to the radiation.\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
                                   '0.3 mm double-pinhole\n'
                                   '0.5 mm\n'
-                                  'focusing mirrors</pre>',
+                                  'focusing mirrors</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_detector': '<pre><h2>_diffrn_radiation_detector</h2> The detector used to '
-                               'measure the diffraction intensities.</pre>',
+                               'measure the diffraction intensities.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_detector_dtime': '<pre><h2>_diffrn_radiation_detector_dtime</h2> The deadtime '
                                      'in microseconds of the detector used to measure\n'
-                                     ' the diffraction intensities.</pre>',
+                                     ' the diffraction intensities.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_radiation_filter_edge': '<pre><h2>_diffrn_radiation_filter_edge</h2> Absorption edge in '
-                                  'angstroms of the radiation filter used.</pre>',
+                                  'angstroms of the radiation filter used.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_radiation_inhomogeneity': '<pre><h2>_diffrn_radiation_inhomogeneity</h2> Half-width in '
                                     'millimetres of the incident beam in the\n'
-                                    ' direction perpendicular to the diffraction plane.</pre>',
+                                    ' direction perpendicular to the diffraction plane.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_radiation_monochromator': '<pre><h2>_diffrn_radiation_monochromator</h2> The method used '
                                     'to obtain monochromatic radiation. If a mono-\n'
                                     ' chromator crystal is used, the material and the indices of '
@@ -2864,12 +3239,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     'Zr filter\n'
                                     'Ge 220\n'
                                     'none\n'
-                                    'equatorial mounted graphite</pre>',
+                                    'equatorial mounted graphite</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_polarisn_norm': '<pre><h2>_diffrn_radiation_polarisn_norm</h2> The angle in '
                                     'degrees, as viewed from the specimen, between the\n'
                                     ' perpendicular component of the polarization and the '
                                     'diffraction\n'
-                                    ' plane. See _diffrn_radiation_polarisn_ratio.</pre>',
+                                    ' plane. See _diffrn_radiation_polarisn_ratio.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_diffrn_radiation_polarisn_ratio': '<pre><h2>_diffrn_radiation_polarisn_ratio</h2> Polarization '
                                      'ratio of the diffraction beam incident on the\n'
                                      ' crystal. It is the ratio of the perpendicularly polarized '
@@ -2880,7 +3258,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      'to\n'
                                      ' the normal to the diffraction plane of the sample (i.e. the '
                                      'plane\n'
-                                     ' containing the incident and reflected beams).</pre>',
+                                     ' containing the incident and reflected beams).</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_radiation_probe': '<pre><h2>_diffrn_radiation_probe</h2>The nature of the radiation used '
                             '(i.e. the name of the\n'
                             'subatomic particle or the region of the electromagnetic\n'
@@ -2891,9 +3271,11 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             'x-ray\n'
                             'neutron\n'
                             'electron\n'
-                            'gamma</pre>',
+                            'gamma</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_source': '<pre><h2>_diffrn_radiation_source</h2> The source of '
-                             'radiation.</pre>',
+                             'radiation.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_type': '<pre><h2>_diffrn_radiation_type</h2> The type of the radiation. This '
                            'is used to give a more\n'
                            ' detailed description than _diffrn_radiation_probe and is\n'
@@ -2904,14 +3286,18 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            'Cu K\\a\n'
                            'Cu K\\a~1~\n'
                            'Cu K-L~2,3~\n'
-                           'white-beam</pre>',
+                           'white-beam</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_wavelength': '<pre><h2>_diffrn_radiation_wavelength</h2> The radiation '
-                                 'wavelength in angstroms.</pre>',
+                                 'wavelength in angstroms.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_radiation_wavelength_details': '<pre><h2>_diffrn_radiation_wavelength_details</h2> '
                                          'Information about the determination of the radiation\n'
                                          ' wavelength that is not conveyed completely by an\n'
                                          ' enumerated value of '
-                                         '_diffrn_radiation_wavelength_determination.</pre>',
+                                         '_diffrn_radiation_wavelength_determination.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_wavelength_determination': '<pre><h2>_diffrn_radiation_wavelength_determination</h2> '
                                                'The method of determination of incident '
                                                'wavelength. \n'
@@ -2930,7 +3316,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                                'refined\n'
                                                '             Based on refinement using a standard\n'
                                                '             material with known cell parameters.\n'
-                                               '</pre>',
+                                               '</pre>\n'
+                                               '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_wavelength_id': '<pre><h2>_diffrn_radiation_wavelength_id</h2> An arbitrary '
                                     'code identifying each value of\n'
                                     ' _diffrn_radiation_wavelength. Items in the DIFFRN_RADIATION\n'
@@ -2942,11 +3329,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     '<h3>Example:</h3>\n'
                                     'x1\n'
                                     'x2\n'
-                                    'neut</pre>',
+                                    'neut</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_radiation_wavelength_wt': '<pre><h2>_diffrn_radiation_wavelength_wt</h2> The relative '
                                     'weight of a wavelength identified by the code\n'
                                     ' _diffrn_radiation_wavelength_id in the list of '
-                                    'wavelengths.</pre>',
+                                    'wavelengths.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:1.0 </p>\n'
+                                    '<br><p><h4>Default:</h4> 1.0 </p>',
  '_diffrn_radiation_xray_symbol': '<pre><h2>_diffrn_radiation_xray_symbol</h2> The IUPAC symbol '
                                   'for the X-ray wavelength for the probe\n'
                                   ' radiation.\n'
@@ -2963,35 +3354,43 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '\n'
                                   'K-L~2,3~\n'
                                   '\tuse where K-L~3~ and K-L~2~ are not resolved\n'
-                                  '</pre>',
+                                  '</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_angle_chi': '<pre><h2>_diffrn_refln_angle_chi</h2> The diffractometer angles of a '
                             'reflection in degrees. These\n'
                             ' correspond to the specified orientation matrix and the original\n'
-                            ' measured cell before any subsequent cell transformations.</pre>',
+                            ' measured cell before any subsequent cell transformations.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_angle_kappa': '<pre><h2>_diffrn_refln_angle_kappa</h2> The diffractometer angles '
                               'of a reflection in degrees. These\n'
                               ' correspond to the specified orientation matrix and the original\n'
-                              ' measured cell before any subsequent cell transformations.</pre>',
+                              ' measured cell before any subsequent cell transformations.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_angle_omega': '<pre><h2>_diffrn_refln_angle_omega</h2> The diffractometer angles '
                               'of a reflection in degrees. These\n'
                               ' correspond to the specified orientation matrix and the original\n'
-                              ' measured cell before any subsequent cell transformations.</pre>',
+                              ' measured cell before any subsequent cell transformations.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_angle_phi': '<pre><h2>_diffrn_refln_angle_phi</h2> The diffractometer angles of a '
                             'reflection in degrees. These\n'
                             ' correspond to the specified orientation matrix and the original\n'
-                            ' measured cell before any subsequent cell transformations.</pre>',
+                            ' measured cell before any subsequent cell transformations.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_angle_psi': '<pre><h2>_diffrn_refln_angle_psi</h2> The diffractometer angles of a '
                             'reflection in degrees. These\n'
                             ' correspond to the specified orientation matrix and the original\n'
-                            ' measured cell before any subsequent cell transformations.</pre>',
+                            ' measured cell before any subsequent cell transformations.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_angle_theta': '<pre><h2>_diffrn_refln_angle_theta</h2> The diffractometer angles '
                               'of a reflection in degrees. These\n'
                               ' correspond to the specified orientation matrix and the original\n'
-                              ' measured cell before any subsequent cell transformations.</pre>',
+                              ' measured cell before any subsequent cell transformations.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_attenuator_code': '<pre><h2>_diffrn_refln_attenuator_code</h2> The code '
                                   'identifying the attenuator setting for this reflection.\n'
                                   ' This code must match one of the _diffrn_attenuator_code '
-                                  'values.</pre>',
+                                  'values.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_class_code': '<pre><h2>_diffrn_refln_class_code</h2> The code identifying the '
                              'class to which this reflection has\n'
                              ' been assigned. This code must match a value of\n'
@@ -3000,81 +3399,104 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' structures each reflection class may be defined by the\n'
                              ' number m=sum|m~i~|, where the m~i~ are the integer coefficients\n'
                              ' that, in addition to h,k,l, index the corresponding diffraction\n'
-                             ' vector in the basis defined for the reciprocal lattice.</pre>',
+                             ' vector in the basis defined for the reciprocal lattice.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_counts_bg_1': '<pre><h2>_diffrn_refln_counts_bg_1</h2> The diffractometer counts '
                               'for the measurements: background\n'
                               ' before the peak, background after the peak, net counts after\n'
                               ' background removed, counts for peak scan or position, and the\n'
-                              ' total counts (background plus peak).</pre>',
+                              ' total counts (background plus peak).</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_counts_bg_2': '<pre><h2>_diffrn_refln_counts_bg_2</h2> The diffractometer counts '
                               'for the measurements: background\n'
                               ' before the peak, background after the peak, net counts after\n'
                               ' background removed, counts for peak scan or position, and the\n'
-                              ' total counts (background plus peak).</pre>',
+                              ' total counts (background plus peak).</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_counts_net': '<pre><h2>_diffrn_refln_counts_net</h2> The diffractometer counts for '
                              'the measurements: background\n'
                              ' before the peak, background after the peak, net counts after\n'
                              ' background removed, counts for peak scan or position, and the\n'
-                             ' total counts (background plus peak).</pre>',
+                             ' total counts (background plus peak).</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_counts_peak': '<pre><h2>_diffrn_refln_counts_peak</h2> The diffractometer counts '
                               'for the measurements: background\n'
                               ' before the peak, background after the peak, net counts after\n'
                               ' background removed, counts for peak scan or position, and the\n'
-                              ' total counts (background plus peak).</pre>',
+                              ' total counts (background plus peak).</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_counts_total': '<pre><h2>_diffrn_refln_counts_total</h2> The diffractometer counts '
                                'for the measurements: background\n'
                                ' before the peak, background after the peak, net counts after\n'
                                ' background removed, counts for peak scan or position, and the\n'
-                               ' total counts (background plus peak).</pre>',
+                               ' total counts (background plus peak).</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_crystal_id': '<pre><h2>_diffrn_refln_crystal_id</h2> Code identifying each crystal '
                              'if multiple crystals are used. Is\n'
                              ' used to link with _exptl_crystal_id in the _exptl_crystal_ '
-                             'list.</pre>',
+                             'list.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_detect_slit_horiz': '<pre><h2>_diffrn_refln_detect_slit_horiz</h2> Total slit '
                                     'apertures in degrees in the diffraction plane\n'
                                     ' (*_horiz) and perpendicular to the diffraction plane '
-                                    '(*_vert).</pre>',
+                                    '(*_vert).</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_refln_detect_slit_vert': '<pre><h2>_diffrn_refln_detect_slit_vert</h2> Total slit '
                                    'apertures in degrees in the diffraction plane\n'
                                    ' (*_horiz) and perpendicular to the diffraction plane '
-                                   '(*_vert).</pre>',
+                                   '(*_vert).</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_refln_elapsed_time': '<pre><h2>_diffrn_refln_elapsed_time</h2> Elapsed time in minutes '
                                'from the start of the diffraction\n'
-                               ' experiment to the measurement of this intensity.</pre>',
+                               ' experiment to the measurement of this intensity.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_refln_index_h': '<pre><h2>_diffrn_refln_index_h</h2> Miller indices of a measured '
                           'reflection. These need not match\n'
                           ' the _refln_index_h, *_k, *_l values if a transformation of the\n'
                           ' original measured cell has taken place. Details of the cell\n'
                           ' transformation are given in _diffrn_reflns_reduction_process.\n'
-                          ' See also _diffrn_reflns_transf_matrix_.</pre>',
+                          ' See also _diffrn_reflns_transf_matrix_.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_k': '<pre><h2>_diffrn_refln_index_k</h2> Miller indices of a measured '
                           'reflection. These need not match\n'
                           ' the _refln_index_h, *_k, *_l values if a transformation of the\n'
                           ' original measured cell has taken place. Details of the cell\n'
                           ' transformation are given in _diffrn_reflns_reduction_process.\n'
-                          ' See also _diffrn_reflns_transf_matrix_.</pre>',
+                          ' See also _diffrn_reflns_transf_matrix_.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_l': '<pre><h2>_diffrn_refln_index_l</h2> Miller indices of a measured '
                           'reflection. These need not match\n'
                           ' the _refln_index_h, *_k, *_l values if a transformation of the\n'
                           ' original measured cell has taken place. Details of the cell\n'
                           ' transformation are given in _diffrn_reflns_reduction_process.\n'
-                          ' See also _diffrn_reflns_transf_matrix_.</pre>',
+                          ' See also _diffrn_reflns_transf_matrix_.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_intensity_net': '<pre><h2>_diffrn_refln_intensity_net</h2> Net intensity '
                                 'calculated from the diffraction counts after\n'
-                                ' the attenuator and standard scales have been applied.</pre>',
+                                ' the attenuator and standard scales have been applied.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_refln_intensity_sigma': '<pre><h2>_diffrn_refln_intensity_sigma</h2> Standard '
                                   'uncertainty (e.s.d.) of the net intensity calculated\n'
                                   ' from the diffraction counts after the attenuator and standard\n'
-                                  ' scales have been applied.</pre>',
+                                  ' scales have been applied.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_refln_intensity_u': '<pre><h2>_diffrn_refln_intensity_u</h2> Standard uncertainty of the '
                               'net intensity calculated from\n'
                               ' the diffraction counts after the attenuator and standard\n'
-                              ' scales have been applied.</pre>',
+                              ' scales have been applied.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_refln_scale_group_code': '<pre><h2>_diffrn_refln_scale_group_code</h2> The code '
                                    'identifying the scale applicable to this reflection.\n'
                                    ' This code must match with a specified '
                                    '_diffrn_scale_group_code\n'
-                                   ' value.</pre>',
+                                   ' value.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_scan_mode': '<pre><h2>_diffrn_refln_scan_mode</h2> The code identifying the mode '
                             'of scanning for measurements\n'
                             ' using a diffractometer. See _diffrn_refln_scan_width and\n'
@@ -3089,7 +3511,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '\n'
                             'q\n'
                             '\tQ scans (arbitrary reciprocal directions)\n'
-                            '</pre>',
+                            '</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_scan_mode_backgd': '<pre><h2>_diffrn_refln_scan_mode_backgd</h2> The code '
                                    'identifying the mode of scanning a reflection to measure\n'
                                    ' the background intensity.\n'
@@ -3100,18 +3523,27 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    'mo\n'
                                    '\tmoving counter background\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_scan_rate': '<pre><h2>_diffrn_refln_scan_rate</h2> The rate of scanning a '
                             'reflection in\n'
-                            ' degrees per minute to measure the intensity.</pre>',
+                            ' degrees per minute to measure the intensity.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_refln_scan_time_backgd': '<pre><h2>_diffrn_refln_scan_time_backgd</h2> The time spent '
-                                   'measuring each background in seconds.</pre>',
+                                   'measuring each background in seconds.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_refln_scan_width': '<pre><h2>_diffrn_refln_scan_width</h2> The scan width in degrees of '
                              'the scan mode defined by the code\n'
-                             ' _diffrn_refln_scan_mode.</pre>',
+                             ' _diffrn_refln_scan_mode.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_refln_sint/lambda': '<pre><h2>_diffrn_refln_sint/lambda</h2> The (sin theta)/lambda '
                               'value in reciprocal angstroms for\n'
-                              ' this reflection.</pre>',
+                              ' this reflection.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_refln_standard_code': '<pre><h2>_diffrn_refln_standard_code</h2> A code indicating that '
                                 'this reflection was measured as a\n'
                                 " standard reflection. The value must be '.' or match one of\n"
@@ -3126,19 +3558,23 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 's3\n'
                                 'A\n'
                                 'B\n'
-                                'C</pre>',
+                                'C</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_wavelength': '<pre><h2>_diffrn_refln_wavelength</h2> The mean wavelength in '
                              'angstroms of the radiation used to measure\n'
                              ' the intensity of this reflection. This is an important parameter\n'
                              ' for reflections measured using energy-dispersive detectors or the\n'
-                             ' Laue method.</pre>',
+                             ' Laue method.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_refln_wavelength_id': '<pre><h2>_diffrn_refln_wavelength_id</h2> Code identifying the '
                                 'wavelength in the _diffrn_radiation_ list.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
                                 'x1\n'
                                 'x2\n'
-                                'neut</pre>',
+                                'neut</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_reflns_Laue_measured_fraction_full': '<pre><h2>_diffrn_reflns_Laue_measured_fraction_full</h2> '
                                                'Fraction of Laue unique reflections '
                                                '(symmetry-independent in\n'
@@ -3157,7 +3593,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                                ' the fraction of reflections measured in the part '
                                                'of the\n'
                                                ' diffraction pattern that is essentially '
-                                               'complete.</pre>',
+                                               'complete.</pre>\n'
+                                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                               '<br><p><h4>Limits:</h4> 0.95:1.0 </p>',
  '_diffrn_reflns_Laue_measured_fraction_max': '<pre><h2>_diffrn_reflns_Laue_measured_fraction_max</h2> '
                                               'Fraction of Laue unique reflections '
                                               '(symmetry-independent in\n'
@@ -3170,79 +3608,109 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                               ' reflection h,k,l is always equivalent to the '
                                               'reflection -h,-k,-l\n'
                                               ' even in space groups without a centre of '
-                                              'symmetry.</pre>',
+                                              'symmetry.</pre>\n'
+                                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                              '<br><p><h4>Limits:</h4> 0:1.0 </p>',
  '_diffrn_reflns_av_R_equivalents': '<pre><h2>_diffrn_reflns_av_R_equivalents</h2> The residual '
                                     '[sum av|del(I)| / sum |av(I)|] for\n'
                                     ' symmetry-equivalent reflections used to calculate the\n'
                                     ' average intensity av(I). The av|del(I)| term is the\n'
                                     ' average absolute difference between av(I) and the\n'
-                                    ' individual symmetry-equivalent intensities.</pre>',
+                                    ' individual symmetry-equivalent intensities.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_av_sigmaI/netI': '<pre><h2>_diffrn_reflns_av_sigmaI/netI</h2> Measure [sum |u(net '
-                                  'I)|/sum|net I|] for all measured reflections.</pre>',
+                                  'I)|/sum|net I|] for all measured reflections.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_av_unetI/netI': '<pre><h2>_diffrn_reflns_av_unetI/netI</h2> Measure [sum |u(net '
-                                 'I)|/sum|net I|] for all measured reflections.</pre>',
+                                 'I)|/sum|net I|] for all measured reflections.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_av_R_eq': '<pre><h2>_diffrn_reflns_class_av_R_eq</h2> For each reflection '
                                  'class, the residual\n'
                                  ' [sum av|del(I)|/sum|av(I)|] for symmetry-equivalent '
                                  'reflections\n'
                                  ' used to calculate the average intensity av(I). The av|del(I)|\n'
                                  ' term is the average absolute difference between av(I) and the\n'
-                                 ' individual intensities.</pre>',
+                                 ' individual intensities.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_av_sgI/I': '<pre><h2>_diffrn_reflns_class_av_sgI/I</h2> Measure [sum|u(net '
                                   'I)|/sum|net I|] for all measured intensities\n'
-                                  ' in a reflection class.</pre>',
+                                  ' in a reflection class.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_av_uI/I': '<pre><h2>_diffrn_reflns_class_av_uI/I</h2> Measure [sum|u(net '
                                  'I)|/sum|net I|] for all measured intensities\n'
-                                 ' in a reflection class.</pre>',
+                                 ' in a reflection class.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_code': '<pre><h2>_diffrn_reflns_class_code</h2> The code identifying a '
                               'certain reflection class.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
                               '1\n'
                               'm1\n'
-                              's2</pre>',
+                              's2</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_reflns_class_d_res_high': '<pre><h2>_diffrn_reflns_class_d_res_high</h2> The smallest '
                                     'value in angstroms of the interplanar\n'
                                     ' spacings of the reflections in each reflection class.\n'
                                     ' This is called the highest resolution for this reflection '
-                                    'class.</pre>',
+                                    'class.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_d_res_low': '<pre><h2>_diffrn_reflns_class_d_res_low</h2> The highest value '
                                    'in angstroms of the interplanar\n'
                                    ' spacings of the reflections in each reflection class.\n'
                                    ' This is called the lowest resolution for this reflection '
-                                   'class.</pre>',
+                                   'class.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_class_description': '<pre><h2>_diffrn_reflns_class_description</h2> Description '
                                      'of each reflection class.\n'
                                      '\n'
                                      '<h3>Example:</h3>\n'
                                      'm=1 first order satellites\n'
-                                     'H0L0 common projection reflections</pre>',
+                                     'H0L0 common projection reflections</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_reflns_class_number': '<pre><h2>_diffrn_reflns_class_number</h2> The total number of '
                                 'measured intensities for each reflection\n'
                                 ' class, excluding the systematic absences arising from\n'
-                                ' centring translations.</pre>',
+                                ' centring translations.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_reflns_limit_h_max': '<pre><h2>_diffrn_reflns_limit_h_max</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_h_min': '<pre><h2>_diffrn_reflns_limit_h_min</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_k_max': '<pre><h2>_diffrn_reflns_limit_k_max</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_k_min': '<pre><h2>_diffrn_reflns_limit_k_min</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_l_max': '<pre><h2>_diffrn_reflns_limit_l_max</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_l_min': '<pre><h2>_diffrn_reflns_limit_l_min</h2> The limits on the Miller '
                                'indices of the intensities specified\n'
-                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>',
+                               ' by _diffrn_refln_index_h, *_k, *_l.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_number': '<pre><h2>_diffrn_reflns_number</h2> The total number of measured '
                           'intensities, excluding\n'
                           ' reflections that are classed as systematically absent arising\n'
-                          ' from translational symmetry in the crystal unit cell.</pre>',
+                          ' from translational symmetry in the crystal unit cell.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_reflns_point_group_measured_fraction_full': '<pre><h2>_diffrn_reflns_point_group_measured_fraction_full</h2> '
                                                       'Fraction of crystal point-group unique '
                                                       'reflections (i.e.\n'
@@ -3260,7 +3728,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                                       'fraction of reflections\n'
                                                       ' measured in the part of the diffraction '
                                                       'pattern that is\n'
-                                                      ' essentially complete.</pre>',
+                                                      ' essentially complete.</pre>\n'
+                                                      '<br><p><h4>Type:</h4> number (int or '
+                                                      'float)</p>\n'
+                                                      '<br><p><h4>Limits:</h4> 0.95:1.0 </p>',
  '_diffrn_reflns_point_group_measured_fraction_max': '<pre><h2>_diffrn_reflns_point_group_measured_fraction_max</h2> '
                                                      'Fraction of crystal point-group unique '
                                                      'reflections (i.e.\n'
@@ -3272,102 +3743,127 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                                      'groups that do not\n'
                                                      ' contain a centre of symmetry the '
                                                      'reflections h,k,l and\n'
-                                                     ' -h,-k,-l are independent.</pre>',
+                                                     ' -h,-k,-l are independent.</pre>\n'
+                                                     '<br><p><h4>Type:</h4> number (int or '
+                                                     'float)</p>\n'
+                                                     '<br><p><h4>Limits:</h4> 0:1.0 </p>',
  '_diffrn_reflns_reduction_process': '<pre><h2>_diffrn_reflns_reduction_process</h2> A description '
                                      'of the process used to reduce the intensities\n'
                                      ' into structure-factor magnitudes.\n'
                                      '\n'
                                      '<h3>Example:</h3>\n'
-                                     'data averaged using Fisher test</pre>',
+                                     'data averaged using Fisher test</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_reflns_resolution_full': '<pre><h2>_diffrn_reflns_resolution_full</h2> The resolution in '
                                    'reciprocal angstroms at which the measured\n'
                                    ' reflection count is close to complete. The fraction of '
                                    'unique\n'
                                    ' reflections measured out to this angle is given by\n'
-                                   ' _diffrn_measured_fraction_theta_full.</pre>',
+                                   ' _diffrn_measured_fraction_theta_full.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_resolution_max': '<pre><h2>_diffrn_reflns_resolution_max</h2> Maximum resolution '
                                   'in reciprocal angstroms of the measured\n'
                                   ' diffraction pattern. The fraction of unique reflections\n'
                                   ' measured out to this angle is given by\n'
-                                  ' _diffrn_measured_fraction_theta_max</pre>',
+                                  ' _diffrn_measured_fraction_theta_max</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_reflns_theta_full': '<pre><h2>_diffrn_reflns_theta_full</h2> The theta angle (in '
                               'degrees) at which the measured reflection\n'
                               ' count is close to complete. The fraction of unique reflections\n'
                               ' measured out to this angle is given by\n'
-                              ' _diffrn_measured_fraction_theta_full.</pre>',
+                              ' _diffrn_measured_fraction_theta_full.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_reflns_theta_max': '<pre><h2>_diffrn_reflns_theta_max</h2> Maximum theta angle in '
                              'degrees for the measured intensities.\n'
                              ' The fraction of unique reflections measured out to this angle\n'
-                             ' is given by _diffrn_measured_fraction_theta_max</pre>',
+                             ' is given by _diffrn_measured_fraction_theta_max</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_reflns_theta_min': '<pre><h2>_diffrn_reflns_theta_min</h2> Minimum theta angle in '
-                             'degrees for the measured intensities.</pre>',
+                             'degrees for the measured intensities.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:90.0 </p>',
  '_diffrn_reflns_transf_matrix_11': '<pre><h2>_diffrn_reflns_transf_matrix_11</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_12': '<pre><h2>_diffrn_reflns_transf_matrix_12</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_13': '<pre><h2>_diffrn_reflns_transf_matrix_13</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_21': '<pre><h2>_diffrn_reflns_transf_matrix_21</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_22': '<pre><h2>_diffrn_reflns_transf_matrix_22</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_23': '<pre><h2>_diffrn_reflns_transf_matrix_23</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_31': '<pre><h2>_diffrn_reflns_transf_matrix_31</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_32': '<pre><h2>_diffrn_reflns_transf_matrix_32</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_transf_matrix_33': '<pre><h2>_diffrn_reflns_transf_matrix_33</h2> Elements of the '
                                     'matrix used to transform the diffraction\n'
                                     ' reflection indices _diffrn_refln_index_h, *_k, *_l into the\n'
                                     ' _refln_index_h, *_k, *_l indices.\n'
                                     '                            |11 12 13|\n'
                                     "       (h k l) diffraction  |21 22 23|  =  (h' k' l')\n"
-                                    '                            |31 32 33|</pre>',
+                                    '                            |31 32 33|</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_scale_group_I_net': '<pre><h2>_diffrn_scale_group_I_net</h2> The scale for a specific '
                               'measurement group which is to be\n'
                               ' multiplied with the net intensity to place all intensities\n'
-                              ' in the _diffrn_refln_ or _refln_ list on a common scale.</pre>',
+                              ' in the _diffrn_refln_ or _refln_ list on a common scale.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_scale_group_code': '<pre><h2>_diffrn_scale_group_code</h2> The code identifying a '
                              'specific measurement group (e.g. for\n'
                              ' multi-film or multi-crystal data). The code must match a\n'
@@ -3382,7 +3878,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              'B\n'
                              'c1\n'
                              'c2\n'
-                             'c3</pre>',
+                             'c3</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source': '<pre><h2>_diffrn_source</h2> The general class of the source of radiation.\n'
                    '\n'
                    '<h3>Example:</h3>\n'
@@ -3391,28 +3888,37 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                    'spallation source\n'
                    'electron microscope\n'
                    'rotating-anode X-ray tube\n'
-                   'synchrotron</pre>',
+                   'synchrotron</pre>\n'
+                   '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source_current': '<pre><h2>_diffrn_source_current</h2> The current in milliamperes at '
                            'which the radiation source was\n'
-                           ' operated.</pre>',
+                           ' operated.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_source_details': '<pre><h2>_diffrn_source_details</h2> A description of special aspects '
-                           'of the source.</pre>',
+                           'of the source.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source_power': '<pre><h2>_diffrn_source_power</h2> The power in kilowatts at which the '
                          'radiation source was\n'
-                         ' operated.</pre>',
+                         ' operated.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_source_size': '<pre><h2>_diffrn_source_size</h2> The dimensions of the source as viewed '
                         'from the sample.\n'
                         '\n'
                         '<h3>Example:</h3>\n'
                         '8mm x 0.4 mm fine-focus\n'
-                        'broad focus</pre>',
+                        'broad focus</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source_take-off_angle': '<pre><h2>_diffrn_source_take-off_angle</h2> The complement of '
                                   'the angle in degrees between the normal\n'
                                   ' to the surface of the X-ray tube target and the primary\n'
                                   ' X-ray beam for beams generated by traditional X-ray tubes.\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
-                                  '1.53</pre>',
+                                  '1.53</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:90 </p>',
  '_diffrn_source_target': '<pre><h2>_diffrn_source_target</h2> The chemical element symbol for the '
                           'X-ray target\n'
                           ' (usually the anode) used to generate X-rays.\n'
@@ -3521,16 +4027,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           'Fm\n'
                           'Md\n'
                           'No\n'
-                          'Lr</pre>',
+                          'Lr</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source_type': '<pre><h2>_diffrn_source_type</h2> The make, model or name of the source '
                         'of radiation.\n'
                         '\n'
                         '<h3>Example:</h3>\n'
                         'NSLS beamline X8C\n'
-                        'Rigaku RU200</pre>',
+                        'Rigaku RU200</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_source_voltage': '<pre><h2>_diffrn_source_voltage</h2> The voltage in kilovolts at which '
                            'the radiation source was\n'
-                           ' operated.</pre>',
+                           ' operated.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_special_details': '<pre><h2>_diffrn_special_details</h2> Special details of the '
                             'intensity-measurement process. Should\n'
                             ' include information about source instability, crystal motion,\n'
@@ -3539,7 +4049,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '<h3>Example:</h3>\n'
                             ' The results may not be entirely reliable\n'
                             ' as the measurement was made during a heat\n'
-                            ' wave when the air-conditioning had failed.</pre>',
+                            ' wave when the air-conditioning had failed.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_standard_refln_code': '<pre><h2>_diffrn_standard_refln_code</h2> The code identifying a '
                                 'reflection measured as a standard\n'
                                 ' reflection with the indices _diffrn_standard_refln_index_.\n'
@@ -3552,16 +4063,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '3\n'
                                 's1\n'
                                 'A\n'
-                                'B</pre>',
+                                'B</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_standard_refln_index_h': '<pre><h2>_diffrn_standard_refln_index_h</h2> Miller indices of '
                                    'standard reflections used in the diffraction\n'
-                                   ' measurement process.</pre>',
+                                   ' measurement process.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_k': '<pre><h2>_diffrn_standard_refln_index_k</h2> Miller indices of '
                                    'standard reflections used in the diffraction\n'
-                                   ' measurement process.</pre>',
+                                   ' measurement process.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_l': '<pre><h2>_diffrn_standard_refln_index_l</h2> Miller indices of '
                                    'standard reflections used in the diffraction\n'
-                                   ' measurement process.</pre>',
+                                   ' measurement process.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standards_decay_%': '<pre><h2>_diffrn_standards_decay_%</h2> The percentage decrease in '
                               'the mean\n'
                               ' intensity of the set of standard reflections measured at the\n'
@@ -3579,33 +4094,48 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '<h3>Example:</h3>\n'
                               '0.5(1)\n'
                               '-1(1)\n'
-                              '0.0(2)</pre>',
+                              '0.0(2)</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> :100 </p>',
  '_diffrn_standards_interval_count': '<pre><h2>_diffrn_standards_interval_count</h2> The number of '
                                      'reflection intensities, or the time in minutes,\n'
                                      ' between the measurement of standard reflection '
-                                     'intensities.</pre>',
+                                     'intensities.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_standards_interval_time': '<pre><h2>_diffrn_standards_interval_time</h2> The number of '
                                     'reflection intensities, or the time in minutes,\n'
                                     ' between the measurement of standard reflection '
-                                    'intensities.</pre>',
+                                    'intensities.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_standards_number': '<pre><h2>_diffrn_standards_number</h2> The number of unique standard '
                              'reflections used during the\n'
-                             ' measurement of the diffraction intensities.</pre>',
+                             ' measurement of the diffraction intensities.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_diffrn_standards_scale_sigma': '<pre><h2>_diffrn_standards_scale_sigma</h2> The standard '
                                   'uncertainty (e.s.d.) of the individual mean\n'
-                                  ' standard scales applied to the intensity data.</pre>',
+                                  ' standard scales applied to the intensity data.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_standards_scale_u': '<pre><h2>_diffrn_standards_scale_u</h2> The standard uncertainty of '
                               'the individual mean\n'
-                              ' standard scales applied to the intensity data.</pre>',
+                              ' standard scales applied to the intensity data.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_diffrn_symmetry_description': '<pre><h2>_diffrn_symmetry_description</h2> Observed diffraction '
                                  'point symmetry, systematic absences and\n'
                                  ' possible space group(s) or superspace group(s) compatible with\n'
-                                 ' these.</pre>',
+                                 ' these.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_exptl_absorpt_coefficient_mu': '<pre><h2>_exptl_absorpt_coefficient_mu</h2> The absorption '
                                   'coefficient mu in reciprocal millimetres\n'
                                   ' calculated from the atomic content of the cell, the density '
                                   'and\n'
-                                  ' the radiation wavelength.</pre>',
+                                  ' the radiation wavelength.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_absorpt_correction_T_max': '<pre><h2>_exptl_absorpt_correction_T_max</h2> The maximum and '
                                     'minimum transmission factors applied to the\n'
                                     ' diffraction pattern measured in this experiment. These\n'
@@ -3613,7 +4143,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' A or 1/A*. As this value is the one that is applied to\n'
                                     ' the measured intensities, it includes the correction for\n'
                                     ' absorption by the specimen mount and diffractometer as well\n'
-                                    ' as by the specimen itself.</pre>',
+                                    ' as by the specimen itself.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_exptl_absorpt_correction_T_min': '<pre><h2>_exptl_absorpt_correction_T_min</h2> The maximum and '
                                     'minimum transmission factors applied to the\n'
                                     ' diffraction pattern measured in this experiment. These\n'
@@ -3621,7 +4153,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' A or 1/A*. As this value is the one that is applied to\n'
                                     ' the measured intensities, it includes the correction for\n'
                                     ' absorption by the specimen mount and diffractometer as well\n'
-                                    ' as by the specimen itself.</pre>',
+                                    ' as by the specimen itself.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_exptl_absorpt_correction_type': '<pre><h2>_exptl_absorpt_correction_type</h2> The '
                                    "absorption-correction type and method. The value 'empirical'\n"
                                    ' should NOT be used unless more detailed information is not\n'
@@ -3660,7 +4194,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    'sphere\n'
                                    '\tspherical\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_exptl_absorpt_process_details': '<pre><h2>_exptl_absorpt_process_details</h2> Description of '
                                    'the absorption process applied to the\n'
                                    ' intensities. A literature reference should be supplied\n'
@@ -3669,7 +4204,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '<h3>Example:</h3>\n'
                                    'Tompa analytical\n'
                                    'MolEN (Fair, 1990)\n'
-                                   '(North, Phillips &amp; Mathews, 1968)</pre>',
+                                   '(North, Phillips &amp; Mathews, 1968)</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_F_000': '<pre><h2>_exptl_crystal_F_000</h2> The expression for a structure factor '
                          'evaluated in the\n'
                          ' zeroth-order case h = k = l = 0, F(000). This may contain\n'
@@ -3686,11 +4222,13 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          ' and counts the effective number of electrons in the unit cell;\n'
                          ' for neutrons, non-dispersive F(000) (which may be negative)\n'
                          ' counts the total nuclear scattering power in the unit cell. See\n'
-                         '    http://reference.iucr.org/dictionary/F(000)</pre>',
+                         '    http://reference.iucr.org/dictionary/F(000)</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_colour': '<pre><h2>_exptl_crystal_colour</h2> The colour of the crystal.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          'dark green</pre>',
+                          'dark green</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_colour_lustre': '<pre><h2>_exptl_crystal_colour_lustre</h2>The enumeration list '
                                  'of standardized names developed for the\n'
                                  'International Centre for Diffraction Data.\n'
@@ -3703,7 +4241,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '<h3>Example:</h3>\n'
                                  'metallic\n'
                                  'dull\n'
-                                 'clear</pre>',
+                                 'clear</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_colour_modifier': '<pre><h2>_exptl_crystal_colour_modifier</h2>The enumeration '
                                    'list of standardized names developed for the\n'
                                    'International Centre for Diffraction Data.\n'
@@ -3725,7 +4264,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    'orangish\n'
                                    'yellowish\n'
                                    'greenish\n'
-                                   'bluish</pre>',
+                                   'bluish</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_colour_primary': '<pre><h2>_exptl_crystal_colour_primary</h2>The enumeration list '
                                   'of standardized names developed for the\n'
                                   'International Centre for Diffraction Data.\n'
@@ -3747,15 +4287,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   'yellow\n'
                                   'green\n'
                                   'blue\n'
-                                  'violet</pre>',
+                                  'violet</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_density_diffrn': '<pre><h2>_exptl_crystal_density_diffrn</h2> Density values '
                                   'calculated from the crystal cell and contents. The\n'
                                   ' units are megagrams per cubic metre (grams per cubic '
-                                  'centimetre).</pre>',
+                                  'centimetre).</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas': '<pre><h2>_exptl_crystal_density_meas</h2> Density values measured '
                                 'using standard chemical and physical\n'
                                 ' methods. The units are megagrams per cubic metre (grams per\n'
-                                ' cubic centimetre).</pre>',
+                                ' cubic centimetre).</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas_gt': '<pre><h2>_exptl_crystal_density_meas_gt</h2> The value above '
                                    'which the density measured using standard\n'
                                    ' chemical and physical methods lies. The units are megagrams\n'
@@ -3769,7 +4314,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' reported under _exptl_crystal_density_meas.\n'
                                    '\n'
                                    '<h3>Example:</h3>\n'
-                                   '2.5</pre>',
+                                   '2.5</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas_lt': '<pre><h2>_exptl_crystal_density_meas_lt</h2> The value below '
                                    'which the density measured using standard\n'
                                    ' chemical and physical methods lies. The units are megagrams\n'
@@ -3784,10 +4331,14 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '\n'
                                    '<h3>Example:</h3>\n'
                                    '1.0\n'
-                                   '5.0</pre>',
+                                   '5.0</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas_temp': '<pre><h2>_exptl_crystal_density_meas_temp</h2> Temperature '
                                      'in kelvins at which _exptl_crystal_density_meas\n'
-                                     ' was determined.</pre>',
+                                     ' was determined.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas_temp_gt': '<pre><h2>_exptl_crystal_density_meas_temp_gt</h2> '
                                         'Temperature in kelvins above which '
                                         '_exptl_crystal_density_meas\n'
@@ -3800,7 +4351,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                         'for\n'
                                         ' use in reporting information stored in databases\n'
                                         ' or archives which would be misleading if reported under\n'
-                                        ' _exptl_crystal_density_meas_temp.</pre>',
+                                        ' _exptl_crystal_density_meas_temp.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_meas_temp_lt': '<pre><h2>_exptl_crystal_density_meas_temp_lt</h2> '
                                         'Temperature in kelvins below which '
                                         '_exptl_crystal_density_meas\n'
@@ -3816,73 +4369,89 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                         ' _exptl_crystal_density_meas_temp.\n'
                                         '\n'
                                         '<h3>Example:</h3>\n'
-                                        '300</pre>',
+                                        '300</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_density_method': '<pre><h2>_exptl_crystal_density_method</h2> The method used to '
                                   'measure _exptl_crystal_density_meas.\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
                                   'flotation in aqueous KI\n'
                                   'not measured\n'
-                                  'Berman density torsion balance</pre>',
+                                  'Berman density torsion balance</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_description': '<pre><h2>_exptl_crystal_description</h2> A description of the '
                                'quality and habit of the crystal.\n'
                                ' The crystal dimensions should not normally be reported here;\n'
                                ' use instead _exptl_crystal_size_ for the gross dimensions of\n'
                                ' the crystal and _exptl_crystal_face_ to describe the\n'
-                               ' relationship between individual faces.</pre>',
+                               ' relationship between individual faces.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_face_diffr_chi': '<pre><h2>_exptl_crystal_face_diffr_chi</h2> The goniometer '
                                   'angle settings in degrees when the perpendicular\n'
                                   ' to the specified crystal face is aligned along a specified\n'
                                   ' direction (e.g. the bisector of the incident and reflected '
                                   'beams\n'
                                   ' in an optical goniometer).\n'
-                                  '</pre>',
+                                  '</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_diffr_kappa': '<pre><h2>_exptl_crystal_face_diffr_kappa</h2> The goniometer '
                                     'angle settings in degrees when the perpendicular\n'
                                     ' to the specified crystal face is aligned along a specified\n'
                                     ' direction (e.g. the bisector of the incident and reflected '
                                     'beams\n'
                                     ' in an optical goniometer).\n'
-                                    '</pre>',
+                                    '</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_diffr_phi': '<pre><h2>_exptl_crystal_face_diffr_phi</h2> The goniometer '
                                   'angle settings in degrees when the perpendicular\n'
                                   ' to the specified crystal face is aligned along a specified\n'
                                   ' direction (e.g. the bisector of the incident and reflected '
                                   'beams\n'
                                   ' in an optical goniometer).\n'
-                                  '</pre>',
+                                  '</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_diffr_psi': '<pre><h2>_exptl_crystal_face_diffr_psi</h2> The goniometer '
                                   'angle settings in degrees when the perpendicular\n'
                                   ' to the specified crystal face is aligned along a specified\n'
                                   ' direction (e.g. the bisector of the incident and reflected '
                                   'beams\n'
                                   ' in an optical goniometer).\n'
-                                  '</pre>',
+                                  '</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_h': '<pre><h2>_exptl_crystal_face_index_h</h2> Miller indices of the '
                                 'crystal face associated with the value\n'
-                                ' _exptl_crystal_face_perp_dist.</pre>',
+                                ' _exptl_crystal_face_perp_dist.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_k': '<pre><h2>_exptl_crystal_face_index_k</h2> Miller indices of the '
                                 'crystal face associated with the value\n'
-                                ' _exptl_crystal_face_perp_dist.</pre>',
+                                ' _exptl_crystal_face_perp_dist.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_l': '<pre><h2>_exptl_crystal_face_index_l</h2> Miller indices of the '
                                 'crystal face associated with the value\n'
-                                ' _exptl_crystal_face_perp_dist.</pre>',
+                                ' _exptl_crystal_face_perp_dist.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_perp_dist': '<pre><h2>_exptl_crystal_face_perp_dist</h2> The perpendicular '
                                   'distance in millimetres from the face to the\n'
-                                  ' centre of rotation of the crystal.</pre>',
+                                  ' centre of rotation of the crystal.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_id': '<pre><h2>_exptl_crystal_id</h2> Code identifying each crystal if multiple '
                       'crystals are used. It\n'
                       ' is used to link with _diffrn_refln_crystal_id in the intensity\n'
-                      ' measurements and with _refln_crystal_id in the _refln_ list.</pre>',
+                      ' measurements and with _refln_crystal_id in the _refln_ list.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_preparation': '<pre><h2>_exptl_crystal_preparation</h2> Details of crystal growth '
                                'and preparation of the crystal (e.g.\n'
                                ' mounting) prior to the intensity measurements.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               'mounted in an argon-filled quartz capillary</pre>',
+                               'mounted in an argon-filled quartz capillary</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_pressure_history': '<pre><h2>_exptl_crystal_pressure_history</h2> Relevant '
                                     'details concerning the pressure history of the\n'
-                                    ' sample.</pre>',
+                                    ' sample.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_recrystallization_method': '<pre><h2>_exptl_crystal_recrystallization_method</h2> '
                                             'Describes the method used to recrystallize the '
                                             'sample.\n'
@@ -3893,86 +4462,109 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                             ' well as details of the solvent, flux or carrier gas '
                                             'with\n'
                                             ' concentrations or pressures and ambient '
-                                            'atmosphere.</pre>',
+                                            'atmosphere.</pre>\n'
+                                            '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystal_size_length': '<pre><h2>_exptl_crystal_size_length</h2> The maximum, medial and '
                                'minimum dimensions in millimetres of\n'
                                ' the crystal. If the crystal is a sphere, then the *_rad item is\n'
                                ' its radius. If the crystal is a cylinder, then the *_rad item\n'
                                ' is its radius and the *_length item is its length. These may\n'
                                ' appear in a list with _exptl_crystal_id if multiple crystals\n'
-                               ' are used in the experiment.</pre>',
+                               ' are used in the experiment.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_size_max': '<pre><h2>_exptl_crystal_size_max</h2> The maximum, medial and minimum '
                             'dimensions in millimetres of\n'
                             ' the crystal. If the crystal is a sphere, then the *_rad item is\n'
                             ' its radius. If the crystal is a cylinder, then the *_rad item\n'
                             ' is its radius and the *_length item is its length. These may\n'
                             ' appear in a list with _exptl_crystal_id if multiple crystals\n'
-                            ' are used in the experiment.</pre>',
+                            ' are used in the experiment.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_size_mid': '<pre><h2>_exptl_crystal_size_mid</h2> The maximum, medial and minimum '
                             'dimensions in millimetres of\n'
                             ' the crystal. If the crystal is a sphere, then the *_rad item is\n'
                             ' its radius. If the crystal is a cylinder, then the *_rad item\n'
                             ' is its radius and the *_length item is its length. These may\n'
                             ' appear in a list with _exptl_crystal_id if multiple crystals\n'
-                            ' are used in the experiment.</pre>',
+                            ' are used in the experiment.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_size_min': '<pre><h2>_exptl_crystal_size_min</h2> The maximum, medial and minimum '
                             'dimensions in millimetres of\n'
                             ' the crystal. If the crystal is a sphere, then the *_rad item is\n'
                             ' its radius. If the crystal is a cylinder, then the *_rad item\n'
                             ' is its radius and the *_length item is its length. These may\n'
                             ' appear in a list with _exptl_crystal_id if multiple crystals\n'
-                            ' are used in the experiment.</pre>',
+                            ' are used in the experiment.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_size_rad': '<pre><h2>_exptl_crystal_size_rad</h2> The maximum, medial and minimum '
                             'dimensions in millimetres of\n'
                             ' the crystal. If the crystal is a sphere, then the *_rad item is\n'
                             ' its radius. If the crystal is a cylinder, then the *_rad item\n'
                             ' is its radius and the *_length item is its length. These may\n'
                             ' appear in a list with _exptl_crystal_id if multiple crystals\n'
-                            ' are used in the experiment.</pre>',
+                            ' are used in the experiment.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_exptl_crystal_thermal_history': '<pre><h2>_exptl_crystal_thermal_history</h2> Relevant details '
                                    'concerning the thermal history of the\n'
-                                   ' sample.</pre>',
+                                   ' sample.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_exptl_crystals_number': '<pre><h2>_exptl_crystals_number</h2> The total number of crystals used '
                            'for the measurement of\n'
-                           ' intensities.</pre>',
+                           ' intensities.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_exptl_special_details': '<pre><h2>_exptl_special_details</h2> Any special information about the '
                            'experimental work prior to the\n'
-                           ' intensity measurements. See also _exptl_crystal_preparation.</pre>',
+                           ' intensity measurements. See also _exptl_crystal_preparation.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_exptl_transmission_factor_max': '<pre><h2>_exptl_transmission_factor_max</h2> The calculated '
                                    'maximum value of the transmission factor for\n'
                                    ' the specimen. Its value does not include the effects of\n'
                                    ' absorption in the specimen mount. The presence of this\n'
                                    ' item does not imply that the structure factors have been\n'
                                    ' corrected for absorption. The applied correction should be \n'
-                                   ' given by _exptl_absorpt_correction_T_max.</pre>',
+                                   ' given by _exptl_absorpt_correction_T_max.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_exptl_transmission_factor_min': '<pre><h2>_exptl_transmission_factor_min</h2> The calculated '
                                    'minimum value of the transmission factor for\n'
                                    ' the specimen. Its value does not include the effects of\n'
                                    ' absorption in the specimen mount. The presence of this\n'
                                    ' item does not imply that the structure factors have been\n'
                                    ' corrected for absorption. The applied correction should be \n'
-                                   ' given by _exptl_absorpt_correction_T_min.</pre>',
+                                   ' given by _exptl_absorpt_correction_T_min.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_geom_angle': '<pre><h2>_geom_angle</h2> Angle in degrees defined by the three sites\n'
                 ' _geom_angle_atom_site_label_1, *_2 and *_3. The site at *_2\n'
-                ' is at the apex of the angle.</pre>',
+                ' is at the apex of the angle.</pre>\n'
+                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_angle_atom_site_label_1': '<pre><h2>_geom_angle_atom_site_label_1</h2> The labels of the '
                                   'three atom sites which define the angle\n'
                                   ' given by _geom_angle. These must match labels specified as\n'
                                   ' _atom_site_label in the atom list. Label 2 identifies the site '
                                   'at\n'
-                                  ' the apex of the angle.</pre>',
+                                  ' the apex of the angle.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_atom_site_label_2': '<pre><h2>_geom_angle_atom_site_label_2</h2> The labels of the '
                                   'three atom sites which define the angle\n'
                                   ' given by _geom_angle. These must match labels specified as\n'
                                   ' _atom_site_label in the atom list. Label 2 identifies the site '
                                   'at\n'
-                                  ' the apex of the angle.</pre>',
+                                  ' the apex of the angle.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_atom_site_label_3': '<pre><h2>_geom_angle_atom_site_label_3</h2> The labels of the '
                                   'three atom sites which define the angle\n'
                                   ' given by _geom_angle. These must match labels specified as\n'
                                   ' _atom_site_label in the atom list. Label 2 identifies the site '
                                   'at\n'
-                                  ' the apex of the angle.</pre>',
+                                  ' the apex of the angle.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_publ_flag': '<pre><h2>_geom_angle_publ_flag</h2> This code signals whether the angle '
                           'is referred to in a\n'
                           ' publication or should be placed in a table of significant\n'
@@ -3990,7 +4582,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           'y\n'
                           '\tabbreviation for "yes"\n'
-                          '</pre>',
+                          '</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>\n'
+                          '<br><p><h4>Default:</h4> no </p>',
  '_geom_angle_site_symmetry_1': '<pre><h2>_geom_angle_site_symmetry_1</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4015,7 +4609,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_site_symmetry_2': '<pre><h2>_geom_angle_site_symmetry_2</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4040,7 +4635,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_site_symmetry_3': '<pre><h2>_geom_angle_site_symmetry_3</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4065,21 +4661,29 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_atom_site_label_1': '<pre><h2>_geom_bond_atom_site_label_1</h2> The labels of two '
                                  'atom sites that form a bond. These must match\n'
-                                 ' labels specified as _atom_site_label in the atom list.</pre>',
+                                 ' labels specified as _atom_site_label in the atom list.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_atom_site_label_2': '<pre><h2>_geom_bond_atom_site_label_2</h2> The labels of two '
                                  'atom sites that form a bond. These must match\n'
-                                 ' labels specified as _atom_site_label in the atom list.</pre>',
+                                 ' labels specified as _atom_site_label in the atom list.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_distance': '<pre><h2>_geom_bond_distance</h2> The intramolecular bond distance in '
-                        'angstroms.</pre>',
+                        'angstroms.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_bond_multiplicity': '<pre><h2>_geom_bond_multiplicity</h2> The number of times the given '
                             'bond appears in the environment\n'
                             ' of the atoms labelled _geom_bond_atom_site_label_1. In cases\n'
                             ' where the full list of bonds is given, one of the series of\n'
                             ' equivalent bonds may be assigned the appropriate multiplicity\n'
-                            ' while the others are assigned a value of 0.</pre>',
+                            ' while the others are assigned a value of 0.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0:∞ </p>\n'
+                            '<br><p><h4>Default:</h4> 1 </p>',
  '_geom_bond_publ_flag': '<pre><h2>_geom_bond_publ_flag</h2> This code signals whether the bond '
                          'distance is referred to in a\n'
                          ' publication or should be placed in a list of significant bond\n'
@@ -4097,7 +4701,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          '\n'
                          'y\n'
                          '\tabbreviation for "yes"\n'
-                         '</pre>',
+                         '</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>\n'
+                         '<br><p><h4>Default:</h4> no </p>',
  '_geom_bond_site_symmetry_1': '<pre><h2>_geom_bond_site_symmetry_1</h2> The symmetry code of each '
                                'atom site as the symmetry-equivalent\n'
                                " position number 'n' and the cell translation number 'klm'.\n"
@@ -4122,7 +4728,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '<h3>Example:</h3>\n'
                                'None\n'
                                '4\n'
-                               '7_645</pre>',
+                               '7_645</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_site_symmetry_2': '<pre><h2>_geom_bond_site_symmetry_2</h2> The symmetry code of each '
                                'atom site as the symmetry-equivalent\n'
                                " position number 'n' and the cell translation number 'klm'.\n"
@@ -4147,19 +4754,25 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '<h3>Example:</h3>\n'
                                'None\n'
                                '4\n'
-                               '7_645</pre>',
+                               '7_645</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_valence': '<pre><h2>_geom_bond_valence</h2> The bond valence calculated from '
-                       '_geom_bond_distance.</pre>',
+                       '_geom_bond_distance.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_contact_atom_site_label_1': '<pre><h2>_geom_contact_atom_site_label_1</h2> The labels of '
                                     'two atom sites that are within contact distance.\n'
                                     ' The labels must match _atom_site_label codes in the atom '
-                                    'list.</pre>',
+                                    'list.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_contact_atom_site_label_2': '<pre><h2>_geom_contact_atom_site_label_2</h2> The labels of '
                                     'two atom sites that are within contact distance.\n'
                                     ' The labels must match _atom_site_label codes in the atom '
-                                    'list.</pre>',
+                                    'list.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_contact_distance': '<pre><h2>_geom_contact_distance</h2> The interatomic contact distance '
-                           'in angstroms.</pre>',
+                           'in angstroms.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_contact_publ_flag': '<pre><h2>_geom_contact_publ_flag</h2> This code signals whether the '
                             'contact distance is referred to\n'
                             ' in a publication or should be placed in a list of significant\n'
@@ -4177,7 +4790,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '\n'
                             'y\n'
                             '\tabbreviation for "yes"\n'
-                            '</pre>',
+                            '</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>\n'
+                            '<br><p><h4>Default:</h4> no </p>',
  '_geom_contact_site_symmetry_1': '<pre><h2>_geom_contact_site_symmetry_1</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4202,7 +4817,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_contact_site_symmetry_2': '<pre><h2>_geom_contact_site_symmetry_2</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4227,39 +4843,50 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_angle_DHA': '<pre><h2>_geom_hbond_angle_DHA</h2> Angle in degrees defined by the '
                           'three sites\n'
                           ' _geom_hbond_atom_site_label_D, *_H and *_A. The site at *_H\n'
                           ' (the hydrogen atom participating in the interaction) is at\n'
-                          ' the apex of the angle.</pre>',
+                          ' the apex of the angle.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_hbond_atom_site_label_A': '<pre><h2>_geom_hbond_atom_site_label_A</h2> The labels of three '
                                   'atom sites (respectively, the donor atom,\n'
                                   ' hydrogen atom and acceptor atom) participating in a hydrogen\n'
                                   ' bond. These must match labels specified as _atom_site_label\n'
-                                  ' in the atom list.</pre>',
+                                  ' in the atom list.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_atom_site_label_D': '<pre><h2>_geom_hbond_atom_site_label_D</h2> The labels of three '
                                   'atom sites (respectively, the donor atom,\n'
                                   ' hydrogen atom and acceptor atom) participating in a hydrogen\n'
                                   ' bond. These must match labels specified as _atom_site_label\n'
-                                  ' in the atom list.</pre>',
+                                  ' in the atom list.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_atom_site_label_H': '<pre><h2>_geom_hbond_atom_site_label_H</h2> The labels of three '
                                   'atom sites (respectively, the donor atom,\n'
                                   ' hydrogen atom and acceptor atom) participating in a hydrogen\n'
                                   ' bond. These must match labels specified as _atom_site_label\n'
-                                  ' in the atom list.</pre>',
+                                  ' in the atom list.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_distance_DA': '<pre><h2>_geom_hbond_distance_DA</h2> Distances in angstroms between '
                             'the donor and hydrogen (*_DH),\n'
                             ' hydrogen and acceptor (*_HA) and donor and acceptor (*_DA)\n'
-                            ' sites in a hydrogen bond.</pre>',
+                            ' sites in a hydrogen bond.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_hbond_distance_DH': '<pre><h2>_geom_hbond_distance_DH</h2> Distances in angstroms between '
                             'the donor and hydrogen (*_DH),\n'
                             ' hydrogen and acceptor (*_HA) and donor and acceptor (*_DA)\n'
-                            ' sites in a hydrogen bond.</pre>',
+                            ' sites in a hydrogen bond.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_hbond_distance_HA': '<pre><h2>_geom_hbond_distance_HA</h2> Distances in angstroms between '
                             'the donor and hydrogen (*_DH),\n'
                             ' hydrogen and acceptor (*_HA) and donor and acceptor (*_DA)\n'
-                            ' sites in a hydrogen bond.</pre>',
+                            ' sites in a hydrogen bond.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_hbond_publ_flag': '<pre><h2>_geom_hbond_publ_flag</h2> This code signals whether the '
                           'hydrogen-bond information\n'
                           ' is referred to in a publication or should be placed in a\n'
@@ -4277,7 +4904,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           'y\n'
                           '\tabbreviation for "yes"\n'
-                          '</pre>',
+                          '</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>\n'
+                          '<br><p><h4>Default:</h4> no </p>',
  '_geom_hbond_site_symmetry_A': '<pre><h2>_geom_hbond_site_symmetry_A</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4302,7 +4931,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_site_symmetry_D': '<pre><h2>_geom_hbond_site_symmetry_D</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4327,7 +4957,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_hbond_site_symmetry_H': '<pre><h2>_geom_hbond_site_symmetry_H</h2> The symmetry code of '
                                 'each atom site as the symmetry-equivalent\n'
                                 " position number 'n' and the cell translation number 'klm'.\n"
@@ -4352,18 +4983,21 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '<h3>Example:</h3>\n'
                                 'None\n'
                                 '4\n'
-                                '7_645</pre>',
+                                '7_645</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_geom_special_details': '<pre><h2>_geom_special_details</h2> The description of geometrical '
                           'information not covered by the\n'
                           ' existing data names in the geometry categories, such as\n'
-                          ' least-squares planes.</pre>',
+                          ' least-squares planes.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion': '<pre><h2>_geom_torsion</h2> The torsion angle in degrees bounded by the four '
                   'atom sites\n'
                   ' identified by the _geom_torsion_atom_site_label_ codes. These\n'
                   ' must match labels specified as _atom_site_label in the atom list.\n'
                   ' The torsion-angle definition should be that of Klyne and Prelog.\n'
                   '\n'
-                  ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>',
+                  ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_torsion_atom_site_label_1': '<pre><h2>_geom_torsion_atom_site_label_1</h2> The labels of '
                                     'the four atom sites which define the torsion angle\n'
                                     ' specified by _geom_torsion. These must match codes specified '
@@ -4380,7 +5014,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' torsions are positive, anticlockwise torsions are negative.\n'
                                     '\n'
                                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, '
-                                    '521-523.</pre>',
+                                    '521-523.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_atom_site_label_2': '<pre><h2>_geom_torsion_atom_site_label_2</h2> The labels of '
                                     'the four atom sites which define the torsion angle\n'
                                     ' specified by _geom_torsion. These must match codes specified '
@@ -4397,7 +5032,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' torsions are positive, anticlockwise torsions are negative.\n'
                                     '\n'
                                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, '
-                                    '521-523.</pre>',
+                                    '521-523.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_atom_site_label_3': '<pre><h2>_geom_torsion_atom_site_label_3</h2> The labels of '
                                     'the four atom sites which define the torsion angle\n'
                                     ' specified by _geom_torsion. These must match codes specified '
@@ -4414,7 +5050,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' torsions are positive, anticlockwise torsions are negative.\n'
                                     '\n'
                                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, '
-                                    '521-523.</pre>',
+                                    '521-523.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_atom_site_label_4': '<pre><h2>_geom_torsion_atom_site_label_4</h2> The labels of '
                                     'the four atom sites which define the torsion angle\n'
                                     ' specified by _geom_torsion. These must match codes specified '
@@ -4431,7 +5068,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' torsions are positive, anticlockwise torsions are negative.\n'
                                     '\n'
                                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, '
-                                    '521-523.</pre>',
+                                    '521-523.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_publ_flag': '<pre><h2>_geom_torsion_publ_flag</h2> This code signals whether the '
                             'torsion angle is referred to in a\n'
                             ' publication or should be placed in a table of significant\n'
@@ -4449,7 +5087,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '\n'
                             'y\n'
                             '\tabbreviation for "yes"\n'
-                            '</pre>',
+                            '</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>\n'
+                            '<br><p><h4>Default:</h4> no </p>',
  '_geom_torsion_site_symmetry_1': '<pre><h2>_geom_torsion_site_symmetry_1</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4474,7 +5114,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_symmetry_2': '<pre><h2>_geom_torsion_site_symmetry_2</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4499,7 +5140,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_symmetry_3': '<pre><h2>_geom_torsion_site_symmetry_3</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4524,7 +5166,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_symmetry_4': '<pre><h2>_geom_torsion_site_symmetry_4</h2> The symmetry code '
                                   'of each atom site as the symmetry-equivalent\n'
                                   " position number 'n' and the cell translation number 'klm'.\n"
@@ -4549,87 +5192,129 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '<h3>Example:</h3>\n'
                                   'None\n'
                                   '4\n'
-                                  '7_645</pre>',
+                                  '7_645</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_journal_coden_ASTM': '<pre><h2>_journal_coden_ASTM</h2> Data items specified by the journal '
-                        'staff.</pre>',
+                        'staff.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_journal_coden_Cambridge': '<pre><h2>_journal_coden_Cambridge</h2> Data items specified by the '
-                             'journal staff.</pre>',
+                             'journal staff.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_address': '<pre><h2>_journal_coeditor_address</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_code': '<pre><h2>_journal_coeditor_code</h2> Data items specified by the '
-                           'journal staff.</pre>',
+                           'journal staff.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_email': '<pre><h2>_journal_coeditor_email</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_fax': '<pre><h2>_journal_coeditor_fax</h2> Data items specified by the journal '
-                          'staff.</pre>',
+                          'staff.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_name': '<pre><h2>_journal_coeditor_name</h2> Data items specified by the '
-                           'journal staff.</pre>',
+                           'journal staff.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_notes': '<pre><h2>_journal_coeditor_notes</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_coeditor_phone': '<pre><h2>_journal_coeditor_phone</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_data_validation_number': '<pre><h2>_journal_data_validation_number</h2> Data items '
-                                    'specified by the journal staff.</pre>',
+                                    'specified by the journal staff.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_accepted': '<pre><h2>_journal_date_accepted</h2> Data items specified by the '
-                           'journal staff.</pre>',
+                           'journal staff.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_from_coeditor': '<pre><h2>_journal_date_from_coeditor</h2> Data items specified by '
-                                'the journal staff.</pre>',
+                                'the journal staff.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_printers_final': '<pre><h2>_journal_date_printers_final</h2> Data items specified '
-                                 'by the journal staff.</pre>',
+                                 'by the journal staff.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_printers_first': '<pre><h2>_journal_date_printers_first</h2> Data items specified '
-                                 'by the journal staff.</pre>',
+                                 'by the journal staff.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_proofs_in': '<pre><h2>_journal_date_proofs_in</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_proofs_out': '<pre><h2>_journal_date_proofs_out</h2> Data items specified by the '
-                             'journal staff.</pre>',
+                             'journal staff.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_recd_copyright': '<pre><h2>_journal_date_recd_copyright</h2> Data items specified '
-                                 'by the journal staff.</pre>',
+                                 'by the journal staff.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_recd_electronic': '<pre><h2>_journal_date_recd_electronic</h2> Data items '
-                                  'specified by the journal staff.</pre>',
+                                  'specified by the journal staff.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_recd_hard_copy': '<pre><h2>_journal_date_recd_hard_copy</h2> Data items specified '
-                                 'by the journal staff.</pre>',
+                                 'by the journal staff.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_journal_date_to_coeditor': '<pre><h2>_journal_date_to_coeditor</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_index_subterm': '<pre><h2>_journal_index_subterm</h2>Indexing terms supplied by the '
-                           'journal staff.</pre>',
+                           'journal staff.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_journal_index_term': '<pre><h2>_journal_index_term</h2>Indexing terms supplied by the journal '
-                        'staff.</pre>',
+                        'staff.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_journal_index_type': '<pre><h2>_journal_index_type</h2>Indexing terms supplied by the journal '
-                        'staff.</pre>',
- '_journal_issue': '<pre><h2>_journal_issue</h2> Data items specified by the journal staff.</pre>',
+                        'staff.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
+ '_journal_issue': '<pre><h2>_journal_issue</h2> Data items specified by the journal staff.</pre>\n'
+                   '<br><p><h4>Type:</h4> string</p>',
  '_journal_language': '<pre><h2>_journal_language</h2> Data items specified by the journal '
-                      'staff.</pre>',
+                      'staff.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_journal_name_full': '<pre><h2>_journal_name_full</h2> Data items specified by the journal '
-                       'staff.</pre>',
+                       'staff.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_journal_page_first': '<pre><h2>_journal_page_first</h2> Data items specified by the journal '
-                        'staff.</pre>',
+                        'staff.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_journal_page_last': '<pre><h2>_journal_page_last</h2> Data items specified by the journal '
-                       'staff.</pre>',
+                       'staff.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_journal_paper_category': '<pre><h2>_journal_paper_category</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_paper_doi': '<pre><h2>_journal_paper_doi</h2> Data items specified by the journal '
-                       'staff.</pre>',
+                       'staff.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_journal_suppl_publ_number': '<pre><h2>_journal_suppl_publ_number</h2> Data items specified by '
-                               'the journal staff.</pre>',
+                               'the journal staff.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_journal_suppl_publ_pages': '<pre><h2>_journal_suppl_publ_pages</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_address': '<pre><h2>_journal_techeditor_address</h2> Data items specified by '
-                                'the journal staff.</pre>',
+                                'the journal staff.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_code': '<pre><h2>_journal_techeditor_code</h2> Data items specified by the '
-                             'journal staff.</pre>',
+                             'journal staff.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_email': '<pre><h2>_journal_techeditor_email</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_fax': '<pre><h2>_journal_techeditor_fax</h2> Data items specified by the '
-                            'journal staff.</pre>',
+                            'journal staff.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_name': '<pre><h2>_journal_techeditor_name</h2> Data items specified by the '
-                             'journal staff.</pre>',
+                             'journal staff.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_notes': '<pre><h2>_journal_techeditor_notes</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_techeditor_phone': '<pre><h2>_journal_techeditor_phone</h2> Data items specified by the '
-                              'journal staff.</pre>',
+                              'journal staff.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_journal_volume': '<pre><h2>_journal_volume</h2> Data items specified by the journal '
-                    'staff.</pre>',
- '_journal_year': '<pre><h2>_journal_year</h2> Data items specified by the journal staff.</pre>',
+                    'staff.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
+ '_journal_year': '<pre><h2>_journal_year</h2> Data items specified by the journal staff.</pre>\n'
+                  '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_address': '<pre><h2>_publ_author_address</h2> The address of a publication author. '
                          'If there is more than one\n'
                          ' author, this will be looped with _publ_author_name.\n'
@@ -4639,7 +5324,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          '          Institute\n'
                          '          Street\n'
                          '          City and postcode\n'
-                         '          COUNTRY</pre>',
+                         '          COUNTRY</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_email': '<pre><h2>_publ_author_email</h2> The e-mail address of a publication '
                        'author. If there is more \n'
                        ' than one author, this will be looped with _publ_author_name.\n'
@@ -4649,7 +5335,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        '\n'
                        '<h3>Example:</h3>\n'
                        'name@host.domain.country\n'
-                       'bm@iucr.org</pre>',
+                       'bm@iucr.org</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_footnote': "<pre><h2>_publ_author_footnote</h2> A footnote accompanying an author's "
                           'name in the list of authors\n'
                           ' of a paper. Typically indicates sabbatical address, additional\n'
@@ -4657,14 +5344,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           '<h3>Example:</h3>\n'
                           'On leave from U. Western Australia\n'
-                          'Also at Department of Biophysics</pre>',
+                          'Also at Department of Biophysics</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_id_iucr': '<pre><h2>_publ_author_id_iucr</h2> Identifier in the IUCr contact '
                          'database of a publication\n'
                          ' author.  This identifier may be available from the World\n'
                          ' Directory of Crystallographers (http://wdc.iucr.org).\n'
                          '\n'
                          '<h3>Example:</h3>\n'
-                         '2985</pre>',
+                         '2985</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_id_orcid': '<pre><h2>_publ_author_id_orcid</h2> Identifier in the ORCID Registry of '
                           'a publication\n'
                           ' author. ORCID is an open, non-profit, community-driven\n'
@@ -4672,7 +5361,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' identifiers (http://orcid.org).\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          '0000-0003-0391-0002</pre>',
+                          '0000-0003-0391-0002</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_publ_author_name': '<pre><h2>_publ_author_name</h2> The name of a publication author. If there '
                       'are multiple authors,\n'
                       ' this will be looped with _publ_author_address. The family\n'
@@ -4686,8 +5376,10 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       'Yang, D.-L.\n'
                       'Simonov, Yu.A.\n'
                       'M\\"uller, H.A.\n'
-                      'Ross II, C.R.</pre>',
- '_publ_body_contents': '<pre><h2>_publ_body_contents</h2> A text section of a paper.</pre>',
+                      'Ross II, C.R.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
+ '_publ_body_contents': '<pre><h2>_publ_body_contents</h2> A text section of a paper.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_publ_body_element': '<pre><h2>_publ_body_element</h2> The functional role of the associated '
                        'text section.\n'
                        '\n'
@@ -4696,7 +5388,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                        'subsection\n'
                        'subsubsection\n'
                        'appendix\n'
-                       'footnote</pre>',
+                       'footnote</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_publ_body_format': '<pre><h2>_publ_body_format</h2> Code indicating the appropriate typesetting '
                       'conventions\n'
                       ' for accented characters and special symbols in the text\n'
@@ -4723,7 +5416,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       '\n'
                       'troff\n'
                       '\ttroff or nroff\n'
-                      '</pre>',
+                      '</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>\n'
+                      '<br><p><h4>Default:</h4> cif </p>',
  '_publ_body_label': '<pre><h2>_publ_body_label</h2> Code identifying the section of text. The '
                      'combination of this\n'
                      ' with _publ_body_element must be unique.\n'
@@ -4731,9 +5426,11 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                      '<h3>Example:</h3>\n'
                      '1\n'
                      '1.1\n'
-                     '2.1.3</pre>',
+                     '2.1.3</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_publ_body_title': '<pre><h2>_publ_body_title</h2> Title of the associated section of '
-                     'text.</pre>',
+                     'text.</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author': '<pre><h2>_publ_contact_author</h2> The name and address of the author '
                          'submitting the manuscript and\n'
                          ' data block. This is the person contacted by the journal\n'
@@ -4746,7 +5443,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          '          University of Guelph\n'
                          '          Ontario\n'
                          '          Canada\n'
-                         '          N1G 2W1</pre>',
+                         '          N1G 2W1</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_address': '<pre><h2>_publ_contact_author_address</h2> The address of the '
                                  'author submitting the manuscript and\n'
                                  ' data block. This is the person contacted by the journal\n'
@@ -4757,7 +5455,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '          University of Guelph\n'
                                  '          Ontario\n'
                                  '          Canada\n'
-                                 '          N1G 2W1</pre>',
+                                 '          N1G 2W1</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_email': '<pre><h2>_publ_contact_author_email</h2> E-mail address in a form '
                                'recognizable to international networks.\n'
                                ' The format of e-mail addresses is given in Section 3.4, Address \n'
@@ -4767,7 +5466,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '\n'
                                '<h3>Example:</h3>\n'
                                'name@host.domain.country\n'
-                               'bm@iucr.org</pre>',
+                               'bm@iucr.org</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_fax': '<pre><h2>_publ_contact_author_fax</h2> Facsimile telephone number of '
                              'the author submitting the\n'
                              ' manuscript and data block.\n'
@@ -4780,7 +5480,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '\n'
                              '<h3>Example:</h3>\n'
                              '12(34)9477334\n'
-                             '12()349477334</pre>',
+                             '12()349477334</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_id_iucr': '<pre><h2>_publ_contact_author_id_iucr</h2> Identifier in the '
                                  'IUCr contact database of the author\n'
                                  ' submitting the manuscript and data block. This identifier may\n'
@@ -4788,7 +5489,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' (http://wdc.iucr.org).\n'
                                  '\n'
                                  '<h3>Example:</h3>\n'
-                                 '2985</pre>',
+                                 '2985</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_id_orcid': '<pre><h2>_publ_contact_author_id_orcid</h2> Identifier in the '
                                   'ORCID Registry of the author submitting\n'
                                   ' the manuscript and data block. ORCID is an open, non-profit,\n'
@@ -4796,14 +5498,16 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' researcher identifiers (http://orcid.org).\n'
                                   '\n'
                                   '<h3>Example:</h3>\n'
-                                  '0000-0003-0391-0002</pre>',
+                                  '0000-0003-0391-0002</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_name': '<pre><h2>_publ_contact_author_name</h2> The name of the author '
                               'submitting the manuscript and\n'
                               ' data block. This is the person contacted by the journal\n'
                               ' editorial staff.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              'Professor George Ferguson</pre>',
+                              'Professor George Ferguson</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_author_phone': '<pre><h2>_publ_contact_author_phone</h2> Telephone number of the '
                                'author submitting the manuscript and\n'
                                ' data block.\n'
@@ -4819,16 +5523,19 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '<h3>Example:</h3>\n'
                                '12(34)9477330\n'
                                '12()349477330\n'
-                               '12(34)9477330x5543</pre>',
+                               '12(34)9477330x5543</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_publ_contact_letter': '<pre><h2>_publ_contact_letter</h2> A letter submitted to the journal '
-                         'editor by the contact author.</pre>',
+                         'editor by the contact author.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_publ_manuscript_creation': '<pre><h2>_publ_manuscript_creation</h2> A description of the '
                               'word-processor package and computer used to\n'
                               ' create the word-processed manuscript stored as\n'
                               ' _publ_manuscript_processed.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              'Tex file created by FrameMaker on a Sun 3/280</pre>',
+                              'Tex file created by FrameMaker on a Sun 3/280</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_publ_manuscript_incl_extra_defn': '<pre><h2>_publ_manuscript_incl_extra_defn</h2> Flags whether '
                                      'the corresponding data item marked for inclusion\n'
                                      ' in a journal request list is a standard CIF definition or '
@@ -4846,12 +5553,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '\n'
                                      'y\n'
                                      '\tabbreviation for "yes"\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>\n'
+                                     '<br><p><h4>Default:</h4> yes </p>',
  '_publ_manuscript_incl_extra_info': '<pre><h2>_publ_manuscript_incl_extra_info</h2> A short note '
                                      'indicating the reason why the author wishes the\n'
                                      ' corresponding data item marked for inclusion in the '
                                      'journal\n'
-                                     ' request list to be published.</pre>',
+                                     ' request list to be published.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_publ_manuscript_incl_extra_item': '<pre><h2>_publ_manuscript_incl_extra_item</h2> Specifies the '
                                      'inclusion of specific data into a manuscript\n'
                                      ' which are not normally requested by the journal. The '
@@ -4859,16 +5569,19 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      ' of this item are the extra data names (which MUST be '
                                      'enclosed\n'
                                      ' in single quotes) that will be added to the journal request '
-                                     'list.</pre>',
+                                     'list.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_publ_manuscript_processed': '<pre><h2>_publ_manuscript_processed</h2> The full manuscript of a '
                                'paper (excluding possibly the figures\n'
                                ' and the tables) output in ASCII characters from a word '
                                'processor.\n'
                                ' Information about the generation of this data item must be\n'
-                               ' specified in the data item _publ_manuscript_creation.</pre>',
+                               ' specified in the data item _publ_manuscript_creation.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_publ_manuscript_text': '<pre><h2>_publ_manuscript_text</h2> The full manuscript of a paper '
                           '(excluding figures and possibly\n'
-                          ' the tables) output as standard ASCII text.</pre>',
+                          ' the tables) output as standard ASCII text.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_publ_requested_category': '<pre><h2>_publ_requested_category</h2> The category of paper '
                              'submitted. For submission to Acta\n'
                              ' Crystallographica Section C or Acta Crystallographica\n'
@@ -4938,13 +5651,17 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '\n'
                              'SC\n'
                              '\tShort communication\n'
-                             '</pre>',
+                             '</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>\n'
+                             '<br><p><h4>Default:</h4> FA </p>',
  '_publ_requested_coeditor_name': '<pre><h2>_publ_requested_coeditor_name</h2> The name of the '
                                   'co-editor whom the authors would like to\n'
-                                  ' handle the submitted manuscript.</pre>',
+                                  ' handle the submitted manuscript.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_publ_requested_journal': '<pre><h2>_publ_requested_journal</h2> The name of the journal to '
                             'which the manuscript is being\n'
-                            ' submitted.</pre>',
+                            ' submitted.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_abstract': '<pre><h2>_publ_section_abstract</h2> The sections of a manuscript if '
                            'submitted in parts. As\n'
                            ' an alternative, see _publ_manuscript_text and\n'
@@ -4953,7 +5670,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                            ' and _publ_section_exptl_solution items are preferred for\n'
                            ' separating the chemical preparation, refinement and structure\n'
-                           ' solution aspects of the experimental description.</pre>',
+                           ' solution aspects of the experimental description.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_acknowledgements': '<pre><h2>_publ_section_acknowledgements</h2> The sections of a '
                                    'manuscript if submitted in parts. As\n'
                                    ' an alternative, see _publ_manuscript_text and\n'
@@ -4963,7 +5681,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' and _publ_section_exptl_solution items are preferred for\n'
                                    ' separating the chemical preparation, refinement and '
                                    'structure\n'
-                                   ' solution aspects of the experimental description.</pre>',
+                                   ' solution aspects of the experimental description.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_comment': '<pre><h2>_publ_section_comment</h2> The sections of a manuscript if '
                           'submitted in parts. As\n'
                           ' an alternative, see _publ_manuscript_text and\n'
@@ -4972,7 +5691,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                           ' and _publ_section_exptl_solution items are preferred for\n'
                           ' separating the chemical preparation, refinement and structure\n'
-                          ' solution aspects of the experimental description.</pre>',
+                          ' solution aspects of the experimental description.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_discussion': '<pre><h2>_publ_section_discussion</h2> The sections of a manuscript '
                              'if submitted in parts. As\n'
                              ' an alternative, see _publ_manuscript_text and\n'
@@ -4981,7 +5701,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                              ' and _publ_section_exptl_solution items are preferred for\n'
                              ' separating the chemical preparation, refinement and structure\n'
-                             ' solution aspects of the experimental description.</pre>',
+                             ' solution aspects of the experimental description.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_experimental': '<pre><h2>_publ_section_experimental</h2> The sections of a '
                                'manuscript if submitted in parts. As\n'
                                ' an alternative, see _publ_manuscript_text and\n'
@@ -4990,7 +5711,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                ' and _publ_section_exptl_solution items are preferred for\n'
                                ' separating the chemical preparation, refinement and structure\n'
-                               ' solution aspects of the experimental description.</pre>',
+                               ' solution aspects of the experimental description.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_exptl_prep': '<pre><h2>_publ_section_exptl_prep</h2> The sections of a manuscript '
                              'if submitted in parts. As\n'
                              ' an alternative, see _publ_manuscript_text and\n'
@@ -4999,7 +5721,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                              ' and _publ_section_exptl_solution items are preferred for\n'
                              ' separating the chemical preparation, refinement and structure\n'
-                             ' solution aspects of the experimental description.</pre>',
+                             ' solution aspects of the experimental description.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_exptl_refinement': '<pre><h2>_publ_section_exptl_refinement</h2> The sections of a '
                                    'manuscript if submitted in parts. As\n'
                                    ' an alternative, see _publ_manuscript_text and\n'
@@ -5009,7 +5732,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' and _publ_section_exptl_solution items are preferred for\n'
                                    ' separating the chemical preparation, refinement and '
                                    'structure\n'
-                                   ' solution aspects of the experimental description.</pre>',
+                                   ' solution aspects of the experimental description.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_exptl_solution': '<pre><h2>_publ_section_exptl_solution</h2> The sections of a '
                                  'manuscript if submitted in parts. As\n'
                                  ' an alternative, see _publ_manuscript_text and\n'
@@ -5018,7 +5742,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                  ' and _publ_section_exptl_solution items are preferred for\n'
                                  ' separating the chemical preparation, refinement and structure\n'
-                                 ' solution aspects of the experimental description.</pre>',
+                                 ' solution aspects of the experimental description.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_figure_captions': '<pre><h2>_publ_section_figure_captions</h2> The sections of a '
                                   'manuscript if submitted in parts. As\n'
                                   ' an alternative, see _publ_manuscript_text and\n'
@@ -5027,7 +5752,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                   ' and _publ_section_exptl_solution items are preferred for\n'
                                   ' separating the chemical preparation, refinement and structure\n'
-                                  ' solution aspects of the experimental description.</pre>',
+                                  ' solution aspects of the experimental description.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_introduction': '<pre><h2>_publ_section_introduction</h2> The sections of a '
                                'manuscript if submitted in parts. As\n'
                                ' an alternative, see _publ_manuscript_text and\n'
@@ -5036,7 +5762,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                ' and _publ_section_exptl_solution items are preferred for\n'
                                ' separating the chemical preparation, refinement and structure\n'
-                               ' solution aspects of the experimental description.</pre>',
+                               ' solution aspects of the experimental description.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_keywords': '<pre><h2>_publ_section_keywords</h2> The sections of a manuscript if '
                            'submitted in parts. As\n'
                            ' an alternative, see _publ_manuscript_text and\n'
@@ -5045,7 +5772,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                            ' and _publ_section_exptl_solution items are preferred for\n'
                            ' separating the chemical preparation, refinement and structure\n'
-                           ' solution aspects of the experimental description.</pre>',
+                           ' solution aspects of the experimental description.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_references': '<pre><h2>_publ_section_references</h2> The sections of a manuscript '
                              'if submitted in parts. As\n'
                              ' an alternative, see _publ_manuscript_text and\n'
@@ -5054,7 +5782,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                              ' and _publ_section_exptl_solution items are preferred for\n'
                              ' separating the chemical preparation, refinement and structure\n'
-                             ' solution aspects of the experimental description.</pre>',
+                             ' solution aspects of the experimental description.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_related_literature': '<pre><h2>_publ_section_related_literature</h2> The sections '
                                      'of a manuscript if submitted in parts. As\n'
                                      ' an alternative, see _publ_manuscript_text and\n'
@@ -5065,7 +5794,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      ' and _publ_section_exptl_solution items are preferred for\n'
                                      ' separating the chemical preparation, refinement and '
                                      'structure\n'
-                                     ' solution aspects of the experimental description.</pre>',
+                                     ' solution aspects of the experimental description.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_synopsis': '<pre><h2>_publ_section_synopsis</h2> The sections of a manuscript if '
                            'submitted in parts. As\n'
                            ' an alternative, see _publ_manuscript_text and\n'
@@ -5074,7 +5804,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                            ' and _publ_section_exptl_solution items are preferred for\n'
                            ' separating the chemical preparation, refinement and structure\n'
-                           ' solution aspects of the experimental description.</pre>',
+                           ' solution aspects of the experimental description.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_table_legends': '<pre><h2>_publ_section_table_legends</h2> The sections of a '
                                 'manuscript if submitted in parts. As\n'
                                 ' an alternative, see _publ_manuscript_text and\n'
@@ -5083,7 +5814,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                 ' and _publ_section_exptl_solution items are preferred for\n'
                                 ' separating the chemical preparation, refinement and structure\n'
-                                ' solution aspects of the experimental description.</pre>',
+                                ' solution aspects of the experimental description.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_title': '<pre><h2>_publ_section_title</h2> The sections of a manuscript if '
                         'submitted in parts. As\n'
                         ' an alternative, see _publ_manuscript_text and\n'
@@ -5092,7 +5824,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                         ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                         ' and _publ_section_exptl_solution items are preferred for\n'
                         ' separating the chemical preparation, refinement and structure\n'
-                        ' solution aspects of the experimental description.</pre>',
+                        ' solution aspects of the experimental description.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_publ_section_title_footnote': '<pre><h2>_publ_section_title_footnote</h2> The sections of a '
                                  'manuscript if submitted in parts. As\n'
                                  ' an alternative, see _publ_manuscript_text and\n'
@@ -5101,7 +5834,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' The _publ_section_exptl_prep, _publ_section_exptl_refinement\n'
                                  ' and _publ_section_exptl_solution items are preferred for\n'
                                  ' separating the chemical preparation, refinement and structure\n'
-                                 ' solution aspects of the experimental description.</pre>',
+                                 ' solution aspects of the experimental description.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_refine_diff_density_max': '<pre><h2>_refine_diff_density_max</h2> The largest and smallest '
                              'values and the root-mean-square\n'
                              ' deviation, in electrons per angstrom cubed, of the final\n'
@@ -5110,7 +5844,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' summations over each grid point in the asymmetric unit of\n'
                              ' the cell. This quantity is useful for assessing the\n'
                              ' significance of *_min and *_max values, and also for\n'
-                             ' defining suitable contour levels.</pre>',
+                             ' defining suitable contour levels.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refine_diff_density_min': '<pre><h2>_refine_diff_density_min</h2> The largest and smallest '
                              'values and the root-mean-square\n'
                              ' deviation, in electrons per angstrom cubed, of the final\n'
@@ -5119,7 +5854,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' summations over each grid point in the asymmetric unit of\n'
                              ' the cell. This quantity is useful for assessing the\n'
                              ' significance of *_min and *_max values, and also for\n'
-                             ' defining suitable contour levels.</pre>',
+                             ' defining suitable contour levels.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refine_diff_density_rms': '<pre><h2>_refine_diff_density_rms</h2> The largest and smallest '
                              'values and the root-mean-square\n'
                              ' deviation, in electrons per angstrom cubed, of the final\n'
@@ -5128,7 +5864,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' summations over each grid point in the asymmetric unit of\n'
                              ' the cell. This quantity is useful for assessing the\n'
                              ' significance of *_min and *_max values, and also for\n'
-                             ' defining suitable contour levels.</pre>',
+                             ' defining suitable contour levels.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refine_ls_F_calc_details': '<pre><h2>_refine_ls_F_calc_details</h2> Details concerning the '
                               'evaluation of the structure\n'
                               ' factors using the expression given in\n'
@@ -5138,16 +5875,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               'Gaussian integration using 16 points\n'
                               '    Bessel functions expansion up to 5th order.\n'
                               '     Bessel functions estimated accuracy: better\n'
-                              '     than 0.001 electrons.</pre>',
+                              '     than 0.001 electrons.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_F_calc_formula': '<pre><h2>_refine_ls_F_calc_formula</h2> Analytical expression used '
-                              'to calculate the structure factors.  </pre>',
+                              'to calculate the structure factors.  </pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_F_calc_precision': '<pre><h2>_refine_ls_F_calc_precision</h2> This item gives an '
                                 'estimate of the precision resulting\n'
                                 ' from the numerical approximations made during the evaluation\n'
                                 ' of the structure factors using the expression given in\n'
                                 ' _refine_ls_F_calc_formula following the method outlined\n'
                                 ' in _refine_ls_F_calc_details.  For X-ray diffraction the\n'
-                                ' result is given in electrons.</pre>',
+                                ' result is given in electrons.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_R_Fsqd_factor': '<pre><h2>_refine_ls_R_Fsqd_factor</h2> Residual factor R(Fsqd), '
                              'calculated on the squared amplitudes\n'
                              ' of the observed and calculated structure factors, for\n'
@@ -5165,7 +5906,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' F(calc)^2^ = squares of the calculated structure-factor\n'
                              '              amplitudes\n'
                              '\n'
-                             ' and the sum is taken over the specified reflections</pre>',
+                             ' and the sum is taken over the specified reflections</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_R_I_factor': '<pre><h2>_refine_ls_R_I_factor</h2> Residual factor R(I) for '
                           'significantly intense reflections\n'
                           ' (satisfying _reflns_threshold_expression) and included in\n'
@@ -5181,7 +5924,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' I(obs)  = the net observed intensities\n'
                           ' I(calc) = the net calculated intensities\n'
                           '\n'
-                          ' and the sum is taken over the specified reflections</pre>',
+                          ' and the sum is taken over the specified reflections</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_R_factor_all': '<pre><h2>_refine_ls_R_factor_all</h2> Residual factor for all '
                             'reflections satisfying the\n'
                             ' resolution limits established by _refine_ls_d_res_high and\n'
@@ -5195,7 +5940,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             ' F(obs)  = the observed structure-factor amplitudes\n'
                             ' F(calc) = the calculated structure-factor amplitudes\n'
                             '\n'
-                            ' and the sum is taken over the specified reflections</pre>',
+                            ' and the sum is taken over the specified reflections</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_R_factor_gt': '<pre><h2>_refine_ls_R_factor_gt</h2> Residual factor for the '
                            'reflections (with number given by\n'
                            ' _reflns_number_gt) judged significantly intense (i.e. satisfying\n'
@@ -5212,7 +5959,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            ' F(obs)  = the observed structure-factor amplitudes\n'
                            ' F(calc) = the calculated structure-factor amplitudes\n'
                            '\n'
-                           ' and the sum is taken over the specified reflections</pre>',
+                           ' and the sum is taken over the specified reflections</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_R_factor_obs': '<pre><h2>_refine_ls_R_factor_obs</h2> Residual factor for the '
                             "reflections classified as 'observed'\n"
                             ' (see _reflns_observed_criterion) and included in the\n'
@@ -5228,7 +5977,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             ' F(obs)  = the observed structure-factor amplitudes\n'
                             ' F(calc) = the calculated structure-factor amplitudes\n'
                             '\n'
-                            ' and the sum is taken over the specified reflections</pre>',
+                            ' and the sum is taken over the specified reflections</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_abs_structure_Flack': '<pre><h2>_refine_ls_abs_structure_Flack</h2> The measure of '
                                    'absolute structure as defined by Flack (1983).\n'
                                    '\n'
@@ -5244,7 +5995,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' _enumeration_range of 0.0:1.0 is correctly interpreted as\n'
                                    ' meaning (0.0 - 3u) =&lt; x =&lt; (1.0 + 3u).\n'
                                    '\n'
-                                   ' Ref: Flack, H. D. (1983). Acta Cryst. A39, 876-881.</pre>',
+                                   ' Ref: Flack, H. D. (1983). Acta Cryst. A39, 876-881.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_refine_ls_abs_structure_Rogers': '<pre><h2>_refine_ls_abs_structure_Rogers</h2> The measure of '
                                     'absolute structure as defined by Rogers (1981).\n'
                                     '\n'
@@ -5257,9 +6010,12 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     ' interpreted as meaning (-1.0 - 3u) =&lt; \\h =&lt; (1.0 + '
                                     '3u).\n'
                                     '\n'
-                                    ' Ref: Rogers, D. (1981). Acta Cryst. A37, 734-741.</pre>',
+                                    ' Ref: Rogers, D. (1981). Acta Cryst. A37, 734-741.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_refine_ls_abs_structure_details': '<pre><h2>_refine_ls_abs_structure_details</h2> The nature of '
-                                     'the absolute structure and how it was determined.</pre>',
+                                     'the absolute structure and how it was determined.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_class_R_Fsqd_factor': '<pre><h2>_refine_ls_class_R_Fsqd_factor</h2> For each '
                                    'reflection class, the residual factor R(F^2^) calculated\n'
                                    ' on the squared amplitudes of the observed and calculated\n'
@@ -5283,7 +6039,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '              amplitudes\n'
                                    '\n'
                                    ' and the sum is taken over the reflections of this '
-                                   'class.</pre>',
+                                   'class.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_R_I_factor': '<pre><h2>_refine_ls_class_R_I_factor</h2> For each reflection '
                                 'class, the residual factor R(I) for the\n'
                                 ' reflections judged significantly intense (i.e. satisfying the\n'
@@ -5301,7 +6059,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 ' I(obs)  = the net observed intensities\n'
                                 ' I(calc) = the net calculated intensities\n'
                                 '\n'
-                                ' and the sum is taken over the reflections of this class.</pre>',
+                                ' and the sum is taken over the reflections of this class.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_R_factor_all': '<pre><h2>_refine_ls_class_R_factor_all</h2> For each reflection '
                                   'class, the residual factors for all\n'
                                   ' reflections, and for significantly intense reflections (see\n'
@@ -5320,7 +6080,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '\n'
                                   ' and the sum is taken over the reflections of this class. See '
                                   'also\n'
-                                  ' _refine_ls_class_wR_factor_all definitions.</pre>',
+                                  ' _refine_ls_class_wR_factor_all definitions.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_R_factor_gt': '<pre><h2>_refine_ls_class_R_factor_gt</h2> For each reflection '
                                  'class, the residual factors for all\n'
                                  ' reflections, and for significantly intense reflections (see\n'
@@ -5339,7 +6101,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  ' and the sum is taken over the reflections of this class. See '
                                  'also\n'
-                                 ' _refine_ls_class_wR_factor_all definitions.</pre>',
+                                 ' _refine_ls_class_wR_factor_all definitions.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_code': '<pre><h2>_refine_ls_class_code</h2> The code identifying a certain '
                           'reflection class. This code must\n'
                           ' match a _reflns_class_code.\n'
@@ -5347,15 +6111,20 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '<h3>Example:</h3>\n'
                           '1\n'
                           'm1\n'
-                          's2</pre>',
+                          's2</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_class_d_res_high': '<pre><h2>_refine_ls_class_d_res_high</h2> For each reflection '
                                 'class, the highest resolution in angstroms\n'
                                 ' for the reflections used in the refinement. This is\n'
-                                ' the lowest d value in a reflection class.</pre>',
+                                ' the lowest d value in a reflection class.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_d_res_low': '<pre><h2>_refine_ls_class_d_res_low</h2> For each reflection '
                                'class, the lowest resolution in angstroms\n'
                                ' for the reflections used in the refinement. This is\n'
-                               ' the highest d value in a reflection class.</pre>',
+                               ' the highest d value in a reflection class.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_class_wR_factor_all': '<pre><h2>_refine_ls_class_wR_factor_all</h2> For each '
                                    'reflection class, the weighted residual factors for all\n'
                                    ' reflections included in the refinement. The reflections also\n'
@@ -5373,15 +6142,21 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' w       = the least-squares weights\n'
                                    '\n'
                                    ' and the sum is taken over the reflections of this class. See\n'
-                                   ' also _refine_ls_class_R_factor_ definitions.</pre>',
+                                   ' also _refine_ls_class_R_factor_ definitions.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_d_res_high': '<pre><h2>_refine_ls_d_res_high</h2> The smallest value in angstroms of '
                           'the interplanar spacings\n'
                           ' of the reflections used in the refinement. This is called\n'
-                          ' the highest resolution.</pre>',
+                          ' the highest resolution.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_d_res_low': '<pre><h2>_refine_ls_d_res_low</h2> The largest value in angstroms of the '
                          'interplanar spacings\n'
                          ' of the reflections used in the refinement. This is called\n'
-                         ' the lowest resolution.</pre>',
+                         ' the lowest resolution.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_extinction_coef': '<pre><h2>_refine_ls_extinction_coef</h2> The extinction '
                                'coefficient used to calculate the correction\n'
                                ' factor applied to the structure-factor data. The nature of the\n'
@@ -5401,7 +6176,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '       Larson, A. C. (1967). Acta Cryst. 23, 664-665.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               '3472(52)</pre>',
+                               '3472(52)</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refine_ls_extinction_expression': '<pre><h2>_refine_ls_extinction_expression</h2> A description '
                                      'of or reference to the extinction-correction\n'
                                      ' equation used to apply the data item '
@@ -5413,7 +6189,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '<h3>Example:</h3>\n'
                                      ' Larson, A. C. (1970). "Crystallographic Computing",\n'
                                      ' edited by F. R. Ahmed. Eq. (22), p. 292.\n'
-                                     ' Copenhagen: Munksgaard.</pre>',
+                                     ' Copenhagen: Munksgaard.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_extinction_method': '<pre><h2>_refine_ls_extinction_method</h2> A description of the '
                                  'extinction-correction method applied.\n'
                                  ' This description should\n'
@@ -5445,7 +6222,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '\n'
                                  '<h3>Example:</h3>\n'
                                  'B-C type 2 Gaussian isotropic\n'
-                                 'none</pre>',
+                                 'none</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>\n'
+                                 '<br><p><h4>Default:</h4> Zachariasen </p>',
  '_refine_ls_goodness_of_fit_all': '<pre><h2>_refine_ls_goodness_of_fit_all</h2> The least-squares '
                                    'goodness-of-fit parameter S for all\n'
                                    ' reflections after the final cycle of refinement.\n'
@@ -5468,7 +6247,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' Nref   = the number of reflections used in the refinement\n'
                                    ' Nparam = the number of refined parameters\n'
                                    '\n'
-                                   ' and the sum is taken over the specified reflections</pre>',
+                                   ' and the sum is taken over the specified reflections</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_goodness_of_fit_gt': '<pre><h2>_refine_ls_goodness_of_fit_gt</h2> The least-squares '
                                   'goodness-of-fit parameter S for\n'
                                   ' significantly intense reflections (see\n'
@@ -5492,7 +6273,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' Nref   = the number of reflections used in the refinement\n'
                                   ' Nparam = the number of refined parameters\n'
                                   '\n'
-                                  ' and the sum is taken over the specified reflections</pre>',
+                                  ' and the sum is taken over the specified reflections</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_goodness_of_fit_obs': '<pre><h2>_refine_ls_goodness_of_fit_obs</h2> The least-squares '
                                    'goodness-of-fit parameter S for observed\n'
                                    ' reflections (see _reflns_observed_criterion) after the final\n'
@@ -5516,7 +6299,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' Nref   = the number of reflections used in the refinement\n'
                                    ' Nparam = the number of refined parameters\n'
                                    '\n'
-                                   ' and the sum is taken over the specified reflections</pre>',
+                                   ' and the sum is taken over the specified reflections</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_goodness_of_fit_ref': '<pre><h2>_refine_ls_goodness_of_fit_ref</h2> The least-squares '
                                    'goodness-of-fit parameter S for all\n'
                                    ' reflections included in the refinement after the final cycle\n'
@@ -5540,7 +6325,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    ' Nref   = the number of reflections used in the refinement\n'
                                    ' Nparam = the number of refined parameters\n'
                                    '\n'
-                                   ' and the sum is taken over the specified reflections</pre>',
+                                   ' and the sum is taken over the specified reflections</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_hydrogen_treatment': '<pre><h2>_refine_ls_hydrogen_treatment</h2> Treatment of '
                                   'hydrogen atoms in the least-squares refinement.\n'
                                   '\n'
@@ -5609,7 +6396,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   '\n'
                                   'undef\n'
                                   '\tH-atom parameters not defined\n'
-                                  '</pre>',
+                                  '</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>\n'
+                                  '<br><p><h4>Default:</h4> undef </p>',
  '_refine_ls_matrix_type': '<pre><h2>_refine_ls_matrix_type</h2> Type of matrix used to accumulate '
                            'the least-squares derivatives.\n'
                            '\n'
@@ -5631,7 +6420,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            '\n'
                            'sparse\n'
                            '\tselected elements only\n'
-                           '</pre>',
+                           '</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>\n'
+                           '<br><p><h4>Default:</h4> full </p>',
  '_refine_ls_number_constraints': '<pre><h2>_refine_ls_number_constraints</h2> The number of '
                                   'constrained (non-refined or dependent) parameters\n'
                                   ' in the least-squares process. These may be due to symmetry or '
@@ -5641,7 +6432,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' _atom_site_constraints and _atom_site_refinement_flags. A '
                                   'general\n'
                                   ' description of constraints may appear in '
-                                  '_refine_special_details.</pre>',
+                                  '_refine_special_details.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_refine_ls_number_parameters': '<pre><h2>_refine_ls_number_parameters</h2> The number of '
                                  'parameters refined in the least-squares process.\n'
                                  ' If possible, this number should include some contribution from\n'
@@ -5651,10 +6444,14 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' another). Least-squares restraints often depend on geometry or\n'
                                  ' energy considerations and this makes their direct contribution\n'
                                  ' to this number, and to the goodness-of-fit calculation,\n'
-                                 ' difficult to assess.</pre>',
+                                 ' difficult to assess.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_refine_ls_number_reflns': '<pre><h2>_refine_ls_number_reflns</h2> The number of unique '
                              'reflections contributing to the\n'
-                             ' least-squares refinement calculation.</pre>',
+                             ' least-squares refinement calculation.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_refine_ls_number_restraints': '<pre><h2>_refine_ls_number_restraints</h2> The number of '
                                  'restrained parameters. These are parameters which\n'
                                  ' are not directly dependent on another refined parameter.\n'
@@ -5663,7 +6460,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' See also _atom_site_constraints and '
                                  '_atom_site_refinement_flags.\n'
                                  ' A general description of refinement constraints may appear in\n'
-                                 ' _refine_special_details.</pre>',
+                                 ' _refine_special_details.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_refine_ls_restrained_S_all': '<pre><h2>_refine_ls_restrained_S_all</h2> The least-squares '
                                 "goodness-of-fit parameter S' for all\n"
                                 ' reflections after the final cycle of least-squares refinement.\n'
@@ -5697,7 +6496,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '          (see _refine_ls_number_parameters)\n'
                                 '\n'
                                 ' sum     is taken over the specified reflections\n'
-                                ' sum~r~  is taken over the restraints</pre>',
+                                ' sum~r~  is taken over the restraints</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_restrained_S_gt': '<pre><h2>_refine_ls_restrained_S_gt</h2> The least-squares '
                                "goodness-of-fit parameter S' for\n"
                                ' significantly intense reflections (satisfying\n'
@@ -5730,7 +6531,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '          (see _refine_ls_number_parameters)\n'
                                '\n'
                                ' sum     is taken over the specified reflections\n'
-                               ' sum~r~  is taken over the restraints</pre>',
+                               ' sum~r~  is taken over the restraints</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_restrained_S_obs': '<pre><h2>_refine_ls_restrained_S_obs</h2> The least-squares '
                                 "goodness-of-fit parameter S' for observed\n"
                                 ' reflections after the final cycle of least-squares refinement.\n'
@@ -5764,33 +6567,48 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '          (see _refine_ls_number_parameters)\n'
                                 '\n'
                                 ' sum     is taken over the specified reflections\n'
-                                ' sum~r~  is taken over the restraints</pre>',
+                                ' sum~r~  is taken over the restraints</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/esd_max': '<pre><h2>_refine_ls_shift/esd_max</h2> The largest ratio of the '
                              'final least-squares parameter\n'
                              ' shift to the final standard uncertainty (s.u.,\n'
-                             ' formerly described as estimated standard deviation, e.s.d.).</pre>',
+                             ' formerly described as estimated standard deviation, e.s.d.).</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/esd_mean': '<pre><h2>_refine_ls_shift/esd_mean</h2> The average ratio of the '
                               'final least-squares parameter\n'
                               ' shift to the final standard uncertainty (s.u.,\n'
-                              ' formerly described as estimated standard deviation, e.s.d.).</pre>',
+                              ' formerly described as estimated standard deviation, '
+                              'e.s.d.).</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/su_max': '<pre><h2>_refine_ls_shift/su_max</h2> The largest ratio of the final '
                             'least-squares parameter\n'
-                            ' shift to the final standard uncertainty.</pre>',
+                            ' shift to the final standard uncertainty.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/su_max_lt': '<pre><h2>_refine_ls_shift/su_max_lt</h2> An upper limit for the '
                                'largest ratio of the final\n'
                                ' least-squares parameter shift to the final\n'
                                ' standard uncertainty.  This item is used when the largest\n'
                                ' value of the shift divided by the final standard uncertainty\n'
-                               ' is too small to measure.</pre>',
+                               ' is too small to measure.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/su_mean': '<pre><h2>_refine_ls_shift/su_mean</h2> The average ratio of the '
                              'final least-squares parameter\n'
-                             ' shift to the final standard uncertainty.</pre>',
+                             ' shift to the final standard uncertainty.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_shift/su_mean_lt': '<pre><h2>_refine_ls_shift/su_mean_lt</h2> An upper limit for the '
                                 'average ratio of the final\n'
                                 ' least-squares parameter shift to the\n'
                                 ' final standard uncertainty.  This\n'
                                 ' item is used when the average value of the shift divided by\n'
-                                ' the final standard uncertainty is too small to measure.</pre>',
+                                ' the final standard uncertainty is too small to measure.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_structure_factor_coef': '<pre><h2>_refine_ls_structure_factor_coef</h2> '
                                      'Structure-factor coefficient |F|, F^2^ or I used in the\n'
                                      ' least-squares refinement process.\n'
@@ -5804,7 +6622,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      '\n'
                                      'Inet\n'
                                      '\tnet intensity\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>\n'
+                                     '<br><p><h4>Default:</h4> F </p>',
  '_refine_ls_wR_factor_all': '<pre><h2>_refine_ls_wR_factor_all</h2> Weighted residual factors for '
                              'all reflections.\n'
                              ' The reflections also satisfy the resolution limits established\n'
@@ -5821,7 +6641,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '           _refine_ls_structure_factor_coef\n'
                              ' w       = the least-squares weight\n'
                              '\n'
-                             ' and the sum is taken over the specified reflections</pre>',
+                             ' and the sum is taken over the specified reflections</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_wR_factor_gt': '<pre><h2>_refine_ls_wR_factor_gt</h2> Weighted residual factors for '
                             'significantly intense reflections\n'
                             ' (satisfying _reflns_threshold_expression) included in the\n'
@@ -5840,7 +6662,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             '           _refine_ls_structure_factor_coef\n'
                             ' w       = the least-squares weight\n'
                             '\n'
-                            ' and the sum is taken over the specified reflections</pre>',
+                            ' and the sum is taken over the specified reflections</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_wR_factor_obs': '<pre><h2>_refine_ls_wR_factor_obs</h2> Weighted residual factors for '
                              'the reflections classified as\n'
                              " 'observed' (see _reflns_observed_criterion) and included\n"
@@ -5859,7 +6683,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '           _refine_ls_structure_factor_coef\n'
                              ' w       = the least-squares weight\n'
                              '\n'
-                             ' and the sum is taken over the specified reflections</pre>',
+                             ' and the sum is taken over the specified reflections</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_wR_factor_ref': '<pre><h2>_refine_ls_wR_factor_ref</h2> Weighted residual factors for '
                              'all reflections included in the\n'
                              ' refinement.  The reflections also satisfy the resolution\n'
@@ -5877,7 +6703,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '           _refine_ls_structure_factor_coef\n'
                              ' w       = the least-squares weight\n'
                              '\n'
-                             ' and the sum is taken over the specified reflections</pre>',
+                             ' and the sum is taken over the specified reflections</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_weighting_details': '<pre><h2>_refine_ls_weighting_details</h2> A description of '
                                  'special aspects of the weighting scheme used\n'
                                  ' in the least-squares refinement. Used to describe the '
@@ -5890,7 +6718,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  '     Sigdel = Afsig +  Bfsig*(sin(\\q)/\\l - 1/6)\n'
                                  '     Afsig = 22.0, Bfsig = 150.0 at the beginning of '
                                  'refinement.\n'
-                                 '     Afsig = 16.0, Bfsig =  60.0 at the end of refinement.</pre>',
+                                 '     Afsig = 16.0, Bfsig =  60.0 at the end of '
+                                 'refinement.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_weighting_scheme': '<pre><h2>_refine_ls_weighting_scheme</h2> The weighting scheme '
                                 'applied in the least-squares process. The\n'
                                 ' standard code may be followed by a description of the weight\n'
@@ -5906,53 +6736,66 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 '\n'
                                 'calc\n'
                                 '\tcalculated weights applied\n'
-                                '</pre>',
+                                '</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>\n'
+                                '<br><p><h4>Default:</h4> sigma </p>',
  '_refine_special_details': '<pre><h2>_refine_special_details</h2> Description of special aspects '
-                            'of the refinement process.</pre>',
+                            'of the refinement process.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_refln_A_calc': '<pre><h2>_refln_A_calc</h2> The calculated and measured structure-factor '
                   'component A\n'
                   ' (in electrons for X-ray diffraction).\n'
                   '\n'
-                  ' A =|F|cos(phase)</pre>',
+                  ' A =|F|cos(phase)</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_A_meas': '<pre><h2>_refln_A_meas</h2> The calculated and measured structure-factor '
                   'component A\n'
                   ' (in electrons for X-ray diffraction).\n'
                   '\n'
-                  ' A =|F|cos(phase)</pre>',
+                  ' A =|F|cos(phase)</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_B_calc': '<pre><h2>_refln_B_calc</h2> The calculated and measured structure-factor '
                   'component B\n'
                   ' (in electrons for X-ray diffraction).\n'
                   '\n'
-                  ' B =|F|sin(phase)</pre>',
+                  ' B =|F|sin(phase)</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_B_meas': '<pre><h2>_refln_B_meas</h2> The calculated and measured structure-factor '
                   'component B\n'
                   ' (in electrons for X-ray diffraction).\n'
                   '\n'
-                  ' B =|F|sin(phase)</pre>',
+                  ' B =|F|sin(phase)</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_calc': '<pre><h2>_refln_F_calc</h2> The calculated, measured and standard uncertainty '
                   '(derived from\n'
                   ' measurement) of the structure factors (in electrons for\n'
-                  ' X-ray diffraction).</pre>',
+                  ' X-ray diffraction).</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_meas': '<pre><h2>_refln_F_meas</h2> The calculated, measured and standard uncertainty '
                   '(derived from\n'
                   ' measurement) of the structure factors (in electrons for\n'
-                  ' X-ray diffraction).</pre>',
+                  ' X-ray diffraction).</pre>\n'
+                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_sigma': '<pre><h2>_refln_F_sigma</h2> The calculated, measured and standard uncertainty '
                    '(derived from\n'
                    ' measurement) of the structure factors (in electrons for\n'
-                   ' X-ray diffraction).</pre>',
+                   ' X-ray diffraction).</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_squared_calc': '<pre><h2>_refln_F_squared_calc</h2> Calculated, measured and estimated '
                           'standard uncertainty (derived\n'
                           ' from measurement) of the squared structure factors (in electrons\n'
-                          ' squared for X-ray diffraction).</pre>',
+                          ' squared for X-ray diffraction).</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_squared_meas': '<pre><h2>_refln_F_squared_meas</h2> Calculated, measured and estimated '
                           'standard uncertainty (derived\n'
                           ' from measurement) of the squared structure factors (in electrons\n'
-                          ' squared for X-ray diffraction).</pre>',
+                          ' squared for X-ray diffraction).</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_F_squared_sigma': '<pre><h2>_refln_F_squared_sigma</h2> Calculated, measured and '
                            'estimated standard uncertainty (derived\n'
                            ' from measurement) of the squared structure factors (in electrons\n'
-                           ' squared for X-ray diffraction).</pre>',
+                           ' squared for X-ray diffraction).</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_class_code': '<pre><h2>_refln_class_code</h2> The code identifying the class to which '
                       'this reflection has been\n'
                       ' assigned. This code must match a value of _reflns_class_code.\n'
@@ -5961,14 +6804,18 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       ' class may be defined by the number m=sum|m~i~|, where the m~i~\n'
                       ' are the integer coefficients that, in addition to h,k,l, index\n'
                       ' the corresponding diffraction vector in the basis defined\n'
-                      ' for the reciprocal lattice.</pre>',
+                      ' for the reciprocal lattice.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_refln_crystal_id': '<pre><h2>_refln_crystal_id</h2> Code identifying each crystal if multiple '
                       'crystals are used. Is\n'
-                      ' used to link with _exptl_crystal_id in the _exptl_crystal_ list.</pre>',
+                      ' used to link with _exptl_crystal_id in the _exptl_crystal_ list.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_refln_d_spacing': '<pre><h2>_refln_d_spacing</h2> The d spacing in angstroms for this '
                      'reflection. This is related\n'
                      ' to the (sin theta)/lambda value by the expression\n'
-                     '      _refln_d_spacing = 2/(_refln_sint/lambda)</pre>',
+                     '      _refln_d_spacing = 2/(_refln_sint/lambda)</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refln_include_status': '<pre><h2>_refln_include_status</h2> Classification of a reflection '
                           'indicating its status with\n'
                           ' respect to inclusion in the refinement and the calculation\n'
@@ -5998,34 +6845,44 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           '\n'
                           'l\n'
                           '\tdoes not satisfy _refine_ls_d_res_low\n'
-                          '</pre>',
+                          '</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>\n'
+                          '<br><p><h4>Default:</h4> o </p>',
  '_refln_index_h': '<pre><h2>_refln_index_h</h2> Miller indices of the reflection. The values of '
                    'the Miller\n'
                    ' indices in the REFLN category must correspond to the cell\n'
-                   ' defined by the cell lengths and cell angles in the CELL category.</pre>',
+                   ' defined by the cell lengths and cell angles in the CELL category.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_k': '<pre><h2>_refln_index_k</h2> Miller indices of the reflection. The values of '
                    'the Miller\n'
                    ' indices in the REFLN category must correspond to the cell\n'
-                   ' defined by the cell lengths and cell angles in the CELL category.</pre>',
+                   ' defined by the cell lengths and cell angles in the CELL category.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_l': '<pre><h2>_refln_index_l</h2> Miller indices of the reflection. The values of '
                    'the Miller\n'
                    ' indices in the REFLN category must correspond to the cell\n'
-                   ' defined by the cell lengths and cell angles in the CELL category.</pre>',
+                   ' defined by the cell lengths and cell angles in the CELL category.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_intensity_calc': '<pre><h2>_refln_intensity_calc</h2> The calculated, measured and '
                           'standard uncertainty (derived from\n'
                           ' measurement) of the intensity, all in the same arbitrary units\n'
-                          ' as _refln_intensity_meas.</pre>',
+                          ' as _refln_intensity_meas.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_intensity_meas': '<pre><h2>_refln_intensity_meas</h2> The calculated, measured and '
                           'standard uncertainty (derived from\n'
                           ' measurement) of the intensity, all in the same arbitrary units\n'
-                          ' as _refln_intensity_meas.</pre>',
+                          ' as _refln_intensity_meas.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_intensity_sigma': '<pre><h2>_refln_intensity_sigma</h2> The calculated, measured and '
                            'standard uncertainty (derived from\n'
                            ' measurement) of the intensity, all in the same arbitrary units\n'
-                           ' as _refln_intensity_meas.</pre>',
+                           ' as _refln_intensity_meas.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_mean_path_length_tbar': '<pre><h2>_refln_mean_path_length_tbar</h2> Mean path length in '
                                  'millimetres through the crystal for this\n'
-                                 ' reflection.</pre>',
+                                 ' reflection.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refln_observed_status': '<pre><h2>_refln_observed_status</h2> Classification of a reflection '
                            'indicating its status with\n'
                            ' respect to inclusion in the refinement and the calculation\n'
@@ -6053,11 +6910,15 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            '\n'
                            'l\n'
                            '\tdoes not satisfy _refine_ls_d_res_low\n'
-                           '</pre>',
+                           '</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>\n'
+                           '<br><p><h4>Default:</h4> o </p>',
  '_refln_phase_calc': '<pre><h2>_refln_phase_calc</h2> The calculated structure-factor phase in '
-                      'degrees.</pre>',
+                      'degrees.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_phase_meas': '<pre><h2>_refln_phase_meas</h2> The measured structure-factor phase in '
-                      'degrees.</pre>',
+                      'degrees.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_refinement_status': '<pre><h2>_refln_refinement_status</h2> Status of a reflection in the '
                              'structure-refinement process.\n'
                              '\n'
@@ -6070,7 +6931,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '\n'
                              'extn\n'
                              '\texcluded due to extinction\n'
-                             '</pre>',
+                             '</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>\n'
+                             '<br><p><h4>Default:</h4> incl </p>',
  '_refln_scale_group_code': '<pre><h2>_refln_scale_group_code</h2> Code identifying the '
                             'structure-factor scale. This code must\n'
                             ' correspond to one of the _reflns_scale_group_code values.\n'
@@ -6084,28 +6947,39 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             'B\n'
                             'c1\n'
                             'c2\n'
-                            'c3</pre>',
+                            'c3</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_refln_sint/lambda': '<pre><h2>_refln_sint/lambda</h2> The (sin theta)/lambda value in '
                        'reciprocal angstroms for this\n'
-                       ' reflection.</pre>',
+                       ' reflection.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refln_symmetry_epsilon': '<pre><h2>_refln_symmetry_epsilon</h2> The symmetry reinforcement '
                             'factor corresponding to the number of\n'
                             ' times the reflection indices are generated identically from the\n'
-                            ' space-group symmetry operations.</pre>',
+                            ' space-group symmetry operations.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 1:48 </p>',
  '_refln_symmetry_multiplicity': '<pre><h2>_refln_symmetry_multiplicity</h2> The number of '
                                  'reflections symmetry-equivalent under the Laue\n'
                                  ' symmetry to the present reflection. In the Laue symmetry, '
                                  'Friedel\n'
                                  ' opposites (h k l and -h -k -l) are equivalent. Tables of\n'
                                  ' symmetry-equivalent reflections are available in International\n'
-                                 ' Tables for Crystallography Volume A (2002), Chapter 10.1.</pre>',
+                                 ' Tables for Crystallography Volume A (2002), Chapter '
+                                 '10.1.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 1:48 </p>',
  '_refln_wavelength': '<pre><h2>_refln_wavelength</h2> The mean wavelength in angstroms of the '
                       'radiation used to measure\n'
                       ' this reflection. This is an important parameter for data\n'
-                      ' collected using energy-dispersive detectors or the Laue method.</pre>',
+                      ' collected using energy-dispersive detectors or the Laue method.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refln_wavelength_id': '<pre><h2>_refln_wavelength_id</h2> Code identifying the wavelength in '
                          'the _diffrn_radiation_ list.\n'
-                         ' See _diffrn_radiation_wavelength_id.</pre>',
+                         ' See _diffrn_radiation_wavelength_id.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_reflns_Friedel_coverage': '<pre><h2>_reflns_Friedel_coverage</h2> The proportion of '
                              'Friedel-related reflections present in\n'
                              " the number of 'independent' reflections specified by\n"
@@ -6140,7 +7014,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              '       two inequivalent octants h &gt;= 0, k &gt;=0, l lead to the\n'
                              '       same value as in (c), whereas measurements of the\n'
                              '       two equivalent octants h &gt;= 0, k, l &gt;= 0 will lead to\n'
-                             '       a value of zero for _reflns_Friedel_coverage.</pre>',
+                             '       a value of zero for _reflns_Friedel_coverage.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_reflns_Friedel_fraction_full': '<pre><h2>_reflns_Friedel_fraction_full</h2> The number of '
                                   'Friedel pairs measured out to\n'
                                   ' _diffrn_reflns_theta_full. divided by the\n'
@@ -6151,7 +7027,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                   ' non-centrosymmetric space group, and so one can see at\n'
                                   ' a glance how completely the Friedel pairs have been\n'
                                   ' measured. For centrosymmetric space groups the value\n'
-                                  " would be 0/0 and so would be given as '.'.</pre>",
+                                  " would be 0/0 and so would be given as '.'.</pre>\n"
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_reflns_Friedel_fraction_max': '<pre><h2>_reflns_Friedel_fraction_max</h2> The number of Friedel '
                                  'pairs measured out to\n'
                                  ' _diffrn_reflns_theta_max. divided by the\n'
@@ -6162,7 +7040,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' non-centrosymmetric space group, and so one can see at\n'
                                  ' a glance how completely the Friedel pairs have been\n'
                                  ' measured. For centrosymmetric space groups the value\n'
-                                 " would be 0/0 and so would be given as '.'.</pre>",
+                                 " would be 0/0 and so would be given as '.'.</pre>\n"
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:1.0 </p>',
  '_reflns_class_R_Fsqd_factor': '<pre><h2>_reflns_class_R_Fsqd_factor</h2> For each reflection '
                                 'class, the residual factor R(F^2^) calculated\n'
                                 ' on the squared amplitudes of the observed and calculated\n'
@@ -6182,7 +7062,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 ' F(calc)^2^ = squares of the calculated structure-factor\n'
                                 '              amplitudes\n'
                                 '\n'
-                                ' and the sum is taken over the reflections of this class.</pre>',
+                                ' and the sum is taken over the reflections of this class.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_R_I_factor': '<pre><h2>_reflns_class_R_I_factor</h2> For each reflection class, '
                              'the residual factor R(I) for the\n'
                              ' reflections judged significantly intense (i.e. satisfying the\n'
@@ -6199,7 +7081,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                              ' I(obs)  = the net observed intensities\n'
                              ' I(calc) = the net calculated intensities\n'
                              '\n'
-                             ' and the sum is taken over the reflections of this class.</pre>',
+                             ' and the sum is taken over the reflections of this class.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_R_factor_all': '<pre><h2>_reflns_class_R_factor_all</h2> For each reflection '
                                'class, the residual factors for all\n'
                                ' reflections, and for significantly intense reflections (see\n'
@@ -6218,7 +7102,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '\n'
                                ' and the sum is taken over the reflections of this class. See '
                                'also\n'
-                               ' _reflns_class_wR_factor_all definitions.</pre>',
+                               ' _reflns_class_wR_factor_all definitions.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_R_factor_gt': '<pre><h2>_reflns_class_R_factor_gt</h2> For each reflection class, '
                               'the residual factors for all\n'
                               ' reflections, and for significantly intense reflections (see\n'
@@ -6235,28 +7121,36 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               ' F(calc) = the calculated structure-factor amplitudes\n'
                               '\n'
                               ' and the sum is taken over the reflections of this class. See also\n'
-                              ' _reflns_class_wR_factor_all definitions.</pre>',
+                              ' _reflns_class_wR_factor_all definitions.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_code': '<pre><h2>_reflns_class_code</h2> The code identifying a certain reflection '
                        'class.\n'
                        '\n'
                        '<h3>Example:</h3>\n'
                        '1\n'
                        'm1\n'
-                       's2</pre>',
+                       's2</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_reflns_class_d_res_high': '<pre><h2>_reflns_class_d_res_high</h2> For each reflection class, '
                              'the highest resolution in angstroms\n'
                              ' for the reflections used in the refinement. This is the smallest\n'
-                             ' d value.</pre>',
+                             ' d value.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_d_res_low': '<pre><h2>_reflns_class_d_res_low</h2> For each reflection class, the '
                             'lowest resolution in angstroms\n'
                             ' for the reflections used in the refinement. This is the largest\n'
-                            ' d value.</pre>',
+                            ' d value.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_description': '<pre><h2>_reflns_class_description</h2> Description of each '
                               'reflection class.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
                               'm=1 first order satellites\n'
-                              'H0L0 common projection reflections</pre>',
+                              'H0L0 common projection reflections</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_reflns_class_number_gt': '<pre><h2>_reflns_class_number_gt</h2> For each reflection class, the '
                             'number of significantly intense\n'
                             ' reflections (see _reflns_threshold_expression) in the _refln_\n'
@@ -6266,7 +7160,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             ' class)  according to the nature of the structure and the\n'
                             ' procedures used. Special characteristics of the reflections\n'
                             ' included in the _refln_ list should be given in the item\n'
-                            ' _reflns_special_details.</pre>',
+                            ' _reflns_special_details.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_number_total': '<pre><h2>_reflns_class_number_total</h2> For each reflection '
                                'class, the total number of reflections\n'
                                ' in the _refln_ list (not the _diffrn_refln_ list). This may\n'
@@ -6275,7 +7171,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' under the crystal class) according to the nature of the\n'
                                ' structure and the procedures used. Special characteristics\n'
                                ' of the reflections included in the _refln_ list should be given\n'
-                               ' in the item _reflns_special_details.</pre>',
+                               ' in the item _reflns_special_details.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_class_wR_factor_all': '<pre><h2>_reflns_class_wR_factor_all</h2> For each reflection '
                                 'class, the weighted residual factors for all\n'
                                 ' reflections included in the refinement. The reflections also\n'
@@ -6293,31 +7191,43 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 ' w       = the least-squares weights\n'
                                 '\n'
                                 ' and the sum is taken over the reflections of this class. See\n'
-                                ' also _reflns_class_R_factor_ definitions.</pre>',
+                                ' also _reflns_class_R_factor_ definitions.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_d_resolution_high': '<pre><h2>_reflns_d_resolution_high</h2> The highest and lowest '
                               'resolution in angstroms for the\n'
-                              ' reflections. These are the smallest and largest d values.</pre>',
+                              ' reflections. These are the smallest and largest d values.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_d_resolution_low': '<pre><h2>_reflns_d_resolution_low</h2> The highest and lowest '
                              'resolution in angstroms for the\n'
-                             ' reflections. These are the smallest and largest d values.</pre>',
+                             ' reflections. These are the smallest and largest d values.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_limit_h_max': '<pre><h2>_reflns_limit_h_max</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_h_min': '<pre><h2>_reflns_limit_h_min</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_k_max': '<pre><h2>_reflns_limit_k_max</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_k_min': '<pre><h2>_reflns_limit_k_min</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_l_max': '<pre><h2>_reflns_limit_l_max</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_l_min': '<pre><h2>_reflns_limit_l_min</h2> Miller indices limits for the reported '
                         'reflections. These need\n'
-                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>',
+                        ' not be the same as the _diffrn_reflns_limit_ values.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_number_gt': '<pre><h2>_reflns_number_gt</h2> The number of reflections in the _refln_ '
                       'list (not the\n'
                       ' _diffrn_refln_ list) that are significantly intense, satisfying\n'
@@ -6327,7 +7237,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                       ' under the crystal class) according to the nature of the\n'
                       ' structure and the procedures used. Special characteristics\n'
                       ' of the reflections included in the _refln_ list should be given\n'
-                      ' in the item _reflns_special_details.</pre>',
+                      ' in the item _reflns_special_details.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_number_observed': "<pre><h2>_reflns_number_observed</h2> The number of 'observed' "
                             'reflections in the _refln_ list (not\n'
                             ' the _diffrn_refln_ list). The observed reflections satisfy the\n'
@@ -6336,7 +7248,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                             ' include Friedel-equivalent reflections according to the nature\n'
                             ' of the structure and the procedures used. Special characteristics\n'
                             ' of the reflections included in the _refln_ list should be given\n'
-                            ' in the item _reflns_special_details.</pre>',
+                            ' in the item _reflns_special_details.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_number_total': '<pre><h2>_reflns_number_total</h2> The total number of reflections in '
                          'the _refln_ list (not the\n'
                          '  _diffrn_refln_ list). This may include Friedel-equivalent\n'
@@ -6345,7 +7259,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                          ' according to the nature of the structure and the procedures\n'
                          ' used. Special characteristics of the reflections included\n'
                          ' in the _refln_ list should be given in the item\n'
-                         ' _reflns_special_details.</pre>',
+                         ' _reflns_special_details.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_observed_criterion': '<pre><h2>_reflns_observed_criterion</h2> The criterion used to '
                                "classify a reflection as 'observed'. This\n"
                                ' criterion is usually expressed in terms of a sigma(I) or '
@@ -6353,18 +7269,26 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' threshold.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               'I&gt;2u(I)</pre>',
+                               'I&gt;2u(I)</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_reflns_scale_group_code': '<pre><h2>_reflns_scale_group_code</h2> The code identifying a scale '
                              '_reflns_scale_meas_. These are\n'
                              ' linked to the _refln_ list by the _refln_scale_group_code. These\n'
                              ' codes need not correspond to those in the _diffrn_scale_ '
-                             'list.</pre>',
+                             'list.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_reflns_scale_meas_F': '<pre><h2>_reflns_scale_meas_F</h2> Scales associated with '
-                         '_reflns_scale_group_code.</pre>',
+                         '_reflns_scale_group_code.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_scale_meas_F_squared': '<pre><h2>_reflns_scale_meas_F_squared</h2> Scales associated '
-                                 'with _reflns_scale_group_code.</pre>',
+                                 'with _reflns_scale_group_code.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_scale_meas_intensity': '<pre><h2>_reflns_scale_meas_intensity</h2> Scales associated '
-                                 'with _reflns_scale_group_code.</pre>',
+                                 'with _reflns_scale_group_code.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_F_all': '<pre><h2>_reflns_shell_Rmerge_F_all</h2> The value of Rmerge(F) '
                                'for all reflections in a given shell.\n'
                                '\n'
@@ -6377,7 +7301,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '        reflection i\n'
                                '\n'
                                ' sum~i~ is taken over all reflections\n'
-                               ' sum~j~ is taken over all observations of each reflection.</pre>',
+                               ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_F_gt': '<pre><h2>_reflns_shell_Rmerge_F_gt</h2> The value of Rmerge(F) for '
                               'significantly intense reflections\n'
                               ' (see _reflns_threshold_expression) in a given shell.\n'
@@ -6391,7 +7317,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '        reflection i\n'
                               '\n'
                               ' sum~i~ is taken over all reflections\n'
-                              ' sum~j~ is taken over all observations of each reflection.</pre>',
+                              ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_F_obs': '<pre><h2>_reflns_shell_Rmerge_F_obs</h2> The value of Rmerge(F) '
                                "for reflections classified as 'observed'\n"
                                ' (see _reflns_observed_criterion) in a given shell.\n'
@@ -6405,7 +7333,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '        reflection i\n'
                                '\n'
                                ' sum~i~ is taken over all reflections\n'
-                               ' sum~j~ is taken over all observations of each reflection.</pre>',
+                               ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_I_all': '<pre><h2>_reflns_shell_Rmerge_I_all</h2> The value of Rmerge(I) '
                                'for all reflections in a given shell.\n'
                                '\n'
@@ -6418,7 +7348,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '        reflection i\n'
                                '\n'
                                ' sum~i~ is taken over all reflections\n'
-                               ' sum~j~ is taken over all observations of each reflection.</pre>',
+                               ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_I_gt': '<pre><h2>_reflns_shell_Rmerge_I_gt</h2> The value of Rmerge(I) for '
                               'significantly intense reflections\n'
                               ' (see _reflns_threshold_expression) in a given shell.\n'
@@ -6432,7 +7364,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '        reflection i\n'
                               '\n'
                               ' sum~i~ is taken over all reflections\n'
-                              ' sum~j~ is taken over all observations of each reflection.</pre>',
+                              ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_Rmerge_I_obs': '<pre><h2>_reflns_shell_Rmerge_I_obs</h2> The value of Rmerge(I) '
                                "for reflections classified as 'observed'\n"
                                ' (see _reflns_observed_criterion) in a given shell.\n'
@@ -6446,19 +7380,26 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                '        reflection i\n'
                                '\n'
                                ' sum~i~ is taken over all reflections\n'
-                               ' sum~j~ is taken over all observations of each reflection.</pre>',
+                               ' sum~j~ is taken over all observations of each reflection.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_d_res_high': '<pre><h2>_reflns_shell_d_res_high</h2> The highest resolution in '
                              'angstroms for the reflections in\n'
-                             ' this shell. This is the smallest d value.</pre>',
+                             ' this shell. This is the smallest d value.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_d_res_low': '<pre><h2>_reflns_shell_d_res_low</h2> The lowest resolution in '
                             'angstroms for the\n'
-                            ' reflections in this shell. This is the largest d value.</pre>',
+                            ' reflections in this shell. This is the largest d value.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_meanI_over_sigI_all': '<pre><h2>_reflns_shell_meanI_over_sigI_all</h2> The ratio '
                                       'of the mean of the intensities of all reflections\n'
                                       ' in this shell to the mean of the standard uncertainties of '
                                       'the\n'
                                       ' intensities of all reflections in the resolution '
-                                      'shell.</pre>',
+                                      'shell.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_shell_meanI_over_sigI_gt': '<pre><h2>_reflns_shell_meanI_over_sigI_gt</h2> The ratio of '
                                      'the mean of the intensities of the significantly\n'
                                      ' intense reflections (see _reflns_threshold_expression) in\n'
@@ -6466,7 +7407,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      'the\n'
                                      ' intensities of the significantly intense reflections in '
                                      'the\n'
-                                     ' resolution shell.</pre>',
+                                     ' resolution shell.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_shell_meanI_over_sigI_obs': '<pre><h2>_reflns_shell_meanI_over_sigI_obs</h2> The ratio '
                                       'of the mean of the intensities of the reflections\n'
                                       " classified as 'observed' (see _reflns_observed_criterion) "
@@ -6475,66 +7417,90 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                       'the\n'
                                       " intensities of the 'observed' reflections in the "
                                       'resolution\n'
-                                      ' shell.</pre>',
+                                      ' shell.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_shell_meanI_over_uI_all': '<pre><h2>_reflns_shell_meanI_over_uI_all</h2> The ratio of '
                                     'the mean of the intensities of all reflections\n'
                                     ' in this shell to the mean of the standard uncertainties of '
                                     'the\n'
                                     ' intensities of all reflections in the resolution '
-                                    'shell.</pre>',
+                                    'shell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_shell_meanI_over_uI_gt': '<pre><h2>_reflns_shell_meanI_over_uI_gt</h2> The ratio of the '
                                    'mean of the intensities of the significantly\n'
                                    ' intense reflections (see _reflns_threshold_expression) in\n'
                                    ' this shell to the mean of the standard uncertainties of the\n'
                                    ' intensities of the significantly intense reflections in the\n'
-                                   ' resolution shell.</pre>',
+                                   ' resolution shell.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_shell_number_measured_all': '<pre><h2>_reflns_shell_number_measured_all</h2> The total '
                                       'number of reflections measured for this\n'
-                                      ' resolution shell.</pre>',
+                                      ' resolution shell.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_number_measured_gt': '<pre><h2>_reflns_shell_number_measured_gt</h2> The number of '
                                      'significantly intense reflections\n'
                                      ' (see _reflns_threshold_expression) measured for this\n'
-                                     ' resolution shell.</pre>',
+                                     ' resolution shell.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_number_measured_obs': '<pre><h2>_reflns_shell_number_measured_obs</h2> The number '
                                       "of reflections classified as 'observed'\n"
                                       ' (see _reflns_observed_criterion) measured for this\n'
-                                      ' resolution shell.</pre>',
+                                      ' resolution shell.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_reflns_shell_number_possible': '<pre><h2>_reflns_shell_number_possible</h2> The number of '
                                   'unique reflections it is possible to measure in\n'
-                                  ' this reflection shell.</pre>',
+                                  ' this reflection shell.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_shell_number_unique_all': '<pre><h2>_reflns_shell_number_unique_all</h2> The total '
                                     'number of measured reflections resulting from\n'
                                     ' merging measured symmetry-equivalent reflections for this\n'
-                                    ' resolution shell.</pre>',
+                                    ' resolution shell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_shell_number_unique_gt': '<pre><h2>_reflns_shell_number_unique_gt</h2> The total number '
                                    'of significantly intense reflections\n'
                                    ' (see _reflns_threshold_expression) resulting from merging\n'
                                    ' measured symmetry-equivalent reflections for this resolution\n'
-                                   ' shell.</pre>',
+                                   ' shell.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_shell_number_unique_obs': '<pre><h2>_reflns_shell_number_unique_obs</h2> The total '
                                     'number of reflections classified as\n'
                                     " 'observed' (see _reflns_observed_criterion) resulting from\n"
                                     ' merging measured symmetry-equivalent reflections for this\n'
-                                    ' resolution shell.</pre>',
+                                    ' resolution shell.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_reflns_shell_percent_possible_all': '<pre><h2>_reflns_shell_percent_possible_all</h2> The '
                                        'percentage of geometrically possible reflections\n'
                                        ' represented by all reflections measured for this\n'
-                                       ' resolution shell.</pre>',
+                                       ' resolution shell.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_reflns_shell_percent_possible_gt': '<pre><h2>_reflns_shell_percent_possible_gt</h2> The '
                                       'percentage of geometrically possible reflections\n'
                                       ' represented by significantly intense reflections\n'
                                       ' (see _reflns_threshold_expression) measured for this\n'
-                                      ' resolution shell.</pre>',
+                                      ' resolution shell.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_reflns_shell_percent_possible_obs': '<pre><h2>_reflns_shell_percent_possible_obs</h2> The '
                                        'percentage of geometrically possible reflections\n'
                                        " represented by reflections classified as 'observed'\n"
                                        ' (see _reflns_observed_criterion) measured for this\n'
-                                       ' resolution shell.</pre>',
+                                       ' resolution shell.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_reflns_special_details': '<pre><h2>_reflns_special_details</h2> Description of the properties '
                             'of the reported reflection list\n'
                             ' that are not given in other data items.  In particular, this\n'
                             ' should include information about the averaging (or not) of\n'
-                            ' symmetry-equivalent reflections including Friedel pairs.</pre>',
+                            ' symmetry-equivalent reflections including Friedel pairs.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_reflns_threshold_expression': '<pre><h2>_reflns_threshold_expression</h2> The threshold, '
                                  'usually based on multiples of u(I), u(F^2^)\n'
                                  ' or u(F), that serves to identify significantly intense\n'
@@ -6544,14 +7510,17 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                  ' _refine_ls_R_factor_gt.\n'
                                  '\n'
                                  '<h3>Example:</h3>\n'
-                                 'I&gt;2u(I)</pre>',
+                                 'I&gt;2u(I)</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_space_group_IT_number': '<pre><h2>_space_group_IT_number</h2> The number as assigned in '
                            'International Tables for\n'
                            ' Crystallography Vol. A, specifying the proper affine class (i.e.\n'
                            ' the orientation-preserving affine class) of space groups\n'
                            ' (crystallographic space-group type) to which the space group\n'
                            ' belongs.  This number defines the space-group type but not\n'
-                           ' the coordinate system in which it is expressed.</pre>',
+                           ' the coordinate system in which it is expressed.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 1:230 </p>',
  '_space_group_crystal_system': '<pre><h2>_space_group_crystal_system</h2> The name of the system '
                                 'of geometric crystal classes of space\n'
                                 ' groups (crystal system) to which the space group belongs.\n'
@@ -6565,9 +7534,11 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 'tetragonal\n'
                                 'trigonal\n'
                                 'hexagonal\n'
-                                'cubic</pre>',
+                                'cubic</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_space_group_id': '<pre><h2>_space_group_id</h2> This is an identifier needed if _space_group_ '
-                    'items are looped.</pre>',
+                    'items are looped.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
  '_space_group_name_H-M_alt': '<pre><h2>_space_group_name_H-M_alt</h2> _space_group_name_H-M_alt '
                               'allows any Hermann-Mauguin symbol\n'
                               ' to be given. The way in which this item is used is determined\n'
@@ -6602,7 +7573,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                               '       _space_group_name_H-M_alt\n'
                               "        1    'C m c m'\n"
                               "        2    'C 2/c 2/m 21/m'\n"
-                              "        3    'A m a m'</pre>",
+                              "        3    'A m a m'</pre>\n"
+                              '<br><p><h4>Type:</h4> string</p>',
  '_space_group_name_Hall': '<pre><h2>_space_group_name_Hall</h2> Space-group symbol defined by '
                            'Hall.\n'
                            '\n'
@@ -6622,7 +7594,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            '\n'
                            '<h3>Example:</h3>\n'
                            'P 2c -2ac\n'
-                           '-I 4bd 2ab 3</pre>',
+                           '-I 4bd 2ab 3</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_space_group_symop_id': '<pre><h2>_space_group_symop_id</h2> An arbitrary identifier that '
                           'uniquely labels each symmetry\n'
                           ' operation in the list.\n'
@@ -6633,7 +7606,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                           ' _space_group_symop_operation_xyz or\n'
                           ' _symmetry_equiv_pos_as_xyz set to x,y,z; \n'
                           ' i.e. the operation labelled 1 should be the identity\n'
-                          ' operation.</pre>',
+                          ' operation.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>\n'
+                          '<br><p><h4>Default:</h4> 1 </p>',
  '_space_group_symop_operation_xyz': '<pre><h2>_space_group_symop_operation_xyz</h2>  A parsable '
                                      'string giving one of the symmetry operations of the\n'
                                      '  space group in algebraic form.  If W is a matrix '
@@ -6678,14 +7653,19 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                      ' operation.\n'
                                      '\n'
                                      '<h3>Example:</h3>\n'
-                                     'x,1/2-y,1/2+z</pre>',
+                                     'x,1/2-y,1/2+z</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>\n'
+                                     '<br><p><h4>Default:</h4> x,y,z </p>',
  '_space_group_symop_sg_id': '<pre><h2>_space_group_symop_sg_id</h2> This must match a particular '
                              'value of _space_group_id, allowing\n'
                              ' the symmetry operation to be identified with a particular space\n'
-                             ' group.</pre>',
+                             ' group.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_symmetry_Int_Tables_number': '<pre><h2>_symmetry_Int_Tables_number</h2> Space-group number from '
                                 'International Tables for Crystallography\n'
-                                ' Vol. A (2002).</pre>',
+                                ' Vol. A (2002).</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 1:230 </p>',
  '_symmetry_cell_setting': '<pre><h2>_symmetry_cell_setting</h2> The cell settings for this '
                            'space-group symmetry.\n'
                            '\n'
@@ -6697,7 +7677,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                            'rhombohedral\n'
                            'trigonal\n'
                            'hexagonal\n'
-                           'cubic</pre>',
+                           'cubic</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_symmetry_equiv_pos_as_xyz': '<pre><h2>_symmetry_equiv_pos_as_xyz</h2> Symmetry-equivalent '
                                "position in the 'xyz' representation. Except\n"
                                ' for the space group P1, these data will be repeated in a loop.\n'
@@ -6715,7 +7696,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                ' operation.\n'
                                '\n'
                                '<h3>Example:</h3>\n'
-                               '-y+x,-y,1/3+z</pre>',
+                               '-y+x,-y,1/3+z</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>\n'
+                               '<br><p><h4>Default:</h4> x,y,z </p>',
  '_symmetry_equiv_pos_site_id': '<pre><h2>_symmetry_equiv_pos_site_id</h2> A code identifying each '
                                 'entry in the _symmetry_equiv_pos_as_xyz\n'
                                 ' list. It is normally the sequence number of the entry in that\n'
@@ -6728,7 +7711,9 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                 ' _space_group_symop_operation_xyz or\n'
                                 ' _symmetry_equiv_pos_as_xyz set to x,y,z; \n'
                                 ' i.e. the operation labelled 1 should be the identity\n'
-                                ' operation.</pre>',
+                                ' operation.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Default:</h4> 1 </p>',
  '_symmetry_space_group_name_H-M': '<pre><h2>_symmetry_space_group_name_H-M</h2>Hermann-Mauguin '
                                    'space-group symbol. Note that the Hermann-Mauguin\n'
                                    'symbol does not necessarily contain complete information\n'
@@ -6746,7 +7731,8 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                    '<h3>Example:</h3>\n'
                                    'P 1 21/m 1\n'
                                    'P 2/n 2/n 2/n (origin at -1)\n'
-                                   'R -3 2/m</pre>',
+                                   'R -3 2/m</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_symmetry_space_group_name_Hall': '<pre><h2>_symmetry_space_group_name_Hall</h2> Space-group '
                                     'symbol as described by Hall. This symbol gives the\n'
                                     ' space-group setting explicitly. Leave spaces between the '
@@ -6759,43 +7745,55 @@ cif_core = {'_atom_site_B_equiv_geom_mea
                                     '<h3>Example:</h3>\n'
                                     '-P 2ac 2n\n'
                                     '-R 3 2"\n'
-                                    'P 61 2 2 (0 0 -1)</pre>',
+                                    'P 61 2 2 (0 0 -1)</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_valence_param_B': '<pre><h2>_valence_param_B</h2> The bond-valence parameter B used in the '
                      'expression\n'
                      '\n'
                      '       s = exp[(Ro - R)/B]\n'
                      '\n'
-                     ' where s is the valence of a bond of length R.</pre>',
+                     ' where s is the valence of a bond of length R.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_valence_param_Ro': '<pre><h2>_valence_param_Ro</h2> The bond-valence parameter Ro used in the '
                       'expression\n'
                       '\n'
                       '       s = exp[(Ro - R)/B]\n'
                       '\n'
-                      ' where s is the valence of a bond of length R.</pre>',
+                      ' where s is the valence of a bond of length R.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_valence_param_atom_1': '<pre><h2>_valence_param_atom_1</h2> The element symbol of the first '
                           'atom forming the bond whose\n'
-                          ' bond-valence parameters are given in this category.</pre>',
+                          ' bond-valence parameters are given in this category.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_valence_param_atom_1_valence': '<pre><h2>_valence_param_atom_1_valence</h2> The valence (formal '
                                   'charge) of the first atom whose\n'
-                                  ' bond-valence parameters are given in this category.</pre>',
+                                  ' bond-valence parameters are given in this category.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_valence_param_atom_2': '<pre><h2>_valence_param_atom_2</h2> The element symbol of the second '
                           'atom forming the bond whose\n'
-                          ' bond-valence parameters are given in this category.</pre>',
+                          ' bond-valence parameters are given in this category.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_valence_param_atom_2_valence': '<pre><h2>_valence_param_atom_2_valence</h2> The valence (formal '
                                   'charge) of the second atom whose\n'
-                                  ' bond-valence parameters are given in this category.</pre>',
+                                  ' bond-valence parameters are given in this category.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_valence_param_details': '<pre><h2>_valence_param_details</h2> Details of or comments on the '
-                           'bond-valence parameters.</pre>',
+                           'bond-valence parameters.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_valence_param_id': '<pre><h2>_valence_param_id</h2> An identifier for the valence parameters of '
                       'a bond between\n'
-                      ' the given atoms.</pre>',
+                      ' the given atoms.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_valence_param_ref_id': '<pre><h2>_valence_param_ref_id</h2> An identifier which links to the '
                           'reference to the source\n'
                           ' from which the bond-valence parameters are taken. A child\n'
-                          ' of _valence_ref_id, which it must match.</pre>',
+                          ' of _valence_ref_id, which it must match.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_valence_ref_id': '<pre><h2>_valence_ref_id</h2> An identifier for items in this category. '
                     'Parent of\n'
-                    ' _valence_param_ref_id, which must have the same value.</pre>',
+                    ' _valence_param_ref_id, which must have the same value.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
  '_valence_ref_reference': '<pre><h2>_valence_ref_reference</h2> Literature reference from which '
                            'the valence parameters\n'
-                           ' identified by _valence_param_id were taken.</pre>'}
\ No newline at end of file
+                           ' identified by _valence_param_id were taken.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>'}
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/cif/modulation_dict.py 137+dfsg-1/finalcif/cif/modulation_dict.py
--- 134+dfsg-1/finalcif/cif/modulation_dict.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/modulation_dict.py	2024-04-19 19:04:23.000000000 +0000
@@ -6,10 +6,12 @@ modulation_dict = {'_atom_site_Fourier_w
                                                ' functions.\n'
                                                '\n'
                                                '<h3>Example:</h3>\n'
-                                               'q(4)=q(1)+q(2)</pre>',
+                                               'q(4)=q(1)+q(2)</pre>\n'
+                                               '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_Fourier_wave_vector_seq_id': '<pre><h2>_atom_site_Fourier_wave_vector_seq_id</h2> A '
                                           'numeric code identifying the wave vectors defined in\n'
-                                          ' _atom_site_Fourier_wave_vector_.</pre>',
+                                          ' _atom_site_Fourier_wave_vector_.</pre>\n'
+                                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_Fourier_wave_vector_x': '<pre><h2>_atom_site_Fourier_wave_vector_x</h2> Wave vectors '
                                      'of the Fourier terms used in the structural model\n'
                                      ' to describe the atomic modulation functions, expressed '
@@ -28,7 +30,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' described in a single data block, these wave vectors are\n'
                                      ' expressed with respect to the three-dimensional reciprocal\n'
                                      ' basis of each subsystem (see '
-                                     '_cell_subsystem_matrix_W_).</pre>',
+                                     '_cell_subsystem_matrix_W_).</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_Fourier_wave_vector_y': '<pre><h2>_atom_site_Fourier_wave_vector_y</h2> Wave vectors '
                                      'of the Fourier terms used in the structural model\n'
                                      ' to describe the atomic modulation functions, expressed '
@@ -47,7 +50,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' described in a single data block, these wave vectors are\n'
                                      ' expressed with respect to the three-dimensional reciprocal\n'
                                      ' basis of each subsystem (see '
-                                     '_cell_subsystem_matrix_W_).</pre>',
+                                     '_cell_subsystem_matrix_W_).</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_Fourier_wave_vector_z': '<pre><h2>_atom_site_Fourier_wave_vector_z</h2> Wave vectors '
                                      'of the Fourier terms used in the structural model\n'
                                      ' to describe the atomic modulation functions, expressed '
@@ -66,7 +70,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' described in a single data block, these wave vectors are\n'
                                      ' expressed with respect to the three-dimensional reciprocal\n'
                                      ' basis of each subsystem (see '
-                                     '_cell_subsystem_matrix_W_).</pre>',
+                                     '_cell_subsystem_matrix_W_).</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_U_Fourier_atom_site_label': '<pre><h2>_atom_site_U_Fourier_atom_site_label</h2> '
                                          'Modulation parameters are usually looped in separate '
                                          'lists.\n'
@@ -89,10 +94,12 @@ modulation_dict = {'_atom_site_Fourier_w
                                          ' match the _atom_site_label of the associated coordinate '
                                          'list\n'
                                          ' and conform to the rules described in '
-                                         '_atom_site_label.</pre>',
+                                         '_atom_site_label.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_U_Fourier_id': '<pre><h2>_atom_site_U_Fourier_id</h2> A code identifying each Fourier '
                             'component used to describe the\n'
-                            ' modulation of the atomic thermal parameters.</pre>',
+                            ' modulation of the atomic thermal parameters.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_U_Fourier_param_cos': '<pre><h2>_atom_site_U_Fourier_param_cos</h2> The modulation of '
                                    'the atomic thermal parameters is usually\n'
                                    ' parameterized by Fourier series. Each term of the series\n'
@@ -109,13 +116,15 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' the Fourier term defined by\n'
                                    ' _atom_site_U_Fourier_atom_site_label,\n'
                                    ' _atom_site_U_Fourier_tens_elem and\n'
-                                   ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>',
+                                   ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_U_Fourier_param_id': '<pre><h2>_atom_site_U_Fourier_param_id</h2> A code identifying '
                                   'the (in general complex) coefficient of each\n'
                                   ' term present in the Fourier series describing the modulation '
                                   'of\n'
                                   ' the atomic thermal parameters. This code must match\n'
-                                  ' _atom_site_U_Fourier_id.</pre>',
+                                  ' _atom_site_U_Fourier_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_U_Fourier_param_modulus': '<pre><h2>_atom_site_U_Fourier_param_modulus</h2> The '
                                        'modulation of the atomic thermal parameters is usually\n'
                                        ' parameterized by Fourier series. Each term of the series\n'
@@ -133,7 +142,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' amplitudes corresponding to the Fourier term defined by\n'
                                        ' _atom_site_U_Fourier_atom_site_label,\n'
                                        ' _atom_site_U_Fourier_tens_elem and\n'
-                                       ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>',
+                                       ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_U_Fourier_param_phase': '<pre><h2>_atom_site_U_Fourier_param_phase</h2> The '
                                      'modulation of the atomic thermal parameters is usually\n'
                                      ' parameterized by Fourier series. Each term of the series\n'
@@ -151,7 +162,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' the Fourier term defined by '
                                      '_atom_site_U_Fourier_atom_site_label,\n'
                                      ' _atom_site_U_Fourier_tens_elem and\n'
-                                     ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>',
+                                     ' _atom_site_U_Fourier_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_site_U_Fourier_param_sin': '<pre><h2>_atom_site_U_Fourier_param_sin</h2> The modulation of '
                                    'the atomic thermal parameters is usually\n'
                                    ' parameterized by Fourier series. Each term of the series\n'
@@ -167,7 +180,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' the Fourier term defined by\n'
                                    ' _atom_site_U_Fourier_atom_site_label,\n'
                                    ' _atom_site_U_Fourier_tens_elem\n'
-                                   ' and _atom_site_U_Fourier_wave_vector_seq_id.</pre>',
+                                   ' and _atom_site_U_Fourier_wave_vector_seq_id.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_U_Fourier_tens_elem': '<pre><h2>_atom_site_U_Fourier_tens_elem</h2> A label '
                                    'identifying the temperature tensor element U(ij) of a\n'
                                    ' given atom or rigid group whose modulation is being '
@@ -195,7 +209,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    '\n'
                                    'Uiso\n'
                                    '\tmodulation of U~isotropic~\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_U_Fourier_wave_vector_seq_id': '<pre><h2>_atom_site_U_Fourier_wave_vector_seq_id</h2> '
                                             'A numeric code identifying the wave vectors of the '
                                             'Fourier terms\n'
@@ -203,7 +218,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'corresponding to the\n'
                                             ' temperature factors of an atom or rigid group. This '
                                             'code must\n'
-                                            ' match _atom_site_Fourier_wave_vector_seq_id.</pre>',
+                                            ' match _atom_site_Fourier_wave_vector_seq_id.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_U_modulation_flag': '<pre><h2>_atom_site_U_modulation_flag</h2> A code that signals '
                                  'whether the structural model includes the\n'
                                  ' modulation of the thermal parameters of a given atom\n'
@@ -221,14 +237,17 @@ modulation_dict = {'_atom_site_Fourier_w
                                  '\n'
                                  'n\n'
                                  '\tabbreviation for "no"\n'
-                                 '</pre>',
+                                 '</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>\n'
+                                 '<br><p><h4>Default:</h4> no </p>',
  '_atom_site_[ms]': '<pre><h2>_atom_site_[ms]</h2> Data items in the ATOM_SITE category record '
                     'details about\n'
                     ' the atom sites in a crystal structure, such as the positional\n'
                     ' coordinates, atomic displacement parameters, and magnetic moments\n'
                     ' and directions. This category exists in the core CIF dictionary\n'
                     ' but is extended in this dictionary by the addition of some items\n'
-                    ' that may appear in the main looped list of atom-site information.</pre>',
+                    ' that may appear in the main looped list of atom-site information.</pre>\n'
+                    '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_atom_site_displace_Fourier_atom_site_label': '<pre><h2>_atom_site_displace_Fourier_atom_site_label</h2> '
                                                 'Modulation parameters are usually looped in '
                                                 'separate lists.\n'
@@ -260,7 +279,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                 ' the _atom_site_label of the associated '
                                                 'coordinate list and\n'
                                                 ' conform to the rules described in '
-                                                '_atom_site_label.</pre>',
+                                                '_atom_site_label.</pre>\n'
+                                                '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_displace_Fourier_axis': '<pre><h2>_atom_site_displace_Fourier_axis</h2> A label '
                                      'identifying the displacement component of a given atom\n'
                                      ' or rigid group that is being parameterized by Fourier '
@@ -290,14 +310,16 @@ modulation_dict = {'_atom_site_Fourier_w
                                      '\n'
                                      'a3\n'
                                      '\tdisplacement along an arbitrary a3 axis\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_displace_Fourier_id': '<pre><h2>_atom_site_displace_Fourier_id</h2> A code '
                                    'identifying each component of the displacive modulation of\n'
                                    ' a given atom or rigid group when the modulation is expressed '
                                    'in\n'
                                    ' terms of Fourier series. In the case of a rigid group, it\n'
                                    ' applies only to the translational part of the '
-                                   'distortion.</pre>',
+                                   'distortion.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_displace_Fourier_param_cos': '<pre><h2>_atom_site_displace_Fourier_param_cos</h2> The '
                                           'displacive distortion of a given atom or rigid group '
                                           '(see\n'
@@ -324,7 +346,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                           ' cell or in angstroms if the modulations are referred '
                                           'to some\n'
                                           ' special axes defined by\n'
-                                          ' _atom_sites_displace_Fourier_axes_description.</pre>',
+                                          ' _atom_sites_displace_Fourier_axes_description.</pre>\n'
+                                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_Fourier_param_id': '<pre><h2>_atom_site_displace_Fourier_param_id</h2> A '
                                          'code identifying the (in general complex) coefficient of '
                                          'each\n'
@@ -335,7 +358,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                          ' group, it applies only to the translational part of '
                                          'the\n'
                                          ' distortion. This code must match '
-                                         '_atom_site_displace_Fourier_id.</pre>',
+                                         '_atom_site_displace_Fourier_id.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_displace_Fourier_param_modulus': '<pre><h2>_atom_site_displace_Fourier_param_modulus</h2> '
                                               'The displacive distortion of a given atom or rigid '
                                               'group (see\n'
@@ -365,7 +389,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                               'referred to some\n'
                                               ' special axes defined by\n'
                                               ' '
-                                              '_atom_sites_displace_Fourier_axes_description.</pre>',
+                                              '_atom_sites_displace_Fourier_axes_description.</pre>\n'
+                                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_displace_Fourier_param_phase': '<pre><h2>_atom_site_displace_Fourier_param_phase</h2> '
                                             'The displacive distortion of a given atom or rigid '
                                             'group (see\n'
@@ -387,7 +413,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             ' _atom_site_displace_Fourier_atom_site_label,\n'
                                             ' _atom_site_displace_Fourier_axis and\n'
                                             ' '
-                                            '_atom_site_displace_Fourier_wave_vector_seq_id.</pre>',
+                                            '_atom_site_displace_Fourier_wave_vector_seq_id.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_site_displace_Fourier_param_sin': '<pre><h2>_atom_site_displace_Fourier_param_sin</h2> The '
                                           'displacive distortion of a given atom or rigid group '
                                           '(see\n'
@@ -414,7 +442,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                           ' cell or in angstroms if the modulations are referred '
                                           'to some\n'
                                           ' special axes defined by\n'
-                                          ' _atom_sites_displace_Fourier_axes_description.</pre>',
+                                          ' _atom_sites_displace_Fourier_axes_description.</pre>\n'
+                                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_Fourier_wave_vector_seq_id': '<pre><h2>_atom_site_displace_Fourier_wave_vector_seq_id</h2> '
                                                    'A numeric code identifying the wave vectors of '
                                                    'the Fourier terms\n'
@@ -425,7 +454,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                                    ' group, it applies only to the translational '
                                                    'part of the\n'
                                                    ' distortion. This code must match\n'
-                                                   ' _atom_site_Fourier_wave_vector_seq_id.</pre>',
+                                                   ' _atom_site_Fourier_wave_vector_seq_id.</pre>\n'
+                                                   '<br><p><h4>Type:</h4> number (int or '
+                                                   'float)</p>',
  '_atom_site_displace_modulation_flag': '<pre><h2>_atom_site_displace_modulation_flag</h2> A code '
                                         'that signals whether the structural model includes the\n'
                                         ' modulation of the positional coordinates of a given '
@@ -444,7 +475,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                         '\n'
                                         'n\n'
                                         '\tabbreviation for "no"\n'
-                                        '</pre>',
+                                        '</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>\n'
+                                        '<br><p><h4>Default:</h4> no </p>',
  '_atom_site_displace_special_func_atom_site_label': '<pre><h2>_atom_site_displace_special_func_atom_site_label</h2> '
                                                      'The code that identifies an atom in a loop '
                                                      'in which the special\n'
@@ -454,7 +487,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                      '_atom_site_label of the\n'
                                                      ' associated coordinate list and conform to '
                                                      'the rules described in\n'
-                                                     ' _atom_site_label.</pre>',
+                                                     ' _atom_site_label.</pre>\n'
+                                                     '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_displace_special_func_sawtooth_ax': '<pre><h2>_atom_site_displace_special_func_sawtooth_ax</h2>  '
                                                  '_atom_site_displace_special_func_sawtooth_ items '
                                                  'are the\n'
@@ -490,7 +524,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                  '  crystallographic computing system. Institute '
                                                  'of Physics, Prague,\n'
                                                  '  Czech Republic.\n'
-                                                 '</pre>',
+                                                 '</pre>\n'
+                                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_special_func_sawtooth_ay': '<pre><h2>_atom_site_displace_special_func_sawtooth_ay</h2>  '
                                                  '_atom_site_displace_special_func_sawtooth_ items '
                                                  'are the\n'
@@ -526,7 +561,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                  '  crystallographic computing system. Institute '
                                                  'of Physics, Prague,\n'
                                                  '  Czech Republic.\n'
-                                                 '</pre>',
+                                                 '</pre>\n'
+                                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_special_func_sawtooth_az': '<pre><h2>_atom_site_displace_special_func_sawtooth_az</h2>  '
                                                  '_atom_site_displace_special_func_sawtooth_ items '
                                                  'are the\n'
@@ -562,7 +598,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                  '  crystallographic computing system. Institute '
                                                  'of Physics, Prague,\n'
                                                  '  Czech Republic.\n'
-                                                 '</pre>',
+                                                 '</pre>\n'
+                                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_special_func_sawtooth_c': '<pre><h2>_atom_site_displace_special_func_sawtooth_c</h2>  '
                                                 '_atom_site_displace_special_func_sawtooth_ items '
                                                 'are the\n'
@@ -598,7 +635,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                 '  crystallographic computing system. Institute of '
                                                 'Physics, Prague,\n'
                                                 '  Czech Republic.\n'
-                                                '</pre>',
+                                                '</pre>\n'
+                                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_displace_special_func_sawtooth_w': '<pre><h2>_atom_site_displace_special_func_sawtooth_w</h2>  '
                                                 '_atom_site_displace_special_func_sawtooth_ items '
                                                 'are the\n'
@@ -634,7 +672,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                 '  crystallographic computing system. Institute of '
                                                 'Physics, Prague,\n'
                                                 '  Czech Republic.\n'
-                                                '</pre>',
+                                                '</pre>\n'
+                                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_occ_Fourier_atom_site_label': '<pre><h2>_atom_site_occ_Fourier_atom_site_label</h2> '
                                            'Modulation parameters are usually looped in separate '
                                            'lists.\n'
@@ -657,11 +696,13 @@ modulation_dict = {'_atom_site_Fourier_w
                                            ' match the _atom_site_label of the associated '
                                            'coordinate list and\n'
                                            ' conform to the rules described in '
-                                           '_atom_site_label.</pre>',
+                                           '_atom_site_label.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_occ_Fourier_id': '<pre><h2>_atom_site_occ_Fourier_id</h2> A code identifying each '
                               'component of the occupational modulation\n'
                               ' of a given atom or rigid group when the modulation is\n'
-                              ' expressed in terms of Fourier series.</pre>',
+                              ' expressed in terms of Fourier series.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_occ_Fourier_param_cos': '<pre><h2>_atom_site_occ_Fourier_param_cos</h2> The '
                                      'occupational distortion of a given atom or rigid group is\n'
                                      ' usually parameterized by Fourier series. Each term of the '
@@ -678,14 +719,16 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' coefficient (Pc) corresponding to the Fourier term defined '
                                      'by\n'
                                      ' _atom_site_occ_Fourier_atom_site_label and\n'
-                                     ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>',
+                                     ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_occ_Fourier_param_id': '<pre><h2>_atom_site_occ_Fourier_param_id</h2> A code '
                                     'identifying the (in general complex) coefficient of each\n'
                                     ' term present in the Fourier series describing the '
                                     'occupational\n'
                                     ' modulation of a given atom or rigid group. This code must '
                                     'match\n'
-                                    ' _atom_site_occ_Fourier_id.</pre>',
+                                    ' _atom_site_occ_Fourier_id.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_occ_Fourier_param_modulus': '<pre><h2>_atom_site_occ_Fourier_param_modulus</h2> The '
                                          'occupational distortion of a given atom or rigid group '
                                          'is\n'
@@ -705,7 +748,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                          'the\n'
                                          ' Fourier term defined by '
                                          '_atom_site_occ_Fourier_atom_site_label\n'
-                                         ' and _atom_site_occ_Fourier_wave_vector_seq_id.</pre>',
+                                         ' and _atom_site_occ_Fourier_wave_vector_seq_id.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_occ_Fourier_param_phase': '<pre><h2>_atom_site_occ_Fourier_param_phase</h2> The '
                                        'occupational distortion of a given atom or rigid group is\n'
                                        ' usually parameterized by Fourier series. Each term of the '
@@ -723,7 +768,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' (\\d/2\\p) in cycles corresponding to the Fourier term '
                                        'defined by\n'
                                        ' _atom_site_occ_Fourier_atom_site_label and\n'
-                                       ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>',
+                                       ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_site_occ_Fourier_param_sin': '<pre><h2>_atom_site_occ_Fourier_param_sin</h2> The '
                                      'occupational distortion of a given atom or rigid group is\n'
                                      ' usually parameterized by Fourier series. Each term of the '
@@ -740,7 +787,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' coefficient (Ps) corresponding to the Fourier term defined '
                                      'by\n'
                                      ' _atom_site_occ_Fourier_atom_site_label and\n'
-                                     ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>',
+                                     ' _atom_site_occ_Fourier_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_occ_Fourier_wave_vector_seq_id': '<pre><h2>_atom_site_occ_Fourier_wave_vector_seq_id</h2> '
                                               'A numeric code identifying the wave vectors of the '
                                               'Fourier terms\n'
@@ -749,7 +797,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                               ' corresponding to the occupational part of the '
                                               'distortion. This\n'
                                               ' code must match '
-                                              '_atom_site_Fourier_wave_vector_seq_id.</pre>',
+                                              '_atom_site_Fourier_wave_vector_seq_id.</pre>\n'
+                                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_occ_modulation_flag': '<pre><h2>_atom_site_occ_modulation_flag</h2> A code that '
                                    'signals whether the structural model includes the\n'
                                    ' modulation of the occupation of a given atom site.\n'
@@ -766,7 +815,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                    '\n'
                                    'n\n'
                                    '\tabbreviation for "no"\n'
-                                   '</pre>',
+                                   '</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> no </p>',
  '_atom_site_occ_special_func_atom_site_label': '<pre><h2>_atom_site_occ_special_func_atom_site_label</h2> '
                                                 'The code that identifies an atom or rigid group '
                                                 'in a loop in\n'
@@ -777,7 +828,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                 ' the _atom_site_label of the associated '
                                                 'coordinate list and\n'
                                                 ' conform to the rules described in '
-                                                '_atom_site_label.</pre>',
+                                                '_atom_site_label.</pre>\n'
+                                                '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_occ_special_func_crenel_c': '<pre><h2>_atom_site_occ_special_func_crenel_c</h2>  '
                                          '_atom_site_occ_special_func_crenel_ items are the '
                                          'adjustable\n'
@@ -805,7 +857,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                          'JANA2000. The\n'
                                          '  crystallographic computing system. Institute of '
                                          'Physics, Prague,\n'
-                                         '  Czech Republic.</pre>',
+                                         '  Czech Republic.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_occ_special_func_crenel_w': '<pre><h2>_atom_site_occ_special_func_crenel_w</h2>  '
                                          '_atom_site_occ_special_func_crenel_ items are the '
                                          'adjustable\n'
@@ -833,7 +886,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                          'JANA2000. The\n'
                                          '  crystallographic computing system. Institute of '
                                          'Physics, Prague,\n'
-                                         '  Czech Republic.</pre>',
+                                         '  Czech Republic.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_phason_atom_site_label': '<pre><h2>_atom_site_phason_atom_site_label</h2> The code '
                                       'that identifies an atom or rigid group in a loop in\n'
                                       ' which the phason coefficients are listed. Although this '
@@ -849,7 +903,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       'must\n'
                                       ' match the _atom_site_label of the associated coordinate '
                                       'list and\n'
-                                      ' conform to the rules described in _atom_site_label.</pre>',
+                                      ' conform to the rules described in _atom_site_label.</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_phason_coeff': '<pre><h2>_atom_site_phason_coeff</h2> The phason coefficient used to '
                             'calculate (with the appropriate\n'
                             ' expression given in _atom_site_phason_formula) the atomic phason\n'
@@ -857,7 +912,9 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' overall, some refinement programs (for example, JANA2000) allow\n'
                             ' an independent phason correction for each atom or rigid group. In\n'
                             ' this case, _atom_site_phason_formula and _atom_site_phason_coeff\n'
-                            ' should be used (see also _refine_ls_mod_overall_phason_).</pre>',
+                            ' should be used (see also _refine_ls_mod_overall_phason_).</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_phason_formula': '<pre><h2>_atom_site_phason_formula</h2> The formula used for the '
                               'phason correction. Although both kinds\n'
                               ' of corrections are intended to be overall, some refinement\n'
@@ -872,7 +929,8 @@ modulation_dict = {'_atom_site_Fourier_w
                               '\n'
                               'Ovr\n'
                               '\tOverhauser, A. W. (1971). Phys. Rev. B, 3, 3173-3182.\n'
-                              '</pre>',
+                              '</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_rot_Fourier_atom_site_label': '<pre><h2>_atom_site_rot_Fourier_atom_site_label</h2> '
                                            'Modulation parameters are usually looped in separate '
                                            'lists.\n'
@@ -900,7 +958,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                            'associated\n'
                                            ' coordinate list and conform to the rules described '
                                            'in\n'
-                                           ' _atom_site_label.</pre>',
+                                           ' _atom_site_label.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_rot_Fourier_axis': '<pre><h2>_atom_site_rot_Fourier_axis</h2> A label identifying the '
                                 'rotation component around a fixed point\n'
                                 ' of a given rigid group whose modulation is being parameterized '
@@ -928,11 +987,13 @@ modulation_dict = {'_atom_site_Fourier_w
                                 '\n'
                                 'a3\n'
                                 '\trotation around an arbitrary a3 axis\n'
-                                '</pre>',
+                                '</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_rot_Fourier_id': '<pre><h2>_atom_site_rot_Fourier_id</h2> A code identifying each '
                               'component of the rotational modulation of\n'
                               ' a given rigid group when the modulation is expressed in terms of\n'
-                              ' Fourier series.</pre>',
+                              ' Fourier series.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_rot_Fourier_param_cos': '<pre><h2>_atom_site_rot_Fourier_param_cos</h2> The '
                                      'displacive distortion of a given rigid group is not\n'
                                      ' completely described by _atom_site_displace_Fourier_. The '
@@ -955,14 +1016,16 @@ modulation_dict = {'_atom_site_Fourier_w
                                      'term\n'
                                      ' defined by _atom_site_rot_Fourier_atom_site_label,\n'
                                      ' _atom_site_rot_Fourier_axis and\n'
-                                     ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>',
+                                     ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_rot_Fourier_param_id': '<pre><h2>_atom_site_rot_Fourier_param_id</h2> A code '
                                     'identifying the (in general complex) coefficient of each\n'
                                     ' term present in the Fourier series describing the rotational '
                                     'part\n'
                                     ' of the displacive modulation of a given rigid group. This '
                                     'code\n'
-                                    ' must match _atom_site_rot_Fourier_id.</pre>',
+                                    ' must match _atom_site_rot_Fourier_id.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_atom_site_rot_Fourier_param_modulus': '<pre><h2>_atom_site_rot_Fourier_param_modulus</h2> The '
                                          'displacive distortion of a given rigid group is not\n'
                                          ' completely described by _atom_site_displace_Fourier_. '
@@ -988,7 +1051,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                          ' to the Fourier term defined by\n'
                                          ' _atom_site_rot_Fourier_atom_site_label,\n'
                                          ' _atom_site_rot_Fourier_axis and\n'
-                                         ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>',
+                                         ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_atom_site_rot_Fourier_param_phase': '<pre><h2>_atom_site_rot_Fourier_param_phase</h2> The '
                                        'displacive distortion of a given rigid group is not\n'
                                        ' completely described by _atom_site_displace_Fourier_. The '
@@ -1013,7 +1078,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' Fourier term defined by '
                                        '_atom_site_rot_Fourier_atom_site_label,\n'
                                        ' _atom_site_rot_Fourier_axis and\n'
-                                       ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>',
+                                       ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_site_rot_Fourier_param_sin': '<pre><h2>_atom_site_rot_Fourier_param_sin</h2> The '
                                      'displacive distortion of a given rigid group is not\n'
                                      ' completely described by _atom_site_displace_Fourier_. The '
@@ -1036,7 +1103,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      'term\n'
                                      ' defined by _atom_site_rot_Fourier_atom_site_label,\n'
                                      ' _atom_site_rot_Fourier_axis and\n'
-                                     ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>',
+                                     ' _atom_site_rot_Fourier_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_rot_Fourier_wave_vector_seq_id': '<pre><h2>_atom_site_rot_Fourier_wave_vector_seq_id</h2> '
                                               'A numeric code identifying the wave vectors of the '
                                               'Fourier terms\n'
@@ -1045,14 +1113,16 @@ modulation_dict = {'_atom_site_Fourier_w
                                               ' corresponding to the rotational distortion of a '
                                               'rigid group. This\n'
                                               ' code must match '
-                                              '_atom_site_Fourier_wave_vector_seq_id.</pre>',
+                                              '_atom_site_Fourier_wave_vector_seq_id.</pre>\n'
+                                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_atom_site_subsystem_code': '<pre><h2>_atom_site_subsystem_code</h2> A code that links a given '
                               'atom or rigid-group site to one of the\n'
                               ' subsystems present in a composite. This code provides an\n'
                               ' alternative description for composites which is less explicit\n'
                               ' than that based on linked data blocks (see the description in\n'
                               ' this dictionary of _audit_link_[ms]). It must match one of\n'
-                              ' the labels specified for _cell_subsystem_code.</pre>',
+                              ' the labels specified for _cell_subsystem_code.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_displace_Fourier_axes_description': '<pre><h2>_atom_sites_displace_Fourier_axes_description</h2> '
                                                   'The definition of the axes used for describing '
                                                   'the displacive\n'
@@ -1064,7 +1134,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                                   ' a1 and a2 are respectively the long molecular '
                                                   'axis\n'
                                                   ' and the axis normal to the mean molecular '
-                                                  'plane.</pre>',
+                                                  'plane.</pre>\n'
+                                                  '<br><p><h4>Type:</h4> string</p>',
  '_atom_sites_modulation_global_phase_t_1': '<pre><h2>_atom_sites_modulation_global_phase_t_1</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1092,7 +1163,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_2': '<pre><h2>_atom_sites_modulation_global_phase_t_2</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1120,7 +1193,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_3': '<pre><h2>_atom_sites_modulation_global_phase_t_3</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1148,7 +1223,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_4': '<pre><h2>_atom_sites_modulation_global_phase_t_4</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1176,7 +1253,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_5': '<pre><h2>_atom_sites_modulation_global_phase_t_5</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1204,7 +1283,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_6': '<pre><h2>_atom_sites_modulation_global_phase_t_6</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1232,7 +1313,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_7': '<pre><h2>_atom_sites_modulation_global_phase_t_7</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1260,7 +1343,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_modulation_global_phase_t_8': '<pre><h2>_atom_sites_modulation_global_phase_t_8</h2> '
                                             'The initial phases, in cycles, of the modulation '
                                             'waves. For\n'
@@ -1288,7 +1373,9 @@ modulation_dict = {'_atom_site_Fourier_w
                                             'J. &amp; Garcia\n'
                                             ' Arribas, A. (1987). Acta Cryst. A43, 216-226. '
                                             'Smaalen, S. van\n'
-                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                            ' (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                            '<br><p><h4>Limits:</h4> -1.0:1.0 </p>',
  '_atom_sites_rot_Fourier_axes_description': '<pre><h2>_atom_sites_rot_Fourier_axes_description</h2> '
                                              'The definition of the axes used for describing the '
                                              'rotational\n'
@@ -1301,7 +1388,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                              '<h3>Example:</h3>\n'
                                              ' a1 and a2 are respectively the long molecular axis\n'
                                              ' and the axis normal to the mean molecular '
-                                             'plane.</pre>',
+                                             'plane.</pre>\n'
+                                             '<br><p><h4>Type:</h4> string</p>',
  '_audit_link_[ms]': '<pre><h2>_audit_link_[ms]</h2> This category description does NOT introduce '
                      'a new category;\n'
                      ' instead, it describes the recommended practice for using\n'
@@ -1358,15 +1446,19 @@ modulation_dict = {'_atom_site_Fourier_w
                      "       K2SEO4_REFRNCE  'reference structure'\n"
                      "       K2SEO4_MOD      'modulated structure'\n"
                      '\n'
-                     "    _audit_link_block_code      'PbSVS2_MOD_VS2'</pre>",
+                     "    _audit_link_block_code      'PbSVS2_MOD_VS2'</pre>\n"
+                     '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_[ms]': '<pre><h2>_cell_[ms]</h2> Data items in the CELL category record details about\n'
                ' the crystallographic cell parameters and their measurement.\n'
                ' This category is already defined in the core CIF dictionary\n'
                ' but is extended in this dictionary by the addition of some items\n'
-               ' that are specific for modulated and composite structures.</pre>',
+               ' that are specific for modulated and composite structures.</pre>\n'
+               '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_modulation_dimension': '<pre><h2>_cell_modulation_dimension</h2> Number of additional '
                                'reciprocal vectors needed to index the\n'
-                               ' whole diffraction pattern using integer Miller indices.</pre>',
+                               ' whole diffraction pattern using integer Miller indices.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 1:8 </p>',
  '_cell_reciprocal_basis_description': '<pre><h2>_cell_reciprocal_basis_description</h2> '
                                        'Definition of the higher-dimensional basis with respect to '
                                        'which\n'
@@ -1385,7 +1477,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' a*~3~=a*~13~, a*~4~=a*~21~. a*~1j~ (j=1,2,3) index the\n'
                                        ' main reflections of the 1st subsystem. a*~21~ is '
                                        'incommensurate\n'
-                                       ' with a*~11~.</pre>',
+                                       ' with a*~11~.</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_cell_subsystem_[ms]': '<pre><h2>_cell_subsystem_[ms]</h2> Data items in the CELL_SUBSYSTEM '
                          'category record details about\n'
                          ' the crystallographic cell parameters of each subsystem present in\n'
@@ -1404,21 +1497,24 @@ modulation_dict = {'_atom_site_Fourier_w
                          '         _cell_subsystem_matrix_W_4_1\n'
                          '         _cell_subsystem_matrix_W_4_4\n'
                          "   NbS2            '1st subsystem'  1 0 1 1 0 1\n"
-                         "   LaS             '2nd subsystem'  0 1 1 1 1 0</pre>",
+                         "   LaS             '2nd subsystem'  0 1 1 1 1 0</pre>\n"
+                         '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_subsystem_code': '<pre><h2>_cell_subsystem_code</h2> The code identifying uniquely a '
                          'certain composite subsystem.\n'
                          ' This code is used to identify the data blocks that contain\n'
                          ' the structural information associated with the subsystem.\n'
                          '\n'
                          '<h3>Example:</h3>\n'
-                         'NbS2</pre>',
+                         'NbS2</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_cell_subsystem_description': '<pre><h2>_cell_subsystem_description</h2> Description of each '
                                 'subsystem defining a composite structurally.\n'
                                 ' The number of definitions must match the number given in\n'
                                 ' _cell_subsystems_number.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
-                                'NbS2 part of the layer compound (LaS)~1.14~NbS~2~</pre>',
+                                'NbS2 part of the layer compound (LaS)~1.14~NbS~2~</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_cell_subsystem_matrix_W_10_1': '<pre><h2>_cell_subsystem_matrix_W_10_1</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1508,7 +1604,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_10': '<pre><h2>_cell_subsystem_matrix_W_10_10</h2> In the case of '
                                    'composites, for each subsystem the matrix W as\n'
                                    ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1603,7 +1700,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' composite.\n'
                                    '\n'
                                    ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_11': '<pre><h2>_cell_subsystem_matrix_W_10_11</h2> In the case of '
                                    'composites, for each subsystem the matrix W as\n'
                                    ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1698,7 +1796,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' composite.\n'
                                    '\n'
                                    ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_2': '<pre><h2>_cell_subsystem_matrix_W_10_2</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1788,7 +1887,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_3': '<pre><h2>_cell_subsystem_matrix_W_10_3</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1878,7 +1978,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_4': '<pre><h2>_cell_subsystem_matrix_W_10_4</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -1968,7 +2069,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_5': '<pre><h2>_cell_subsystem_matrix_W_10_5</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2058,7 +2160,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_6': '<pre><h2>_cell_subsystem_matrix_W_10_6</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2148,7 +2251,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_7': '<pre><h2>_cell_subsystem_matrix_W_10_7</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2238,7 +2342,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_8': '<pre><h2>_cell_subsystem_matrix_W_10_8</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2328,7 +2433,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_10_9': '<pre><h2>_cell_subsystem_matrix_W_10_9</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2418,7 +2524,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_1': '<pre><h2>_cell_subsystem_matrix_W_11_1</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2508,7 +2615,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_10': '<pre><h2>_cell_subsystem_matrix_W_11_10</h2> In the case of '
                                    'composites, for each subsystem the matrix W as\n'
                                    ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2603,7 +2711,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' composite.\n'
                                    '\n'
                                    ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_11': '<pre><h2>_cell_subsystem_matrix_W_11_11</h2> In the case of '
                                    'composites, for each subsystem the matrix W as\n'
                                    ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2698,7 +2807,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    ' composite.\n'
                                    '\n'
                                    ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                   ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_2': '<pre><h2>_cell_subsystem_matrix_W_11_2</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2788,7 +2898,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_3': '<pre><h2>_cell_subsystem_matrix_W_11_3</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2878,7 +2989,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_4': '<pre><h2>_cell_subsystem_matrix_W_11_4</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -2968,7 +3080,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_5': '<pre><h2>_cell_subsystem_matrix_W_11_5</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3058,7 +3171,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_6': '<pre><h2>_cell_subsystem_matrix_W_11_6</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3148,7 +3262,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_7': '<pre><h2>_cell_subsystem_matrix_W_11_7</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3238,7 +3353,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_8': '<pre><h2>_cell_subsystem_matrix_W_11_8</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3328,7 +3444,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_11_9': '<pre><h2>_cell_subsystem_matrix_W_11_9</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3418,7 +3535,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_1': '<pre><h2>_cell_subsystem_matrix_W_1_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3501,7 +3619,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_10': '<pre><h2>_cell_subsystem_matrix_W_1_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3591,7 +3710,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_11': '<pre><h2>_cell_subsystem_matrix_W_1_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3681,7 +3801,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_2': '<pre><h2>_cell_subsystem_matrix_W_1_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3764,7 +3885,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_3': '<pre><h2>_cell_subsystem_matrix_W_1_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3847,7 +3969,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_4': '<pre><h2>_cell_subsystem_matrix_W_1_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -3930,7 +4053,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_5': '<pre><h2>_cell_subsystem_matrix_W_1_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4013,7 +4137,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_6': '<pre><h2>_cell_subsystem_matrix_W_1_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4096,7 +4221,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_7': '<pre><h2>_cell_subsystem_matrix_W_1_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4179,7 +4305,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_8': '<pre><h2>_cell_subsystem_matrix_W_1_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4262,7 +4389,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_1_9': '<pre><h2>_cell_subsystem_matrix_W_1_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4345,7 +4473,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_1': '<pre><h2>_cell_subsystem_matrix_W_2_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4428,7 +4557,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_10': '<pre><h2>_cell_subsystem_matrix_W_2_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4518,7 +4648,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_11': '<pre><h2>_cell_subsystem_matrix_W_2_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4608,7 +4739,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_2': '<pre><h2>_cell_subsystem_matrix_W_2_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4691,7 +4823,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_3': '<pre><h2>_cell_subsystem_matrix_W_2_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4774,7 +4907,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_4': '<pre><h2>_cell_subsystem_matrix_W_2_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4857,7 +4991,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_5': '<pre><h2>_cell_subsystem_matrix_W_2_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -4940,7 +5075,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_6': '<pre><h2>_cell_subsystem_matrix_W_2_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5023,7 +5159,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_7': '<pre><h2>_cell_subsystem_matrix_W_2_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5106,7 +5243,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_8': '<pre><h2>_cell_subsystem_matrix_W_2_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5189,7 +5327,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_2_9': '<pre><h2>_cell_subsystem_matrix_W_2_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5272,7 +5411,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_1': '<pre><h2>_cell_subsystem_matrix_W_3_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5355,7 +5495,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_10': '<pre><h2>_cell_subsystem_matrix_W_3_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5445,7 +5586,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_11': '<pre><h2>_cell_subsystem_matrix_W_3_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5535,7 +5677,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_2': '<pre><h2>_cell_subsystem_matrix_W_3_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5618,7 +5761,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_3': '<pre><h2>_cell_subsystem_matrix_W_3_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5701,7 +5845,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_4': '<pre><h2>_cell_subsystem_matrix_W_3_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5784,7 +5929,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_5': '<pre><h2>_cell_subsystem_matrix_W_3_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5867,7 +6013,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_6': '<pre><h2>_cell_subsystem_matrix_W_3_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -5950,7 +6097,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_7': '<pre><h2>_cell_subsystem_matrix_W_3_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6033,7 +6181,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_8': '<pre><h2>_cell_subsystem_matrix_W_3_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6116,7 +6265,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_3_9': '<pre><h2>_cell_subsystem_matrix_W_3_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6199,7 +6349,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_1': '<pre><h2>_cell_subsystem_matrix_W_4_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6282,7 +6433,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_10': '<pre><h2>_cell_subsystem_matrix_W_4_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6372,7 +6524,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_11': '<pre><h2>_cell_subsystem_matrix_W_4_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6462,7 +6615,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_2': '<pre><h2>_cell_subsystem_matrix_W_4_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6545,7 +6699,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_3': '<pre><h2>_cell_subsystem_matrix_W_4_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6628,7 +6783,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_4': '<pre><h2>_cell_subsystem_matrix_W_4_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6711,7 +6867,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_5': '<pre><h2>_cell_subsystem_matrix_W_4_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6794,7 +6951,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_6': '<pre><h2>_cell_subsystem_matrix_W_4_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6877,7 +7035,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_7': '<pre><h2>_cell_subsystem_matrix_W_4_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -6960,7 +7119,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_8': '<pre><h2>_cell_subsystem_matrix_W_4_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7043,7 +7203,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_4_9': '<pre><h2>_cell_subsystem_matrix_W_4_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7126,7 +7287,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_1': '<pre><h2>_cell_subsystem_matrix_W_5_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7209,7 +7371,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_10': '<pre><h2>_cell_subsystem_matrix_W_5_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7299,7 +7462,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_11': '<pre><h2>_cell_subsystem_matrix_W_5_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7389,7 +7553,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_2': '<pre><h2>_cell_subsystem_matrix_W_5_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7472,7 +7637,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_3': '<pre><h2>_cell_subsystem_matrix_W_5_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7555,7 +7721,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_4': '<pre><h2>_cell_subsystem_matrix_W_5_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7638,7 +7805,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_5': '<pre><h2>_cell_subsystem_matrix_W_5_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7721,7 +7889,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_6': '<pre><h2>_cell_subsystem_matrix_W_5_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7804,7 +7973,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_7': '<pre><h2>_cell_subsystem_matrix_W_5_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7887,7 +8057,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_8': '<pre><h2>_cell_subsystem_matrix_W_5_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -7970,7 +8141,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_5_9': '<pre><h2>_cell_subsystem_matrix_W_5_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8053,7 +8225,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_1': '<pre><h2>_cell_subsystem_matrix_W_6_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8136,7 +8309,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_10': '<pre><h2>_cell_subsystem_matrix_W_6_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8226,7 +8400,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_11': '<pre><h2>_cell_subsystem_matrix_W_6_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8316,7 +8491,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_2': '<pre><h2>_cell_subsystem_matrix_W_6_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8399,7 +8575,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_3': '<pre><h2>_cell_subsystem_matrix_W_6_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8482,7 +8659,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_4': '<pre><h2>_cell_subsystem_matrix_W_6_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8565,7 +8743,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_5': '<pre><h2>_cell_subsystem_matrix_W_6_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8648,7 +8827,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_6': '<pre><h2>_cell_subsystem_matrix_W_6_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8731,7 +8911,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_7': '<pre><h2>_cell_subsystem_matrix_W_6_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8814,7 +8995,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_8': '<pre><h2>_cell_subsystem_matrix_W_6_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8897,7 +9079,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_6_9': '<pre><h2>_cell_subsystem_matrix_W_6_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -8980,7 +9163,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_1': '<pre><h2>_cell_subsystem_matrix_W_7_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9063,7 +9247,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_10': '<pre><h2>_cell_subsystem_matrix_W_7_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9153,7 +9338,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_11': '<pre><h2>_cell_subsystem_matrix_W_7_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9243,7 +9429,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_2': '<pre><h2>_cell_subsystem_matrix_W_7_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9326,7 +9513,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_3': '<pre><h2>_cell_subsystem_matrix_W_7_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9409,7 +9597,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_4': '<pre><h2>_cell_subsystem_matrix_W_7_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9492,7 +9681,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_5': '<pre><h2>_cell_subsystem_matrix_W_7_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9575,7 +9765,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_6': '<pre><h2>_cell_subsystem_matrix_W_7_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9658,7 +9849,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_7': '<pre><h2>_cell_subsystem_matrix_W_7_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9741,7 +9933,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_8': '<pre><h2>_cell_subsystem_matrix_W_7_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9824,7 +10017,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_7_9': '<pre><h2>_cell_subsystem_matrix_W_7_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9907,7 +10101,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_1': '<pre><h2>_cell_subsystem_matrix_W_8_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -9990,7 +10185,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_10': '<pre><h2>_cell_subsystem_matrix_W_8_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10080,7 +10276,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_11': '<pre><h2>_cell_subsystem_matrix_W_8_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10170,7 +10367,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_2': '<pre><h2>_cell_subsystem_matrix_W_8_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10253,7 +10451,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_3': '<pre><h2>_cell_subsystem_matrix_W_8_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10336,7 +10535,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_4': '<pre><h2>_cell_subsystem_matrix_W_8_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10419,7 +10619,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_5': '<pre><h2>_cell_subsystem_matrix_W_8_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10502,7 +10703,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_6': '<pre><h2>_cell_subsystem_matrix_W_8_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10585,7 +10787,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_7': '<pre><h2>_cell_subsystem_matrix_W_8_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10668,7 +10871,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_8': '<pre><h2>_cell_subsystem_matrix_W_8_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10751,7 +10955,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_8_9': '<pre><h2>_cell_subsystem_matrix_W_8_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10834,7 +11039,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_1': '<pre><h2>_cell_subsystem_matrix_W_9_1</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -10917,7 +11123,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_10': '<pre><h2>_cell_subsystem_matrix_W_9_10</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11007,7 +11214,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_11': '<pre><h2>_cell_subsystem_matrix_W_9_11</h2> In the case of '
                                   'composites, for each subsystem the matrix W as\n'
                                   ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11097,7 +11305,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' composite.\n'
                                   '\n'
                                   ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                  ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_2': '<pre><h2>_cell_subsystem_matrix_W_9_2</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11180,7 +11389,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_3': '<pre><h2>_cell_subsystem_matrix_W_9_3</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11263,7 +11473,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_4': '<pre><h2>_cell_subsystem_matrix_W_9_4</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11346,7 +11557,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_5': '<pre><h2>_cell_subsystem_matrix_W_9_5</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11429,7 +11641,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_6': '<pre><h2>_cell_subsystem_matrix_W_9_6</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11512,7 +11725,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_7': '<pre><h2>_cell_subsystem_matrix_W_9_7</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11595,7 +11809,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_8': '<pre><h2>_cell_subsystem_matrix_W_9_8</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11678,7 +11893,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystem_matrix_W_9_9': '<pre><h2>_cell_subsystem_matrix_W_9_9</h2> In the case of '
                                  'composites, for each subsystem the matrix W as\n'
                                  ' defined in van Smaalen (1991); see also van Smaalen (1995).\n'
@@ -11761,17 +11977,21 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' composite.\n'
                                  '\n'
                                  ' Ref: Smaalen, S. van (1991). Phys. Rev. B, 43, 11330-11341.\n'
-                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>',
+                                 ' Smaalen, S. van (1995). Crystallogr. Rev. 4, 79-202.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_subsystems_[ms]': '<pre><h2>_cell_subsystems_[ms]</h2> Data items in the CELL_SUBSYSTEMS '
                           'category describe the gross\n'
                           ' structure of the subsystems present in a composite.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
                           '\n'
-                          '     _cell_subsystems_number                  2</pre>',
+                          '     _cell_subsystems_number                  2</pre>\n'
+                          '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_subsystems_number': '<pre><h2>_cell_subsystems_number</h2> The number of subsystems used '
                             'to define the structural model of\n'
-                            ' a composite structure.</pre>',
+                            ' a composite structure.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 2:∞ </p>',
  '_cell_wave_vector_[ms]': '<pre><h2>_cell_wave_vector_[ms]</h2> Data items in the '
                            'CELL_WAVE_VECTOR category list the\n'
                            ' independent modulation wave vectors q~i~. The diffraction\n'
@@ -11785,12 +12005,14 @@ modulation_dict = {'_atom_site_Fourier_w
                            '     loop_\n'
                            '         _cell_wave_vector_seq_id\n'
                            '         _cell_wave_vector_x\n'
-                           '  1       0.318(5)</pre>',
+                           '  1       0.318(5)</pre>\n'
+                           '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_wave_vector_seq_id': '<pre><h2>_cell_wave_vector_seq_id</h2> A numeric code to identify '
                              'each independent wave vector. These\n'
                              ' codes define uniquely the reciprocal basis and, therefore,\n'
                              ' force the order of the Miller indices assigned to\n'
-                             ' intensities, crystal faces etc.</pre>',
+                             ' intensities, crystal faces etc.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_wave_vector_x': '<pre><h2>_cell_wave_vector_x</h2> Independent modulation wave vector(s) '
                         'with which the whole\n'
                         ' diffraction pattern is indexed, expressed as fractions of the\n'
@@ -11808,7 +12030,8 @@ modulation_dict = {'_atom_site_Fourier_w
                         ' the wave vectors used to describe the modulation of each\n'
                         ' subsystem are referred to their own reciprocal basis via the W\n'
                         ' matrices (for details see _cell_subsystem_matrix_W_ and\n'
-                        ' _atom_site_Fourier_wave_vector_).</pre>',
+                        ' _atom_site_Fourier_wave_vector_).</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_wave_vector_y': '<pre><h2>_cell_wave_vector_y</h2> Independent modulation wave vector(s) '
                         'with which the whole\n'
                         ' diffraction pattern is indexed, expressed as fractions of the\n'
@@ -11826,7 +12049,8 @@ modulation_dict = {'_atom_site_Fourier_w
                         ' the wave vectors used to describe the modulation of each\n'
                         ' subsystem are referred to their own reciprocal basis via the W\n'
                         ' matrices (for details see _cell_subsystem_matrix_W_ and\n'
-                        ' _atom_site_Fourier_wave_vector_).</pre>',
+                        ' _atom_site_Fourier_wave_vector_).</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_wave_vector_z': '<pre><h2>_cell_wave_vector_z</h2> Independent modulation wave vector(s) '
                         'with which the whole\n'
                         ' diffraction pattern is indexed, expressed as fractions of the\n'
@@ -11844,7 +12068,8 @@ modulation_dict = {'_atom_site_Fourier_w
                         ' the wave vectors used to describe the modulation of each\n'
                         ' subsystem are referred to their own reciprocal basis via the W\n'
                         ' matrices (for details see _cell_subsystem_matrix_W_ and\n'
-                        ' _atom_site_Fourier_wave_vector_).</pre>',
+                        ' _atom_site_Fourier_wave_vector_).</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_cell_wave_vectors_[ms]': '<pre><h2>_cell_wave_vectors_[ms]</h2> Data items in the '
                             'CELL_WAVE_VECTORS category record details\n'
                             ' about the set of independent modulation wave vectors q~i~ and\n'
@@ -11856,30 +12081,40 @@ modulation_dict = {'_atom_site_Fourier_w
                             '<h3>Example:</h3>\n'
                             '\n'
                             "     _cell_wave_vectors_meas_details          'Determined from "
-                            "profiles along q'</pre>",
+                            "profiles along q'</pre>\n"
+                            '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_cell_wave_vectors_meas_details': '<pre><h2>_cell_wave_vectors_meas_details</h2> Details about '
                                     'the method used to determine the independent\n'
-                                    ' modulation wave vector(s).</pre>',
+                                    ' modulation wave vector(s).</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_cell_wave_vectors_pressure_max': '<pre><h2>_cell_wave_vectors_pressure_max</h2> The maximum and '
                                     'minimum values of the pressure in kilopascals\n'
                                     ' defining the interval within which the modulation wave '
                                     'vector(s)\n'
-                                    ' were measured.</pre>',
+                                    ' were measured.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_wave_vectors_pressure_min': '<pre><h2>_cell_wave_vectors_pressure_min</h2> The maximum and '
                                     'minimum values of the pressure in kilopascals\n'
                                     ' defining the interval within which the modulation wave '
                                     'vector(s)\n'
-                                    ' were measured.</pre>',
+                                    ' were measured.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_wave_vectors_temp_max': '<pre><h2>_cell_wave_vectors_temp_max</h2> The maximum and minimum '
                                 'values of the temperature in kelvins\n'
                                 ' defining the interval within which the modulation wave '
                                 'vector(s)\n'
-                                ' were measured.</pre>',
+                                ' were measured.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_wave_vectors_temp_min': '<pre><h2>_cell_wave_vectors_temp_min</h2> The maximum and minimum '
                                 'values of the temperature in kelvins\n'
                                 ' defining the interval within which the modulation wave '
                                 'vector(s)\n'
-                                ' were measured.</pre>',
+                                ' were measured.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_cell_wave_vectors_variation': '<pre><h2>_cell_wave_vectors_variation</h2> Details concerning '
                                  'the behaviour (and its experimental\n'
                                  ' detection) of the wave vector(s) with temperature and/or\n'
@@ -11887,7 +12122,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                  ' _cell_wave_vectors_pressure_max, '
                                  '_cell_wave_vectors_pressure_min,\n'
                                  ' _cell_wave_vectors_temp_max and '
-                                 '_cell_wave_vectors_temp_min.</pre>',
+                                 '_cell_wave_vectors_temp_min.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_diffrn_refln_[ms]': '<pre><h2>_diffrn_refln_[ms]</h2> Data items in the DIFFRN_REFLN category '
                        'record details about\n'
                        ' the intensities measured in the diffraction experiment. The\n'
@@ -11897,7 +12133,8 @@ modulation_dict = {'_atom_site_Fourier_w
                        ' to all intensity measurements. The DIFFRN_REFLNS data items\n'
                        ' are not looped.) Data items in this category are extensions\n'
                        ' of the core CIF dictionary definitions to the indexing of\n'
-                       ' diffraction intensities by higher-dimensional components.</pre>',
+                       ' diffraction intensities by higher-dimensional components.</pre>\n'
+                       '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_diffrn_refln_index_m_1': '<pre><h2>_diffrn_refln_index_m_1</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11912,7 +12149,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_2': '<pre><h2>_diffrn_refln_index_m_2</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11927,7 +12165,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_3': '<pre><h2>_diffrn_refln_index_m_3</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11942,7 +12181,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_4': '<pre><h2>_diffrn_refln_index_m_4</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11957,7 +12197,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_5': '<pre><h2>_diffrn_refln_index_m_5</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11972,7 +12213,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_6': '<pre><h2>_diffrn_refln_index_m_6</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -11987,7 +12229,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_7': '<pre><h2>_diffrn_refln_index_m_7</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -12002,7 +12245,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_refln_index_m_8': '<pre><h2>_diffrn_refln_index_m_8</h2> Additional Miller indices '
                             'needed to write the reciprocal vector\n'
                             ' of a certain reflection in the basis described in\n'
@@ -12017,7 +12261,8 @@ modulation_dict = {'_atom_site_Fourier_w
                             ' additional indices must be consistent with the codes given in\n'
                             ' _cell_wave_vector_seq_id. These indices need not match\n'
                             ' _refln_index_m_ values if a transformation of the original\n'
-                            ' measured cell has occurred.</pre>',
+                            ' measured cell has occurred.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_[ms]': '<pre><h2>_diffrn_reflns_[ms]</h2> Data items in the DIFFRN_REFLNS '
                         'category record details about\n'
                         ' the set of intensities measured in the diffraction experiment.\n'
@@ -12028,7 +12273,8 @@ modulation_dict = {'_atom_site_Fourier_w
                         ' Data items in this category extend the core CIF dictionary\n'
                         ' definitions providing independent checks on the range of values\n'
                         ' recorded for each of the additional Miller indices given in\n'
-                        ' the DIFFRN_REFLN category.</pre>',
+                        ' the DIFFRN_REFLN category.</pre>\n'
+                        '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_diffrn_reflns_limit_index_m_1_max': '<pre><h2>_diffrn_reflns_limit_index_m_1_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12036,7 +12282,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_1_min': '<pre><h2>_diffrn_reflns_limit_index_m_1_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12044,7 +12291,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_2_max': '<pre><h2>_diffrn_reflns_limit_index_m_2_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12052,7 +12300,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_2_min': '<pre><h2>_diffrn_reflns_limit_index_m_2_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12060,7 +12309,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_3_max': '<pre><h2>_diffrn_reflns_limit_index_m_3_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12068,7 +12318,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_3_min': '<pre><h2>_diffrn_reflns_limit_index_m_3_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12076,7 +12327,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_4_max': '<pre><h2>_diffrn_reflns_limit_index_m_4_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12084,7 +12336,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_4_min': '<pre><h2>_diffrn_reflns_limit_index_m_4_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12092,7 +12345,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_5_max': '<pre><h2>_diffrn_reflns_limit_index_m_5_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12100,7 +12354,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_5_min': '<pre><h2>_diffrn_reflns_limit_index_m_5_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12108,7 +12363,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_6_max': '<pre><h2>_diffrn_reflns_limit_index_m_6_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12116,7 +12372,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_6_min': '<pre><h2>_diffrn_reflns_limit_index_m_6_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12124,7 +12381,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_7_max': '<pre><h2>_diffrn_reflns_limit_index_m_7_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12132,7 +12390,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_7_min': '<pre><h2>_diffrn_reflns_limit_index_m_7_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12140,7 +12399,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_8_max': '<pre><h2>_diffrn_reflns_limit_index_m_8_max</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12148,7 +12408,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_limit_index_m_8_min': '<pre><h2>_diffrn_reflns_limit_index_m_8_min</h2> Maximum '
                                        'and minimum values of the additional Miller indices\n'
                                        ' appearing in _diffrn_refln_index_m_. The number of ranges '
@@ -12156,9 +12417,11 @@ modulation_dict = {'_atom_site_Fourier_w
                                        ' match _cell_modulation_dimension. The order of the '
                                        'additional\n'
                                        ' indices must be consistent with the codes given in\n'
-                                       ' _cell_wave_vector_seq_id.</pre>',
+                                       ' _cell_wave_vector_seq_id.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_reflns_satellite_order_max': '<pre><h2>_diffrn_reflns_satellite_order_max</h2> Maximum '
-                                       'order of observed satellites.</pre>',
+                                       'order of observed satellites.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_[ms]': '<pre><h2>_diffrn_standard_refln_[ms]</h2> Data items in the '
                                 'DIFFRN_STANDARD_REFLN category record\n'
                                 ' details about the reflections treated as standards during the\n'
@@ -12168,7 +12431,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                 ' of the standard reflections. Data items in this category are\n'
                                 ' extensions of  the core CIF dictionary definitions\n'
                                 ' to the indexing of standard reflections by\n'
-                                ' higher-dimensional components.</pre>',
+                                ' higher-dimensional components.</pre>\n'
+                                '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_diffrn_standard_refln_index_m_1': '<pre><h2>_diffrn_standard_refln_index_m_1</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12180,7 +12444,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_2': '<pre><h2>_diffrn_standard_refln_index_m_2</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12192,7 +12457,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_3': '<pre><h2>_diffrn_standard_refln_index_m_3</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12204,7 +12470,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_4': '<pre><h2>_diffrn_standard_refln_index_m_4</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12216,7 +12483,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_5': '<pre><h2>_diffrn_standard_refln_index_m_5</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12228,7 +12496,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_6': '<pre><h2>_diffrn_standard_refln_index_m_6</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12240,7 +12509,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_7': '<pre><h2>_diffrn_standard_refln_index_m_7</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12252,7 +12522,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_diffrn_standard_refln_index_m_8': '<pre><h2>_diffrn_standard_refln_index_m_8</h2> Additional '
                                      'Miller indices needed to write the reciprocal vectors\n'
                                      ' of the standard intensities used in the diffraction '
@@ -12264,18 +12535,21 @@ modulation_dict = {'_atom_site_Fourier_w
                                      ' (_cell_modulation_dimension + 3) and the order of the\n'
                                      ' additional indices must be consistent with the codes given '
                                      'in\n'
-                                     ' _cell_wave_vector_seq_id.</pre>',
+                                     ' _cell_wave_vector_seq_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_[ms]': '<pre><h2>_exptl_crystal_[ms]</h2> Data items in the EXPTL_CRYSTAL '
                         'category record\n'
                         ' details about experimental measurements on the crystal or\n'
                         ' crystals used, such as shape, size and density. The new\n'
                         ' data item added to this category specifies whether the structure\n'
-                        ' is crystalline, modulated or composite.</pre>',
+                        ' is crystalline, modulated or composite.</pre>\n'
+                        '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_exptl_crystal_face_[ms]': '<pre><h2>_exptl_crystal_face_[ms]</h2> Data items in the '
                              'EXPTL_CRYSTAL_FACE category record\n'
                              ' details of the crystal faces. Data items in this category are\n'
                              ' extensions of the core CIF dictionary definitions to the\n'
-                             ' indexing of crystal faces by higher-dimensional components.</pre>',
+                             ' indexing of crystal faces by higher-dimensional components.</pre>\n'
+                             '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_exptl_crystal_face_index_m_1': '<pre><h2>_exptl_crystal_face_index_m_1</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12284,7 +12558,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_2': '<pre><h2>_exptl_crystal_face_index_m_2</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12293,7 +12568,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_3': '<pre><h2>_exptl_crystal_face_index_m_3</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12302,7 +12578,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_4': '<pre><h2>_exptl_crystal_face_index_m_4</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12311,7 +12588,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_5': '<pre><h2>_exptl_crystal_face_index_m_5</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12320,7 +12598,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_6': '<pre><h2>_exptl_crystal_face_index_m_6</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12329,7 +12608,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_7': '<pre><h2>_exptl_crystal_face_index_m_7</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12338,7 +12618,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_face_index_m_8': '<pre><h2>_exptl_crystal_face_index_m_8</h2> Additional Miller '
                                   'indices of the crystal face associated with the\n'
                                   ' value _exptl_crystal_face_perp_dist when the face is indexed\n'
@@ -12347,7 +12628,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                   ' match (_cell_modulation_dimension + 3). The order of the '
                                   'indices\n'
                                   ' must be consistent with the codes given in\n'
-                                  ' _cell_wave_vector_seq_id.</pre>',
+                                  ' _cell_wave_vector_seq_id.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_exptl_crystal_type_of_structure': '<pre><h2>_exptl_crystal_type_of_structure</h2>       The '
                                      'type of structure. This is used to check the consistency of '
                                      'a\n'
@@ -12367,26 +12649,32 @@ modulation_dict = {'_atom_site_Fourier_w
                                      '\n'
                                      'comp\n'
                                      '\tcomposite (misfit) structure\n'
-                                     '</pre>',
+                                     '</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>\n'
+                                     '<br><p><h4>Default:</h4> cryst </p>',
  '_geom_angle_[ms]': '<pre><h2>_geom_angle_[ms]</h2> Data items in the GEOM_ANGLE category record\n'
                      ' details about the bond angles, as calculated from the\n'
                      ' ATOM, CELL and SYMMETRY data. These extensions\n'
                      ' to the core CIF dictionary definitions record the maximum,\n'
                      ' minimum and average values of angles and extend the\n'
                      ' symmetry-operation code used in angle listings to the\n'
-                     ' higher-dimensional superspace form.</pre>',
+                     ' higher-dimensional superspace form.</pre>\n'
+                     '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_geom_angle_av': '<pre><h2>_geom_angle_av</h2> Maximum, minimum and average angles in degrees '
                    'bounded by\n'
                    ' _geom_angle_atom_site_label_1, *_2, and *_3. The site at *_2\n'
-                   ' is at the apex of the angle.</pre>',
+                   ' is at the apex of the angle.</pre>\n'
+                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_angle_max': '<pre><h2>_geom_angle_max</h2> Maximum, minimum and average angles in degrees '
                     'bounded by\n'
                     ' _geom_angle_atom_site_label_1, *_2, and *_3. The site at *_2\n'
-                    ' is at the apex of the angle.</pre>',
+                    ' is at the apex of the angle.</pre>\n'
+                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_angle_min': '<pre><h2>_geom_angle_min</h2> Maximum, minimum and average angles in degrees '
                     'bounded by\n'
                     ' _geom_angle_atom_site_label_1, *_2, and *_3. The site at *_2\n'
-                    ' is at the apex of the angle.</pre>',
+                    ' is at the apex of the angle.</pre>\n'
+                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_angle_site_ssg_symmetry_1': '<pre><h2>_geom_angle_site_ssg_symmetry_1</h2> The symmetry '
                                     'code of each atom site as the symmetry operation\n'
                                     " number 'n' and the higher-dimensional translation "
@@ -12416,7 +12704,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_6455</pre>',
+                                    '7_6455</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_site_ssg_symmetry_2': '<pre><h2>_geom_angle_site_ssg_symmetry_2</h2> The symmetry '
                                     'code of each atom site as the symmetry operation\n'
                                     " number 'n' and the higher-dimensional translation "
@@ -12446,7 +12735,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_6455</pre>',
+                                    '7_6455</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_angle_site_ssg_symmetry_3': '<pre><h2>_geom_angle_site_ssg_symmetry_3</h2> The symmetry '
                                     'code of each atom site as the symmetry operation\n'
                                     " number 'n' and the higher-dimensional translation "
@@ -12476,23 +12766,31 @@ modulation_dict = {'_atom_site_Fourier_w
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_6455</pre>',
+                                    '7_6455</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_[ms]': '<pre><h2>_geom_bond_[ms]</h2> Data items in the GEOM_BOND category record\n'
                     ' details about bonds, as calculated from the\n'
                     ' ATOM, CELL and SYMMETRY data. These extensions\n'
                     ' to the core CIF dictionary definitions record the maximum,\n'
                     ' minimum and average lengths of bonds and extend the\n'
                     ' symmetry-operation code used in bond listings to the\n'
-                    ' higher-dimensional superspace form.</pre>',
+                    ' higher-dimensional superspace form.</pre>\n'
+                    '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_geom_bond_distance_av': '<pre><h2>_geom_bond_distance_av</h2> Maximum, minimum and average '
                            'values of the intramolecular bond\n'
-                           ' distance in angstroms.</pre>',
+                           ' distance in angstroms.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_bond_distance_max': '<pre><h2>_geom_bond_distance_max</h2> Maximum, minimum and average '
                             'values of the intramolecular bond\n'
-                            ' distance in angstroms.</pre>',
+                            ' distance in angstroms.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_bond_distance_min': '<pre><h2>_geom_bond_distance_min</h2> Maximum, minimum and average '
                             'values of the intramolecular bond\n'
-                            ' distance in angstroms.</pre>',
+                            ' distance in angstroms.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_bond_site_ssg_symmetry_1': '<pre><h2>_geom_bond_site_ssg_symmetry_1</h2> The symmetry code '
                                    'of each atom site as the symmetry operation\n'
                                    " number 'n' and the higher-dimensional translation 'm1...mp'.\n"
@@ -12521,7 +12819,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_6455</pre>',
+                                   '7_6455</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_geom_bond_site_ssg_symmetry_2': '<pre><h2>_geom_bond_site_ssg_symmetry_2</h2> The symmetry code '
                                    'of each atom site as the symmetry operation\n'
                                    " number 'n' and the higher-dimensional translation 'm1...mp'.\n"
@@ -12550,7 +12849,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_6455</pre>',
+                                   '7_6455</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_geom_contact_[ms]': '<pre><h2>_geom_contact_[ms]</h2> Data items in the GEOM_CONTACT category '
                        'record\n'
                        ' details about interatomic contacts, as calculated from the\n'
@@ -12558,16 +12858,23 @@ modulation_dict = {'_atom_site_Fourier_w
                        ' to the core CIF dictionary definitions record the maximum,\n'
                        ' minimum and average values of contact distances and extend the\n'
                        ' symmetry-operation code used in contact-distance listings to the\n'
-                       ' higher-dimensional superspace form.</pre>',
+                       ' higher-dimensional superspace form.</pre>\n'
+                       '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_geom_contact_distance_av': '<pre><h2>_geom_contact_distance_av</h2> Maximum, minimum and '
                               'average values of the interatomic contact\n'
-                              ' distance in angstroms.</pre>',
+                              ' distance in angstroms.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_contact_distance_max': '<pre><h2>_geom_contact_distance_max</h2> Maximum, minimum and '
                                'average values of the interatomic contact\n'
-                               ' distance in angstroms.</pre>',
+                               ' distance in angstroms.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_contact_distance_min': '<pre><h2>_geom_contact_distance_min</h2> Maximum, minimum and '
                                'average values of the interatomic contact\n'
-                               ' distance in angstroms.</pre>',
+                               ' distance in angstroms.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_geom_contact_site_ssg_symmetry_1': '<pre><h2>_geom_contact_site_ssg_symmetry_1</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12601,7 +12908,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_geom_contact_site_ssg_symmetry_2': '<pre><h2>_geom_contact_site_ssg_symmetry_2</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12635,7 +12943,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_[ms]': '<pre><h2>_geom_torsion_[ms]</h2> Data items in the GEOM_TORSION category '
                        'record\n'
                        ' details about torsion angles, as calculated from the\n'
@@ -12643,7 +12952,8 @@ modulation_dict = {'_atom_site_Fourier_w
                        ' to the core CIF dictionary definitions record the maximum,\n'
                        ' minimum and average values of torsion angles and extend the\n'
                        ' symmetry-operation code used in torsion-angle listings to the\n'
-                       ' higher-dimensional superspace form.</pre>',
+                       ' higher-dimensional superspace form.</pre>\n'
+                       '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_geom_torsion_av': '<pre><h2>_geom_torsion_av</h2> Maximum, minimum and average torsion angles '
                      'in degrees bounded\n'
                      ' by the four atom sites identified by the\n'
@@ -12651,7 +12961,8 @@ modulation_dict = {'_atom_site_Fourier_w
                      ' specified as _atom_site_label in the atom list. The torsion-\n'
                      ' angle definition should be that of Klyne and Prelog (1960).\n'
                      '\n'
-                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>',
+                     ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_torsion_max': '<pre><h2>_geom_torsion_max</h2> Maximum, minimum and average torsion angles '
                       'in degrees bounded\n'
                       ' by the four atom sites identified by the\n'
@@ -12659,7 +12970,8 @@ modulation_dict = {'_atom_site_Fourier_w
                       ' specified as _atom_site_label in the atom list. The torsion-\n'
                       ' angle definition should be that of Klyne and Prelog (1960).\n'
                       '\n'
-                      ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>',
+                      ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_torsion_min': '<pre><h2>_geom_torsion_min</h2> Maximum, minimum and average torsion angles '
                       'in degrees bounded\n'
                       ' by the four atom sites identified by the\n'
@@ -12667,7 +12979,8 @@ modulation_dict = {'_atom_site_Fourier_w
                       ' specified as _atom_site_label in the atom list. The torsion-\n'
                       ' angle definition should be that of Klyne and Prelog (1960).\n'
                       '\n'
-                      ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>',
+                      ' Ref: Klyne, W. &amp; Prelog, V. (1960). Experientia, 16, 521-523.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_geom_torsion_site_ssg_symmetry_1': '<pre><h2>_geom_torsion_site_ssg_symmetry_1</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12699,7 +13012,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_ssg_symmetry_2': '<pre><h2>_geom_torsion_site_ssg_symmetry_2</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12731,7 +13045,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_ssg_symmetry_3': '<pre><h2>_geom_torsion_site_ssg_symmetry_3</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12763,7 +13078,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_geom_torsion_site_ssg_symmetry_4': '<pre><h2>_geom_torsion_site_ssg_symmetry_4</h2> The '
                                       'symmetry code of each atom site as the symmetry operation\n'
                                       " number 'n' and the higher-dimensional translation "
@@ -12795,12 +13111,14 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '<h3>Example:</h3>\n'
                                       'None\n'
                                       '4\n'
-                                      '7_6455</pre>',
+                                      '7_6455</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_refine_[ms]': '<pre><h2>_refine_[ms]</h2> Data items in the REFINE category record\n'
                  ' details about the structure refinement parameters. The\n'
                  ' new items in this category extend those of the core CIF\n'
                  ' dictionary and are specific to the refinement of\n'
-                 ' modulated structures.</pre>',
+                 ' modulated structures.</pre>\n'
+                 '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_refine_ls_mod_func_description': '<pre><h2>_refine_ls_mod_func_description</h2> Types of '
                                     'modulation present in the structural model and their\n'
                                     ' parameterization.\n'
@@ -12808,7 +13126,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                     '<h3>Example:</h3>\n'
                                     'Only displacive modulation. Fourier series.\n'
                                     'Modulation of atom S(1) described by a non-standard\n'
-                                    ' linear sawtooth function</pre>',
+                                    ' linear sawtooth function</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_refine_ls_mod_hydrogen_treatment': '<pre><h2>_refine_ls_mod_hydrogen_treatment</h2> Treatment '
                                       'of hydrogen-atom modulation parameters in the\n'
                                       ' refinement.\n'
@@ -12830,10 +13149,14 @@ modulation_dict = {'_atom_site_Fourier_w
                                       '\n'
                                       'nomod\n'
                                       '\tno modulation of H-atom parameters\n'
-                                      '</pre>',
+                                      '</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>\n'
+                                      '<br><p><h4>Default:</h4> nomod </p>',
  '_refine_ls_mod_overall_phason_coeff': '<pre><h2>_refine_ls_mod_overall_phason_coeff</h2> The '
                                         'phason coefficient used to calculate the overall phason\n'
-                                        ' correction.</pre>',
+                                        ' correction.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_refine_ls_mod_overall_phason_formula': '<pre><h2>_refine_ls_mod_overall_phason_formula</h2> The '
                                           'expression for the overall phason correction, if used.\n'
                                           '\n'
@@ -12844,7 +13167,8 @@ modulation_dict = {'_atom_site_Fourier_w
                                           'Ovr\n'
                                           '\tOverhauser, A. W. (1971). Phys. Rev. B, 3, '
                                           '3173-3182.\n'
-                                          '</pre>',
+                                          '</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>',
  '_refln_[ms]': '<pre><h2>_refln_[ms]</h2> Data items in the REFLN category record details about '
                 'the\n'
                 ' reflections used to determine the ATOM_SITE data items.\n'
@@ -12854,55 +13178,64 @@ modulation_dict = {'_atom_site_Fourier_w
                 ' REFLNS data items are not looped. Data items in this category\n'
                 ' are extensions of the core CIF dictionary definitions to the\n'
                 ' indexing of reflections used in the refinement by\n'
-                ' higher-dimensional components.</pre>',
+                ' higher-dimensional components.</pre>\n'
+                '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_refln_index_m_1': '<pre><h2>_refln_index_m_1</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_2': '<pre><h2>_refln_index_m_2</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_3': '<pre><h2>_refln_index_m_3</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_4': '<pre><h2>_refln_index_m_4</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_5': '<pre><h2>_refln_index_m_5</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_6': '<pre><h2>_refln_index_m_6</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_7': '<pre><h2>_refln_index_m_7</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_refln_index_m_8': '<pre><h2>_refln_index_m_8</h2> Additional Miller indices of a particular '
                      'reflection in the basis\n'
                      ' described in _cell_reciprocal_basis_description. The total number\n'
                      ' of indices must match (_cell_modulation_dimension + 3). The\n'
                      ' order of the additional indices must be consistent with the codes\n'
-                     ' given in _cell_wave_vector_seq_id.</pre>',
+                     ' given in _cell_wave_vector_seq_id.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_[ms]': '<pre><h2>_reflns_[ms]</h2> Data items in the REFLNS category record details '
                  'about the\n'
                  ' reflections used to determine the ATOM_SITE data items.\n'
@@ -12912,132 +13245,152 @@ modulation_dict = {'_atom_site_Fourier_w
                  ' REFLNS data items are not looped. Data items in this category\n'
                  ' extend the core CIF dictionary definitions providing independent\n'
                  ' checks on the range of values recorded for each of the\n'
-                 ' additional Miller indices given in the REFLN category.</pre>',
+                 ' additional Miller indices given in the REFLN category.</pre>\n'
+                 '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_reflns_limit_index_m_1_max': '<pre><h2>_reflns_limit_index_m_1_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_1_min': '<pre><h2>_reflns_limit_index_m_1_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_2_max': '<pre><h2>_reflns_limit_index_m_2_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_2_min': '<pre><h2>_reflns_limit_index_m_2_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_3_max': '<pre><h2>_reflns_limit_index_m_3_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_3_min': '<pre><h2>_reflns_limit_index_m_3_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_4_max': '<pre><h2>_reflns_limit_index_m_4_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_4_min': '<pre><h2>_reflns_limit_index_m_4_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_5_max': '<pre><h2>_reflns_limit_index_m_5_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_5_min': '<pre><h2>_reflns_limit_index_m_5_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_6_max': '<pre><h2>_reflns_limit_index_m_6_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_6_min': '<pre><h2>_reflns_limit_index_m_6_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_7_max': '<pre><h2>_reflns_limit_index_m_7_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_7_min': '<pre><h2>_reflns_limit_index_m_7_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_8_max': '<pre><h2>_reflns_limit_index_m_8_max</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_reflns_limit_index_m_8_min': '<pre><h2>_reflns_limit_index_m_8_min</h2> Maximum and minimum '
                                 'values of the additional Miller indices\n'
                                 ' appearing in _refln_index_m_. The number of ranges must match\n'
                                 ' _cell_modulation_dimension. The order of the additional indices\n'
                                 ' must be consistent with the codes given in\n'
                                 ' _cell_wave_vector_seq_id. These need not be the same as\n'
-                                ' the _diffrn_reflns_limit_index_m_.</pre>',
+                                ' the _diffrn_reflns_limit_index_m_.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_space_group_[ms]': '<pre><h2>_space_group_[ms]</h2> The SPACE_GROUP category introduced in the '
                       'symmetry CIF\n'
                       ' dictionary (cif_sym.dic) is intended to replace the original\n'
                       ' core SYMMETRY category. For modulated structures, superspace-\n'
                       ' group descriptions may be included in the same category, but\n'
-                      ' include the _ssg_ flag to indicate their dimensionality of &gt; 3.</pre>',
+                      ' include the _ssg_ flag to indicate their dimensionality of &gt; 3.</pre>\n'
+                      '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_space_group_ssg_IT_number': '<pre><h2>_space_group_ssg_IT_number</h2> Superspace-group number '
                                'from International Tables for\n'
                                ' Crystallography, Vol. C (2004). Valid only for one-dimensional\n'
                                ' modulated structures.\n'
                                '\n'
                                ' Ref: International Tables for Crystallography (2004). Vol. C,\n'
-                               '      Chapter 9.8. Dordrecht: Kluwer Academic Publishers.</pre>',
+                               '      Chapter 9.8. Dordrecht: Kluwer Academic Publishers.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 1.1:∞ </p>',
  '_space_group_ssg_WJJ_code': '<pre><h2>_space_group_ssg_WJJ_code</h2> Superspace-group code as '
                               'given by de Wolff, Janssen &amp; Janner\n'
                               ' (1981). Valid only for one-dimensional modulated structures.\n'
@@ -13046,7 +13399,8 @@ modulation_dict = {'_atom_site_Fourier_w
                               '      Acta Cryst. A37, 625-636.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              '28a.10.1/2</pre>',
+                              '28a.10.1/2</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_space_group_ssg_name': '<pre><h2>_space_group_ssg_name</h2> Superspace-group symbol conforming '
                           'to an alternative definition\n'
                           ' from that given in _space_group_ssg_name_IT and\n'
@@ -13065,7 +13419,8 @@ modulation_dict = {'_atom_site_Fourier_w
                           ' appropriate W matrices.\n'
                           '\n'
                           '<h3>Example:</h3>\n'
-                          "Hall's notation W:-P -2xb -2ya:q q</pre>",
+                          "Hall's notation W:-P -2xb -2ya:q q</pre>\n"
+                          '<br><p><h4>Type:</h4> string</p>',
  '_space_group_ssg_name_IT': '<pre><h2>_space_group_ssg_name_IT</h2> Superspace-group symbol as '
                              'given in International Tables for\n'
                              ' Crystallography, Vol. C (2004). Valid only for one-dimensional\n'
@@ -13087,7 +13442,8 @@ modulation_dict = {'_atom_site_Fourier_w
                              '      Chapter 9.8. Dordrecht: Kluwer Academic Publishers.\n'
                              '\n'
                              '<h3>Example:</h3>\n'
-                             'P n m a (0 0 \\g) 0 s 0</pre>',
+                             'P n m a (0 0 \\g) 0 s 0</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_space_group_ssg_name_WJJ': '<pre><h2>_space_group_ssg_name_WJJ</h2> Superspace-group symbol as '
                               'given by de Wolff, Janssen &amp; Janner\n'
                               ' (1981). Valid only for one-dimensional modulated structures.\n'
@@ -13107,7 +13463,8 @@ modulation_dict = {'_atom_site_Fourier_w
                               '      Acta Cryst. A37, 625-636.\n'
                               '\n'
                               '<h3>Example:</h3>\n'
-                              'P:P c m n:s s -1</pre>',
+                              'P:P c m n:s s -1</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_space_group_symop_[ms]': '<pre><h2>_space_group_symop_[ms]</h2> The SPACE_GROUP_SYMOP category '
                             'introduced in the symmetry CIF\n'
                             ' dictionary (cif_sym.dic) is intended to replace the original\n'
@@ -13129,10 +13486,12 @@ modulation_dict = {'_atom_site_Fourier_w
                             '  5                       -x1,-x2,-x3,-x4\n'
                             '  6                       1/2-x1,1/2+x2,1/2+x3,-x4\n'
                             '  7                       1/2+x1,1/2-x2,x3,1/2+x4\n'
-                            '  8                       x1,x2,1/2-x3,1/2+x4</pre>',
+                            '  8                       x1,x2,1/2-x3,1/2+x4</pre>\n'
+                            '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_space_group_symop_ssg_id': '<pre><h2>_space_group_symop_ssg_id</h2> A numeric code identifying '
                               'each entry in the\n'
-                              ' _space_group_symop_ssg_operation_algebraic list.</pre>',
+                              ' _space_group_symop_ssg_operation_algebraic list.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_space_group_symop_ssg_operation_algebraic': '<pre><h2>_space_group_symop_ssg_operation_algebraic</h2> '
                                                'A parsable string giving one of the symmetry '
                                                'operations of the\n'
@@ -13156,4 +13515,5 @@ modulation_dict = {'_atom_site_Fourier_w
                                                ' in a CIF corresponding to a modulated structure.\n'
                                                '\n'
                                                '<h3>Example:</h3>\n'
-                                               'x1,-x2,x3,1/2+x4</pre>'}
\ No newline at end of file
+                                               'x1,-x2,x3,1/2+x4</pre>\n'
+                                               '<br><p><h4>Type:</h4> string</p>'}
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/cif/powder_dict.py 137+dfsg-1/finalcif/cif/powder_dict.py
--- 134+dfsg-1/finalcif/cif/powder_dict.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/powder_dict.py	2024-04-19 19:04:23.000000000 +0000
@@ -22,7 +22,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                    '\n'
                    ' It is the responsibility of a data archive site or local\n'
                    " laboratory to create a catalogue of block ID's if that site\n"
-                   ' wishes to resolve these references.</pre>',
+                   ' wishes to resolve these references.</pre>\n'
+                   '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_block_diffractogram_id': '<pre><h2>_pd_block_diffractogram_id</h2> A block ID code (see '
                                '_pd_block_id) that identifies\n'
                                ' diffraction data contained in a data block other\n'
@@ -31,7 +32,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' is used for a structure determination. The data\n'
                                ' block containing the diffraction data will contain\n'
                                ' a _pd_block_id code matching the code in\n'
-                               ' _pd_block_diffractogram_id.</pre>',
+                               ' _pd_block_diffractogram_id.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_block_id': '<pre><h2>_pd_block_id</h2> Used to assign a unique character string to a block.\n'
                  ' Note that this code is not intended to be parsed; the\n'
                  ' concatenation of several strings is used in order to\n'
@@ -100,12 +102,14 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                  '\n'
                  '<h3>Example:</h3>\n'
                  '1991-15-09T16:54|Si-std|B.Toby|D500#1234-987\n'
-                 '1991-15-09T16:54|SEPD7234|B.Toby|SEPD.IPNS.ANL.GOV</pre>',
+                 '1991-15-09T16:54|SEPD7234|B.Toby|SEPD.IPNS.ANL.GOV</pre>\n'
+                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_calc_[pd]': '<pre><h2>_pd_calc_[pd]</h2> This section is used for storing a computed '
                   'diffractogram trace.\n'
                   ' This may be a simulated powder pattern for a material from a\n'
                   ' program such as LAZY/PULVERIX or the computed intensities from a\n'
-                  ' Rietveld refinement.</pre>',
+                  ' Rietveld refinement.</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_calc_intensity_net': '<pre><h2>_pd_calc_intensity_net</h2> Intensity values for a computed '
                            'diffractogram at\n'
                            ' each angle setting. Values should be computed at the\n'
@@ -127,7 +131,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                            '\n'
                            ' If an observed pattern is included, _pd_calc_intensity_\n'
                            ' should be looped with either _pd_proc_intensity_net,\n'
-                           ' _pd_meas_counts_ or _pd_meas_intensity_.</pre>',
+                           ' _pd_meas_counts_ or _pd_meas_intensity_.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_calc_intensity_total': '<pre><h2>_pd_calc_intensity_total</h2> Intensity values for a '
                              'computed diffractogram at\n'
                              ' each angle setting. Values should be computed at the\n'
@@ -149,19 +155,23 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              '\n'
                              ' If an observed pattern is included, _pd_calc_intensity_\n'
                              ' should be looped with either _pd_proc_intensity_net,\n'
-                             ' _pd_meas_counts_ or _pd_meas_intensity_.</pre>',
+                             ' _pd_meas_counts_ or _pd_meas_intensity_.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_calc_method': '<pre><h2>_pd_calc_method</h2> A description of the method used for the '
                     'calculation of\n'
                     ' the intensities in _pd_calc_intensity_. If the pattern was\n'
                     ' calculated from crystal structure data, the atom coordinates\n'
                     ' and other crystallographic information should be included\n'
-                    ' using the core CIF _atom_site_ and _cell_ data items.</pre>',
+                    ' using the core CIF _atom_site_ and _cell_ data items.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
  '_pd_calc_point_id': '<pre><h2>_pd_calc_point_id</h2> Arbitrary label identifying a calculated '
                       'data point. Used to\n'
                       ' identify a specific entry in a list of values forming the\n'
                       ' calculated diffractogram. The role of this identifier may\n'
                       ' be adopted by _pd_data_point_id if measured, processed and\n'
-                      ' calculated intensity values are combined in a single list.</pre>',
+                      ' calculated intensity values are combined in a single list.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_calib_2theta_off_max': '<pre><h2>_pd_calib_2theta_off_max</h2> _pd_calib_2theta_offset '
                              'defines an offset angle (in degrees)\n'
                              ' used to calibrate 2\\q (as defined in _pd_meas_2theta_).\n'
@@ -175,7 +185,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' the value where the offset has been determined can be\n'
                              ' specified as _pd_calib_2theta_off_point. Alternatively, a\n'
                              ' range where the offset is applicable can be specified using\n'
-                             ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>',
+                             ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_calib_2theta_off_min': '<pre><h2>_pd_calib_2theta_off_min</h2> _pd_calib_2theta_offset '
                              'defines an offset angle (in degrees)\n'
                              ' used to calibrate 2\\q (as defined in _pd_meas_2theta_).\n'
@@ -189,7 +201,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' the value where the offset has been determined can be\n'
                              ' specified as _pd_calib_2theta_off_point. Alternatively, a\n'
                              ' range where the offset is applicable can be specified using\n'
-                             ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>',
+                             ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_calib_2theta_off_point': '<pre><h2>_pd_calib_2theta_off_point</h2> _pd_calib_2theta_offset '
                                'defines an offset angle (in degrees)\n'
                                ' used to calibrate 2\\q (as defined in _pd_meas_2theta_).\n'
@@ -203,7 +217,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' the value where the offset has been determined can be\n'
                                ' specified as _pd_calib_2theta_off_point. Alternatively, a\n'
                                ' range where the offset is applicable can be specified using\n'
-                               ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>',
+                               ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_calib_2theta_offset': '<pre><h2>_pd_calib_2theta_offset</h2> _pd_calib_2theta_offset defines '
                             'an offset angle (in degrees)\n'
                             ' used to calibrate 2\\q (as defined in _pd_meas_2theta_).\n'
@@ -217,7 +233,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             ' the value where the offset has been determined can be\n'
                             ' specified as _pd_calib_2theta_off_point. Alternatively, a\n'
                             ' range where the offset is applicable can be specified using\n'
-                            ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>',
+                            ' _pd_calib_2theta_off_min and _pd_calib_2theta_off_max.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_calib_[pd]': '<pre><h2>_pd_calib_[pd]</h2> This section defines the parameters used for the '
                    'calibration \n'
                    ' of the instrument that are used directly or indirectly in the \n'
@@ -238,42 +256,51 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                    '    _pd_calibration_conversion_eqn\n'
                    '    ; 2\\q~actual~ = 2\\q~setting~ + arctan(\n'
                    '      cos(P~1~)/{1/[P~0~ (CC - CH~0~ - P~2~ CC^2^)] - sin(P~1~)})\n'
-                   '    ;</pre>',
+                   '    ;</pre>\n'
+                   '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_calib_detector_id': '<pre><h2>_pd_calib_detector_id</h2> A code which identifies the '
                           'detector or channel number in a\n'
                           ' position-sensitive, energy-dispersive or other multiple-detector\n'
                           ' instrument. Note that this code should match the code name used\n'
-                          ' for _pd_meas_detector_id.</pre>',
+                          ' for _pd_meas_detector_id.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_pd_calib_detector_response': '<pre><h2>_pd_calib_detector_response</h2> A value that indicates '
                                 'the relative sensitivity of each\n'
                                 ' detector. This can compensate for differences in electronics,\n'
                                 ' size and collimation. Usually, one detector or the mean for\n'
-                                ' all detectors will be assigned the value of 1.</pre>',
+                                ' all detectors will be assigned the value of 1.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_calib_std_external_block_id': '<pre><h2>_pd_calib_std_external_block_id</h2> Identifies the '
                                     'data set used as an external standard for\n'
                                     ' the diffraction angle or the intensity calibrations.\n'
                                     ' *_name specifies the name of the material and\n'
                                     ' *_id the _pd_block_id for the CIF containing calibration\n'
                                     ' measurements. If more than one data set is used for\n'
-                                    ' calibration, these fields may be looped.</pre>',
+                                    ' calibration, these fields may be looped.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_pd_calib_std_external_name': '<pre><h2>_pd_calib_std_external_name</h2> Identifies the data set '
                                 'used as an external standard for\n'
                                 ' the diffraction angle or the intensity calibrations.\n'
                                 ' *_name specifies the name of the material and\n'
                                 ' *_id the _pd_block_id for the CIF containing calibration\n'
                                 ' measurements. If more than one data set is used for\n'
-                                ' calibration, these fields may be looped.</pre>',
+                                ' calibration, these fields may be looped.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_calib_std_internal_mass_%': '<pre><h2>_pd_calib_std_internal_mass_%</h2> Per cent presence '
                                   'of the internal standard specified by the\n'
                                   ' data item _pd_calib_std_internal_name expressed as 100 times\n'
                                   ' the ratio of the amount of standard added to the original\n'
-                                  ' sample mass.</pre>',
+                                  ' sample mass.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_pd_calib_std_internal_name': '<pre><h2>_pd_calib_std_internal_name</h2> Identity of material(s) '
                                 'used as an internal intensity standard.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
                                 'NIST 640a Silicon standard\n'
-                                'Al2O3</pre>',
+                                'Al2O3</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_calibration_conversion_eqn': '<pre><h2>_pd_calibration_conversion_eqn</h2> The calibration '
                                    'function for converting a channel number\n'
                                    ' supplied in _pd_meas_detector_id for a position-sensitive\n'
@@ -286,7 +313,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                    '<h3>Example:</h3>\n'
                                    ' 2\\q~actual~ = 2\\q~setting~ + arctan(\n'
                                    'os(P~1~) / {1/[P~0~ (CC - CH~0~ - P~2~ CC^2^)] - sin(P~1~)} '
-                                   ')</pre>',
+                                   ')</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_pd_calibration_special_details': '<pre><h2>_pd_calibration_special_details</h2> Description of '
                                     'how the instrument was\n'
                                     ' calibrated, particularly for instruments where\n'
@@ -294,10 +322,12 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                     ' settings that would otherwise be invisible once data\n'
                                     ' collection is completed. Do not use this item to specify\n'
                                     ' information that can be specified using other _pd_calib_\n'
-                                    ' items.</pre>',
+                                    ' items.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_pd_char_[pd]': '<pre><h2>_pd_char_[pd]</h2>   This section contains experimental '
                   '(non-diffraction) information\n'
-                  '    relevant to the chemical and physical nature of the material.</pre>',
+                  '    relevant to the chemical and physical nature of the material.</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_char_atten_coef_mu_calc': '<pre><h2>_pd_char_atten_coef_mu_calc</h2> The observed and '
                                 'calculated linear attenuation coefficient,\n'
                                 ' \\m, in units of inverse millimetres. Note that this quantity\n'
@@ -312,7 +342,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' determined by a transmission measurement.\n'
                                 ' Note that _pd_char_atten_coef_mu_calc will differ from\n'
                                 ' _exptl_absorpt_coefficient_mu if the packing density is\n'
-                                ' not unity.</pre>',
+                                ' not unity.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_char_atten_coef_mu_obs': '<pre><h2>_pd_char_atten_coef_mu_obs</h2> The observed and '
                                'calculated linear attenuation coefficient,\n'
                                ' \\m, in units of inverse millimetres. Note that this quantity\n'
@@ -327,7 +359,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' determined by a transmission measurement.\n'
                                ' Note that _pd_char_atten_coef_mu_calc will differ from\n'
                                ' _exptl_absorpt_coefficient_mu if the packing density is\n'
-                               ' not unity.</pre>',
+                               ' not unity.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_char_colour': '<pre><h2>_pd_char_colour</h2> The colour of the material used for the '
                     'measurement.\n'
                     ' To facilitate more standardized use of names, the\n'
@@ -359,16 +393,19 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                     'dark_green\n'
                     'orange_red\n'
                     'brownish_red\n'
-                    'yellow_metallic</pre>',
+                    'yellow_metallic</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>',
  '_pd_char_particle_morphology': '<pre><h2>_pd_char_particle_morphology</h2> A description of the '
                                  'sample morphology and estimates for\n'
                                  ' particle sizes (before grinding/sieving, if noted by\n'
                                  ' _pd_spec_preparation). Include the method used for\n'
-                                 ' these estimates (SEM, visual estimate etc.).</pre>',
+                                 ' these estimates (SEM, visual estimate etc.).</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_char_special_details': '<pre><h2>_pd_char_special_details</h2> Additional characterization '
                              'information relevant to the sample\n'
                              ' or documentation of non-routine processing steps used\n'
-                             ' for characterization.</pre>',
+                             ' for characterization.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_pd_data_[pd]': '<pre><h2>_pd_data_[pd]</h2> The PD_DATA category contains raw, processed and '
                   'calculated\n'
                   ' data points in a diffraction data set. In many cases, it is\n'
@@ -436,18 +473,24 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                   '            1a  21.3  56\n'
                   '            4   21.6  76\n'
                   '            4a  21.9  90\n'
-                  '</pre>',
+                  '</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_data_point_id': '<pre><h2>_pd_data_point_id</h2> Arbitrary label identifying an entry in the '
                       'table of\n'
-                      ' diffractogram intensity values.</pre>',
+                      ' diffractogram intensity values.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_2theta_monochr_post': '<pre><h2>_pd_instr_2theta_monochr_post</h2> The 2\\q angle for '
                                   'a pre-specimen or post-specimen\n'
                                   ' monochromator (see _pd_instr_monochr_pre_spec and\n'
-                                  ' _pd_instr_monochr_post_spec).</pre>',
+                                  ' _pd_instr_monochr_post_spec).</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_instr_2theta_monochr_pre': '<pre><h2>_pd_instr_2theta_monochr_pre</h2> The 2\\q angle for a '
                                  'pre-specimen or post-specimen\n'
                                  ' monochromator (see _pd_instr_monochr_pre_spec and\n'
-                                 ' _pd_instr_monochr_post_spec).</pre>',
+                                 ' _pd_instr_monochr_post_spec).</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_instr_[pd]': '<pre><h2>_pd_instr_[pd]</h2> This section contains information relevant to the '
                    'instrument\n'
                    ' used for the diffraction measurement. For most laboratories,\n'
@@ -496,17 +539,22 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                    '\n'
                    '    _pd_instr_geometry              Bragg-Brentano\n'
                    "    _pd_instr_monochr_post_spec     'graphite (0001)'\n"
-                   '    _pd_instr_cons_illum_flag       no</pre>',
+                   '    _pd_instr_cons_illum_flag       no</pre>\n'
+                   '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_instr_beam_size_ax': '<pre><h2>_pd_instr_beam_size_ax</h2> Axial and equatorial dimensions '
                            'of the radiation beam\n'
                            ' at the specimen position (in millimetres).\n'
                            ' The perpendicular to the plane containing the incident\n'
-                           ' and scattered beam is the axial (*_ax) direction.</pre>',
+                           ' and scattered beam is the axial (*_ax) direction.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_beam_size_eq': '<pre><h2>_pd_instr_beam_size_eq</h2> Axial and equatorial dimensions '
                            'of the radiation beam\n'
                            ' at the specimen position (in millimetres).\n'
                            ' The perpendicular to the plane containing the incident\n'
-                           ' and scattered beam is the axial (*_ax) direction.</pre>',
+                           ' and scattered beam is the axial (*_ax) direction.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_cons_illum_flag': "<pre><h2>_pd_instr_cons_illum_flag</h2> Use 'yes' for instruments "
                               'where the divergence slit is\n'
                               ' \\q-compensated to yield a constant illumination length\n'
@@ -519,7 +567,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                               '\n'
                               '<h3>Example:</h3>\n'
                               'yes\n'
-                              'no</pre>',
+                              'no</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_cons_illum_len': '<pre><h2>_pd_instr_cons_illum_len</h2> Length of the specimen that '
                              'is illuminated by the radiation\n'
                              ' source (in millimetres).\n'
@@ -531,7 +580,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' Use _pd_instr_var_illum_len for instruments where\n'
                              ' the illuminated length of the specimen has been \n'
                              ' characterized as a function of 2\\q, most commonly true\n'
-                             ' with a fixed divergence slit.</pre>',
+                             ' with a fixed divergence slit.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_anal/detc': '<pre><h2>_pd_instr_dist_anal/detc</h2> Specifies distances in '
                              'millimetres for the instrument geometry:\n'
                              '   *_src/mono, the distance from the radiation source\n'
@@ -550,7 +601,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' Note that *_src/spec is used in place of *_src/mono and \n'
                              ' *_mono/spec if there is no monochromator in use, and \n'
                              ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                             ' if there is no analyser in use.</pre>',
+                             ' if there is no analyser in use.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_mono/spec': '<pre><h2>_pd_instr_dist_mono/spec</h2> Specifies distances in '
                              'millimetres for the instrument geometry:\n'
                              '   *_src/mono, the distance from the radiation source\n'
@@ -569,7 +622,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' Note that *_src/spec is used in place of *_src/mono and \n'
                              ' *_mono/spec if there is no monochromator in use, and \n'
                              ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                             ' if there is no analyser in use.</pre>',
+                             ' if there is no analyser in use.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_spec/anal': '<pre><h2>_pd_instr_dist_spec/anal</h2> Specifies distances in '
                              'millimetres for the instrument geometry:\n'
                              '   *_src/mono, the distance from the radiation source\n'
@@ -588,7 +643,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' Note that *_src/spec is used in place of *_src/mono and \n'
                              ' *_mono/spec if there is no monochromator in use, and \n'
                              ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                             ' if there is no analyser in use.</pre>',
+                             ' if there is no analyser in use.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_spec/detc': '<pre><h2>_pd_instr_dist_spec/detc</h2> Specifies distances in '
                              'millimetres for the instrument geometry:\n'
                              '   *_src/mono, the distance from the radiation source\n'
@@ -607,7 +664,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' Note that *_src/spec is used in place of *_src/mono and \n'
                              ' *_mono/spec if there is no monochromator in use, and \n'
                              ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                             ' if there is no analyser in use.</pre>',
+                             ' if there is no analyser in use.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_src/mono': '<pre><h2>_pd_instr_dist_src/mono</h2> Specifies distances in '
                             'millimetres for the instrument geometry:\n'
                             '   *_src/mono, the distance from the radiation source\n'
@@ -626,7 +685,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             ' Note that *_src/spec is used in place of *_src/mono and \n'
                             ' *_mono/spec if there is no monochromator in use, and \n'
                             ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                            ' if there is no analyser in use.</pre>',
+                            ' if there is no analyser in use.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_dist_src/spec': '<pre><h2>_pd_instr_dist_src/spec</h2> Specifies distances in '
                             'millimetres for the instrument geometry:\n'
                             '   *_src/mono, the distance from the radiation source\n'
@@ -645,7 +706,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             ' Note that *_src/spec is used in place of *_src/mono and \n'
                             ' *_mono/spec if there is no monochromator in use, and \n'
                             ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                            ' if there is no analyser in use.</pre>',
+                            ' if there is no analyser in use.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_anal/detc': '<pre><h2>_pd_instr_divg_ax_anal/detc</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -669,7 +732,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_mono/spec': '<pre><h2>_pd_instr_divg_ax_mono/spec</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -693,7 +758,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_spec/anal': '<pre><h2>_pd_instr_divg_ax_spec/anal</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -717,7 +784,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_spec/detc': '<pre><h2>_pd_instr_divg_ax_spec/detc</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -741,7 +810,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_src/mono': '<pre><h2>_pd_instr_divg_ax_src/mono</h2> Describes collimation in '
                                'the axial direction\n'
                                ' (perpendicular to the plane containing the incident\n'
@@ -765,7 +836,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_ax_src/spec': '<pre><h2>_pd_instr_divg_ax_src/spec</h2> Describes collimation in '
                                'the axial direction\n'
                                ' (perpendicular to the plane containing the incident\n'
@@ -789,7 +862,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_anal/detc': '<pre><h2>_pd_instr_divg_eq_anal/detc</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for\n'
@@ -812,7 +887,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_mono/spec': '<pre><h2>_pd_instr_divg_eq_mono/spec</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for\n'
@@ -835,7 +912,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_spec/anal': '<pre><h2>_pd_instr_divg_eq_spec/anal</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for\n'
@@ -858,7 +937,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_spec/detc': '<pre><h2>_pd_instr_divg_eq_spec/detc</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for\n'
@@ -881,7 +962,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_src/mono': '<pre><h2>_pd_instr_divg_eq_src/mono</h2> Describes collimation in '
                                'the equatorial plane (the plane\n'
                                ' containing the incident and diffracted beams) for\n'
@@ -904,7 +987,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_divg_eq_src/spec': '<pre><h2>_pd_instr_divg_eq_src/spec</h2> Describes collimation in '
                                'the equatorial plane (the plane\n'
                                ' containing the incident and diffracted beams) for\n'
@@ -927,7 +1012,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_geometry': '<pre><h2>_pd_instr_geometry</h2> A description of the diffractometer type '
                        'or geometry.\n'
                        '\n'
@@ -936,7 +1023,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                        'Guinier\n'
                        '           Parallel-beam non-focusing optics with\n'
                        '            channel-cut monochromator and linear\n'
-                       '            position-sensitive detector</pre>',
+                       '            position-sensitive detector</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_location': '<pre><h2>_pd_instr_location</h2> The name and location of the instrument '
                        'where measurements\n'
                        ' were made. This is used primarily to identify data sets\n'
@@ -944,7 +1032,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                        ' resources such as a reactor or spallation source.\n'
                        '\n'
                        '<h3>Example:</h3>\n'
-                       'SEPD diffractometer, IPNS, Argonne National Lab (USA)</pre>',
+                       'SEPD diffractometer, IPNS, Argonne National Lab (USA)</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_monochr_post_spec': '<pre><h2>_pd_instr_monochr_post_spec</h2> Indicates the method '
                                 'used to obtain monochromatic radiation.\n'
                                 ' Use _pd_instr_monochr_pre_spec to describe the primary beam\n'
@@ -973,7 +1062,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 'Ge 220\n'
                                 'none\n'
                                 'equatorial mounted graphite (0001)\n'
-                                'Si (111), antiparallel</pre>',
+                                'Si (111), antiparallel</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_monochr_pre_spec': '<pre><h2>_pd_instr_monochr_pre_spec</h2> Indicates the method used '
                                'to obtain monochromatic radiation.\n'
                                ' Use _pd_instr_monochr_pre_spec to describe the primary beam\n'
@@ -1002,7 +1092,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                'Ge 220\n'
                                'none\n'
                                'equatorial mounted graphite (0001)\n'
-                               'Si (111), antiparallel</pre>',
+                               'Si (111), antiparallel</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_slit_ax_anal/detc': '<pre><h2>_pd_instr_slit_ax_anal/detc</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -1025,7 +1116,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_ax_mono/spec': '<pre><h2>_pd_instr_slit_ax_mono/spec</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -1048,7 +1141,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_ax_spec/anal': '<pre><h2>_pd_instr_slit_ax_spec/anal</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -1071,7 +1166,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_ax_spec/detc': '<pre><h2>_pd_instr_slit_ax_spec/detc</h2> Describes collimation '
                                 'in the axial direction\n'
                                 ' (perpendicular to the plane containing the incident\n'
@@ -1094,7 +1191,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                                ' if there is no analyser in use.</pre>',
+                                ' if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_ax_src/mono': '<pre><h2>_pd_instr_slit_ax_src/mono</h2> Describes collimation in '
                                'the axial direction\n'
                                ' (perpendicular to the plane containing the incident\n'
@@ -1117,7 +1216,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_ax_src/spec': '<pre><h2>_pd_instr_slit_ax_src/spec</h2> Describes collimation in '
                                'the axial direction\n'
                                ' (perpendicular to the plane containing the incident\n'
@@ -1140,7 +1241,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and *_anal/detc \n'
-                               ' if there is no analyser in use.</pre>',
+                               ' if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_anal/detc': '<pre><h2>_pd_instr_slit_eq_anal/detc</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for the\n'
@@ -1162,7 +1265,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and \n'
-                                ' *_anal/detc if there is no analyser in use.</pre>',
+                                ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_mono/spec': '<pre><h2>_pd_instr_slit_eq_mono/spec</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for the\n'
@@ -1184,7 +1289,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and \n'
-                                ' *_anal/detc if there is no analyser in use.</pre>',
+                                ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_spec/anal': '<pre><h2>_pd_instr_slit_eq_spec/anal</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for the\n'
@@ -1206,7 +1313,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and \n'
-                                ' *_anal/detc if there is no analyser in use.</pre>',
+                                ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_spec/detc': '<pre><h2>_pd_instr_slit_eq_spec/detc</h2> Describes collimation '
                                 'in the equatorial plane (the plane\n'
                                 ' containing the incident and diffracted beams) for the\n'
@@ -1228,7 +1337,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' Note that *_src/spec is used in place of *_src/mono and \n'
                                 ' *_mono/spec if there is no monochromator in use, and \n'
                                 ' *_spec/detc is used in place of *_spec/anal and \n'
-                                ' *_anal/detc if there is no analyser in use.</pre>',
+                                ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_src/mono': '<pre><h2>_pd_instr_slit_eq_src/mono</h2> Describes collimation in '
                                'the equatorial plane (the plane\n'
                                ' containing the incident and diffracted beams) for the\n'
@@ -1250,7 +1361,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and \n'
-                               ' *_anal/detc if there is no analyser in use.</pre>',
+                               ' *_anal/detc if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_slit_eq_src/spec': '<pre><h2>_pd_instr_slit_eq_src/spec</h2> Describes collimation in '
                                'the equatorial plane (the plane\n'
                                ' containing the incident and diffracted beams) for the\n'
@@ -1272,7 +1385,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' Note that *_src/spec is used in place of *_src/mono and \n'
                                ' *_mono/spec if there is no monochromator in use, and \n'
                                ' *_spec/detc is used in place of *_spec/anal and \n'
-                               ' *_anal/detc if there is no analyser in use.</pre>',
+                               ' *_anal/detc if there is no analyser in use.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_anal/detc': '<pre><h2>_pd_instr_soller_ax_anal/detc</h2> Describes '
                                   'collimation in the axial direction\n'
                                   ' (perpendicular to the plane containing the incident\n'
@@ -1295,7 +1410,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_mono/spec': '<pre><h2>_pd_instr_soller_ax_mono/spec</h2> Describes '
                                   'collimation in the axial direction\n'
                                   ' (perpendicular to the plane containing the incident\n'
@@ -1318,7 +1435,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_spec/anal': '<pre><h2>_pd_instr_soller_ax_spec/anal</h2> Describes '
                                   'collimation in the axial direction\n'
                                   ' (perpendicular to the plane containing the incident\n'
@@ -1341,7 +1460,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_spec/detc': '<pre><h2>_pd_instr_soller_ax_spec/detc</h2> Describes '
                                   'collimation in the axial direction\n'
                                   ' (perpendicular to the plane containing the incident\n'
@@ -1364,7 +1485,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_src/mono': '<pre><h2>_pd_instr_soller_ax_src/mono</h2> Describes collimation '
                                  'in the axial direction\n'
                                  ' (perpendicular to the plane containing the incident\n'
@@ -1387,7 +1510,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' Note that *_src/spec is used in place of *_src/mono and \n'
                                  ' *_mono/spec if there is no monochromator in use, and \n'
                                  ' *_spec/detc is used in place of *_spec/anal and \n'
-                                 ' *_anal/detc if there is no analyser in use.</pre>',
+                                 ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_ax_src/spec': '<pre><h2>_pd_instr_soller_ax_src/spec</h2> Describes collimation '
                                  'in the axial direction\n'
                                  ' (perpendicular to the plane containing the incident\n'
@@ -1410,7 +1535,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' Note that *_src/spec is used in place of *_src/mono and \n'
                                  ' *_mono/spec if there is no monochromator in use, and \n'
                                  ' *_spec/detc is used in place of *_spec/anal and \n'
-                                 ' *_anal/detc if there is no analyser in use.</pre>',
+                                 ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_anal/detc': '<pre><h2>_pd_instr_soller_eq_anal/detc</h2> Describes '
                                   'collimation in the equatorial plane (the plane\n'
                                   ' containing the incident and diffracted beams) for\n'
@@ -1432,7 +1559,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_mono/spec': '<pre><h2>_pd_instr_soller_eq_mono/spec</h2> Describes '
                                   'collimation in the equatorial plane (the plane\n'
                                   ' containing the incident and diffracted beams) for\n'
@@ -1454,7 +1583,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_spec/anal': '<pre><h2>_pd_instr_soller_eq_spec/anal</h2> Describes '
                                   'collimation in the equatorial plane (the plane\n'
                                   ' containing the incident and diffracted beams) for\n'
@@ -1476,7 +1607,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_spec/detc': '<pre><h2>_pd_instr_soller_eq_spec/detc</h2> Describes '
                                   'collimation in the equatorial plane (the plane\n'
                                   ' containing the incident and diffracted beams) for\n'
@@ -1498,7 +1631,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' Note that *_src/spec is used in place of *_src/mono and \n'
                                   ' *_mono/spec if there is no monochromator in use, and \n'
                                   ' *_spec/detc is used in place of *_spec/anal and \n'
-                                  ' *_anal/detc if there is no analyser in use.</pre>',
+                                  ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_src/mono': '<pre><h2>_pd_instr_soller_eq_src/mono</h2> Describes collimation '
                                  'in the equatorial plane (the plane\n'
                                  ' containing the incident and diffracted beams) for\n'
@@ -1520,7 +1655,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' Note that *_src/spec is used in place of *_src/mono and \n'
                                  ' *_mono/spec if there is no monochromator in use, and \n'
                                  ' *_spec/detc is used in place of *_spec/anal and \n'
-                                 ' *_anal/detc if there is no analyser in use.</pre>',
+                                 ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_soller_eq_src/spec': '<pre><h2>_pd_instr_soller_eq_src/spec</h2> Describes collimation '
                                  'in the equatorial plane (the plane\n'
                                  ' containing the incident and diffracted beams) for\n'
@@ -1542,21 +1679,28 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' Note that *_src/spec is used in place of *_src/mono and \n'
                                  ' *_mono/spec if there is no monochromator in use, and \n'
                                  ' *_spec/detc is used in place of *_spec/anal and \n'
-                                 ' *_anal/detc if there is no analyser in use.</pre>',
+                                 ' *_anal/detc if there is no analyser in use.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_source_size_ax': '<pre><h2>_pd_instr_source_size_ax</h2> Axial and equatorial '
                              'intrinsic dimensions\n'
                              ' of the radiation source (in millimetres).\n'
                              ' The perpendicular to the plane containing the incident\n'
-                             ' and scattered beam is the axial (*_ax) direction.</pre>',
+                             ' and scattered beam is the axial (*_ax) direction.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_source_size_eq': '<pre><h2>_pd_instr_source_size_eq</h2> Axial and equatorial '
                              'intrinsic dimensions\n'
                              ' of the radiation source (in millimetres).\n'
                              ' The perpendicular to the plane containing the incident\n'
-                             ' and scattered beam is the axial (*_ax) direction.</pre>',
+                             ' and scattered beam is the axial (*_ax) direction.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_instr_special_details': '<pre><h2>_pd_instr_special_details</h2> A brief description of the '
                               'instrument giving\n'
                               ' details that cannot be given in other\n'
-                              ' _pd_instr_ entries.</pre>',
+                              ' _pd_instr_ entries.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_pd_instr_var_illum_len': '<pre><h2>_pd_instr_var_illum_len</h2> Length of the specimen that is '
                             'illuminated by the radiation\n'
                             ' source (in millimetres) for instruments where\n'
@@ -1567,27 +1711,37 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             '\n'
                             ' See _pd_instr_cons_illum_len for instruments where\n'
                             ' the divergence slit is \\q-compensated to yield a\n'
-                            ' constant illumination length.</pre>',
+                            ' constant illumination length.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_meas_2theta_fixed': '<pre><h2>_pd_meas_2theta_fixed</h2> The 2\\q diffraction angle in '
                           'degrees for measurements\n'
                           ' in a white-beam fixed-angle experiment. For measurements\n'
                           ' where 2\\q is scanned, see _pd_meas_2theta_scan or\n'
-                          ' _pd_meas_2theta_range_.</pre>',
+                          ' _pd_meas_2theta_range_.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_2theta_range_inc': '<pre><h2>_pd_meas_2theta_range_inc</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_meas_2theta_scan values for data sets measured with a\n'
-                              ' constant step size.</pre>',
+                              ' constant step size.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_2theta_range_max': '<pre><h2>_pd_meas_2theta_range_max</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_meas_2theta_scan values for data sets measured with a\n'
-                              ' constant step size.</pre>',
+                              ' constant step size.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_2theta_range_min': '<pre><h2>_pd_meas_2theta_range_min</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_meas_2theta_scan values for data sets measured with a\n'
-                              ' constant step size.</pre>',
+                              ' constant step size.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_2theta_scan': '<pre><h2>_pd_meas_2theta_scan</h2> 2\\q diffraction angle (in degrees) '
                          'for intensity\n'
                          ' points measured in a scanning method. The scan method used\n'
@@ -1604,7 +1758,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                          '\n'
                          ' Note that for data sets collected with constant step size,\n'
                          ' _pd_meas_2theta_range_ (*_min, *_max and *_inc) may be\n'
-                         ' used instead of _pd_meas_2theta_scan.</pre>',
+                         ' used instead of _pd_meas_2theta_scan.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_[pd]': '<pre><h2>_pd_meas_[pd]</h2> This section contains the measured diffractogram '
                   'and information\n'
                   ' about the conditions used for the measurement of the diffraction \n'
@@ -1638,27 +1794,36 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                   '    _pd_meas_2theta_range_min        6.0\n'
                   '    _pd_meas_2theta_range_max        164.0\n'
                   '    _pd_meas_2theta_range_inc        0.025\n'
-                  '    _pd_meas_step_count_time         2.0</pre>',
+                  '    _pd_meas_step_count_time         2.0</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_meas_angle_2theta': '<pre><h2>_pd_meas_angle_2theta</h2> The diffractometer angles in '
                           'degrees for an instrument with a\n'
                           ' Euler circle. The definitions for these angles follow the\n'
                           ' convention of International Tables for X-ray Crystallography\n'
-                          ' (1974), Vol. IV, p. 276.</pre>',
+                          ' (1974), Vol. IV, p. 276.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_angle_chi': '<pre><h2>_pd_meas_angle_chi</h2> The diffractometer angles in degrees for '
                        'an instrument with a\n'
                        ' Euler circle. The definitions for these angles follow the\n'
                        ' convention of International Tables for X-ray Crystallography\n'
-                       ' (1974), Vol. IV, p. 276.</pre>',
+                       ' (1974), Vol. IV, p. 276.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_angle_omega': '<pre><h2>_pd_meas_angle_omega</h2> The diffractometer angles in degrees '
                          'for an instrument with a\n'
                          ' Euler circle. The definitions for these angles follow the\n'
                          ' convention of International Tables for X-ray Crystallography\n'
-                         ' (1974), Vol. IV, p. 276.</pre>',
+                         ' (1974), Vol. IV, p. 276.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_angle_phi': '<pre><h2>_pd_meas_angle_phi</h2> The diffractometer angles in degrees for '
                        'an instrument with a\n'
                        ' Euler circle. The definitions for these angles follow the\n'
                        ' convention of International Tables for X-ray Crystallography\n'
-                       ' (1974), Vol. IV, p. 276.</pre>',
+                       ' (1974), Vol. IV, p. 276.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> -180.0:360.0 </p>',
  '_pd_meas_counts_background': '<pre><h2>_pd_meas_counts_background</h2> Counts measured at the '
                                'measurement point as a function of\n'
                                ' angle, time, channel or some other variable (see\n'
@@ -1688,7 +1853,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                '\n'
                                ' Standard uncertainties should not be quoted for these values.\n'
                                ' If the standard uncertainties differ from the square root of\n'
-                               ' the number of counts, _pd_meas_intensity_ should be used.</pre>',
+                               ' the number of counts, _pd_meas_intensity_ should be used.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_meas_counts_container': '<pre><h2>_pd_meas_counts_container</h2> Counts measured at the '
                               'measurement point as a function of\n'
                               ' angle, time, channel or some other variable (see\n'
@@ -1718,7 +1885,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                               '\n'
                               ' Standard uncertainties should not be quoted for these values.\n'
                               ' If the standard uncertainties differ from the square root of\n'
-                              ' the number of counts, _pd_meas_intensity_ should be used.</pre>',
+                              ' the number of counts, _pd_meas_intensity_ should be used.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_meas_counts_monitor': '<pre><h2>_pd_meas_counts_monitor</h2> Counts measured at the '
                             'measurement point as a function of\n'
                             ' angle, time, channel or some other variable (see\n'
@@ -1748,7 +1917,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             '\n'
                             ' Standard uncertainties should not be quoted for these values.\n'
                             ' If the standard uncertainties differ from the square root of\n'
-                            ' the number of counts, _pd_meas_intensity_ should be used.</pre>',
+                            ' the number of counts, _pd_meas_intensity_ should be used.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_meas_counts_total': '<pre><h2>_pd_meas_counts_total</h2> Counts measured at the measurement '
                           'point as a function of\n'
                           ' angle, time, channel or some other variable (see\n'
@@ -1778,7 +1949,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                           '\n'
                           ' Standard uncertainties should not be quoted for these values.\n'
                           ' If the standard uncertainties differ from the square root of\n'
-                          ' the number of counts, _pd_meas_intensity_ should be used.</pre>',
+                          ' the number of counts, _pd_meas_intensity_ should be used.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_meas_datetime_initiated': '<pre><h2>_pd_meas_datetime_initiated</h2> The date and time of '
                                 'the data-set measurement. Entries follow\n'
                                 " the standard CIF format 'yyyy-mm-ddThh:mm:ss+zz'. Use\n"
@@ -1788,7 +1961,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' it was completed.\n'
                                 '\n'
                                 '<h3>Example:</h3>\n'
-                                '1990-07-13T14:40</pre>',
+                                '1990-07-13T14:40</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_detector_id': '<pre><h2>_pd_meas_detector_id</h2> A code or number which identifies the '
                          'measuring detector or\n'
                          ' channel number in a position-sensitive, energy-dispersive\n'
@@ -1799,33 +1973,39 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                          ' to Q, energy, wavelength, angle etc. should\n'
                          ' be described with _pd_calib_ values. If\n'
                          " _pd_calibration_conversion_eqn is used, the detector ID's\n"
-                         ' should be the number to be used in the equation.</pre>',
+                         ' should be the number to be used in the equation.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_info_author_address': '<pre><h2>_pd_meas_info_author_address</h2> The address of the '
                                  'person who measured the data set. If there\n'
                                  ' is more than one person, this will be looped with\n'
-                                 ' _pd_meas_info_author_name.</pre>',
+                                 ' _pd_meas_info_author_name.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_info_author_email': '<pre><h2>_pd_meas_info_author_email</h2> The e-mail address of the '
                                'person who measured the data set. If\n'
                                ' there is more than one person, this will be looped with\n'
-                               ' _pd_meas_info_author_name.</pre>',
+                               ' _pd_meas_info_author_name.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_info_author_fax': '<pre><h2>_pd_meas_info_author_fax</h2> The fax number of the person '
                              'who measured the data set. If\n'
                              ' there is more than one person, this will be looped with\n'
                              ' _pd_meas_info_author_name. The recommended style is\n'
                              ' the international dialing prefix, followed by the area code in\n'
-                             ' parentheses, followed by the local number with no spaces.</pre>',
+                             ' parentheses, followed by the local number with no spaces.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_info_author_name': '<pre><h2>_pd_meas_info_author_name</h2> The name of the person who '
                               'measured the data set. The family\n'
                               ' name(s), followed by a comma and including any dynastic\n'
                               ' components, precedes the first name(s) or initial(s).\n'
                               ' For more than one person use a loop to specify multiple '
-                              'values.</pre>',
+                              'values.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_info_author_phone': '<pre><h2>_pd_meas_info_author_phone</h2> The telephone number of '
                                'the person who measured the data set.\n'
                                ' If there is more than one person, this will be looped with\n'
                                ' _pd_meas_info_author_name. The recommended style is\n'
                                ' the international dialing prefix, followed by the area code in\n'
-                               ' parentheses, followed by the local number with no spaces.</pre>',
+                               ' parentheses, followed by the local number with no spaces.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_intensity_background': '<pre><h2>_pd_meas_intensity_background</h2> Intensity '
                                   'measurements at the measurement point (see\n'
                                   ' the definition of _pd_meas_2theta_).\n'
@@ -1854,7 +2034,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                   ' _pd_proc_intensity_ for corrected diffractograms.\n'
                                   '\n'
                                   ' _pd_meas_units_of_intensity should be used to specify\n'
-                                  ' the units of the intensity measurements.</pre>',
+                                  ' the units of the intensity measurements.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_meas_intensity_container': '<pre><h2>_pd_meas_intensity_container</h2> Intensity '
                                  'measurements at the measurement point (see\n'
                                  ' the definition of _pd_meas_2theta_).\n'
@@ -1882,7 +2063,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' _pd_proc_intensity_ for corrected diffractograms.\n'
                                  '\n'
                                  ' _pd_meas_units_of_intensity should be used to specify\n'
-                                 ' the units of the intensity measurements.</pre>',
+                                 ' the units of the intensity measurements.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_meas_intensity_monitor': '<pre><h2>_pd_meas_intensity_monitor</h2> Intensity measurements at '
                                'the measurement point (see\n'
                                ' the definition of _pd_meas_2theta_).\n'
@@ -1909,7 +2091,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' _pd_proc_intensity_ for corrected diffractograms.\n'
                                '\n'
                                ' _pd_meas_units_of_intensity should be used to specify\n'
-                               ' the units of the intensity measurements.</pre>',
+                               ' the units of the intensity measurements.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_meas_intensity_total': '<pre><h2>_pd_meas_intensity_total</h2> Intensity measurements at the '
                              'measurement point (see\n'
                              ' the definition of _pd_meas_2theta_).\n'
@@ -1936,16 +2119,20 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' _pd_proc_intensity_ for corrected diffractograms.\n'
                              '\n'
                              ' _pd_meas_units_of_intensity should be used to specify\n'
-                             ' the units of the intensity measurements.</pre>',
+                             ' the units of the intensity measurements.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_meas_number_of_points': '<pre><h2>_pd_meas_number_of_points</h2> The total number of points '
                               'in the measured\n'
-                              ' diffractogram.</pre>',
+                              ' diffractogram.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_pd_meas_point_id': '<pre><h2>_pd_meas_point_id</h2> Arbitrary label identifying a measured data '
                       'point. Used to\n'
                       ' identify a specific entry in a list of measured intensities.\n'
                       ' The role of this identifier may be adopted by\n'
                       ' _pd_data_point_id if measured, processed and calculated\n'
-                      ' intensity values are combined in a single list.</pre>',
+                      ' intensity values are combined in a single list.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_position': '<pre><h2>_pd_meas_position</h2> A linear distance in millimetres '
                       'corresponding to the\n'
                       ' location where an intensity measurement is made.\n'
@@ -1963,11 +2150,14 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                       ' or d-space, should be supplied with the _pd_calib_ values.\n'
                       '\n'
                       ' Do not confuse this with the instrument geometry\n'
-                      ' descriptions given by _pd_instr_dist_.</pre>',
+                      ' descriptions given by _pd_instr_dist_.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_meas_rocking_angle': '<pre><h2>_pd_meas_rocking_angle</h2> The angular range in degrees '
                            'through which a sample is rotated\n'
                            ' or oscillated during a measurement step\n'
-                           ' (see _pd_meas_rocking_axis).</pre>',
+                           ' (see _pd_meas_rocking_axis).</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0:360.0 </p>',
  '_pd_meas_rocking_axis': '<pre><h2>_pd_meas_rocking_axis</h2> Description of the axis (or axes) '
                           'used to rotate or rock the\n'
                           ' specimen for better randomization of crystallites\n'
@@ -1976,7 +2166,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                           '<h3>Example:</h3>\n'
                           'chi\n'
                           'omega\n'
-                          'phi</pre>',
+                          'phi</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_scan_method': '<pre><h2>_pd_meas_scan_method</h2> Code identifying the method for '
                          'scanning reciprocal space.\n'
                          " The designation `fixed' should be used for measurements where\n"
@@ -1999,22 +2190,28 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                          '\n'
                          'fixed\n'
                          '\tstationary detector\n'
-                         '</pre>',
+                         '</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_special_details': '<pre><h2>_pd_meas_special_details</h2> Special details of the '
                              'diffraction measurement process.\n'
                              ' Include information about source instability, degradation etc.\n'
                              ' However, this item should not be used to record information\n'
-                             ' that can be specified in other _pd_meas_ entries.</pre>',
+                             ' that can be specified in other _pd_meas_ entries.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_pd_meas_step_count_time': '<pre><h2>_pd_meas_step_count_time</h2> The count time in seconds for '
                              'each intensity measurement.\n'
                              ' If this value varies for different intensity measurements,\n'
                              ' then this item will be placed in the loop with the\n'
                              ' diffraction measurements. If a single fixed value is used,\n'
-                             ' it may be recorded outside the loop.</pre>',
+                             ' it may be recorded outside the loop.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_meas_time_of_flight': '<pre><h2>_pd_meas_time_of_flight</h2> Measured time in microseconds '
                             'for time-of-flight neutron\n'
                             ' measurements. Note that the flight distance may be\n'
-                            ' specified using _pd_instr_dist_ values.</pre>',
+                            ' specified using _pd_instr_dist_ values.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_meas_units_of_intensity': '<pre><h2>_pd_meas_units_of_intensity</h2> Units for intensity '
                                 'measurements when _pd_meas_intensity_\n'
                                 " is used. Note that use of 'counts' or 'counts per second'\n"
@@ -2025,13 +2222,18 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 '<h3>Example:</h3>\n'
                                 'estimated from strip chart\n'
                                 'arbitrary, from film density\n'
-                                'counts, with automatic dead-time correction applied</pre>',
+                                'counts, with automatic dead-time correction applied</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_peak_2theta_centroid': '<pre><h2>_pd_peak_2theta_centroid</h2> Position of the centroid and '
                              'maximum of a peak as a\n'
-                             ' 2\\q angle in degrees.</pre>',
+                             ' 2\\q angle in degrees.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:180.0 </p>',
  '_pd_peak_2theta_maximum': '<pre><h2>_pd_peak_2theta_maximum</h2> Position of the centroid and '
                             'maximum of a peak as a\n'
-                            ' 2\\q angle in degrees.</pre>',
+                            ' 2\\q angle in degrees.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:180.0 </p>',
  '_pd_peak_[pd]': '<pre><h2>_pd_peak_[pd]</h2> This section contains peak information extracted '
                   'from the\n'
                   ' measured or, if present, the processed diffractogram. Each\n'
@@ -2042,9 +2244,12 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                   '\n'
                   ' Note that peak positions are customarily determined from the\n'
                   ' processed diffractogram and thus corrections for position\n'
-                  ' and intensity will have been previously applied.</pre>',
+                  ' and intensity will have been previously applied.</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_peak_d_spacing': '<pre><h2>_pd_peak_d_spacing</h2> Peak position as a d-spacing in '
-                       'angstroms.</pre>',
+                       'angstroms.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_peak_id': '<pre><h2>_pd_peak_id</h2> An arbitrary code is assigned to each peak. Used to '
                 'link with\n'
                 ' _pd_refln_peak_id so that multiple hkl and/or phase\n'
@@ -2053,20 +2258,26 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                 ' where two peaks are severely overlapped, it may be\n'
                 ' desirable to list them as a single peak.\n'
                 '\n'
-                ' A peak ID must be included for every peak.</pre>',
+                ' A peak ID must be included for every peak.</pre>\n'
+                '<br><p><h4>Type:</h4> string</p>',
  '_pd_peak_intensity': '<pre><h2>_pd_peak_intensity</h2> Integrated area for the peak, with the '
                        'same scaling as\n'
                        ' the _pd_proc_intensity_ values. It is good practice to\n'
-                       " include s.u.'s for these values.</pre>",
+                       " include s.u.'s for these values.</pre>\n"
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_peak_pk_height': '<pre><h2>_pd_peak_pk_height</h2> The maximum intensity of the peak, either '
                        'extrapolated\n'
                        ' or the highest observed intensity value. The same\n'
                        ' scaling is used for the _pd_proc_intensity_ values.\n'
-                       " It is good practice to include s.u.'s for these values.</pre>",
+                       " It is good practice to include s.u.'s for these values.</pre>\n"
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_peak_special_details': '<pre><h2>_pd_peak_special_details</h2> Detailed description of any '
                              'non-routine processing steps\n'
                              ' used for peak determination or other comments\n'
-                             ' related to the peak table that cannot be given elsewhere.</pre>',
+                             ' related to the peak table that cannot be given elsewhere.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_pd_peak_wavelength_id': '<pre><h2>_pd_peak_wavelength_id</h2> Code identifying the wavelength '
                            'appropriate for this peak\n'
                            ' from the wavelengths in the _diffrn_radiation_ list.\n'
@@ -2076,13 +2287,18 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                            ' complex peak tables with multiple superimposed peaks,\n'
                            ' specify wavelengths in the reflection table using\n'
                            ' _pd_refln_wavelength_id rather than identifying peaks by\n'
-                           ' wavelength.</pre>',
+                           ' wavelength.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_pd_peak_width_2theta': '<pre><h2>_pd_peak_width_2theta</h2> Peak width as full-width at '
                           'half-maximum expressed as\n'
-                          ' a 2\\q value in degrees.</pre>',
+                          ' a 2\\q value in degrees.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0.0:180.0 </p>',
  '_pd_peak_width_d_spacing': '<pre><h2>_pd_peak_width_d_spacing</h2> Peak width as full-width at '
                              'half-maximum expressed as\n'
-                             ' a d-spacing in angstroms.</pre>',
+                             ' a d-spacing in angstroms.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_phase_[pd]': '<pre><h2>_pd_phase_[pd]</h2> This section contains a description of the '
                    'crystalline phases\n'
                    ' contributing to the powder diffraction data set. Note that if\n'
@@ -2093,41 +2309,55 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                    ' The _pd_phase_block_id entry points to the CIF block with\n'
                    ' structural parameters for each crystalline phase. The\n'
                    ' _pd_phase_id serves to link to _pd_refln_phase_id, which is\n'
-                   ' used to label peaks by phase.</pre>',
+                   ' used to label peaks by phase.</pre>\n'
+                   '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_phase_block_id': '<pre><h2>_pd_phase_block_id</h2> A block ID code identifying the phase '
                        'contributing to\n'
                        ' the diffraction peak. The data block containing the\n'
                        ' crystallographic information for this phase will be\n'
                        ' identified with a _pd_block_id code matching the\n'
-                       ' code in _pd_phase_block_id.</pre>',
+                       ' code in _pd_phase_block_id.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_pd_phase_id': '<pre><h2>_pd_phase_id</h2> A code for each crystal phase used to link with\n'
-                 ' _pd_refln_phase_id.</pre>',
+                 ' _pd_refln_phase_id.</pre>\n'
+                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_phase_mass_%': '<pre><h2>_pd_phase_mass_%</h2> Per cent composition of the specified crystal '
                      'phase\n'
                      ' expressed as the total mass of the component\n'
-                     ' with respect to the total mass of the specimen.</pre>',
+                     ' with respect to the total mass of the specimen.</pre>\n'
+                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                     '<br><p><h4>Limits:</h4> 0.0:100.0 </p>',
  '_pd_phase_name': '<pre><h2>_pd_phase_name</h2> The name of the crystal phase identified by '
                    '_pd_phase_id.\n'
-                   ' It may be designated as unknown or by a structure type etc.</pre>',
+                   ' It may be designated as unknown or by a structure type etc.</pre>\n'
+                   '<br><p><h4>Type:</h4> string</p>',
  '_pd_prep_[pd]': '<pre><h2>_pd_prep_[pd]</h2> This section contains descriptive information about '
                   'how the\n'
-                  ' sample was prepared.</pre>',
+                  ' sample was prepared.</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_prep_conditions': '<pre><h2>_pd_prep_conditions</h2> A description of how the material was '
                         'prepared\n'
-                        ' (reaction conditions etc.)</pre>',
+                        ' (reaction conditions etc.)</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_pd_prep_cool_rate': '<pre><h2>_pd_prep_cool_rate</h2> Cooling rate in kelvins per minute for '
                        'samples prepared\n'
                        ' at high temperatures. If the cooling rate is not linear\n'
                        ' or is unknown (e.g. quenched samples), it should be\n'
-                       ' described in _pd_prep_conditions instead.</pre>',
+                       ' described in _pd_prep_conditions instead.</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_prep_pressure': '<pre><h2>_pd_prep_pressure</h2> Preparation pressure of the sample in '
                       'kilopascals. This\n'
                       ' is particularly important for materials which are metastable\n'
-                      ' at the measurement pressure, _diffrn_ambient_pressure.</pre>',
+                      ' at the measurement pressure, _diffrn_ambient_pressure.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_prep_temperature': '<pre><h2>_pd_prep_temperature</h2> Preparation temperature of the sample '
                          'in kelvins. This is\n'
                          ' particularly important for materials which are metastable\n'
-                         ' at the measurement temperature, _diffrn_ambient_temperature.</pre>',
+                         ' at the measurement temperature, _diffrn_ambient_temperature.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_2theta_corrected': '<pre><h2>_pd_proc_2theta_corrected</h2> The 2\\q diffraction angle '
                               'in degrees of an intensity\n'
                               ' measurement where 2\\q is not constant. Used if\n'
@@ -2136,30 +2366,41 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                               ' 2\\q values are computed. If the 2\\q values\n'
                               ' are evenly spaced, _pd_proc_2theta_range_min,\n'
                               ' _pd_proc_2theta_range_max and _pd_proc_2theta_range_inc\n'
-                              ' may be used to specify the 2\\q values.</pre>',
+                              ' may be used to specify the 2\\q values.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_proc_2theta_range_inc': '<pre><h2>_pd_proc_2theta_range_inc</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_proc_2theta_corrected values, or in the case of white-beam\n'
-                              ' experiments it will define the fixed 2\\q value.</pre>',
+                              ' experiments it will define the fixed 2\\q value.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_proc_2theta_range_max': '<pre><h2>_pd_proc_2theta_range_max</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_proc_2theta_corrected values, or in the case of white-beam\n'
-                              ' experiments it will define the fixed 2\\q value.</pre>',
+                              ' experiments it will define the fixed 2\\q value.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_proc_2theta_range_min': '<pre><h2>_pd_proc_2theta_range_min</h2> The range of 2\\q '
                               'diffraction angles in degrees for the\n'
                               ' measurement of intensities. These may be used in place of the\n'
                               ' _pd_proc_2theta_corrected values, or in the case of white-beam\n'
-                              ' experiments it will define the fixed 2\\q value.</pre>',
+                              ' experiments it will define the fixed 2\\q value.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> -180.0:180.0 </p>',
  '_pd_proc_[pd]': '<pre><h2>_pd_proc_[pd]</h2> This section contains the diffraction data set '
                   'after processing\n'
                   ' and application of correction terms. If the data set is\n'
                   ' reprocessed, this section may be replaced (with the addition of\n'
-                  ' a new _pd_block_id entry).</pre>',
+                  ' a new _pd_block_id entry).</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_proc_d_spacing': '<pre><h2>_pd_proc_d_spacing</h2> d-spacing corresponding to an intensity '
                        'point\n'
-                       " from Bragg's law, d = \\l/(2 sin\\q), in units of angstroms.</pre>",
+                       " from Bragg's law, d = \\l/(2 sin\\q), in units of angstroms.</pre>\n"
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_energy_detection': '<pre><h2>_pd_proc_energy_detection</h2> Incident energy in '
                               'electronvolts of the source computed\n'
                               ' from secondary calibration information (time-of-flight\n'
@@ -2168,7 +2409,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                               ' if not the same as the incident energy (triple-axis or \n'
                               ' energy-dispersive data). This may be a single value or may \n'
                               ' vary for each data point (triple-axis and time-of-flight '
-                              'data).</pre>',
+                              'data).</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_energy_incident': '<pre><h2>_pd_proc_energy_incident</h2> Incident energy in '
                              'electronvolts of the source computed\n'
                              ' from secondary calibration information (time-of-flight\n'
@@ -2177,37 +2420,46 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' if not the same as the incident energy (triple-axis or \n'
                              ' energy-dispersive data). This may be a single value or may \n'
                              ' vary for each data point (triple-axis and time-of-flight '
-                             'data).</pre>',
+                             'data).</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_info_author_address': '<pre><h2>_pd_proc_info_author_address</h2>  The address of the '
                                  'person who processed the data.\n'
                                  '  If there is more than one person, this will be looped with\n'
-                                 '  _pd_proc_info_author_name.</pre>',
+                                 '  _pd_proc_info_author_name.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_author_email': '<pre><h2>_pd_proc_info_author_email</h2>  The e-mail address of '
                                'the person who processed the\n'
                                '  data.  If there is more than one person, this will be looped\n'
-                               '  with _pd_proc_info_author_name.</pre>',
+                               '  with _pd_proc_info_author_name.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_author_fax': '<pre><h2>_pd_proc_info_author_fax</h2>  The fax number of the person '
                              'who processed the data.\n'
                              '  If there is more than one person, this will be looped with\n'
                              '  _pd_proc_info_author_name. The recommended style is\n'
                              '  the international dialing prefix, followed by the area code in\n'
-                             '  parentheses, followed by the local number with no spaces.</pre>',
+                             '  parentheses, followed by the local number with no spaces.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_author_name': '<pre><h2>_pd_proc_info_author_name</h2>  The name of the person who '
                               'processed the data, if different\n'
                               '  from the person(s) who measured the data set. The family\n'
                               '  name(s), followed by a comma and including any dynastic\n'
                               '  components, precedes the first name(s) or initial(s). For\n'
-                              '  more than one person use a loop to specify multiple values.</pre>',
+                              '  more than one person use a loop to specify multiple '
+                              'values.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_author_phone': '<pre><h2>_pd_proc_info_author_phone</h2>  The telephone number of '
                                'the person who processed the data.\n'
                                '  If there is more than one person, this will be looped\n'
                                '  with _pd_proc_info_author_name. The recommended style is\n'
                                '  the international dialing prefix, followed by the area code in\n'
-                               '  parentheses, followed by the local number with no spaces.</pre>',
+                               '  parentheses, followed by the local number with no spaces.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_data_reduction': '<pre><h2>_pd_proc_info_data_reduction</h2> Description of the '
                                  'processing steps applied in the data-reduction\n'
                                  ' process (background subtraction, \\a-2 stripping, smoothing\n'
-                                 ' etc.). Include details of the program(s) used etc.</pre>',
+                                 ' etc.). Include details of the program(s) used etc.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_datetime': '<pre><h2>_pd_proc_info_datetime</h2> Date(s) and time(s) when the data '
                            'set was processed.\n'
                            ' May be looped if multiple processing steps were used.\n'
@@ -2218,18 +2470,21 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                            ' strongly encouraged.\n'
                            '\n'
                            '<h3>Example:</h3>\n'
-                           '1990-07-13T14:40</pre>',
+                           '1990-07-13T14:40</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_excluded_regions': '<pre><h2>_pd_proc_info_excluded_regions</h2> Description of '
                                    'regions in the diffractogram excluded\n'
                                    ' from processing along with a justification of why the\n'
                                    ' data points were not used.\n'
                                    '\n'
                                    '<h3>Example:</h3>\n'
-                                   '20 to 21 degrees unreliable due to beam dump</pre>',
+                                   '20 to 21 degrees unreliable due to beam dump</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_info_special_details': '<pre><h2>_pd_proc_info_special_details</h2> Detailed '
                                   'description of any non-routine processing steps\n'
                                   ' applied due to any irregularities in this particular data '
-                                  'set.</pre>',
+                                  'set.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_intensity_bkg_calc': '<pre><h2>_pd_proc_intensity_bkg_calc</h2> _pd_proc_intensity_net '
                                 'contains intensity values for the\n'
                                 ' processed diffractogram for each data point (see\n'
@@ -2282,7 +2537,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' example, Lp corrections, compensation for variation in\n'
                                 ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                                 ' The function should be specified as the one used to divide the\n'
-                                ' measured intensities.</pre>',
+                                ' measured intensities.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_intensity_bkg_fix': '<pre><h2>_pd_proc_intensity_bkg_fix</h2> _pd_proc_intensity_net '
                                'contains intensity values for the\n'
                                ' processed diffractogram for each data point (see\n'
@@ -2335,7 +2592,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                ' example, Lp corrections, compensation for variation in\n'
                                ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                                ' The function should be specified as the one used to divide the\n'
-                               ' measured intensities.</pre>',
+                               ' measured intensities.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_intensity_incident': '<pre><h2>_pd_proc_intensity_incident</h2> _pd_proc_intensity_net '
                                 'contains intensity values for the\n'
                                 ' processed diffractogram for each data point (see\n'
@@ -2388,7 +2647,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                 ' example, Lp corrections, compensation for variation in\n'
                                 ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                                 ' The function should be specified as the one used to divide the\n'
-                                ' measured intensities.</pre>',
+                                ' measured intensities.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_intensity_net': '<pre><h2>_pd_proc_intensity_net</h2> _pd_proc_intensity_net contains '
                            'intensity values for the\n'
                            ' processed diffractogram for each data point (see\n'
@@ -2440,7 +2701,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                            ' example, Lp corrections, compensation for variation in\n'
                            ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                            ' The function should be specified as the one used to divide the\n'
-                           ' measured intensities.</pre>',
+                           ' measured intensities.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                           '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_intensity_norm': '<pre><h2>_pd_proc_intensity_norm</h2> _pd_proc_intensity_net contains '
                             'intensity values for the\n'
                             ' processed diffractogram for each data point (see\n'
@@ -2492,7 +2755,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                             ' example, Lp corrections, compensation for variation in\n'
                             ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                             ' The function should be specified as the one used to divide the\n'
-                            ' measured intensities.</pre>',
+                            ' measured intensities.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                            '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_intensity_total': '<pre><h2>_pd_proc_intensity_total</h2> _pd_proc_intensity_net '
                              'contains intensity values for the\n'
                              ' processed diffractogram for each data point (see\n'
@@ -2544,7 +2809,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                              ' example, Lp corrections, compensation for variation in\n'
                              ' counting time) may be specified in _pd_proc_intensity_norm.\n'
                              ' The function should be specified as the one used to divide the\n'
-                             ' measured intensities.</pre>',
+                             ' measured intensities.</pre>\n'
+                             '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                             '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_ls_[pd]': '<pre><h2>_pd_proc_ls_[pd]</h2> This section is used to define parameters '
                      'relevant to a\n'
                      ' least-squares fit to a powder diffractogram, using a Rietveld\n'
@@ -2556,7 +2823,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                      ' intensities estimated from a powder diffractogram by \n'
                      ' pattern-decomposition methods. Also note that many entries in \n'
                      ' the core _refine_ls_ entries may also be useful (for example\n'
-                     ' _refine_ls_shift/su_*).</pre>',
+                     ' _refine_ls_shift/su_*).</pre>\n'
+                     '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_proc_ls_background_function': '<pre><h2>_pd_proc_ls_background_function</h2> Description of '
                                     'the background treatment mechanism used to\n'
                                     ' fit the data set.\n'
@@ -2585,14 +2853,16 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                     ' etc.) and whether the values were refined to improve the\n'
                                     ' agreement. The extrapolated background intensity value for\n'
                                     ' each data point should be specified in\n'
-                                    ' _pd_proc_intensity_bkg_calc.</pre>',
+                                    ' _pd_proc_intensity_bkg_calc.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_ls_peak_cutoff': '<pre><h2>_pd_proc_ls_peak_cutoff</h2> Describes where peak-intensity '
                             'computation is\n'
                             ' discontinued as a fraction of the intensity of the\n'
                             ' peak at maximum. Thus for a value of 0.005, the\n'
                             ' tails of a diffraction peak are neglected\n'
                             ' after the intensity has dropped below 0.5% of the\n'
-                            ' diffraction intensity at the maximum.</pre>',
+                            ' diffraction intensity at the maximum.</pre>\n'
+                            '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_pd_proc_ls_pref_orient_corr': '<pre><h2>_pd_proc_ls_pref_orient_corr</h2> Description of the '
                                  'preferred-orientation correction if\n'
                                  ' such a correction is used. Omitting this entry\n'
@@ -2601,7 +2871,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  ' recommended that the actual equation in TeX, or a\n'
                                  ' programming language, is used to specify the function as\n'
                                  ' well as a giving a description. Include the value(s) used \n'
-                                 " for the correction with s.u.'s.</pre>",
+                                 " for the correction with s.u.'s.</pre>\n"
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_ls_prof_R_factor': '<pre><h2>_pd_proc_ls_prof_R_factor</h2> Rietveld/profile fit R '
                               'factors.\n'
                               '\n'
@@ -2654,7 +2925,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                               '     n is the total number of data points (see\n'
                               '          _pd_proc_number_of_points) less the number of\n'
                               '          data points excluded from the refinement.\n'
-                              '     p is the total number of refined parameters.</pre>',
+                              '     p is the total number of refined parameters.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_ls_prof_wR_expected': '<pre><h2>_pd_proc_ls_prof_wR_expected</h2> Rietveld/profile fit '
                                  'R factors.\n'
                                  '\n'
@@ -2709,7 +2982,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                  '     n is the total number of data points (see\n'
                                  '          _pd_proc_number_of_points) less the number of\n'
                                  '          data points excluded from the refinement.\n'
-                                 '     p is the total number of refined parameters.</pre>',
+                                 '     p is the total number of refined parameters.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_ls_prof_wR_factor': '<pre><h2>_pd_proc_ls_prof_wR_factor</h2> Rietveld/profile fit R '
                                'factors.\n'
                                '\n'
@@ -2763,18 +3038,22 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                                '     n is the total number of data points (see\n'
                                '          _pd_proc_number_of_points) less the number of\n'
                                '          data points excluded from the refinement.\n'
-                               '     p is the total number of refined parameters.</pre>',
+                               '     p is the total number of refined parameters.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                               '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_ls_profile_function': '<pre><h2>_pd_proc_ls_profile_function</h2> Description of the '
                                  'profile function used to\n'
                                  ' fit the data set. If a function form is used, it is\n'
                                  ' recommended that the actual equation in TeX, or a\n'
                                  ' programming language, is used to specify the function as\n'
                                  ' well as giving a description. Include the values used \n'
-                                 " for the profile-function coefficients and their s.u.'s.</pre>",
+                                 " for the profile-function coefficients and their s.u.'s.</pre>\n"
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_ls_special_details': '<pre><h2>_pd_proc_ls_special_details</h2> Additional '
                                 'characterization information relevant to\n'
                                 ' non-routine steps used for refinement of a structural model\n'
-                                ' that cannot be specified elsewhere.</pre>',
+                                ' that cannot be specified elsewhere.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_ls_weight': '<pre><h2>_pd_proc_ls_weight</h2> Weight applied to each profile point. '
                        'These values\n'
                        ' may be omitted if the weights are 1/u^2^, where\n'
@@ -2782,9 +3061,13 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                        '\n'
                        ' A weight value of zero is used to indicate a data\n'
                        ' point not used for refinement (see\n'
-                       ' _pd_proc_info_excluded_regions).</pre>',
+                       ' _pd_proc_info_excluded_regions).</pre>\n'
+                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                       '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_pd_proc_number_of_points': '<pre><h2>_pd_proc_number_of_points</h2> The total number of data '
-                              'points in the processed diffractogram.</pre>',
+                              'points in the processed diffractogram.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 1:∞ </p>',
  '_pd_proc_point_id': '<pre><h2>_pd_proc_point_id</h2> Arbitrary label identifying a processed '
                       'data point. Used to\n'
                       ' identify a specific entry in a list of processed intensities.\n'
@@ -2792,10 +3075,13 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                       ' _pd_data_point_id if measured, processed and calculated\n'
                       ' intensity values are combined in a single list, or by\n'
                       ' _pd_meas_point_id if measured and processed lists are\n'
-                      ' combined.</pre>',
+                      ' combined.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_proc_recip_len_Q': '<pre><h2>_pd_proc_recip_len_Q</h2> Length in reciprocal space (|Q|= '
                          '2\\p/d) corresponding to\n'
-                         ' an intensity point. Units are inverse angstroms.</pre>',
+                         ' an intensity point. Units are inverse angstroms.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                         '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_proc_wavelength': '<pre><h2>_pd_proc_wavelength</h2> Wavelength in angstroms for the '
                         'incident radiation as\n'
                         ' computed from secondary calibration information. This will\n'
@@ -2803,7 +3089,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                         ' measurements. This will be a single value for\n'
                         ' continuous-wavelength methods or may vary for each data point\n'
                         ' and be looped with the intensity values for energy-dispersive\n'
-                        ' measurements.</pre>',
+                        ' measurements.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_refln_[pd]': '<pre><h2>_pd_refln_[pd]</h2> This section provides a mechanism to identify '
                    'each peak in the\n'
                    ' peak-table section (_pd_peak_) with the phase(s) (_pd_phase_id)\n'
@@ -2811,18 +3099,22 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                    ' peak.  There are no restrictions on the number of phases or\n'
                    ' reflections associated with an observed peak. Reflections may\n'
                    " also be included that are not observed; use '.' for the\n"
-                   ' _pd_refln_peak_id.</pre>',
+                   ' _pd_refln_peak_id.</pre>\n'
+                   '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_refln_peak_id': '<pre><h2>_pd_refln_peak_id</h2> Code which identifies the powder '
                       'diffraction peak that\n'
                       ' contains the current reflection. This code must match a\n'
-                      ' _pd_peak_id code.</pre>',
+                      ' _pd_peak_id code.</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_refln_phase_id': '<pre><h2>_pd_refln_phase_id</h2> Code which identifies the crystal phase '
                        'associated with this\n'
-                       ' reflection. This code must match a _pd_phase_id code.</pre>',
+                       ' reflection. This code must match a _pd_phase_id code.</pre>\n'
+                       '<br><p><h4>Type:</h4> string</p>',
  '_pd_refln_wavelength_id': '<pre><h2>_pd_refln_wavelength_id</h2> Code which identifies the '
                             'wavelength associated with the\n'
                             ' reflection and the peak pointed to by _pd_refln_peak_id.\n'
-                            ' This code must match a _diffrn_radiation_wavelength_id code.</pre>',
+                            ' This code must match a _diffrn_radiation_wavelength_id code.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_[pd]': '<pre><h2>_pd_spec_[pd]</h2> This section contains information about the '
                   'specimen used\n'
                   ' for measurement of the diffraction data set. Note that \n'
@@ -2834,16 +3126,19 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                   '    _pd_spec_mounting               ?\n'
                   '    _pd_spec_mount_mode             transmission\n'
                   '    _pd_spec_orientation            horizontal\n'
-                  '    _pd_spec_preparation            ?</pre>',
+                  '    _pd_spec_preparation            ?</pre>\n'
+                  '<br><p><h4>Type:</h4> ? (unknown)</p>',
  '_pd_spec_description': '<pre><h2>_pd_spec_description</h2>  A description of the specimen, such '
                          'as the source of the\n'
-                         '  specimen, identification of standards, mixtures etc.</pre>',
+                         '  specimen, identification of standards, mixtures etc.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_mount_mode': '<pre><h2>_pd_spec_mount_mode</h2> A code describing the beam path through '
                         'the specimen.\n'
                         '\n'
                         '<h3>Example:</h3>\n'
                         'reflection\n'
-                        'transmission</pre>',
+                        'transmission</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_mounting': '<pre><h2>_pd_spec_mounting</h2> A description of how the specimen is '
                       'mounted.\n'
                       '\n'
@@ -2852,7 +3147,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                       'quartz capillary\n'
                       'packed powder pellet\n'
                       'drifted powder on off-cut Si\n'
-                      'drifted powder on Kapton film</pre>',
+                      'drifted powder on Kapton film</pre>\n'
+                      '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_orientation': '<pre><h2>_pd_spec_orientation</h2> The orientation of the \\w (\\q) and '
                          '2\\q axis.\n'
                          ' Note that this axis is parallel to the specimen axial axis\n'
@@ -2871,7 +3167,8 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                          '<h3>Example:</h3>\n'
                          'horizontal\n'
                          'vertical\n'
-                         'both</pre>',
+                         'both</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_preparation': '<pre><h2>_pd_spec_preparation</h2> A description of the preparation '
                          'steps for producing the\n'
                          ' diffraction specimen from the sample. Include any procedures\n'
@@ -2882,13 +3179,15 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                          '<h3>Example:</h3>\n'
                          'wet grinding in acetone\n'
                          'sieved through a 44 micron (325 mesh/inch) sieve\n'
-                         'spray dried in water with 1% clay</pre>',
+                         'spray dried in water with 1% clay</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_shape': '<pre><h2>_pd_spec_shape</h2> A code describing the specimen shape.\n'
                    '\n'
                    '<h3>Example:</h3>\n'
                    'cylinder\n'
                    'flat_sheet\n'
-                   'irregular</pre>',
+                   'irregular</pre>\n'
+                   '<br><p><h4>Type:</h4> string</p>',
  '_pd_spec_size_axial': '<pre><h2>_pd_spec_size_axial</h2> The size of the specimen in three '
                         'mutually perpendicular\n'
                         ' directions in millimetres.\n'
@@ -2897,7 +3196,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                         ' In transmission geometry, the scattering vector is parallel\n'
                         ' to *_equat and in reflection geometry the scattering vector is\n'
                         ' parallel to *_thick.\n'
-                        '</pre>',
+                        '</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_spec_size_equat': '<pre><h2>_pd_spec_size_equat</h2> The size of the specimen in three '
                         'mutually perpendicular\n'
                         ' directions in millimetres.\n'
@@ -2906,7 +3207,9 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                         ' In transmission geometry, the scattering vector is parallel\n'
                         ' to *_equat and in reflection geometry the scattering vector is\n'
                         ' parallel to *_thick.\n'
-                        '</pre>',
+                        '</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_spec_size_thick': '<pre><h2>_pd_spec_size_thick</h2> The size of the specimen in three '
                         'mutually perpendicular\n'
                         ' directions in millimetres.\n'
@@ -2915,7 +3218,10 @@ powder_dict = {'_pd_block_[pd]': '<pre><
                         ' In transmission geometry, the scattering vector is parallel\n'
                         ' to *_equat and in reflection geometry the scattering vector is\n'
                         ' parallel to *_thick.\n'
-                        '</pre>',
+                        '</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0.0:∞ </p>',
  '_pd_spec_special_details': '<pre><h2>_pd_spec_special_details</h2> Descriptive information about '
                              'the specimen that cannot be\n'
-                             ' included in other data items.</pre>'}
\ No newline at end of file
+                             ' included in other data items.</pre>\n'
+                             '<br><p><h4>Type:</h4> string</p>'}
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/cif/restraints_dict.py 137+dfsg-1/finalcif/cif/restraints_dict.py
--- 134+dfsg-1/finalcif/cif/restraints_dict.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/restraints_dict.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,24 +1,32 @@
 restraints_dict = {'_restr_U_iso_atom_site_label': '<pre><h2>_restr_U_iso_atom_site_label</h2> Label of the atom '
                                  'whose atomic displacement parameters\n'
-                                 ' are restrained.</pre>',
+                                 ' are restrained.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_iso_weight_param': '<pre><h2>_restr_U_iso_weight_param</h2> The expectation value of '
                               'the difference between\n'
                               ' the refined and the isotropic equivalent of the\n'
                               ' anisotropic atomic displacement parameters.\n'
-                              ' The default value of zero indicates a constraint.</pre>',
+                              ' The default value of zero indicates a constraint.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_U_rigid_U_parallel': '<pre><h2>_restr_U_rigid_U_parallel</h2> The average value of the '
                               'components parallel to the bond\n'
                               ' of the atomic displacement parameters of the two atoms\n'
-                              ' that define the bond.</pre>',
+                              ' that define the bond.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_U_rigid_atom_site_label_1': '<pre><h2>_restr_U_rigid_atom_site_label_1</h2> The atom-site '
-                                     'labels of the two atoms that define the rigid bond.</pre>',
+                                     'labels of the two atoms that define the rigid bond.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_rigid_atom_site_label_2': '<pre><h2>_restr_U_rigid_atom_site_label_2</h2> The atom-site '
-                                     'labels of the two atoms that define the rigid bond.</pre>',
+                                     'labels of the two atoms that define the rigid bond.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_rigid_details': '<pre><h2>_restr_U_rigid_details</h2> Free-text information about the '
-                           'rigid-bond restraint.</pre>',
+                           'rigid-bond restraint.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_rigid_diff': '<pre><h2>_restr_U_rigid_diff</h2> The difference between the components '
                         'along the bond direction\n'
-                        ' of the atomic displacement parameters, U, of the two atoms.</pre>',
+                        ' of the atomic displacement parameters, U, of the two atoms.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_U_rigid_site_symmetry_1': '<pre><h2>_restr_U_rigid_site_symmetry_1</h2> The site '
                                    'symmetries of the two atoms that define the rigid bond.\n'
                                    '\n'
@@ -49,7 +57,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_U_rigid_site_symmetry_2': '<pre><h2>_restr_U_rigid_site_symmetry_2</h2> The site '
                                    'symmetries of the two atoms that define the rigid bond.\n'
                                    '\n'
@@ -80,7 +90,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_U_rigid_target_weight_param': '<pre><h2>_restr_U_rigid_target_weight_param</h2>        '
                                        'The weighting parameter = sqrt(1/weight).\n'
                                        '         The expectation value of the difference between '
@@ -92,7 +104,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        'refinement.\n'
                                        '         A value of zero causes the restraint to become a '
                                        'constraint.\n'
-                                       '         This item has a default value of zero.</pre>',
+                                       '         This item has a default value of zero.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_U_similar_atom_site_label_1': '<pre><h2>_restr_U_similar_atom_site_label_1</h2> '
                                        '_restr_U_similar_atom_site_label_1 is the atom-site label '
                                        'of  \n'
@@ -102,7 +115,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        '\t       atom-site label of the atom whose atomic '
                                        'displacement \n'
                                        '\t       parameters are restrained to be the same as atom '
-                                       '1.</pre>',
+                                       '1.</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_similar_atom_site_label_2': '<pre><h2>_restr_U_similar_atom_site_label_2</h2> '
                                        '_restr_U_similar_atom_site_label_1 is the atom-site label '
                                        'of  \n'
@@ -112,25 +126,34 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        '\t       atom-site label of the atom whose atomic '
                                        'displacement \n'
                                        '\t       parameters are restrained to be the same as atom '
-                                       '1.</pre>',
+                                       '1.</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_restr_U_similar_weight_param': '<pre><h2>_restr_U_similar_weight_param</h2> The expectation '
                                   'value of the difference between the\n'
                                   ' anisotropic atomic displacement parameters\n'
                                   ' of the two atoms.\n'
-                                  ' The default value of zero represents a constraint.</pre>',
+                                  ' The default value of zero represents a constraint.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                  '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_angle_atom_site_label_1': '<pre><h2>_restr_angle_atom_site_label_1</h2> The atom-site '
                                    'labels used to define the angle. Atom 2\n'
-                                   ' is at the apex of the angle.</pre>',
+                                   ' is at the apex of the angle.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_restr_angle_atom_site_label_2': '<pre><h2>_restr_angle_atom_site_label_2</h2> The atom-site '
                                    'labels used to define the angle. Atom 2\n'
-                                   ' is at the apex of the angle.</pre>',
+                                   ' is at the apex of the angle.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_restr_angle_atom_site_label_3': '<pre><h2>_restr_angle_atom_site_label_3</h2> The atom-site '
                                    'labels used to define the angle. Atom 2\n'
-                                   ' is at the apex of the angle.</pre>',
+                                   ' is at the apex of the angle.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_restr_angle_details': '<pre><h2>_restr_angle_details</h2> A free-text description of the '
-                         'restraint.</pre>',
+                         'restraint.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_angle_diff': '<pre><h2>_restr_angle_diff</h2> The difference between the target and the '
-                      'refined angle.</pre>',
+                      'refined angle.</pre>\n'
+                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                      '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_angle_site_symmetry_1': '<pre><h2>_restr_angle_site_symmetry_1</h2> The symmetry '
                                  'transformation needed to generate the coordinates\n'
                                  ' of the three atoms that define the angle.\n'
@@ -159,7 +182,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                  '<h3>Example:</h3>\n'
                                  'None\n'
                                  '4\n'
-                                 '7_645</pre>',
+                                 '7_645</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>\n'
+                                 '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_angle_site_symmetry_2': '<pre><h2>_restr_angle_site_symmetry_2</h2> The symmetry '
                                  'transformation needed to generate the coordinates\n'
                                  ' of the three atoms that define the angle.\n'
@@ -188,7 +213,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                  '<h3>Example:</h3>\n'
                                  'None\n'
                                  '4\n'
-                                 '7_645</pre>',
+                                 '7_645</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>\n'
+                                 '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_angle_site_symmetry_3': '<pre><h2>_restr_angle_site_symmetry_3</h2> The symmetry '
                                  'transformation needed to generate the coordinates\n'
                                  ' of the three atoms that define the angle.\n'
@@ -217,10 +244,14 @@ restraints_dict = {'_restr_U_iso_atom_si
                                  '<h3>Example:</h3>\n'
                                  'None\n'
                                  '4\n'
-                                 '7_645</pre>',
+                                 '7_645</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>\n'
+                                 '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_angle_target': '<pre><h2>_restr_angle_target</h2> The expectation angle defined by the '
                         'three atoms.\n'
-                        ' This is the target angle for the restrained refinement.</pre>',
+                        ' This is the target angle for the restrained refinement.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                        '<br><p><h4>Limits:</h4> 0:180 </p>',
  '_restr_angle_target_weight_param': '<pre><h2>_restr_angle_target_weight_param</h2> Weighting '
                                      'parameter = sqrt(1/weight).\n'
                                      ' It is the expectation value of the difference between\n'
@@ -229,17 +260,23 @@ restraints_dict = {'_restr_U_iso_atom_si
                                      'constrained\n'
                                      ' to refine to the target value.\n'
                                      ' If this item is absent, its value will be taken as zero\n'
-                                     ' and the distance will be constrained.</pre>',
+                                     ' and the distance will be constrained.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0:180 </p>',
  '_restr_distance_atom_site_label_1': '<pre><h2>_restr_distance_atom_site_label_1</h2> The '
                                       'atom-site labels of the two atoms defining\n'
-                                      ' the distance restrained.</pre>',
+                                      ' the distance restrained.</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_atom_site_label_2': '<pre><h2>_restr_distance_atom_site_label_2</h2> The '
                                       'atom-site labels of the two atoms defining\n'
-                                      ' the distance restrained.</pre>',
+                                      ' the distance restrained.</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_details': '<pre><h2>_restr_distance_details</h2> A free-text description of the '
-                            'restraint.</pre>',
+                            'restraint.</pre>\n'
+                            '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_diff': '<pre><h2>_restr_distance_diff</h2> The difference between the target and '
-                         'the refined distance.</pre>',
+                         'the refined distance.</pre>\n'
+                         '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_min_A': '<pre><h2>_restr_distance_min_A</h2> The weight associated with the '
                           'difference between the\n'
                           ' refined distance D and the prescribed minimum distance\n'
@@ -257,7 +294,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0.  In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target distance\n'
-                          ' of F so as to avoid division by zero.</pre>',
+                          ' of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_distance_min_B': '<pre><h2>_restr_distance_min_B</h2> The weight associated with the '
                           'difference between the\n'
                           ' refined distance D and the prescribed minimum distance\n'
@@ -275,7 +314,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0. In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target\n'
-                          ' distance of F so as to avoid division by zero.</pre>',
+                          ' distance of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_distance_min_C': '<pre><h2>_restr_distance_min_C</h2> The weight associated with the '
                           'difference between the\n'
                           ' refined distance D and the prescribed minimum distance\n'
@@ -293,7 +334,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0.  In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target\n'
-                          ' distance of F so as to avoid division by zero.</pre>',
+                          ' distance of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_min_E': '<pre><h2>_restr_distance_min_E</h2> The weight associated with the '
                           'difference between the\n'
                           ' refined distance D and the prescribed minimum distance\n'
@@ -311,7 +353,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0.  In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target\n'
-                          ' distance of F so as to avoid division by zero.</pre>',
+                          ' distance of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_min_F': '<pre><h2>_restr_distance_min_F</h2> The weight associated with the '
                           'difference between the\n'
                           ' refined distance D and the prescribed minimum distance\n'
@@ -329,7 +372,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0.  In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target\n'
-                          ' distance of F so as to avoid division by zero.</pre>',
+                          ' distance of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                          '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_distance_min_G': '<pre><h2>_restr_distance_min_G</h2> The weight associated with the '
                           'difference between\n'
                           ' the refined distance D and the prescribed minimum\n'
@@ -347,23 +392,30 @@ restraints_dict = {'_restr_U_iso_atom_si
                           ' F=prescribed minimum distance and G=0.  In this case G\n'
                           ' (combined with a non-zero E) should be treated as a flag\n'
                           ' indicating a hard-sphere interaction with a target\n'
-                          ' distance of F so as to avoid division by zero.</pre>',
+                          ' distance of F so as to avoid division by zero.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_min_atom_site_label_1': '<pre><h2>_restr_distance_min_atom_site_label_1</h2> The '
                                           'atom-site labels for the two atoms that are kept '
-                                          'apart.</pre>',
+                                          'apart.</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_min_atom_site_label_2': '<pre><h2>_restr_distance_min_atom_site_label_2</h2> The '
                                           'atom-site labels for the two atoms that are kept '
-                                          'apart.</pre>',
+                                          'apart.</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_min_details': '<pre><h2>_restr_distance_min_details</h2> A text description of '
                                 'the restraint giving details not\n'
-                                ' given elsewhere.</pre>',
+                                ' given elsewhere.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_min_difference': '<pre><h2>_restr_distance_min_difference</h2> The difference in '
                                    'angstroms between the refined distance\n'
                                    ' of approach of the two atoms and the target distance B or F:\n'
                                    '\n'
-                                   ' difference = D - B or D - F</pre>',
+                                   ' difference = D - B or D - F</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_min_distance': '<pre><h2>_restr_distance_min_distance</h2> The refined distance, '
-                                 'D, between the two atoms.</pre>',
+                                 'D, between the two atoms.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_distance_min_site_symmetry_1': '<pre><h2>_restr_distance_min_site_symmetry_1</h2> The '
                                         'site symmetries of the two atoms kept apart.\n'
                                         '\n'
@@ -395,7 +447,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                         '      m = 5 + z\n'
                                         ' By adding 5 to the translations, the use of negative '
                                         'numbers\n'
-                                        ' is avoided.</pre>',
+                                        ' is avoided.</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_min_site_symmetry_2': '<pre><h2>_restr_distance_min_site_symmetry_2</h2> The '
                                         'site symmetries of the two atoms kept apart.\n'
                                         '\n'
@@ -427,7 +480,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                         '      m = 5 + z\n'
                                         ' By adding 5 to the translations, the use of negative '
                                         'numbers\n'
-                                        ' is avoided.</pre>',
+                                        ' is avoided.</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>',
  '_restr_distance_site_symmetry_1': '<pre><h2>_restr_distance_site_symmetry_1</h2> The symmetry '
                                     'transformation needed to generate the coordinates\n'
                                     ' of the two atoms that define the distance.\n'
@@ -463,7 +517,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_645</pre>',
+                                    '7_645</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>\n'
+                                    '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_distance_site_symmetry_2': '<pre><h2>_restr_distance_site_symmetry_2</h2> The symmetry '
                                     'transformation needed to generate the coordinates\n'
                                     ' of the two atoms that define the distance.\n'
@@ -499,10 +555,13 @@ restraints_dict = {'_restr_U_iso_atom_si
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_645</pre>',
+                                    '7_645</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>\n'
+                                    '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_distance_target': '<pre><h2>_restr_distance_target</h2> The expectation distance between '
                            'the two atoms.\n'
-                           ' This is the target distance for the restrained refinement.</pre>',
+                           ' This is the target distance for the restrained refinement.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_distance_target_weight_param': '<pre><h2>_restr_distance_target_weight_param</h2> '
                                         'Weighting parameter = sqrt(1/weight).\n'
                                         ' It is the expectation value of the difference between\n'
@@ -510,39 +569,54 @@ restraints_dict = {'_restr_U_iso_atom_si
                                         ' If this parameter is set to zero, the distance will be\n'
                                         ' constrained to refine to the target value.\n'
                                         ' If this item is absent, its value will be taken as zero\n'
-                                        ' and the distance will be constrained.</pre>',
+                                        ' and the distance will be constrained.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_equal_angle_atom_site_label_1': '<pre><h2>_restr_equal_angle_atom_site_label_1</h2> The '
                                          'atom-site labels of the three atoms that define one of\n'
                                          ' the angles restrained to be equal to other angles in\n'
-                                         ' the same class.</pre>',
+                                         ' the same class.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_angle_atom_site_label_2': '<pre><h2>_restr_equal_angle_atom_site_label_2</h2> The '
                                          'atom-site labels of the three atoms that define one of\n'
                                          ' the angles restrained to be equal to other angles in\n'
-                                         ' the same class.</pre>',
+                                         ' the same class.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_angle_atom_site_label_3': '<pre><h2>_restr_equal_angle_atom_site_label_3</h2> The '
                                          'atom-site labels of the three atoms that define one of\n'
                                          ' the angles restrained to be equal to other angles in\n'
-                                         ' the same class.</pre>',
+                                         ' the same class.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_angle_class_average': '<pre><h2>_restr_equal_angle_class_average</h2> The average '
                                      'angle in the class of angles restrained to\n'
-                                     ' be the same after refinement.</pre>',
+                                     ' be the same after refinement.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_angle_class_class_id': '<pre><h2>_restr_equal_angle_class_class_id</h2> A character '
                                       'string that identifies the class of angles\n'
-                                      ' whose properties are described.</pre>',
+                                      ' whose properties are described.</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>\n'
+                                      '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_angle_class_detail': '<pre><h2>_restr_equal_angle_class_detail</h2> A text '
                                     'description giving details of the class of angles that\n'
-                                    ' are restrained to be equal.</pre>',
+                                    ' are restrained to be equal.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_angle_class_diff_max': '<pre><h2>_restr_equal_angle_class_diff_max</h2> The maximum '
                                       'deviation of an angle in the class from the\n'
-                                      ' class average after refinement.</pre>',
+                                      ' class average after refinement.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_angle_class_esd': '<pre><h2>_restr_equal_angle_class_esd</h2> The actual estimated '
                                  'standard deviation of the angles in the\n'
                                  ' class from their average after refinement.\n'
                                  ' This number is expected to be similar to the value set for\n'
-                                 ' _restr_equal_angle_class_target_weight_param.</pre>',
+                                 ' _restr_equal_angle_class_target_weight_param.</pre>\n'
+                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                 '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_angle_class_id': '<pre><h2>_restr_equal_angle_class_id</h2> A character string '
                                 'identifying the class of equal angles\n'
-                                ' to which this angle belongs.</pre>',
+                                ' to which this angle belongs.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>\n'
+                                '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_angle_class_target_weight_param': '<pre><h2>_restr_equal_angle_class_target_weight_param</h2> '
                                                  'The weighting parameter = sqrt(1/weight).\n'
                                                  ' The expectation value of the estimated standard '
@@ -553,10 +627,13 @@ restraints_dict = {'_restr_U_iso_atom_si
                                                  'the restraint.\n'
                                                  ' If it is zero the angles are constrained to be '
                                                  'equal.\n'
-                                                 ' The default value is zero.</pre>',
+                                                 ' The default value is zero.</pre>\n'
+                                                 '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                                 '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_angle_detail': '<pre><h2>_restr_equal_angle_detail</h2> A text description giving '
                               'details of an angle in\n'
-                              ' a class of angles that are restrained to be equal.</pre>',
+                              ' a class of angles that are restrained to be equal.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_angle_site_symmetry_1': '<pre><h2>_restr_equal_angle_site_symmetry_1</h2> The site '
                                        'symmetries of the three atoms that define an angle\n'
                                        ' restrained to be equal to other angles in the same '
@@ -596,7 +673,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        '<h3>Example:</h3>\n'
                                        'None\n'
                                        '4\n'
-                                       '7_645</pre>',
+                                       '7_645</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>\n'
+                                       '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_angle_site_symmetry_2': '<pre><h2>_restr_equal_angle_site_symmetry_2</h2> The site '
                                        'symmetries of the three atoms that define an angle\n'
                                        ' restrained to be equal to other angles in the same '
@@ -636,7 +715,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        '<h3>Example:</h3>\n'
                                        'None\n'
                                        '4\n'
-                                       '7_645</pre>',
+                                       '7_645</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>\n'
+                                       '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_angle_site_symmetry_3': '<pre><h2>_restr_equal_angle_site_symmetry_3</h2> The site '
                                        'symmetries of the three atoms that define an angle\n'
                                        ' restrained to be equal to other angles in the same '
@@ -676,40 +757,55 @@ restraints_dict = {'_restr_U_iso_atom_si
                                        '<h3>Example:</h3>\n'
                                        'None\n'
                                        '4\n'
-                                       '7_645</pre>',
+                                       '7_645</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>\n'
+                                       '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_distance_atom_site_label_1': '<pre><h2>_restr_equal_distance_atom_site_label_1</h2> '
                                             'The atom-site labels of the two atoms that define one '
                                             'of the\n'
                                             ' distances restrained to be equal to other distances '
                                             'in\n'
-                                            ' the same class.</pre>',
+                                            ' the same class.</pre>\n'
+                                            '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_distance_atom_site_label_2': '<pre><h2>_restr_equal_distance_atom_site_label_2</h2> '
                                             'The atom-site labels of the two atoms that define one '
                                             'of the\n'
                                             ' distances restrained to be equal to other distances '
                                             'in\n'
-                                            ' the same class.</pre>',
+                                            ' the same class.</pre>\n'
+                                            '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_distance_class_average': '<pre><h2>_restr_equal_distance_class_average</h2> The '
                                         'average distance in the class of distances restrained to\n'
-                                        ' be the same after refinement.</pre>',
+                                        ' be the same after refinement.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_distance_class_class_id': '<pre><h2>_restr_equal_distance_class_class_id</h2> A '
                                          'character string that identifies the class of distances\n'
-                                         ' whose properties are described.</pre>',
+                                         ' whose properties are described.</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>\n'
+                                         '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_distance_class_details': '<pre><h2>_restr_equal_distance_class_details</h2> A text '
                                         'description giving details of the class of distances '
                                         'that\n'
-                                        ' are restrained to be equal.</pre>',
+                                        ' are restrained to be equal.</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_distance_class_diff_max': '<pre><h2>_restr_equal_distance_class_diff_max</h2> The '
                                          'maximum deviation of a distance in the class from the\n'
-                                         ' class average after refinement.</pre>',
+                                         ' class average after refinement.</pre>\n'
+                                         '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                         '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_distance_class_esd': '<pre><h2>_restr_equal_distance_class_esd</h2> The actual '
                                     'estimated standard deviation of the distances in the\n'
                                     ' class from their average after refinement.\n'
                                     ' This number is expected to be similar to the value set for\n'
-                                    ' _restr_equal_distance_class_target_weight_param.</pre>',
+                                    ' _restr_equal_distance_class_target_weight_param.</pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                    '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_distance_class_id': '<pre><h2>_restr_equal_distance_class_id</h2> A character '
                                    'string identifying the class of equal distances\n'
-                                   ' to which this distance belongs.</pre>',
+                                   ' to which this distance belongs.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_distance_class_target_weight_param': '<pre><h2>_restr_equal_distance_class_target_weight_param</h2> '
                                                     'The weighting parameter = sqrt(1/weight).\n'
                                                     ' The expectation value of the estimated '
@@ -720,10 +816,14 @@ restraints_dict = {'_restr_U_iso_atom_si
                                                     'the restraint.\n'
                                                     ' If it is zero the distances are constrained '
                                                     'to be equal.\n'
-                                                    ' The default value is zero.</pre>',
+                                                    ' The default value is zero.</pre>\n'
+                                                    '<br><p><h4>Type:</h4> number (int or '
+                                                    'float)</p>\n'
+                                                    '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_distance_details': '<pre><h2>_restr_equal_distance_details</h2> A text description '
                                   'giving details of a distance in\n'
-                                  ' a class of distances that are restrained to be equal.</pre>',
+                                  ' a class of distances that are restrained to be equal.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_distance_site_symmetry_1': '<pre><h2>_restr_equal_distance_site_symmetry_1</h2> The '
                                           'site symmetries of the two atoms that define a '
                                           'distance\n'
@@ -765,7 +865,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                           '<h3>Example:</h3>\n'
                                           'None\n'
                                           '4\n'
-                                          '7_645</pre>',
+                                          '7_645</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>\n'
+                                          '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_distance_site_symmetry_2': '<pre><h2>_restr_equal_distance_site_symmetry_2</h2> The '
                                           'site symmetries of the two atoms that define a '
                                           'distance\n'
@@ -807,7 +909,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                           '<h3>Example:</h3>\n'
                                           'None\n'
                                           '4\n'
-                                          '7_645</pre>',
+                                          '7_645</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>\n'
+                                          '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_torsion_atom_site_label_1': '<pre><h2>_restr_equal_torsion_atom_site_label_1</h2> '
                                            'The atom-site labels of the four atoms that define one '
                                            'of the\n'
@@ -817,7 +921,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                            'dihedral\n'
                                            ' angle between the plane defined by atoms 1, 2 and 3, '
                                            'and\n'
-                                           ' the plane defined by atoms 2, 3 and 4.</pre>',
+                                           ' the plane defined by atoms 2, 3 and 4.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_atom_site_label_2': '<pre><h2>_restr_equal_torsion_atom_site_label_2</h2> '
                                            'The atom-site labels of the four atoms that define one '
                                            'of the\n'
@@ -827,7 +932,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                            'dihedral\n'
                                            ' angle between the plane defined by atoms 1, 2 and 3, '
                                            'and\n'
-                                           ' the plane defined by atoms 2, 3 and 4.</pre>',
+                                           ' the plane defined by atoms 2, 3 and 4.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_atom_site_label_3': '<pre><h2>_restr_equal_torsion_atom_site_label_3</h2> '
                                            'The atom-site labels of the four atoms that define one '
                                            'of the\n'
@@ -837,7 +943,8 @@ restraints_dict = {'_restr_U_iso_atom_si
                                            'dihedral\n'
                                            ' angle between the plane defined by atoms 1, 2 and 3, '
                                            'and\n'
-                                           ' the plane defined by atoms 2, 3 and 4.</pre>',
+                                           ' the plane defined by atoms 2, 3 and 4.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_atom_site_label_4': '<pre><h2>_restr_equal_torsion_atom_site_label_4</h2> '
                                            'The atom-site labels of the four atoms that define one '
                                            'of the\n'
@@ -847,27 +954,39 @@ restraints_dict = {'_restr_U_iso_atom_si
                                            'dihedral\n'
                                            ' angle between the plane defined by atoms 1, 2 and 3, '
                                            'and\n'
-                                           ' the plane defined by atoms 2, 3 and 4.</pre>',
+                                           ' the plane defined by atoms 2, 3 and 4.</pre>\n'
+                                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_class_average': '<pre><h2>_restr_equal_torsion_class_average</h2> The '
                                        'average torsion angle in the class of torsion angles\n'
-                                       ' restrained to be the same after refinement.</pre>',
+                                       ' restrained to be the same after refinement.</pre>\n'
+                                       '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                       '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_torsion_class_class_id': '<pre><h2>_restr_equal_torsion_class_class_id</h2> A '
                                         'character string that identifies the class of torsion\n'
-                                        ' angles whose properties are described.</pre>',
+                                        ' angles whose properties are described.</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>\n'
+                                        '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_torsion_class_details': '<pre><h2>_restr_equal_torsion_class_details</h2> A text '
                                        'description giving details of the class of torsion\n'
-                                       ' angles that are restrained to be equal.</pre>',
+                                       ' angles that are restrained to be equal.</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_class_diff_max': '<pre><h2>_restr_equal_torsion_class_diff_max</h2> The '
                                         'maximum deviation of a torsion angle in the class\n'
-                                        ' from the class average after refinement.</pre>',
+                                        ' from the class average after refinement.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_torsion_class_esd': '<pre><h2>_restr_equal_torsion_class_esd</h2> The actual '
                                    'estimated standard deviation of the torsion\n'
                                    ' angles in the class from their average after refinement.\n'
                                    ' This number is expected to be similar to the value set for\n'
-                                   ' _restr_equal_torsion_class_target_weight_param.</pre>',
+                                   ' _restr_equal_torsion_class_target_weight_param.</pre>\n'
+                                   '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                   '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_torsion_class_id': '<pre><h2>_restr_equal_torsion_class_id</h2> A character string '
                                   'identifying the class of equal torsion\n'
-                                  ' angles to which this torsion angle belongs.</pre>',
+                                  ' angles to which this torsion angle belongs.</pre>\n'
+                                  '<br><p><h4>Type:</h4> string</p>\n'
+                                  '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_equal_torsion_class_target_weight_param': '<pre><h2>_restr_equal_torsion_class_target_weight_param</h2> '
                                                    'The weighting parameter = sqrt(1/weight).\n'
                                                    ' This is the expectation value of the '
@@ -881,11 +1000,15 @@ restraints_dict = {'_restr_U_iso_atom_si
                                                    'the target.\n'
                                                    ' If it is zero the torsion angles are '
                                                    'constrained to be equal.\n'
-                                                   ' The default value is zero.</pre>',
+                                                   ' The default value is zero.</pre>\n'
+                                                   '<br><p><h4>Type:</h4> number (int or '
+                                                   'float)</p>\n'
+                                                   '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_equal_torsion_details': '<pre><h2>_restr_equal_torsion_details</h2> A text description '
                                  'giving details of a torsion angle in\n'
                                  ' a class of torsion angles that are restrained to be '
-                                 'equal.</pre>',
+                                 'equal.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_restr_equal_torsion_site_symmetry_1': '<pre><h2>_restr_equal_torsion_site_symmetry_1</h2> The '
                                          'site symmetries of the four atoms that define a torsion '
                                          'angle\n'
@@ -927,7 +1050,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                          '<h3>Example:</h3>\n'
                                          'None\n'
                                          '4\n'
-                                         '7_645</pre>',
+                                         '7_645</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>\n'
+                                         '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_torsion_site_symmetry_2': '<pre><h2>_restr_equal_torsion_site_symmetry_2</h2> The '
                                          'site symmetries of the four atoms that define a torsion '
                                          'angle\n'
@@ -969,7 +1094,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                          '<h3>Example:</h3>\n'
                                          'None\n'
                                          '4\n'
-                                         '7_645</pre>',
+                                         '7_645</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>\n'
+                                         '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_torsion_site_symmetry_3': '<pre><h2>_restr_equal_torsion_site_symmetry_3</h2> The '
                                          'site symmetries of the four atoms that define a torsion '
                                          'angle\n'
@@ -1011,7 +1138,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                          '<h3>Example:</h3>\n'
                                          'None\n'
                                          '4\n'
-                                         '7_645</pre>',
+                                         '7_645</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>\n'
+                                         '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_equal_torsion_site_symmetry_4': '<pre><h2>_restr_equal_torsion_site_symmetry_4</h2> The '
                                          'site symmetries of the four atoms that define a torsion '
                                          'angle\n'
@@ -1053,19 +1182,29 @@ restraints_dict = {'_restr_U_iso_atom_si
                                          '<h3>Example:</h3>\n'
                                          'None\n'
                                          '4\n'
-                                         '7_645</pre>',
+                                         '7_645</pre>\n'
+                                         '<br><p><h4>Type:</h4> string</p>\n'
+                                         '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_parameter_atom_coefficient': '<pre><h2>_restr_parameter_atom_coefficient</h2> A parameter '
                                       'that scales the quantity being restrained.\n'
                                       ' It can be used to convert a constraint on occupancy to\n'
-                                      ' a constraint on ionic charge.</pre>',
+                                      ' a constraint on ionic charge.</pre>\n'
+                                      '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                      '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_parameter_atom_site_label': '<pre><h2>_restr_parameter_atom_site_label</h2> The atom-site '
-                                     'label for an atom in this class.</pre>',
+                                     'label for an atom in this class.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_parameter_class_class_id': '<pre><h2>_restr_parameter_class_class_id</h2> The class ID of '
-                                    'the restraint described in this category.</pre>',
+                                    'the restraint described in this category.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>\n'
+                                    '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_parameter_class_details': '<pre><h2>_restr_parameter_class_details</h2> A text '
-                                   'description of the restraint.</pre>',
+                                   'description of the restraint.</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>',
  '_restr_parameter_class_id': '<pre><h2>_restr_parameter_class_id</h2> The identifier of the class '
-                              'of restraint applied to the atoms.</pre>',
+                              'of restraint applied to the atoms.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>\n'
+                              '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_parameter_class_parameter_type': '<pre><h2>_restr_parameter_class_parameter_type</h2> A '
                                           'flag that indicates the nature of the value\n'
                                           ' that is being restrained.\n'
@@ -1082,10 +1221,13 @@ restraints_dict = {'_restr_U_iso_atom_si
                                           '\n'
                                           'position_z\n'
                                           '\t_atom_site_fract_z\n'
-                                          '</pre>',
+                                          '</pre>\n'
+                                          '<br><p><h4>Type:</h4> string</p>',
  '_restr_parameter_class_target': '<pre><h2>_restr_parameter_class_target</h2> The target value '
                                   'for the sum of values of the appropriate\n'
-                                  ' parameter type multiplied by the _*_target_weight_param.</pre>',
+                                  ' parameter type multiplied by the '
+                                  '_*_target_weight_param.</pre>\n'
+                                  '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_parameter_class_target_weight_param': '<pre><h2>_restr_parameter_class_target_weight_param</h2> '
                                                'Weighting parameter = sqrt(1/weight).\n'
                                                ' It is the expectation value of the difference '
@@ -1098,27 +1240,38 @@ restraints_dict = {'_restr_U_iso_atom_si
                                                ' to refine to the target value.\n'
                                                ' If this item is absent, its value will be taken '
                                                'as zero\n'
-                                               ' and the distance will be constrained.</pre>',
+                                               ' and the distance will be constrained.</pre>\n'
+                                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_parameter_id': '<pre><h2>_restr_parameter_id</h2> A unique identifier for each line in a '
-                        'loop.</pre>',
+                        'loop.</pre>\n'
+                        '<br><p><h4>Type:</h4> string</p>',
  '_restr_plane_atom_site_label': '<pre><h2>_restr_plane_atom_site_label</h2> An atom-site label of '
-                                 'one of the atoms that form the plane.</pre>',
+                                 'one of the atoms that form the plane.</pre>\n'
+                                 '<br><p><h4>Type:</h4> string</p>',
  '_restr_plane_class_class_id': '<pre><h2>_restr_plane_class_class_id</h2>       The class '
-                                'identifier for the plane whose properties are described.</pre>',
+                                'identifier for the plane whose properties are described.</pre>\n'
+                                '<br><p><h4>Type:</h4> string</p>\n'
+                                '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_plane_class_details': '<pre><h2>_restr_plane_class_details</h2>        Text describing '
-                               'any special features of the restraint.</pre>',
+                               'any special features of the restraint.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>',
  '_restr_plane_class_displacement_esd': '<pre><h2>_restr_plane_class_displacement_esd</h2> The '
                                         'observed estimated standard deviation of the\n'
-                                        ' atoms from this plane.</pre>',
+                                        ' atoms from this plane.</pre>\n'
+                                        '<br><p><h4>Type:</h4> string</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_plane_class_displacement_max': '<pre><h2>_restr_plane_class_displacement_max</h2> The '
                                         'distance in angstroms from the plane to the atom '
                                         'furthest\n'
-                                        ' removed from the plane.</pre>',
+                                        ' removed from the plane.</pre>\n'
+                                        '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                        '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_plane_class_displacement_max_atom_site_label': '<pre><h2>_restr_plane_class_displacement_max_atom_site_label</h2> '
                                                         'The atom-site label of the atom that lies '
                                                         'furthest\n'
                                                         ' from the plane defined by this '
-                                                        'class.</pre>',
+                                                        'class.</pre>\n'
+                                                        '<br><p><h4>Type:</h4> string</p>',
  '_restr_plane_class_displacement_max_site_symmetry': '<pre><h2>_restr_plane_class_displacement_max_site_symmetry</h2> '
                                                       'The site symmetry of the atom lying '
                                                       'furthest from the plane\n'
@@ -1161,17 +1314,26 @@ restraints_dict = {'_restr_U_iso_atom_si
                                                       '<h3>Example:</h3>\n'
                                                       'None\n'
                                                       '4\n'
-                                                      '7_645</pre>',
+                                                      '7_645</pre>\n'
+                                                      '<br><p><h4>Type:</h4> string</p>\n'
+                                                      '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_plane_class_id': '<pre><h2>_restr_plane_class_id</h2> A character string that identifies '
                           'the plane\n'
-                          ' to which this atom is constrained.</pre>',
+                          ' to which this atom is constrained.</pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>\n'
+                          '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_plane_details': '<pre><h2>_restr_plane_details</h2> A text string giving details not '
-                         'described elsewhere.</pre>',
+                         'described elsewhere.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_plane_displacement': '<pre><h2>_restr_plane_displacement</h2> The distance between this '
                               'atom and the best plane through\n'
-                              ' all the atoms.</pre>',
+                              ' all the atoms.</pre>\n'
+                              '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                              '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_plane_id': '<pre><h2>_restr_plane_id</h2> A unique identifier for each line in the '
-                    'list.</pre>',
+                    'list.</pre>\n'
+                    '<br><p><h4>Type:</h4> string</p>\n'
+                    '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_plane_site_symmetry': '<pre><h2>_restr_plane_site_symmetry</h2> The site symmetry of the '
                                'atom that helps to define the plane\n'
                                ' to which it is restrained.\n'
@@ -1200,28 +1362,40 @@ restraints_dict = {'_restr_U_iso_atom_si
                                '<h3>Example:</h3>\n'
                                'None\n'
                                '4\n'
-                               '7_645</pre>',
+                               '7_645</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>\n'
+                               '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_plane_target_weight_param': '<pre><h2>_restr_plane_target_weight_param</h2> The weighting '
                                      'parameter = sqrt(1/weight).\n'
                                      ' The expectation value of the distance in angstroms\n'
                                      ' between this atom and the best plane through all\n'
-                                     ' the atoms of the class.</pre>',
+                                     ' the atoms of the class.</pre>\n'
+                                     '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                     '<br><p><h4>Limits:</h4> 0:∞ </p>',
  '_restr_rigid_body_atom_site_label': '<pre><h2>_restr_rigid_body_atom_site_label</h2> The '
-                                      'atom-site labels of an atom in a rigid body.</pre>',
+                                      'atom-site labels of an atom in a rigid body.</pre>\n'
+                                      '<br><p><h4>Type:</h4> string</p>',
  '_restr_rigid_body_class_class_id': '<pre><h2>_restr_rigid_body_class_class_id</h2> A character '
                                      'string that identifies the rigid body.\n'
                                      ' It must match one of the values of '
-                                     '_restr_rigid_body_class_id.</pre>',
+                                     '_restr_rigid_body_class_id.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>\n'
+                                     '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_rigid_body_class_details': '<pre><h2>_restr_rigid_body_class_details</h2> A text '
-                                    'description giving details of a rigid body.</pre>',
+                                    'description giving details of a rigid body.</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>',
  '_restr_rigid_body_class_id': '<pre><h2>_restr_rigid_body_class_id</h2> A character string '
-                               'identifying a rigid body.</pre>',
+                               'identifying a rigid body.</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>\n'
+                               '<br><p><h4>Default:</h4> 1 </p>',
  '_restr_rigid_body_details': '<pre><h2>_restr_rigid_body_details</h2> A text description giving '
                               'details of a rigid body in\n'
-                              ' a class of rigid bodies that are constrained to be equal.</pre>',
+                              ' a class of rigid bodies that are constrained to be equal.</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_restr_rigid_body_id': '<pre><h2>_restr_rigid_body_id</h2> A unique identifier for each atom in '
                          'the list of atoms in the\n'
-                         ' RESTR_RIGID_BODY category.</pre>',
+                         ' RESTR_RIGID_BODY category.</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_restr_rigid_body_site_symmetry': '<pre><h2>_restr_rigid_body_site_symmetry</h2> The site '
                                     'symmetry of an atom in a rigid body.\n'
                                     '\n'
@@ -1256,37 +1430,48 @@ restraints_dict = {'_restr_U_iso_atom_si
                                     '<h3>Example:</h3>\n'
                                     'None\n'
                                     '4\n'
-                                    '7_645</pre>',
+                                    '7_645</pre>\n'
+                                    '<br><p><h4>Type:</h4> string</p>\n'
+                                    '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_special_details': '<pre><h2>_restr_special_details</h2> Text describing any restraint or '
                            'constraint that cannot be\n'
                            ' described using any of the the other restraint items.\n'
-                           ' See also _atom_site_restraints.</pre>',
+                           ' See also _atom_site_restraints.</pre>\n'
+                           '<br><p><h4>Type:</h4> string</p>',
  '_restr_torsion_angle_target': '<pre><h2>_restr_torsion_angle_target</h2> The angle in degrees to '
                                 'which the torsion angle is restrained.\n'
                                 ' The torsion angle is the dihedral angle between the plane '
                                 'defined\n'
                                 ' by atoms 1, 2 and 3, and the plane defined by atoms 2, 3 and '
-                                '4.</pre>',
+                                '4.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> -180:180 </p>',
  '_restr_torsion_atom_site_label_1': '<pre><h2>_restr_torsion_atom_site_label_1</h2> The atom-site '
                                      'labels of the atoms in the sequence in which\n'
                                      ' they are linked by the bonds whose torsion angle is to\n'
-                                     ' be restrained.</pre>',
+                                     ' be restrained.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_torsion_atom_site_label_2': '<pre><h2>_restr_torsion_atom_site_label_2</h2> The atom-site '
                                      'labels of the atoms in the sequence in which\n'
                                      ' they are linked by the bonds whose torsion angle is to\n'
-                                     ' be restrained.</pre>',
+                                     ' be restrained.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_torsion_atom_site_label_3': '<pre><h2>_restr_torsion_atom_site_label_3</h2> The atom-site '
                                      'labels of the atoms in the sequence in which\n'
                                      ' they are linked by the bonds whose torsion angle is to\n'
-                                     ' be restrained.</pre>',
+                                     ' be restrained.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_torsion_atom_site_label_4': '<pre><h2>_restr_torsion_atom_site_label_4</h2> The atom-site '
                                      'labels of the atoms in the sequence in which\n'
                                      ' they are linked by the bonds whose torsion angle is to\n'
-                                     ' be restrained.</pre>',
+                                     ' be restrained.</pre>\n'
+                                     '<br><p><h4>Type:</h4> string</p>',
  '_restr_torsion_details': '<pre><h2>_restr_torsion_details</h2> A free-text description of the '
-                           'restraint.</pre>',
+                           'restraint.</pre>\n'
+                           '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_torsion_diff': '<pre><h2>_restr_torsion_diff</h2> The difference between the target and '
-                        'the refined torsion angle.</pre>',
+                        'the refined torsion angle.</pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_restr_torsion_site_symmetry_1': '<pre><h2>_restr_torsion_site_symmetry_1</h2> The symmetry '
                                    'transformations needed to generate the coordinates\n'
                                    ' of the four atoms that define the torsion angle.\n'
@@ -1317,7 +1502,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_torsion_site_symmetry_2': '<pre><h2>_restr_torsion_site_symmetry_2</h2> The symmetry '
                                    'transformations needed to generate the coordinates\n'
                                    ' of the four atoms that define the torsion angle.\n'
@@ -1348,7 +1535,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_torsion_site_symmetry_3': '<pre><h2>_restr_torsion_site_symmetry_3</h2> The symmetry '
                                    'transformations needed to generate the coordinates\n'
                                    ' of the four atoms that define the torsion angle.\n'
@@ -1379,7 +1568,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_torsion_site_symmetry_4': '<pre><h2>_restr_torsion_site_symmetry_4</h2> The symmetry '
                                    'transformations needed to generate the coordinates\n'
                                    ' of the four atoms that define the torsion angle.\n'
@@ -1410,7 +1601,9 @@ restraints_dict = {'_restr_U_iso_atom_si
                                    '<h3>Example:</h3>\n'
                                    'None\n'
                                    '4\n'
-                                   '7_645</pre>',
+                                   '7_645</pre>\n'
+                                   '<br><p><h4>Type:</h4> string</p>\n'
+                                   '<br><p><h4>Default:</h4> 1_555 </p>',
  '_restr_torsion_weight_param': '<pre><h2>_restr_torsion_weight_param</h2> Weighting parameter = '
                                 'sqrt(1/weight).\n'
                                 ' It is the expectation value of the difference between\n'
@@ -1418,4 +1611,6 @@ restraints_dict = {'_restr_U_iso_atom_si
                                 ' If this parameter is set to zero, the angle will be constrained\n'
                                 ' to refine to the target value.\n'
                                 ' If this item is absent, its value will be taken as zero\n'
-                                ' and the angle will be constrained.</pre>'}
\ No newline at end of file
+                                ' and the angle will be constrained.</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                '<br><p><h4>Limits:</h4> 0:∞ </p>'}
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/cif/twin_dict.py 137+dfsg-1/finalcif/cif/twin_dict.py
--- 134+dfsg-1/finalcif/cif/twin_dict.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/cif/twin_dict.py	2024-04-19 19:04:23.000000000 +0000
@@ -16,7 +16,8 @@ twinning_dict = {'_twin_dimensionality':
                          '\n'
                          'monoperiodic\n'
                          '\tcommon lattice in one dimension\n'
-                         '</pre>',
+                         '</pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_twin_formation_mechanism': '<pre><h2>_twin_formation_mechanism</h2>\n'
                               '     A description of the method of twin formation.\n'
                               '\n'
@@ -29,18 +30,22 @@ twinning_dict = {'_twin_dimensionality':
                               '\n'
                               'mt\n'
                               '\tmechanical twin formed as a result of mechanical action\n'
-                              '</pre>',
+                              '</pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_twin_individual_id': '<pre><h2>_twin_individual_id</h2>\n'
                         '      The unique identifier for this twin individual. \n'
                         '      The twin for which _twin_individual_twin_matrix_\n'
                         '      is the identity matrix is called the reference twin.  \n'
-                        "      It is recommended that the reference twin be labelled '1'. </pre>",
+                        "      It is recommended that the reference twin be labelled '1'. </pre>\n"
+                        '<br><p><h4>Type:</h4> string</p>',
  '_twin_individual_mass_fraction_refined': '<pre><h2>_twin_individual_mass_fraction_refined</h2>\n'
                                            '      The refined mass fraction of this twin '
                                            'individual; the sum\n'
                                            '      of all mass fractions must equal unity within '
                                            'the limits of \n'
-                                           '      experimental uncertainty.</pre>',
+                                           '      experimental uncertainty.</pre>\n'
+                                           '<br><p><h4>Type:</h4> number (int or float)</p>\n'
+                                           '<br><p><h4>Limits:</h4> 0:1.0 </p>',
  '_twin_individual_twin_lattice_type': '<pre><h2>_twin_individual_twin_lattice_type</h2>\n'
                                        '       Identification of the symmetry relationships '
                                        'between the \n'
@@ -74,7 +79,8 @@ twinning_dict = {'_twin_dimensionality':
                                        '\n'
                                        'nmt\n'
                                        '\tnon-merohedral\n'
-                                       '</pre>',
+                                       '</pre>\n'
+                                       '<br><p><h4>Type:</h4> string</p>',
  '_twin_individual_twin_matrix_11': '<pre><h2>_twin_individual_twin_matrix_11</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -85,7 +91,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_12': '<pre><h2>_twin_individual_twin_matrix_12</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -96,7 +103,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_13': '<pre><h2>_twin_individual_twin_matrix_13</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -107,7 +115,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_21': '<pre><h2>_twin_individual_twin_matrix_21</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -118,7 +127,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_22': '<pre><h2>_twin_individual_twin_matrix_22</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -129,7 +139,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_23': '<pre><h2>_twin_individual_twin_matrix_23</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -140,7 +151,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_31': '<pre><h2>_twin_individual_twin_matrix_31</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -151,7 +163,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_32': '<pre><h2>_twin_individual_twin_matrix_32</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -162,7 +175,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_individual_twin_matrix_33': '<pre><h2>_twin_individual_twin_matrix_33</h2>\n'
                                     '     Elements of the matrix U that multiplies the Miller '
                                     'indices h,k,l \n'
@@ -173,7 +187,8 @@ twinning_dict = {'_twin_dimensionality':
                                     "           (h' k' l') = U (h k l )\n"
                                     '\n'
                                     '     It follows that the reference twin must have U = I, the '
-                                    'identity matrix. </pre>',
+                                    'identity matrix. </pre>\n'
+                                    '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_morphology': '<pre><h2>_twin_morphology</h2>\n'
                      ' The physical relationship of the different twins to one another.\n'
                      '\n'
@@ -192,7 +207,8 @@ twinning_dict = {'_twin_dimensionality':
                      '\n'
                      'cyclic\n'
                      '\tindividuals repeat in closed edifice\n'
-                     '</pre>',
+                     '</pre>\n'
+                     '<br><p><h4>Type:</h4> string</p>',
  '_twin_refln_F_squared_calc': '<pre><h2>_twin_refln_F_squared_calc</h2> \n'
                                '\n'
                                '        Calculated value for the overall squared structure factors '
@@ -218,7 +234,8 @@ twinning_dict = {'_twin_dimensionality':
                                '\n'
                                '        Reference: Pratt, C. S., Coyle, B. A. &amp; Ibers, J. A. '
                                '(1971).\n'
-                               '        J. Chem. Soc. A, pp. 2146-2151.</pre>',
+                               '        J. Chem. Soc. A, pp. 2146-2151.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_F_squared_calc_individual': '<pre><h2>_twin_refln_F_squared_calc_individual</h2> \n'
                                           '\n'
                                           '        Contribution of the twin identified by '
@@ -232,16 +249,19 @@ twinning_dict = {'_twin_dimensionality':
                                           'the mass factor.\n'
                                           '        For X-ray diffraction the units are electrons '
                                           'squared.\n'
-                                          '</pre>',
+                                          '</pre>\n'
+                                          '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_F_squared_meas': '<pre><h2>_twin_refln_F_squared_meas</h2>\n'
                                '         The observed value F^2^ of the peak referenced by \n'
                                '         _twin_refln_datum_id. This is typically the observed '
                                'peak\n'
                                '         intensity after Lorentz and polarization '
-                               'corrections.</pre>',
+                               'corrections.</pre>\n'
+                               '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_F_squared_sigma': '<pre><h2>_twin_refln_F_squared_sigma</h2>\n'
                                 '            Standard uncertainty of '
-                                '_twin_refln_F_squared_meas</pre>',
+                                '_twin_refln_F_squared_meas</pre>\n'
+                                '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_datum_id': '<pre><h2>_twin_refln_datum_id</h2>\n'
                          '     This item serves to identify an observed diffraction peak. \n'
                          '     It may include contributions from one or more twin components\n'
@@ -256,7 +276,8 @@ twinning_dict = {'_twin_dimensionality':
                          '     \n'
                          '     The list reference includes both _twin_refln_datum_id and \n'
                          '     _twin_refln_individual_id.  The combination of these two items \n'
-                         '     may only appear once in a list. </pre>',
+                         '     may only appear once in a list. </pre>\n'
+                         '<br><p><h4>Type:</h4> string</p>',
  '_twin_refln_include_status': '<pre><h2>_twin_refln_include_status</h2>\n'
                                '    A symbol indicating how the reflection is treated during '
                                'refinement.\n'
@@ -287,22 +308,27 @@ twinning_dict = {'_twin_dimensionality':
                                '\n'
                                'l\n'
                                '\tdoes not satisfy _refine_ls_d_res_low\n'
-                               '</pre>',
+                               '</pre>\n'
+                               '<br><p><h4>Type:</h4> string</p>\n'
+                               '<br><p><h4>Default:</h4> o </p>',
  '_twin_refln_index_h': '<pre><h2>_twin_refln_index_h</h2>\n'
                         '     Miller indices of a reflection from the twin component \n'
                         '     labelled by _twin_refln_individual_id. \n'
                         '     The values of the Miller indices must correspond \n'
-                        '     to the cell defined for this twin component.  </pre>',
+                        '     to the cell defined for this twin component.  </pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_index_k': '<pre><h2>_twin_refln_index_k</h2>\n'
                         '     Miller indices of a reflection from the twin component \n'
                         '     labelled by _twin_refln_individual_id. \n'
                         '     The values of the Miller indices must correspond \n'
-                        '     to the cell defined for this twin component.  </pre>',
+                        '     to the cell defined for this twin component.  </pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_index_l': '<pre><h2>_twin_refln_index_l</h2>\n'
                         '     Miller indices of a reflection from the twin component \n'
                         '     labelled by _twin_refln_individual_id. \n'
                         '     The values of the Miller indices must correspond \n'
-                        '     to the cell defined for this twin component.  </pre>',
+                        '     to the cell defined for this twin component.  </pre>\n'
+                        '<br><p><h4>Type:</h4> number (int or float)</p>',
  '_twin_refln_individual_id': '<pre><h2>_twin_refln_individual_id</h2>\n'
                               '      The unique identifier of the twin individual \n'
                               '      whose Miller indices are given in _twin_refln_index_.  \n'
@@ -312,7 +338,8 @@ twinning_dict = {'_twin_dimensionality':
                               '     The list reference includes both _twin_refln_datum_id and \n'
                               '     _twin_refln_individual_id.  The combination of these two '
                               'items \n'
-                              '     may only appear once in a list. </pre>',
+                              '     may only appear once in a list. </pre>\n'
+                              '<br><p><h4>Type:</h4> string</p>',
  '_twin_special_details': '<pre><h2>_twin_special_details</h2>\n'
                           '    Information about twinning in the sample not contained in other '
                           'data items.\n'
@@ -320,4 +347,5 @@ twinning_dict = {'_twin_dimensionality':
                           '<h3>Example:</h3>\n'
                           '   Individuals 3 and 4 arise from form (I) following an\n'
                           '    enantiotropic phase transition by sudden cooling in\n'
-                          '    a cryostat to 173K. </pre>'}
\ No newline at end of file
+                          '    a cryostat to 173K. </pre>\n'
+                          '<br><p><h4>Type:</h4> string</p>'}
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/equip_property/author_loop_templates.py 137+dfsg-1/finalcif/equip_property/author_loop_templates.py
--- 134+dfsg-1/finalcif/equip_property/author_loop_templates.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/equip_property/author_loop_templates.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,3 +1,4 @@
+from __future__ import annotations
 #   ----------------------------------------------------------------------------
 #   "THE BEER-WARE LICENSE" (Revision 42):
 #   Daniel Kratzert <dkratzert@gmx.de> wrote this file.  As long as you retain
@@ -5,7 +6,6 @@
 #   and you think this stuff is worth it, you can buy me a beer in return.
 #   ----------------------------------------------------------------------------
 import re
-from contextlib import suppress
 from dataclasses import dataclass
 from enum import Enum
 from pathlib import Path
@@ -51,7 +51,7 @@ class Author:
 
 
 class AuthorLoops():
-    def __init__(self, ui: Ui_FinalCifWindow, cif: CifContainer, app: 'AppWindow'):
+    def __init__(self, ui: Ui_FinalCifWindow, cif: CifContainer, app: AppWindow):
         self.ui = ui
         self.cif = cif
         self.app = app
@@ -369,7 +369,7 @@ class AuthorLoops():
         """
         Import all authors from an external file"""
         for author in authors_data:
-            if author:
+            if author and isinstance(author, Author):
                 self.general_author_save(author)
 
     def authors_list(self) -> List[str]:
diff -pruN 134+dfsg-1/finalcif/equip_property/equipment.py 137+dfsg-1/finalcif/equip_property/equipment.py
--- 134+dfsg-1/finalcif/equip_property/equipment.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/equip_property/equipment.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,3 +1,4 @@
+from __future__ import annotations
 from bisect import bisect
 from pathlib import Path
 from typing import List, Dict
@@ -7,6 +8,7 @@ from PyQt5.QtCore import Qt
 from PyQt5.QtWidgets import QListWidgetItem
 from gemmi import cif
 
+from finalcif.app_path import application_path
 from finalcif.cif.cif_file_io import CifContainer
 from finalcif.cif.text import retranslate_delimiter, string_to_utf8
 from finalcif.equip_property.tools import read_document_from_cif_file
@@ -22,7 +24,7 @@ if TYPE_CHECKING:
 
 class Equipment:
 
-    def __init__(self, app: 'AppWindow', settings: FinalCifSettings):
+    def __init__(self, app: AppWindow, settings: FinalCifSettings):
         self.app = app
         self.settings = settings
         if app:
@@ -122,6 +124,20 @@ class Equipment:
         self.store_predefined_templates()
         self.show_equipment()
 
+    def load_equipment_files(self):
+        template_path = Path(application_path).joinpath('template/machines').resolve()
+        files = template_path.glob('*.cif')
+        for file in files:
+            try:
+                doc = read_document_from_cif_file(file.__str__())
+                block = doc.sole_block()
+            except Exception as e:
+                print(f'DBG> Could not load equipment templates: {e.__str__()}')
+                continue
+            if file.stem.replace('_', ' ') in self.settings.deleted_equipment:
+                continue
+            self._import_block(block, filename=str(file.resolve()))
+
     def store_predefined_templates(self):
         equipment_list = self.settings.get_equipment_list() or []
         for item in misc.predefined_equipment_templates:
@@ -182,14 +198,15 @@ class Equipment:
         for key, _ in table_data:
             if key not in cif_all_dict.keys():
                 if not key.startswith('_'):
-                    show_general_warning(self.app, '"{}" is not a valid keyword! '
-                                                   '\nChange the name in order to save.\n'
-                                                   'Keys must start with an underscore.'.format(key))
+                    show_general_warning(self.app,
+                                         f'"{key}" is not a valid keyword! \n'
+                                         f'Change the name in order to save.\n'
+                                         f'Keys must start with an underscore.')
                     return
                 show_general_warning(self.app, '"{}" is not an official CIF keyword!'.format(key))
         self.settings.save_settings_list('equipment', self.selected_template_name(), table_data)
         self.app.ui.EquipmentTemplatesStackedWidget.setCurrentIndex(0)
-        print('saved')
+        self.load_default_equipment()
 
     def import_equipment_from_file(self, filename: Path | str = '') -> None:
         """
@@ -198,7 +215,7 @@ class Equipment:
         if isinstance(filename, Path):
             filename = str(filename)
         if not filename:
-            filename = cif_file_open_dialog(filter="CIF file (*.cif  *.cif_od *.cfx)")
+            filename = cif_file_open_dialog(filter="CIF file (*.pcf *.cif  *.cif_od *.cfx)")
         if not filename:
             print('No file given')
             return
@@ -207,7 +224,7 @@ class Equipment:
             return
         for block in doc:
             self._import_block(block, filename)
-        self.show_equipment()
+        self.load_default_equipment()
 
     def _import_block(self, block: cif.Block, filename: str) -> None:
         table_data = []
@@ -219,6 +236,10 @@ class Equipment:
                 table_data.append([key, retranslate_delimiter(cif.as_string(value).strip('\n\r ;'))])
         if filename.endswith('.cif_od'):
             name = Path(filename).stem
+        elif filename.endswith('.pcf'):
+            name = Path(filename).stem.replace('_', ' ')
+        elif block.name == 'site_settings':
+            name = Path(filename).stem.replace('_', ' ')
         else:
             name = block.name.replace('__', ' ')
         self.undelete_equipment(equipment_name=name)
@@ -282,7 +303,7 @@ class Equipment:
         table.clearContents()
         table.setRowCount(0)
         self.app.ui.EquipmentTemplatesStackedWidget.setCurrentIndex(0)
-        print('cancelled equipment')
+        self.load_default_equipment()
 
 
 if __name__ == '__main__':
diff -pruN 134+dfsg-1/finalcif/equip_property/properties.py 137+dfsg-1/finalcif/equip_property/properties.py
--- 134+dfsg-1/finalcif/equip_property/properties.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/equip_property/properties.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,3 +1,4 @@
+from __future__ import annotations
 import threading
 import time
 from contextlib import suppress
@@ -15,7 +16,6 @@ from finalcif.gui.plaintextedit import P
 from finalcif.tools.settings import FinalCifSettings
 from finalcif.tools import misc
 
-
 from typing import TYPE_CHECKING
 
 if TYPE_CHECKING:
@@ -23,7 +23,7 @@ if TYPE_CHECKING:
 
 
 class Properties(QtCore.QObject):
-    def __init__(self, parent: 'AppWindow', settings: FinalCifSettings):
+    def __init__(self, parent: AppWindow, settings: FinalCifSettings):
         super().__init__(parent=parent)
         self.app = parent
         self.settings = settings
@@ -220,7 +220,10 @@ class Properties(QtCore.QObject):
                 if len(i.loop.tags) > 0:
                     loop_column_name = i.loop.tags[0]
                 for n in range(i.loop.length()):
-                    value = i.loop.val(n, 0)
+                    try:
+                        value = i.loop.val(n, 0)
+                    except AttributeError:
+                        value = i.loop[n, 0]
                     template_list.append(retranslate_delimiter(cif.as_string(value).strip("\n\r ;")))
         block_name = block.name.replace('__', ' ')
         # This is the list shown in the Main menu:
diff -pruN 134+dfsg-1/finalcif/equip_property/tools.py 137+dfsg-1/finalcif/equip_property/tools.py
--- 134+dfsg-1/finalcif/equip_property/tools.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/equip_property/tools.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,4 +1,3 @@
-from pathlib import Path
 from typing import Union
 
 import gemmi.cif
diff -pruN 134+dfsg-1/finalcif/finalcif_start.py 137+dfsg-1/finalcif/finalcif_start.py
--- 134+dfsg-1/finalcif/finalcif_start.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/finalcif_start.py	2024-04-19 19:04:23.000000000 +0000
@@ -5,15 +5,12 @@
 #  and you think this stuff is worth it, you can buy me a beer in return.
 #  Dr. Daniel Kratzert
 #  ----------------------------------------------------------------------------
-import os
 import sys
 import time
 import traceback
 from pathlib import Path
 from typing import Type
 
-from PyQt5.QtGui import QIcon
-
 from finalcif import VERSION
 from finalcif.app_path import application_path
 from finalcif.appwindow import AppWindow, DEBUG, app
@@ -57,12 +54,14 @@ def main():
     if len(sys.argv) > 1:
         file = Path(sys.argv[1])
         if not file.is_file():
-            show_general_warning(parent=None, warn_text=f'The file {file.resolve().absolute()} \nyou tried to open does not exist.',
+            show_general_warning(parent=None,
+                                 warn_text=f'The file {file.resolve().absolute()} \nyou tried to open does not exist.',
                                  window_title='File not found')
             file = None
     app.setQuitOnLastWindowClosed(True)
     w = AppWindow(file=file)
-    app.setWindowIcon(QIcon(os.path.join(application_path, r'icon/finalcif2.png')))
+    from PyQt5.QtGui import QIcon
+    app.setWindowIcon(QIcon(str(application_path / r'icon/finalcif2.png')))
     w.setWindowTitle('FinalCif v{}'.format(VERSION))
     # w.showMaximized()  # For full screen view
     w.setBaseSize(1200, 780)
diff -pruN 134+dfsg-1/finalcif/gui/custom_classes.py 137+dfsg-1/finalcif/gui/custom_classes.py
--- 134+dfsg-1/finalcif/gui/custom_classes.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/custom_classes.py	2024-04-19 19:04:23.000000000 +0000
@@ -11,7 +11,6 @@ from PyQt5.QtWidgets import QAbstractScr
 from finalcif.cif.text import retranslate_delimiter
 from finalcif.gui.combobox import MyComboBox
 from finalcif.gui.dialogs import show_keyword_help
-from finalcif.gui.edit_button import FloatingButtonWidget
 from finalcif.gui.mixins import ItemTextMixin
 from finalcif.gui.plaintextedit import MyQPlainTextEdit
 
@@ -96,7 +95,7 @@ class MyCifTable(QTableWidget, ItemTextM
             for row in range(self.rowCount()):
                 self.setRowHidden(row, False)
             return
-
+        searchtext = searchtext.replace('.', '_')
         searchpattern = re.compile(f'.*{searchtext}.*', re.IGNORECASE)
         searched = [x for x in self.vheaderitems if searchpattern.match(x)]
 
@@ -180,6 +179,7 @@ class MyCifTable(QTableWidget, ItemTextM
         """
         Set text in current table cell regardless of the containing item.
         """
+        self.color = color
         txt = retranslate_delimiter(txt)
         if row is None and key in self.vheaderitems:
             row = self.vheaderitems.index(key)
@@ -196,6 +196,7 @@ class MyCifTable(QTableWidget, ItemTextM
             widget.cif_key = key
         else:
             textedit = MyQPlainTextEdit(self)
+            textedit.color = self.color
             textedit.cif_key = key
             textedit.templateRequested.connect(self.goto_template_page)
             textedit.new_key.connect(lambda x: self.new_key.emit(x))
diff -pruN 134+dfsg-1/finalcif/gui/dialogs.py 137+dfsg-1/finalcif/gui/dialogs.py
--- 134+dfsg-1/finalcif/gui/dialogs.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/dialogs.py	2024-04-19 19:04:23.000000000 +0000
@@ -3,9 +3,8 @@ import os
 import sys
 from pathlib import Path
 
-from PyQt5.QtCore import Qt
-from PyQt5.QtWidgets import QMessageBox, QMainWindow, QFileDialog, QVBoxLayout, QTextEdit, \
-    QPushButton, QFrame, QApplication
+from PyQt5 import QtCore
+from PyQt5.QtWidgets import QMessageBox, QMainWindow, QFileDialog, QVBoxLayout, QTextEdit, QPushButton, QFrame
 
 from finalcif import VERSION
 
@@ -86,9 +85,9 @@ def show_general_warning(parent, warn_te
         print(f'DBG> Running inside a pytest -> not showing error message:\n{warn_text}\n{info_text}')
         return None
     box = QMessageBox(parent=parent)
-    box.setTextFormat(Qt.AutoText)
+    box.setTextFormat(QtCore.Qt.AutoText)
     box.setWindowTitle(window_title)
-    box.setTextInteractionFlags(Qt.TextBrowserInteraction)
+    box.setTextInteractionFlags(QtCore.Qt.TextBrowserInteraction)
     box.setText(warn_text)
     box.setModal(True)
     if info_text:
@@ -109,7 +108,7 @@ def show_keyword_help(parent, helptext:
     window.setWindowTitle(title)
 
     def close_window(event):
-        if event.key() == Qt.Key_Escape:
+        if event.key() == QtCore.Qt.Key_Escape:
             window.close()
 
     window.keyPressEvent = close_window
@@ -135,9 +134,9 @@ def show_keyword_help(parent, helptext:
 
 def show_ok_cancel_warning(parent, warn_text: str = '') -> bool:
     box = QMessageBox(parent=parent)
-    box.setTextFormat(Qt.AutoText)
+    box.setTextFormat(QtCore.Qt.AutoText)
     box.setWindowTitle(" ")
-    box.setTextInteractionFlags(Qt.TextBrowserInteraction)
+    box.setTextInteractionFlags(QtCore.Qt.TextBrowserInteraction)
     box.setText(warn_text)
     box.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
     box.setDefaultButton(QMessageBox.Ok)
@@ -154,9 +153,9 @@ def show_update_warning(parent, remote_v
                 "<a href='https://dkratzert.de/finalcif.html'>" \
                 "https://dkratzert.de/finalcif.html</a>"
     box = QMessageBox(parent)
-    box.setTextFormat(Qt.AutoText)
+    box.setTextFormat(QtCore.Qt.AutoText)
     box.setWindowTitle(" ")
-    box.setTextInteractionFlags(Qt.TextBrowserInteraction)
+    box.setTextInteractionFlags(QtCore.Qt.TextBrowserInteraction)
     if sys.platform.startswith("win"):
         warn_text += r"<br><br>Updating now will end all running FinalCIF programs!"
         update_button = box.addButton('Update Now', QMessageBox.AcceptRole)
@@ -187,9 +186,9 @@ def show_bug_found_warning(logfile) -> N
     box = QMessageBox(parent=window)
     box.setWindowTitle('Warning')
     box.setText(title)
-    box.setTextInteractionFlags(Qt.TextBrowserInteraction)
-    box.setTextFormat(Qt.AutoText)
     box.setInformativeText(text)
+    box.setTextFormat(QtCore.Qt.RichText)
+    box.setTextInteractionFlags(QtCore.Qt.TextBrowserInteraction)
     box.exec()
     window.show()
 
@@ -226,6 +225,7 @@ def cif_file_save_dialog(filename: str)
 
 if __name__ == '__main__':
     from PyQt5 import QtWidgets
+    from PyQt5.QtWidgets import QApplication
 
     app = QApplication.instance()
     if app is None:
@@ -239,7 +239,7 @@ if __name__ == '__main__':
     # answer = show_yes_now_question(title='Delete templates', question='Fobar?', parent=w)
     # bad_z_message(parent=w, z=3.0)
     # show_update_warning(parent=w, remote_version=123)
-    # show_bug_found_warning(Path(r'C:\test.txt'))
+    show_bug_found_warning(Path(r'test.txt'))
     # show_ok_cancel_warning(parent=w, warn_text='foobar')
     # show_keyword_help(parent=w, helptext="This is a helptext", title='A Title')
     # show_general_warning(parent=w, warn_text='Warning text', info_text='Info text', window_title='Title')
@@ -247,6 +247,6 @@ if __name__ == '__main__':
     # show_res_checksum_warning(parent=w)
     # unable_to_open_message(parent=w, not_ok=Exception('foo'), filepath=Path('C:/foo.txt'))
     # do_update_program('127')
-    window.show()
+    # window.show()
 
     app.exec_()
diff -pruN 134+dfsg-1/finalcif/gui/finalcif_gui_ui.py 137+dfsg-1/finalcif/gui/finalcif_gui_ui.py
--- 134+dfsg-1/finalcif/gui/finalcif_gui_ui.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/finalcif_gui_ui.py	2024-04-19 19:04:23.000000000 +0000
@@ -13,7 +13,7 @@ from PyQt5 import QtCore, QtGui, QtWidge
 class Ui_FinalCifWindow(object):
     def setupUi(self, FinalCifWindow):
         FinalCifWindow.setObjectName("FinalCifWindow")
-        FinalCifWindow.resize(1566, 812)
+        FinalCifWindow.resize(1596, 812)
         self.Mainwidget = QtWidgets.QWidget(FinalCifWindow)
         self.Mainwidget.setObjectName("Mainwidget")
         self.horizontalLayout_4 = QtWidgets.QHBoxLayout(self.Mainwidget)
@@ -525,6 +525,11 @@ class Ui_FinalCifWindow(object):
         self.verticalLayout_41 = QtWidgets.QVBoxLayout(self.groupBox_9)
         self.verticalLayout_41.setObjectName("verticalLayout_41")
         self.shelx_TextEdit = QtWidgets.QPlainTextEdit(self.groupBox_9)
+        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Expanding)
+        sizePolicy.setHorizontalStretch(0)
+        sizePolicy.setVerticalStretch(90)
+        sizePolicy.setHeightForWidth(self.shelx_TextEdit.sizePolicy().hasHeightForWidth())
+        self.shelx_TextEdit.setSizePolicy(sizePolicy)
         font = QtGui.QFont()
         font.setFamily("Courier New")
         font.setPointSize(11)
@@ -536,6 +541,23 @@ class Ui_FinalCifWindow(object):
         self.shelx_TextEdit.setReadOnly(True)
         self.shelx_TextEdit.setObjectName("shelx_TextEdit")
         self.verticalLayout_41.addWidget(self.shelx_TextEdit)
+        self.shelx_warn_TextEdit = QtWidgets.QPlainTextEdit(self.groupBox_9)
+        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Expanding)
+        sizePolicy.setHorizontalStretch(0)
+        sizePolicy.setVerticalStretch(10)
+        sizePolicy.setHeightForWidth(self.shelx_warn_TextEdit.sizePolicy().hasHeightForWidth())
+        self.shelx_warn_TextEdit.setSizePolicy(sizePolicy)
+        font = QtGui.QFont()
+        font.setFamily("Courier New")
+        font.setPointSize(11)
+        font.setBold(True)
+        font.setWeight(75)
+        self.shelx_warn_TextEdit.setFont(font)
+        self.shelx_warn_TextEdit.setUndoRedoEnabled(False)
+        self.shelx_warn_TextEdit.setLineWrapMode(QtWidgets.QPlainTextEdit.NoWrap)
+        self.shelx_warn_TextEdit.setReadOnly(True)
+        self.shelx_warn_TextEdit.setObjectName("shelx_warn_TextEdit")
+        self.verticalLayout_41.addWidget(self.shelx_warn_TextEdit)
         self.gridLayout_3.addWidget(self.groupBox_9, 0, 1, 1, 1)
         self.groupBox_3 = QtWidgets.QGroupBox(self.page_molinfo)
         sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Expanding)
@@ -1729,8 +1751,6 @@ class Ui_FinalCifWindow(object):
         self.datanameComboBox.setObjectName("datanameComboBox")
         self.gridLayout_6.addWidget(self.datanameComboBox, 0, 1, 1, 1)
         self.CCDCNumLineEdit = QtWidgets.QTextEdit(self.CifDataItemsFrame)
-        self.CCDCNumLineEdit.setMinimumSize(QtCore.QSize(0, 24))
-        self.CCDCNumLineEdit.setMaximumSize(QtCore.QSize(16777215, 24))
         self.CCDCNumLineEdit.viewport().setProperty("cursor", QtGui.QCursor(QtCore.Qt.IBeamCursor))
         self.CCDCNumLineEdit.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
         self.CCDCNumLineEdit.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
@@ -1742,8 +1762,6 @@ class Ui_FinalCifWindow(object):
         self.CCDCNumLineEdit.setObjectName("CCDCNumLineEdit")
         self.gridLayout_6.addWidget(self.CCDCNumLineEdit, 0, 8, 1, 1)
         self.SumFormMainLineEdit = QtWidgets.QTextEdit(self.CifDataItemsFrame)
-        self.SumFormMainLineEdit.setMinimumSize(QtCore.QSize(0, 24))
-        self.SumFormMainLineEdit.setMaximumSize(QtCore.QSize(16777215, 24))
         self.SumFormMainLineEdit.viewport().setProperty("cursor", QtGui.QCursor(QtCore.Qt.IBeamCursor))
         self.SumFormMainLineEdit.setInputMethodHints(QtCore.Qt.ImhNone)
         self.SumFormMainLineEdit.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
@@ -1772,8 +1790,6 @@ class Ui_FinalCifWindow(object):
         spacerItem42 = QtWidgets.QSpacerItem(10, 0, QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Minimum)
         self.gridLayout_6.addItem(spacerItem42, 0, 6, 1, 1)
         self.Spacegroup_top_LineEdit = QtWidgets.QTextEdit(self.CifDataItemsFrame)
-        self.Spacegroup_top_LineEdit.setMinimumSize(QtCore.QSize(0, 24))
-        self.Spacegroup_top_LineEdit.setMaximumSize(QtCore.QSize(16777215, 24))
         self.Spacegroup_top_LineEdit.viewport().setProperty("cursor", QtGui.QCursor(QtCore.Qt.IBeamCursor))
         self.Spacegroup_top_LineEdit.setInputMethodHints(QtCore.Qt.ImhNone)
         self.Spacegroup_top_LineEdit.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
@@ -1794,7 +1810,7 @@ class Ui_FinalCifWindow(object):
         self.retranslateUi(FinalCifWindow)
         self.TemplatesStackedWidget.setCurrentIndex(0)
         self.EquipmentTemplatesStackedWidget.setCurrentIndex(0)
-        self.MainStackedWidget.setCurrentIndex(5)
+        self.MainStackedWidget.setCurrentIndex(2)
         self.PropertiesTemplatesStackedWidget.setCurrentIndex(1)
         self.LoopsTabWidget.setCurrentIndex(0)
         self.authorEditTabWidget.setCurrentIndex(1)
diff -pruN 134+dfsg-1/finalcif/gui/finalcif_gui_ui.ui 137+dfsg-1/finalcif/gui/finalcif_gui_ui.ui
--- 134+dfsg-1/finalcif/gui/finalcif_gui_ui.ui	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/finalcif_gui_ui.ui	2024-04-19 19:04:23.000000000 +0000
@@ -7,7 +7,7 @@
    <rect>
     <x>0</x>
     <y>0</y>
-    <width>1566</width>
+    <width>1596</width>
     <height>812</height>
    </rect>
   </property>
@@ -834,7 +834,7 @@
         <item row="2" column="0" colspan="13">
          <widget class="MyMainStackedWidget" name="MainStackedWidget">
           <property name="currentIndex">
-           <number>5</number>
+           <number>2</number>
           </property>
           <widget class="QWidget" name="page_MainTable">
            <layout class="QVBoxLayout" name="verticalLayout">
@@ -1313,6 +1313,12 @@
               <layout class="QVBoxLayout" name="verticalLayout_41">
                <item>
                 <widget class="QPlainTextEdit" name="shelx_TextEdit">
+                 <property name="sizePolicy">
+                  <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+                   <horstretch>0</horstretch>
+                   <verstretch>90</verstretch>
+                  </sizepolicy>
+                 </property>
                  <property name="font">
                   <font>
                    <family>Courier New</family>
@@ -1339,6 +1345,33 @@
                  </property>
                 </widget>
                </item>
+               <item>
+                <widget class="QPlainTextEdit" name="shelx_warn_TextEdit">
+                 <property name="sizePolicy">
+                  <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+                   <horstretch>0</horstretch>
+                   <verstretch>10</verstretch>
+                  </sizepolicy>
+                 </property>
+                 <property name="font">
+                  <font>
+                   <family>Courier New</family>
+                   <pointsize>11</pointsize>
+                   <weight>75</weight>
+                   <bold>true</bold>
+                  </font>
+                 </property>
+                 <property name="undoRedoEnabled">
+                  <bool>false</bool>
+                 </property>
+                 <property name="lineWrapMode">
+                  <enum>QPlainTextEdit::NoWrap</enum>
+                 </property>
+                 <property name="readOnly">
+                  <bool>true</bool>
+                 </property>
+                </widget>
+               </item>
               </layout>
              </widget>
             </item>
@@ -4072,18 +4105,6 @@ please add a publication author:</string
         </item>
         <item row="0" column="8">
          <widget class="QTextEdit" name="CCDCNumLineEdit">
-          <property name="minimumSize">
-           <size>
-            <width>0</width>
-            <height>24</height>
-           </size>
-          </property>
-          <property name="maximumSize">
-           <size>
-            <width>16777215</width>
-            <height>24</height>
-           </size>
-          </property>
           <property name="cursor" stdset="0">
            <cursorShape>IBeamCursor</cursorShape>
           </property>
@@ -4112,18 +4133,6 @@ please add a publication author:</string
         </item>
         <item row="0" column="11">
          <widget class="QTextEdit" name="SumFormMainLineEdit">
-          <property name="minimumSize">
-           <size>
-            <width>0</width>
-            <height>24</height>
-           </size>
-          </property>
-          <property name="maximumSize">
-           <size>
-            <width>16777215</width>
-            <height>24</height>
-           </size>
-          </property>
           <property name="cursor" stdset="0">
            <cursorShape>IBeamCursor</cursorShape>
           </property>
@@ -4215,18 +4224,6 @@ please add a publication author:</string
         </item>
         <item row="0" column="5">
          <widget class="QTextEdit" name="Spacegroup_top_LineEdit">
-          <property name="minimumSize">
-           <size>
-            <width>0</width>
-            <height>24</height>
-           </size>
-          </property>
-          <property name="maximumSize">
-           <size>
-            <width>16777215</width>
-            <height>24</height>
-           </size>
-          </property>
           <property name="cursor" stdset="0">
            <cursorShape>IBeamCursor</cursorShape>
           </property>
diff -pruN 134+dfsg-1/finalcif/gui/loop_creator_ui.py 137+dfsg-1/finalcif/gui/loop_creator_ui.py
--- 134+dfsg-1/finalcif/gui/loop_creator_ui.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/loop_creator_ui.py	2024-04-19 19:04:23.000000000 +0000
@@ -31,9 +31,6 @@ class Ui_LoopCreator(object):
         self.horizontalLayout.addWidget(self.searchLineEdit)
         self.verticalLayout_2.addLayout(self.horizontalLayout)
         self.availableKeysListWidget = QtWidgets.QListWidget(LoopCreator)
-        font = QtGui.QFont()
-        font.setPointSize(13)
-        self.availableKeysListWidget.setFont(font)
         self.availableKeysListWidget.setObjectName("availableKeysListWidget")
         self.verticalLayout_2.addWidget(self.availableKeysListWidget)
         self.horizontalLayout_2.addLayout(self.verticalLayout_2)
@@ -60,9 +57,6 @@ class Ui_LoopCreator(object):
         self.label_4.setObjectName("label_4")
         self.verticalLayout_3.addWidget(self.label_4)
         self.newLoopKeysListWidget = QtWidgets.QListWidget(LoopCreator)
-        font = QtGui.QFont()
-        font.setPointSize(13)
-        self.newLoopKeysListWidget.setFont(font)
         self.newLoopKeysListWidget.setObjectName("newLoopKeysListWidget")
         self.verticalLayout_3.addWidget(self.newLoopKeysListWidget)
         self.saveLoopPushButton = QtWidgets.QPushButton(LoopCreator)
diff -pruN 134+dfsg-1/finalcif/gui/loop_creator_ui.ui 137+dfsg-1/finalcif/gui/loop_creator_ui.ui
--- 134+dfsg-1/finalcif/gui/loop_creator_ui.ui	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/loop_creator_ui.ui	2024-04-19 19:04:23.000000000 +0000
@@ -38,13 +38,7 @@
       </layout>
      </item>
      <item>
-      <widget class="QListWidget" name="availableKeysListWidget">
-       <property name="font">
-        <font>
-         <pointsize>13</pointsize>
-        </font>
-       </property>
-      </widget>
+      <widget class="QListWidget" name="availableKeysListWidget"/>
      </item>
     </layout>
    </item>
@@ -112,13 +106,7 @@
       </widget>
      </item>
      <item>
-      <widget class="QListWidget" name="newLoopKeysListWidget">
-       <property name="font">
-        <font>
-         <pointsize>13</pointsize>
-        </font>
-       </property>
-      </widget>
+      <widget class="QListWidget" name="newLoopKeysListWidget"/>
      </item>
      <item>
       <widget class="QPushButton" name="saveLoopPushButton">
diff -pruN 134+dfsg-1/finalcif/gui/plaintextedit.py 137+dfsg-1/finalcif/gui/plaintextedit.py
--- 134+dfsg-1/finalcif/gui/plaintextedit.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/plaintextedit.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,13 +1,15 @@
+import dataclasses
 from enum import IntEnum
-from typing import TYPE_CHECKING
+from typing import TYPE_CHECKING, Union
 
-from PyQt5 import QtCore
+from PyQt5 import QtCore, QtGui
 from PyQt5.QtCore import pyqtSignal, Qt, QObject, QEvent, QSize
 from PyQt5.QtGui import QTextOption, QFontMetrics, QContextMenuEvent, QFont, QColor
 from PyQt5.QtWidgets import QPlainTextEdit, QFrame, QAbstractScrollArea
 
 from finalcif.gui.edit_button import FloatingButtonWidget
 from finalcif.gui.new_key_dialog import NewKey
+from finalcif.gui.validators import validators
 
 if TYPE_CHECKING:
     from finalcif.gui.custom_classes import MyCifTable
@@ -28,11 +30,12 @@ class MyQPlainTextEdit(QPlainTextEdit):
     to_be_shortened = {'_shelx_hkl_file', '_shelx_res_file', '_shelx_fab_file', '_shelx_fcf_file',
                        '_iucr_refine_instructions_details', '_iucr_refine_fcf_details'}
 
-    def __init__(self, parent=None, *args, **kwargs):
+    def __init__(self, parent=None, *args):
         """
         Plaintext edit field for most of the table cells.
         """
-        super().__init__(parent=parent, *args, **kwargs)
+        super().__init__(*args, parent)
+        self.color = None
         self.cif_key = ''
         self.edit_button = None
         font = QFont()
@@ -101,10 +104,6 @@ class MyQPlainTextEdit(QPlainTextEdit):
         Set background color of the text field.
         """
         self.setStyleSheet("background-color: {};".format(str(color.name())))
-        # No idea why this does not work
-        # pal = self.palette()
-        # pal.setColor(QPalette.Base, color)
-        # self.setPalette(pal)
 
     def setUneditable(self):
         self.setReadOnly(True)
@@ -150,6 +149,23 @@ class MyQPlainTextEdit(QPlainTextEdit):
             self.parent.setCurrentCell(self.row, self.column)
         return super().event(e)
 
+    def keyPressEvent(self, event: QtGui.QKeyEvent):
+        super().keyPressEvent(event)
+        if self.column == Column.EDIT:
+            self.validate_text(self.toPlainText())
+
+    def validate_text(self, text: str):
+        validator = validators.get(self.cif_key, None)
+        if validator and not validator.valid(text):
+            self.setBackground(QColor(254, 191, 189))
+            self.setToolTip(validator.help_text)
+        else:
+            self.setToolTip('')
+            if self.color:
+                self.setBackground(self.color)
+            else:
+                self.setStyleSheet("")
+
     def leaveEvent(self, a0: QEvent) -> None:
         super().leaveEvent(a0)
         if self.edit_button and self.column == Column.EDIT:
diff -pruN 134+dfsg-1/finalcif/gui/text_templates_ui.py 137+dfsg-1/finalcif/gui/text_templates_ui.py
--- 134+dfsg-1/finalcif/gui/text_templates_ui.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/text_templates_ui.py	2024-04-19 19:04:23.000000000 +0000
@@ -30,7 +30,6 @@ class Ui_TextTemplatesWidget(object):
         sizePolicy.setHeightForWidth(self.cifKeyLineEdit.sizePolicy().hasHeightForWidth())
         self.cifKeyLineEdit.setSizePolicy(sizePolicy)
         font = QtGui.QFont()
-        font.setPointSize(12)
         font.setBold(True)
         font.setWeight(75)
         self.cifKeyLineEdit.setFont(font)
@@ -88,9 +87,6 @@ class Ui_TextTemplatesWidget(object):
         sizePolicy.setVerticalStretch(0)
         sizePolicy.setHeightForWidth(self.plainTextEdit.sizePolicy().hasHeightForWidth())
         self.plainTextEdit.setSizePolicy(sizePolicy)
-        font = QtGui.QFont()
-        font.setPointSize(10)
-        self.plainTextEdit.setFont(font)
         self.plainTextEdit.setFrameShadow(QtWidgets.QFrame.Plain)
         self.plainTextEdit.setLineWidth(0)
         self.plainTextEdit.setBackgroundVisible(False)
diff -pruN 134+dfsg-1/finalcif/gui/text_templates_ui.ui 137+dfsg-1/finalcif/gui/text_templates_ui.ui
--- 134+dfsg-1/finalcif/gui/text_templates_ui.ui	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/text_templates_ui.ui	2024-04-19 19:04:23.000000000 +0000
@@ -51,7 +51,6 @@
        </property>
        <property name="font">
         <font>
-         <pointsize>12</pointsize>
          <weight>75</weight>
          <bold>true</bold>
         </font>
@@ -174,11 +173,6 @@
             <verstretch>0</verstretch>
            </sizepolicy>
           </property>
-          <property name="font">
-           <font>
-            <pointsize>10</pointsize>
-           </font>
-          </property>
           <property name="frameShadow">
            <enum>QFrame::Plain</enum>
           </property>
diff -pruN 134+dfsg-1/finalcif/gui/text_value_editor.py 137+dfsg-1/finalcif/gui/text_value_editor.py
--- 134+dfsg-1/finalcif/gui/text_value_editor.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/text_value_editor.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,6 +1,7 @@
 import sys
 from typing import Tuple, List, Union
 
+from PyQt5 import QtGui
 from PyQt5.QtCore import QSize, Qt, pyqtSignal
 from PyQt5.QtWidgets import QWidget, QHBoxLayout, QCheckBox, QListWidgetItem, QVBoxLayout, QLabel
 
@@ -24,9 +25,7 @@ class TextEditItem(QWidget):
         self.number_label = QLabel()
         self.vlayout.addWidget(self.number_label)
         self.textfield = SpellTextEdit(self)
-        font = self.textfield.font()
-        font.setPixelSize(12)
-        self.textfield.setFont(font)
+        self.set_font_size()
         self.vlayout.addWidget(self.checkbox)
         layout.addLayout(self.vlayout)
         layout.addWidget(self.textfield)
@@ -34,6 +33,11 @@ class TextEditItem(QWidget):
         self.setAutoFillBackground(False)
         self.checkbox.clicked.connect(self.on_checkbox_clicked)
 
+    def set_font_size(self):
+        font: QtGui.QFont = self.textfield.font()
+        font.setPointSize(font.pointSize() + 2)
+        self.textfield.setFont(font)
+
     @property
     def text(self) -> str:
         return self.textfield.toPlainText()
@@ -65,6 +69,15 @@ class MyTextTemplateEdit(QWidget):
         self.ui.cancelTextPushButton.clicked.connect(self._on_backbutton_clicked)
         if not self.ui.templatesListWidget.count():
             self.add_more_fiels()
+        self.set_font_size()
+
+    def set_font_size(self):
+        textedit_font: QtGui.QFont = self.ui.plainTextEdit.font()
+        textedit_font.setPointSize(textedit_font.pointSize() + 3)
+        self.ui.plainTextEdit.setFont(textedit_font)
+        cif_key_font = self.ui.cifKeyLineEdit.font()
+        cif_key_font.setPointSize(textedit_font.pointSize())
+        self.ui.cifKeyLineEdit.setFont(cif_key_font)
 
     def _on_backbutton_clicked(self) -> None:
         self.ui.templatesListWidget.clear()
diff -pruN 134+dfsg-1/finalcif/gui/validators.py 137+dfsg-1/finalcif/gui/validators.py
--- 134+dfsg-1/finalcif/gui/validators.py	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/finalcif/gui/validators.py	2024-04-19 19:04:23.000000000 +0000
@@ -0,0 +1,201 @@
+from math import inf
+from typing import Union, Type
+
+
+class BaseLimits:
+    upper: Union[int, float, str]
+    lower: Union[int, float, str]
+    valid: callable
+    value_type: Type[Union[int, float, str]]
+    help_text: str
+
+    def __init__(self, lower, upper, help_text: str = ''):
+        self.lower = lower
+        self.upper = upper
+        self.help_text = help_text
+        self.valid = self.validate_cif_key
+
+    def __repr__(self):
+        return (f"<{self.__class__.__name__}(lower bound: {self.lower}, upper bound: {self.upper}, "
+                f"type: {self.value_type})> )>")
+
+    def validate_cif_key(self, value: str):
+        if '(' in value and ')' in value:
+            value, esd = value.split('(')
+            value = value.strip()
+            after_esd = esd.split(')')[1]
+            if after_esd:
+                return False
+        valid = False
+        value = value.split('(')[0].strip()
+        if value in ('', '?', '.'):
+            return True
+        try:
+            value = self.value_type(value)
+        except Exception:
+            return False
+        if self.lower <= value <= self.upper:
+            valid = True
+        return valid
+
+
+class Integerlimits(BaseLimits):
+    value_type = int
+
+    def __init__(self, lower: int, upper: int, help_text: str = None):
+        if not help_text:
+            help_text = (f'Must be a {"negative" if lower < 0 else "positive"} '
+                         f'integer number between {lower} and {upper}.')
+        super().__init__(lower, upper, help_text)
+
+    def validate_cif_key(self, value: str):
+        valid = super().validate_cif_key(value)
+        value = value.split('(')[0].strip()
+        if not value.replace('-', '').isdigit() and value not in ('', '?', '.'):
+            valid = False
+        return valid
+
+
+class Floatlimits(BaseLimits):
+    value_type = float
+
+    def __init__(self, lower: float, upper: float, help_text: str = None):
+        if not help_text:
+            help_text = (f'Must be a {"negative" if lower < 0 else "positive"} '
+                         f'decimal number between {lower} and {upper}.')
+        super().__init__(lower, upper, help_text)
+
+
+class Textlimits:
+    def __init__(self, options: list[str], help_text: str = None):
+        self.valid = self.validate_cif_key
+        self.options = options
+        self.help_text = f'Must be one of: {", ".join(options)}.'
+        if help_text:
+            self.help_text = help_text
+
+    def validate_cif_key(self, value: str):
+        if value.lower() in ('', '?', '.') or value.lower() in self.options:
+            return True
+        return False
+
+
+validators: dict[str, BaseLimits] = {
+    '_database_code_depnum_ccdc_archive'  : Integerlimits(lower=0, upper=inf),
+    '_cell_measurement_reflns_used'       : Integerlimits(lower=0, upper=inf),
+    '_cell_measurement_theta_min'         : Floatlimits(lower=0.0, upper=90.0),
+    '_cell_measurement_theta_max'         : Floatlimits(lower=0.0, upper=90.0),
+    '_chemical_melting_point'             : Floatlimits(lower=0.0, upper=5000.0),
+    '_diffrn_reflns_number'               : Integerlimits(lower=0, upper=inf),
+    '_exptl_crystal_density_meas'         : Floatlimits(lower=0, upper=25.0),
+    '_exptl_crystal_density_diffrn'       : Floatlimits(lower=0, upper=25.0),
+    '_diffrn_ambient_temperature'         : Floatlimits(lower=0, upper=inf),
+    '_diffrn_source_current'              : Floatlimits(lower=0.0, upper=inf),
+    '_diffrn_source_voltage'              : Floatlimits(lower=0.0, upper=inf),
+    '_exptl_absorpt_correction_T_max'     : Floatlimits(lower=0.0, upper=1.0),
+    '_exptl_absorpt_correction_T_min'     : Floatlimits(lower=0.0, upper=1.0),
+    '_exptl_transmission_factor_max'      : Floatlimits(lower=0.0, upper=1.0),
+    '_exptl_transmission_factor_min'      : Floatlimits(lower=0.0, upper=1.0),
+    '_cell_angle_alpha'                   : Floatlimits(lower=0.0, upper=180.0),
+    '_cell_angle_beta'                    : Floatlimits(lower=0.0, upper=180.0),
+    '_cell_angle_gamma'                   : Floatlimits(lower=0.0, upper=180.0),
+    '_cell_formula_units_Z'               : Integerlimits(lower=1, upper=inf),
+    '_cell_length_a'                      : Floatlimits(lower=0.0, upper=inf),
+    '_cell_length_b'                      : Floatlimits(lower=0.0, upper=inf),
+    '_cell_length_c'                      : Floatlimits(lower=0.0, upper=inf),
+    '_cell_measurement_temperature'       : Floatlimits(lower=0.0, upper=inf),
+    '_cell_volume'                        : Floatlimits(lower=0.0, upper=inf),
+    '_chemical_formula_weight'            : Floatlimits(lower=1.0, upper=inf),
+    '_diffrn_measured_fraction_theta_full': Floatlimits(lower=0.0, upper=1.0),
+    '_diffrn_measured_fraction_theta_max' : Floatlimits(lower=0.0, upper=1.0),
+    '_diffrn_radiation_wavelength'        : Floatlimits(lower=0.0, upper=1.0 * inf),
+    '_diffrn_reflns_Laue_'
+    'measured_fraction_full'              : Floatlimits(lower=0.95,
+                                                        upper=1.0,
+                                                        help_text="This number should not be between zero and 0.95,\n"
+                                                                  "since it represents the fraction of reflections\n"
+                                                                  "measured in the part of the diffraction pattern\n"
+                                                                  "that is essentially complete."),
+    '_diffrn_reflns_point_group_'
+    'measured_fraction_full'              : Floatlimits(lower=0.95,
+                                                        upper=1.0,
+                                                        help_text="This number should not be between zero and 0.95,\n"
+                                                                  "since it represents the fraction of reflections\n"
+                                                                  "measured in the part of the diffraction pattern\n"
+                                                                  "that is essentially complete."),
+    '_diffrn_reflns_Laue_'
+    'measured_fraction_max'               : Floatlimits(lower=0.0, upper=1.0),
+    '_diffrn_reflns_point_'
+    'group_measured_fraction_max'         : Floatlimits(lower=0.0, upper=1.0),
+    '_diffrn_reflns_theta_full'           : Floatlimits(lower=0.0, upper=90.0),
+    '_diffrn_reflns_theta_max'            : Floatlimits(lower=0.0, upper=90.0),
+    '_diffrn_reflns_theta_min'            : Floatlimits(lower=0.0, upper=90.0),
+    '_diffrn_reflns_av_R_equivalents'     : Floatlimits(lower=0.0, upper=inf),
+    '_diffrn_reflns_av_unetI/netI'        : Floatlimits(lower=0.0, upper=inf),
+    '_diffrn_reflns_limit_h_max'          : Integerlimits(lower=0, upper=inf),
+    '_diffrn_reflns_limit_k_max'          : Integerlimits(lower=0, upper=inf),
+    '_diffrn_reflns_limit_l_max'          : Integerlimits(lower=0, upper=inf),
+    '_diffrn_reflns_limit_h_min'          : Integerlimits(lower=-inf, upper=0),
+    '_diffrn_reflns_limit_k_min'          : Integerlimits(lower=-inf, upper=0),
+    '_diffrn_reflns_limit_l_min'          : Integerlimits(lower=-inf, upper=0),
+    '_exptl_absorpt_coefficient_mu'       : Floatlimits(lower=0.0, upper=inf),
+    '_exptl_crystal_size_max'             : Floatlimits(lower=0.0, upper=inf),
+    '_exptl_crystal_size_min'             : Floatlimits(lower=0.0, upper=inf),
+    '_exptl_crystal_size_mid'             : Floatlimits(lower=0.0, upper=inf),
+    '_refine_diff_density_max'            : Floatlimits(lower=0.0, upper=inf),
+    '_refine_diff_density_min'            : Floatlimits(lower=-inf, upper=0.0),
+    '_refine_diff_density_rms'            : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_R_factor_all'             : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_R_factor_gt'              : Floatlimits(lower=0.0, upper=inf),
+    # In fact from 0.0-1.0, but some software does other:
+    '_refine_ls_abs_structure_Flack'      : Floatlimits(lower=-inf, upper=inf),
+    '_refine_ls_goodness_of_fit_ref'      : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_number_parameters'        : Integerlimits(lower=0, upper=inf),
+    '_refine_ls_number_reflns'            : Integerlimits(lower=0, upper=inf),
+    '_refine_ls_number_restraints'        : Integerlimits(lower=0, upper=inf),
+    '_refine_ls_restrained_S_all'         : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_shift/su_max'             : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_shift/su_mean'            : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_wR_factor_gt'             : Floatlimits(lower=0.0, upper=inf),
+    '_refine_ls_wR_factor_ref'            : Floatlimits(lower=0.0, upper=inf),
+    '_reflns_Friedel_coverage'            : Floatlimits(lower=0.0, upper=1.0),
+    '_reflns_Friedel_fraction_full'       : Floatlimits(lower=0.0, upper=1.0),
+    '_reflns_Friedel_fraction_max'        : Floatlimits(lower=0.0, upper=1.0),
+    '_reflns_number_gt'                   : Integerlimits(lower=0.0, upper=inf),
+    '_reflns_number_total'                : Integerlimits(lower=0.0, upper=inf),
+    '_shelx_estimated_absorpt_T_max'      : Floatlimits(lower=0.0, upper=1.0),
+    '_shelx_estimated_absorpt_T_min'      : Floatlimits(lower=0.0, upper=1.0),
+    '_shelx_hkl_checksum'                 : Integerlimits(lower=0, upper=inf),
+    '_shelx_res_checksum'                 : Integerlimits(lower=0, upper=inf),
+    '_shelx_fcf_checksum'                 : Integerlimits(lower=0, upper=inf),
+    '_space_group_IT_number'              : Integerlimits(lower=1, upper=230),
+    '_space_group_crystal_system'         : Textlimits(options=['triclinic',
+                                                                'monoclinic',
+                                                                'orthorhombic',
+                                                                'tetragonal',
+                                                                'trigonal',
+                                                                'hexagonal',
+                                                                'cubic', ]),
+
+}
+
+if __name__ == '__main__':
+    limits = validators['_chemical_melting_point']
+    print(limits.valid('5'))
+    print(limits.valid('-5'))
+
+    min_ = validators['_diffrn_reflns_limit_h_min']
+    print(min_.valid('-5'))
+    print(min_.help_text)
+
+    min_ = validators['_diffrn_reflns_Laue_measured_fraction_max']
+    print(min_.valid('-5'))
+    print(min_.help_text)
+
+    min_ = validators['_refine_ls_number_restraints']
+    print(min_.valid('-5'))
+    print(min_.help_text)
+
+    min_ = validators['_space_group_crystal_system']
+    print(min_.valid('Triclinic'))
+    print(min_.help_text)
diff -pruN 134+dfsg-1/finalcif/report/references.py 137+dfsg-1/finalcif/report/references.py
--- 134+dfsg-1/finalcif/report/references.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/report/references.py	2024-04-19 19:04:23.000000000 +0000
@@ -191,6 +191,32 @@ class ReferenceFormatter():
         return r
 
     @property
+    def html(self) -> str:
+        txt = ''
+        if self.authors:
+            txt += f'{self.authors}, '
+        if self.journal:
+            txt += f'<i>{self.journal}</i>'
+            if not self.journal.endswith('.'):
+                txt += ', '
+            else:
+                txt += ' '
+        if self.year:
+            txt += f'<b>{self.year}</b>'
+            txt += ', '
+        if self.volume:
+            txt += f'<i>{self.volume}</i>'
+            txt += ', '
+        if self.pages:
+            txt += f'{self.pages}'
+            if self.doi:
+                txt += ', '
+        if self.doi:
+            txt += f'{self.doi}'
+        if any([self.journal, self.pages, self.year, self.volume, self.doi]):
+            txt += '.'
+        return txt
+    @property
     def short_ref(self) -> RichText:
         """
         Adds a reference with (name year) instead of a number.
diff -pruN 134+dfsg-1/finalcif/report/report_text.py 137+dfsg-1/finalcif/report/report_text.py
--- 134+dfsg-1/finalcif/report/report_text.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/report/report_text.py	2024-04-19 19:04:23.000000000 +0000
@@ -14,11 +14,9 @@ from shelxfile.atoms.atoms import Atom a
 from finalcif.app_path import application_path
 from finalcif.cif.cif_file_io import CifContainer
 from finalcif.cif.text import retranslate_delimiter, string_to_utf8
-from finalcif.report.references import DummyReference, SAINTReference, SORTAVReference, ReferenceList, CCDCReference, \
-    SHELXLReference, SHELXTReference, SHELXSReference, FinalCifReference, ShelXleReference, Olex2Reference, \
-    SHELXDReference, SadabsTwinabsReference, CrysalisProReference, Nosphera2Reference, XDSReference, DSRReference2015, \
-    DSRReference2018, XRedReference
-from finalcif.tools.misc import protected_space, angstrom, zero_width_space, remove_line_endings, flatten
+from finalcif.report import references
+from finalcif.tools.misc import (protected_space, angstrom, zero_width_space, remove_line_endings,
+                                 flatten, minus_sign)
 
 
 def math_to_word(eq: str) -> BaseOxmlElement:
@@ -34,12 +32,6 @@ def math_to_word(eq: str) -> BaseOxmlEle
 def clean_string(string: str) -> str:
     """
     Removes control characters from a string.
-    >>> clean_string('This is a sentence\\nwith newline.')
-    'This is a sentence with newline'
-    >>> clean_string('')
-    ''
-    >>> clean_string('  This is  a sentence\\nwith. newline.  ')
-    'This is  a sentence with. newline'
     """
     repl = string.replace('\t', ' ') \
         .replace('\f', ' ') \
@@ -166,18 +158,18 @@ class MachineType():
 
 
 class DataReduction():
-    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: ReferenceList):
+    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: references.ReferenceList):
         integration = gstr(cif['_computing_data_reduction']) or '??'
         abstype = gstr(cif['_exptl_absorpt_correction_type']) or '??'
         abs_details = gstr(cif['_exptl_absorpt_process_details']) or '??'
-        data_reduct_ref = DummyReference()
-        absorpt_ref = DummyReference()
-        integration_prog = '[unknown integration program]'
-        scale_prog = '[unknown program]'
+        data_reduct_ref = references.DummyReference()
+        absorpt_ref = references.DummyReference()
+        integration_prog = '[No _computing_data_reduction given]'
+        scale_prog = '[Unknown scaling program]'
         if 'SAINT' in integration:
             data_reduct_ref, integration_prog = self.add_saint_reference(integration)
         if 'XDS' in integration:
-            data_reduct_ref = XDSReference()
+            data_reduct_ref = references.XDSReference()
             integration_prog = 'XDS'
         if 'CrysAlisPro'.lower() in integration.lower():
             data_reduct_ref, absorpt_ref, integration_prog = self.add_crysalispro_reference(integration)
@@ -193,11 +185,11 @@ class DataReduction():
                 scale_prog = 'SADABS'
             else:
                 scale_prog = 'TWINABS'
-            # absorpt_ref = SAINTReference(scale_prog, version)
-            absorpt_ref = SadabsTwinabsReference()
+            # absorpt_ref = references.SAINTReference(scale_prog, version)
+            absorpt_ref = references.SadabsTwinabsReference()
         if 'SORTAV' in absdetails.upper():
             scale_prog = 'SORTAV'
-            absorpt_ref = SORTAVReference()
+            absorpt_ref = references.SORTAVReference()
         if 'crysalis' in abs_details.lower():
             scale_prog = 'SCALE3 ABSPACK'
         txt = (f'All data were integrated with {integration_prog} and {get_inf_article(abstype)} '
@@ -210,7 +202,7 @@ class DataReduction():
         if len(integration.split()) > 1:
             saintversion = integration.split()[1]
         integration_prog = 'SAINT'
-        data_reduct_ref = SAINTReference('SAINT', saintversion)
+        data_reduct_ref = references.SAINTReference('SAINT', saintversion)
         return data_reduct_ref, integration_prog
 
     def add_x_red_reference(self, integration):
@@ -218,10 +210,11 @@ class DataReduction():
         # if len(integration.split()) > 1:
         #    xredversion = integration.split()[1]
         integration_prog = 'STOE X-RED'
-        data_reduct_ref = XRedReference('X-RED', xredversion)
+        data_reduct_ref = references.XRedReference('X-RED', xredversion)
         return data_reduct_ref, integration_prog
 
-    def add_crysalispro_reference(self, integration: str) -> Tuple[CrysalisProReference, CrysalisProReference, str]:
+    def add_crysalispro_reference(self, integration: str) -> Tuple[
+        references.CrysalisProReference, references.CrysalisProReference, str]:
         """
         CrysAlisPro, Agilent Technologies,Version 1.171.37.31h (release 21-03-2014 CrysAlis171 .NET)
             (compiled Mar 21 2014,18:13:45)
@@ -241,36 +234,36 @@ class DataReduction():
                 year = year.split('-')[-1]
             version = integration.split()[3]
         integration_prog = 'Crysalispro'
-        data_reduct_ref = CrysalisProReference(version=version, year=year, pages=pages)
-        absorpt_ref = CrysalisProReference(version=version, year=year, pages=pages)
+        data_reduct_ref = references.CrysalisProReference(version=version, year=year, pages=pages)
+        absorpt_ref = references.CrysalisProReference(version=version, year=year, pages=pages)
         return data_reduct_ref, absorpt_ref, integration_prog
 
 
 class SolveRefine():
-    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: ReferenceList):
+    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: references.ReferenceList):
         manual_method = False
-        refineref = DummyReference()
-        solveref = DummyReference()
+        refineref = references.DummyReference()
+        solveref = references.DummyReference()
         solution_prog = gstr(cif['_computing_structure_solution']) or '[No _computing_structure_solution given]'
         solution_method = gstr(cif['_atom_sites_solution_primary']).strip(
             '\n\r') or '[No _atom_sites_solution_primary given]'
         if 'isomor' in solution_method:
             manual_method = True
         if solution_prog.upper().startswith(('SHELXT', 'XT')):
-            solveref = SHELXTReference()
+            solveref = references.SHELXTReference()
         if 'SHELXS' in solution_prog.upper():
-            solveref = SHELXSReference()
+            solveref = references.SHELXSReference()
         if 'SHELXD' in solution_prog.upper():
-            solveref = SHELXDReference()
+            solveref = references.SHELXDReference()
         refined = gstr(cif['_computing_structure_refinement']).split(' ')[
                       0] or '[No _computing_structure_refinement given]'
         if refined.upper().startswith(('SHELXL', 'XL')):
-            refineref = SHELXLReference()
+            refineref = references.SHELXLReference()
         if 'OLEX' in refined.upper():
-            refineref = Olex2Reference()
-        if 'NOSPHERA2' in solution_prog.upper() or 'NOSPHERA2' in cif['_refine_special_details'].upper() \
-            or 'NOSPHERA2' in cif['_olex2_refine_details'].upper():
-            refineref = [Olex2Reference(), Nosphera2Reference()]
+            refineref = references.Olex2Reference()
+        if ('NOSPHERA2' in solution_prog.upper() or 'NOSPHERA2' in cif['_refine_special_details'].upper()
+                or 'NOSPHERA2' in cif['_olex2_refine_details'].upper()):
+            refineref = [references.Olex2Reference(), references.Nosphera2Reference()]
         refine_coef = gstr(cif['_refine_ls_structure_factor_coef'])
         if manual_method:
             methods = f"{solution_prog} "
@@ -285,10 +278,10 @@ class SolveRefine():
         gui_reference = None
         if 'shelxle' in refined.lower() or 'shelxle' in cif['_computing_molecular_graphics'].lower():
             paragraph.add_run(' using ShelXle')
-            gui_reference = ShelXleReference()
+            gui_reference = references.ShelXleReference()
         if 'olex' in refined.lower() or 'olex' in cif['_computing_molecular_graphics'].lower():
             paragraph.add_run(' using Olex2')
-            gui_reference = Olex2Reference()
+            gui_reference = references.Olex2Reference()
         paragraph.add_run('.')
         ref.append(flatten([solveref, refineref, gui_reference]))
 
@@ -428,7 +421,7 @@ class Hydrogens():
 
 
 class Disorder():
-    def __init__(self, cif: CifContainer, paragraph: Paragraph, reflist: ReferenceList):
+    def __init__(self, cif: CifContainer, paragraph: Paragraph, reflist: references.ReferenceList):
         """
         TODO: Search for SIMU, DELU, SADI, DFIX, etc in cif.shx.restraints in order to
               make the sentence1 more specific.
@@ -442,12 +435,12 @@ class Disorder():
             dsr_sentence = "Some parts of the disorder model were introduced by the " \
                            "program DSR."
             paragraph.add_run(dsr_sentence)
-            reflist.append([DSRReference2015(), DSRReference2018()])
+            reflist.append([references.DSRReference2015(), references.DSRReference2018()])
             SpaceChar(paragraph).regular()
 
 
 class Twinning():
-    def __init__(self, cif: CifContainer, paragraph: Paragraph, reflist: ReferenceList):
+    def __init__(self, cif: CifContainer, paragraph: Paragraph, reflist: references.ReferenceList):
         """ _twin_formation_mechanism         gt
             _twin_dimensionality              triperiodic
             _twin_morphology                  polysynthetic
@@ -480,7 +473,7 @@ class SpaceChar():
 
 
 class CCDC():
-    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: ReferenceList):
+    def __init__(self, cif: CifContainer, paragraph: Paragraph, ref: references.ReferenceList):
         ccdc_num = gstr(cif['_database_code_depnum_ccdc_archive']) or '??????'
         splitted_number = ccdc_num.split(' ')
         if len(splitted_number) > 1 and splitted_number[1].isdigit():
@@ -491,16 +484,16 @@ class CCDC():
                     "These data can be obtained free of charge from The Cambridge Crystallographic Data Centre " \
                     f"via www.ccdc.cam.ac.uk/{zero_width_space}structures."
         paragraph.add_run(sentence1)
-        ref.append(CCDCReference())
+        ref.append(references.CCDCReference())
         SpaceChar(paragraph).regular()
         paragraph.add_run(sentence2)
 
 
 class FinalCifreport():
-    def __init__(self, paragraph: Paragraph, reflist: ReferenceList):
+    def __init__(self, paragraph: Paragraph, reflist: references.ReferenceList):
         sentence = "This report and the CIF file were generated using FinalCif."
         paragraph.add_run(sentence)
-        reflist.append(FinalCifReference())
+        reflist.append(references.FinalCifReference())
 
 
 class RefinementDetails():
@@ -508,7 +501,10 @@ class RefinementDetails():
         ph = document.add_paragraph(style='Heading 2')
         ph.add_run(text=fr"Refinement details for {cif.block.name}")
         p = document.add_paragraph()
-        p.style = document.styles['fliesstext']
+        try:
+            p.style = document.styles['fliesstext']
+        except KeyError:
+            print('DBG> Text style not found')
         text = ' '.join(cif['_refine_special_details'].splitlines(keepends=False))
         if cif['_olex2_refine_details']:
             text += ' '.join(cif['_olex2_refine_details'].splitlines(keepends=False))
@@ -533,10 +529,13 @@ def format_radiation(radiation_type: str
         return radtype
 
 
-def make_report_text(cif, document: Document) -> ReferenceList:
+def make_report_text(cif, document: Document) -> references.ReferenceList:
     paragr = document.add_paragraph()
-    paragr.style = document.styles['fliesstext']
-    ref = ReferenceList(paragr)
+    try:
+        paragr.style = document.styles['fliesstext']
+    except KeyError:
+        print('DBG> Text style not found')
+    ref = references.ReferenceList(paragr)
     # -- The main text:
     paragr.add_run('The following text is only a suggestion: ').font.bold = True
     Crystallization(cif, paragr)
diff -pruN 134+dfsg-1/finalcif/report/tables.py 137+dfsg-1/finalcif/report/tables.py
--- 134+dfsg-1/finalcif/report/tables.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/report/tables.py	2024-04-19 19:04:23.000000000 +0000
@@ -22,10 +22,11 @@ from finalcif.report.mtools import forma
 from finalcif.report.references import ReferenceList
 from finalcif.report.report_text import format_radiation, RefinementDetails, make_report_text
 from finalcif.report.templated_report import BondsAndAngles, TorsionAngles, HydrogenBonds
-from finalcif.tools.misc import protected_space, angstrom, bequal, sigma_sm, halbgeviert, degree_sign, ellipsis_mid, \
-    less_or_equal, \
-    timessym, lambdasym, this_or_quest, isnumeric, minus_sign, theta_symbol, grouper, open_file, pi_symbol, \
-    ellipsis_char, medium_math_space, alpha_symol, beta_symol, gamma_symol
+from finalcif.tools.misc import (protected_space, angstrom, bequal, sigma_sm, halbgeviert, degree_sign,
+                                 ellipsis_mid, less_or_equal, timessym, lambdasym, this_or_quest,
+                                 isnumeric, minus_sign, theta_symbol, grouper, open_file, pi_symbol,
+                                 ellipsis_char, medium_math_space, alpha_symol, beta_symol,
+                                 gamma_symol)
 from finalcif.tools.options import Options
 from finalcif.tools.settings import FinalCifSettings
 
@@ -69,8 +70,6 @@ def make_multi_tables(cif: CifContainer,
 def make_report_from(options: Options, cif: CifContainer, output_filename: str = None, picfile: Path = None) -> str:
     """
     Creates a tabular cif report.
-    :param file_obj: Input cif file.
-    :param output_filename: the table is saved to this file.
     """
     document = create_document()
     references: Union[ReferenceList, None] = None
diff -pruN 134+dfsg-1/finalcif/report/templated_report.py 137+dfsg-1/finalcif/report/templated_report.py
--- 134+dfsg-1/finalcif/report/templated_report.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/report/templated_report.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,31 +1,41 @@
 import dataclasses
+import enum
 import itertools
+import pathlib
 import re
+import sys
+from abc import ABC
 from collections import namedtuple
 from contextlib import suppress
 from math import sin, radians
 from pathlib import Path
-from typing import List, Dict, Union
+from typing import List, Dict, Union, Iterator, Any
 
 import jinja2
 from docx.enum.text import WD_PARAGRAPH_ALIGNMENT
 from docx.shared import Cm
 from docx.text.paragraph import Paragraph
 from docxtpl import DocxTemplate, RichText, InlineImage, Subdoc
-from shelxfile.misc.dsrmath import my_isnumeric
 
+from finalcif import app_path
 from finalcif.cif.cif_file_io import CifContainer
 from finalcif.gui.dialogs import show_general_warning
-from finalcif.report.references import SAINTReference, SHELXLReference, SadabsTwinabsReference, SHELXTReference, \
-    SHELXSReference, SHELXDReference, SORTAVReference, FinalCifReference, CCDCReference, \
-    CrysalisProReference, Nosphera2Reference, Olex2Reference
-from finalcif.report.report_text import math_to_word, gstr, format_radiation, get_inf_article, MachineType
+from finalcif.report import references as ref
+from finalcif.report.report_text import (math_to_word, gstr, format_radiation, get_inf_article,
+                                         MachineType)
 from finalcif.report.symm import SymmetryElement
-from finalcif.tools.misc import isnumeric, this_or_quest, timessym, angstrom, protected_space, less_or_equal, \
-    halbgeviert, minus_sign, ellipsis_mid
+from finalcif.tools.misc import (isnumeric, this_or_quest, timessym, angstrom, protected_space,
+                                 less_or_equal, halbgeviert, minus_sign, ellipsis_mid)
 from finalcif.tools.options import Options
 from finalcif.tools.space_groups import SpaceGroups
 
+AdpWithMinus = namedtuple('AdpWithMinus', ('label', 'U11', 'U22', 'U33', 'U23', 'U13', 'U12'))
+
+
+class ReportFormat(enum.Enum):
+    RICHTEXT = 'richtext'
+    HTML = 'html'
+
 
 @dataclasses.dataclass(frozen=True)
 class Bond():
@@ -75,13 +85,13 @@ class BondsAndAngles():
         self.bonds_as_string: List[Bond] = []
         self.angles_as_string: List[Angle] = []
         # These can be used as Richtext for python-docx-tpl:
-        self.bonds: List[dict] = self._get_bonds_list(without_h)
-        self.angles: List[dict] = self._get_angles_list(without_h)
+        self.bonds_richtext: List[Dict[str, RichText]] = self._get_bonds_list(without_h)
+        self.angles_richtext: List[Dict[str, RichText]] = self._get_angles_list(without_h)
         # The list of symmetry elements at the table end used for generated atoms:
         self.symminfo: str = get_symminfo(self._symmlist)
 
     def __len__(self):
-        return len(self.bonds) + len(self.angles)
+        return len(self.bonds_richtext) + len(self.angles_richtext)
 
     @property
     def symmetry_generated_atoms_used(self):
@@ -107,7 +117,7 @@ class BondsAndAngles():
         self._symmlist.update(newsymms)
         return bonds
 
-    def _get_angles_list(self, without_h):
+    def _get_angles_list(self, without_h: bool) -> List[Dict[str, RichText]]:
         angles_list = []
         newsymms = {}
         symms = {}
@@ -144,18 +154,18 @@ class TorsionAngles():
         self.without_h = without_h
         self._symmlist = {}
         self.torsion_angles_as_string: List[Torsion] = []
-        self.torsion_angles = self._get_torsion_angles_list(without_h)
+        self.torsion_angles_as_richtext = self._get_torsion_angles_list(without_h)
         # The list of symmetry elements at the table end used for generated atoms:
         self.symminfo: str = get_symminfo(self._symmlist)
 
     def __len__(self):
-        return len(self.torsion_angles)
+        return len(self.torsion_angles_as_richtext)
 
     @property
     def symmetry_generated_atoms_used(self):
         return len(self._symmlist) > 0
 
-    def _get_torsion_angles_list(self, without_h: bool):
+    def _get_torsion_angles_list(self, without_h: bool) -> List[Dict[str, RichText]]:
         if self.cif.nangles(without_h) <= 0:
             return []
         symms = {}
@@ -254,7 +264,7 @@ def get_card(cif: CifContainer, symm: st
     return card
 
 
-def get_symminfo(newsymms: dict) -> str:
+def get_symminfo(newsymms: Dict[int, str]) -> str:
     """
     Adds text about the symmetry generators used in order to add symmetry generated atoms.
     """
@@ -273,7 +283,8 @@ def get_symminfo(newsymms: dict) -> str:
         return ''
 
 
-def symmsearch(cif: CifContainer, newsymms, num, symm, symms_list) -> int:
+def symmsearch(cif: CifContainer, newsymms: Dict[int, str], num: int,
+               symm: Union[str, None], symms_list: Dict[str, int]) -> int:
     if symm and symm not in symms_list.keys():
         symms_list[symm] = num
         card = get_card(cif, symm)
@@ -287,59 +298,60 @@ def symmsearch(cif: CifContainer, newsym
     return num
 
 
-class TemplatedReport():
-
-    def __init__(self):
-        self.literature = {'finalcif'   : FinalCifReference(),
-                           'ccdc'       : CCDCReference(),
+class Formatter(ABC):
+    def __init__(self, options: Options, cif: CifContainer) -> None:
+        self.literature = {'finalcif'   : ref.FinalCifReference(),
+                           'ccdc'       : ref.CCDCReference(),
                            'absorption' : '[no reference found]',
                            'solution'   : '[no reference found]',
                            'refinement' : '[no reference found]',
                            'integration': '[no reference found]',
                            }
+        self._bonds_angles = BondsAndAngles(cif, without_h=options.without_h)
+        self._torsions = TorsionAngles(cif, without_h=options.without_h)
+        self._hydrogens = HydrogenBonds(cif)
 
-    def format_sum_formula(self, sum_formula: str) -> RichText:
-        sum_formula_group = [''.join(x[1]) for x in itertools.groupby(sum_formula, lambda x: x.isalpha())]
-        richtext = RichText('')
-        if sum_formula_group:
-            for _, word in enumerate(sum_formula_group):
-                if isnumeric(word):
-                    richtext.add(word, subscript=True)
-                elif ')' in word:
-                    richtext.add(word.split(')')[0], subscript=True)
-                    richtext.add(')')
-                elif ']' in word:
-                    richtext.add(word.split(']')[0], subscript=True)
-                    richtext.add(']')
-                else:
-                    richtext.add(word)
-                    if word == ',':
-                        richtext.add(' ')
-            return richtext
-        else:
-            return RichText('no formula')
+    def get_bonds(self):
+        raise NotImplementedError
 
-    @staticmethod
-    def space_group_subdoc(tpl_doc: DocxTemplate, cif: CifContainer) -> Subdoc:
-        """
-        Generates a Subdoc subdocument with the xml code for a math element in MSWord.
-        """
-        s = SpaceGroups()
-        try:
-            spgrxml = s.to_mathml(cif.space_group)
-        except KeyError:
-            spgrxml = '<math xmlns="http://www.w3.org/1998/Math/MathML">?</math>'
-        spgr_word = math_to_word(spgrxml)
-        # I have to create a subdocument in order to add the xml:
-        sd = tpl_doc.new_subdoc()
-        p: Paragraph = sd.add_paragraph()
-        p.alignment = WD_PARAGRAPH_ALIGNMENT.LEFT
-        p._element.append(spgr_word)
-        try:
-            p.add_run(f' ({cif.spgr_number})')
-        except AttributeError:
-            pass
-        return sd
+    def get_angles(self):
+        raise NotImplementedError
+
+    def get_torsion_angles(self) -> list[dict[str, RichText]] | list[Torsion]:
+        raise NotImplementedError
+
+    def get_hydrogen_bonds(self) -> list[dict[str, RichText]] | list[HydrogenBond]:
+        raise NotImplementedError
+
+    def get_bonds_angles_symminfo(self) -> str:
+        return self._bonds_angles.symminfo
+
+    def get_torsion_symminfo(self) -> str:
+        return self._torsions.symminfo
+
+    def get_hydrogen_symminfo(self) -> str:
+        return self._hydrogens.symminfo
+
+    def get_crystallization_method(self, cif) -> str:
+        return gstr(cif['_exptl_crystal_recrystallization_method']) or '[No crystallization method given!]'
+
+    def get_radiation(self, cif: CifContainer) -> str | RichText:
+        raise NotImplementedError
+
+    def hkl_index_limits(self, cif: CifContainer) -> str:
+        raise NotImplementedError
+
+    def make_3d(self, cif: CifContainer, options: Options) -> str:
+        raise NotImplementedError
+
+    def space_group_subdoc(self, cif: CifContainer, tpl_doc: DocxTemplate):
+        raise NotImplementedError
+
+    def make_picture(self, options: Options, picfile: Path, tpl_doc: DocxTemplate):
+        raise NotImplementedError
+
+    def format_sum_formula(self, sum_formula: str) -> str:
+        raise NotImplementedError
 
     @staticmethod
     def get_from_to_theta_range(cif: CifContainer) -> str:
@@ -355,37 +367,6 @@ class TemplatedReport():
             return '? to ?'
 
     @staticmethod
-    def hkl_index_limits(cif: CifContainer) -> str:
-        limit_h_min = cif['_diffrn_reflns_limit_h_min']
-        limit_h_max = cif['_diffrn_reflns_limit_h_max']
-        limit_k_min = cif['_diffrn_reflns_limit_k_min']
-        limit_k_max = cif['_diffrn_reflns_limit_k_max']
-        limit_l_min = cif['_diffrn_reflns_limit_l_min']
-        limit_l_max = cif['_diffrn_reflns_limit_l_max']
-        return f'{minus_sign if limit_h_min != "0" else ""}{limit_h_min.replace("-", "")} ' \
-               f'{less_or_equal} h {less_or_equal} {limit_h_max}\n' \
-            + f'{minus_sign if limit_k_min != "0" else ""}{limit_k_min.replace("-", "")} ' \
-              f'{less_or_equal} k {less_or_equal} {limit_k_max}\n' \
-            + f'{minus_sign if limit_l_min != "0" else ""}{limit_l_min.replace("-", "")} ' \
-              f'{less_or_equal} l {less_or_equal} {limit_l_max}'
-
-    @staticmethod
-    def get_radiation(cif: CifContainer) -> RichText:
-        rad_element, radtype, radline = format_radiation(cif['_diffrn_radiation_type'])
-        radiation = RichText(rad_element)
-        radiation.add(radtype, italic=True)
-        radiation.add(radline, italic=True, subscript=True)
-        return radiation
-
-    @staticmethod
-    def get_completeness(cif: CifContainer) -> str:
-        try:
-            completeness = f"{float(cif['_diffrn_measured_fraction_theta_full']) * 100:.1f}{protected_space}%"
-        except ValueError:
-            completeness = '?'
-        return completeness
-
-    @staticmethod
     def get_diff_density_min(cif: CifContainer) -> str:
         try:
             diff_density_min = f"{float(cif['_refine_diff_density_min']):.2f}"
@@ -425,7 +406,7 @@ class TemplatedReport():
             if len(integration.split()) > 1:
                 saintversion = integration.split()[1]
                 integration_prog += " " + saintversion
-            self.literature['integration'] = SAINTReference('SAINT', saintversion)
+            self.literature['integration'] = ref.SAINTReference('SAINT', saintversion)
         if 'CrysAlisPro'.lower() in integration.lower():
             regex = r"(CrysAlisPro)\s{0,2}(\d+\.\d+\.\d+\.\d+.*)\((.*),\s?(\d+)\)"
             year = 'unknown version'
@@ -437,12 +418,11 @@ class TemplatedReport():
                 integration_prog = match.group(1).strip()
             else:
                 integration_prog = 'CrysAlisPro'
-            self.literature['integration'] = CrysalisProReference(version=version, year=year)
-            self.literature['absorption'] = CrysalisProReference(version=version, year=year)
+            self.literature['integration'] = ref.CrysalisProReference(version=version, year=year)
+            self.literature['absorption'] = ref.CrysalisProReference(version=version, year=year)
         return integration_prog
 
-    def get_absortion_correction_program(self, cif: CifContainer) -> str:
-        absdetails = cif['_exptl_absorpt_process_details'].replace('-', ' ').replace(':', '')
+    def _get_scaling_program(self, absdetails: str) -> tuple[str, str]:
         scale_prog = ''
         version = ''
         if 'SADABS' in absdetails.upper() or 'TWINABS' in absdetails.upper():
@@ -454,10 +434,18 @@ class TemplatedReport():
                 scale_prog = 'SADABS'
             else:
                 scale_prog = 'TWINABS'
-            self.literature['absorption'] = SadabsTwinabsReference()
+            self.literature['absorption'] = ref.SadabsTwinabsReference()
+        return scale_prog, version
+
+    def get_absortion_correction_program(self, cif: CifContainer) -> str:
+        absdetails = cif['_exptl_absorpt_process_details'].replace('-', ' ').replace(':', '')
+        bruker_scaling = cif['_computing_bruker_data_scaling'].replace('-', ' ').replace(':', '')
+        scale_prog, version = self._get_scaling_program(absdetails)
+        if not scale_prog:
+            scale_prog, version = self._get_scaling_program(bruker_scaling)
         if 'SORTAV' in absdetails.upper():
             scale_prog = 'SORTAV'
-            self.literature['absorption'] = SORTAVReference()
+            self.literature['absorption'] = ref.SORTAVReference()
         if 'crysalis' in absdetails.lower():
             scale_prog = 'SCALE3 ABSPACK'
             # see above also
@@ -469,28 +457,33 @@ class TemplatedReport():
         solution_method = gstr(cif['_atom_sites_solution_primary']) or '??'
         return solution_method.strip('\n\r')
 
+    def refinement_prog(self, cif: CifContainer) -> str:
+        refined = gstr(cif['_computing_structure_refinement']) or '??'
+        if 'SHELXL' in refined.upper() or 'XL' in refined.upper():
+            self.literature['refinement'] = ref.SHELXLReference()
+        if 'OLEX' in refined.upper():
+            self.literature['refinement'] = ref.Olex2Reference()
+        if ('NOSPHERA2' in refined.upper() or 'NOSPHERA2' in cif['_refine_special_details'].upper() or
+                'NOSPHERAT2' in cif['_olex2_refine_details'].upper()):
+            self.literature['refinement'] = ref.Nosphera2Reference()
+        return refined.split()[0]
+
     def solution_program(self, cif: CifContainer) -> str:
         solution_prog = gstr(cif['_computing_structure_solution']) or '??'
         if solution_prog.upper().startswith(('SHELXT', 'XT')):
-            self.literature['solution'] = SHELXTReference()
+            self.literature['solution'] = ref.SHELXTReference()
         if 'SHELXS' in solution_prog.upper():
-            self.literature['solution'] = SHELXSReference()
+            self.literature['solution'] = ref.SHELXSReference()
         if 'SHELXD' in solution_prog.upper():
-            self.literature['solution'] = SHELXDReference()
+            self.literature['solution'] = ref.SHELXDReference()
         return solution_prog.split()[0]
 
-    def refinement_prog(self, cif: CifContainer) -> str:
-        refined = gstr(cif['_computing_structure_refinement']) or '??'
-        if 'SHELXL' in refined.upper() or 'XL' in refined.upper():
-            self.literature['refinement'] = SHELXLReference()
-        if 'OLEX' in refined.upper():
-            self.literature['refinement'] = Olex2Reference()
-        if ('NOSPHERA2' in refined.upper() or 'NOSPHERA2' in cif['_refine_special_details'].upper() or
-            'NOSPHERAT2' in cif['_olex2_refine_details'].upper()):
-            self.literature['refinement'] = Nosphera2Reference()
-        return refined.split()[0]
+    def _tvalue(self, tval: str) -> str:
+        with suppress(ValueError):
+            return f'{float(tval):.3f}'
+        return tval
 
-    def get_atomic_coordinates(self, cif: CifContainer):
+    def get_atomic_coordinates(self, cif: CifContainer) -> Iterator[dict[str, str]]:
         for at in cif.atoms(without_h=False):
             yield {'label': at.label,
                    'type' : at.type,
@@ -501,37 +494,228 @@ class TemplatedReport():
                    'occ'  : at.occ.replace('-', minus_sign),
                    'u_eq' : at.u_eq.replace('-', minus_sign)}
 
-    def get_displacement_parameters(self, cif: CifContainer):
+    def get_displacement_parameters(self, cif: CifContainer) -> Iterator[AdpWithMinus]:
         """
         Yields the anisotropic displacement parameters. With hypehens replaced to minus signs.
         """
-        adp = namedtuple('adp', ('label', 'U11', 'U22', 'U33', 'U23', 'U13', 'U12'))
         for label, u11, u22, u33, u23, u13, u12 in cif.displacement_parameters():
-            yield adp(label=label,
-                      U11=u11.replace('-', minus_sign),
-                      U22=u22.replace('-', minus_sign),
-                      U33=u33.replace('-', minus_sign),
-                      U12=u12.replace('-', minus_sign),
-                      U13=u13.replace('-', minus_sign),
-                      U23=u23.replace('-', minus_sign))
+            yield AdpWithMinus(label=label,
+                               U11=u11.replace('-', minus_sign),
+                               U22=u22.replace('-', minus_sign),
+                               U33=u33.replace('-', minus_sign),
+                               U12=u12.replace('-', minus_sign),
+                               U13=u13.replace('-', minus_sign),
+                               U23=u23.replace('-', minus_sign))
 
-    def _tvalue(self, tval: str) -> str:
-        with suppress(ValueError):
-            return f'{float(tval):.3f}'
-        return tval
+    def get_completeness(self, cif: CifContainer) -> str:
+        try:
+            completeness = f"{float(cif['_diffrn_measured_fraction_theta_full']) * 100:.1f}{protected_space}%"
+        except ValueError:
+            completeness = '?'
+        return completeness
 
-    def get_crystallization_method(self, cif):
-        return gstr(cif['_exptl_crystal_recrystallization_method']) or '[No crystallization method given!]'
+
+class HtmlFormatter(Formatter):
+
+    def __init__(self, options: Options, cif: CifContainer) -> None:
+        super().__init__(options, cif)
+
+    def get_bonds(self) -> list[Bond]:
+        return self._bonds_angles.bonds_as_string
+
+    def get_angles(self) -> list[Angle]:
+        return self._bonds_angles.angles_as_string
+
+    def get_torsion_angles(self) -> list[Torsion]:
+        return self._torsions.torsion_angles_as_string
+
+    def get_hydrogen_bonds(self) -> list[HydrogenBond]:
+        return self._hydrogens.hydrogen_bonds_as_str
+
+    def _format_symminfo(self, txt):
+        return (txt.replace('#1:', '<br>#1:')
+                .replace(', ', ',&nbsp;')
+                .replace(': ', ':&nbsp;')
+                .replace('-', minus_sign))
+
+    def get_bonds_angles_symminfo(self) -> str:
+        return self._format_symminfo(self._bonds_angles.symminfo)
+
+    def get_torsion_symminfo(self):
+        return self._format_symminfo(self._torsions.symminfo)
+
+    def get_hydrogen_symminfo(self):
+        return self._format_symminfo(self._hydrogens.symminfo)
+
+    def make_3d(self, cif: CifContainer, options: Options) -> str:
+        return '[3D representation of the structure in html/javascript not implemented]'
+
+    def space_group_subdoc(self, cif: CifContainer, _: None) -> str:
+        s = SpaceGroups()
+        try:
+            spgrxml = s.to_mathml(cif.space_group)
+        except KeyError:
+            spgrxml = '<math xmlns="http://www.w3.org/1998/Math/MathML">?</math>'
+        return f'{spgrxml} ({cif.spgr_number})'
+
+    def make_picture(self, options: Options, picfile: Path, _: None):
+        picture_path = ''
+        if options.report_text and picfile and picfile.exists():
+            picture_path = str(picfile.resolve())
+        return picture_path  # (f'<img src="{picture_path}" '
+        # f'alt="Structure View" style="width:20%;height:20%;">')
+
+    def format_sum_formula(self, sum_formula: str) -> str:
+        sum_formula_group = [''.join(x[1]) for x in itertools.groupby(sum_formula, lambda x: x.isalpha())]
+        html_text = ''
+        if sum_formula_group:
+            for _, word in enumerate(sum_formula_group):
+                if isnumeric(word):
+                    html_text += f'<sub>{word}</sub>'
+                elif ')' in word:
+                    html_text += f"<sub>{word.split(')')[0]}</sub>)"
+                elif ']' in word:
+                    html_text += f"<sub>{word.split(']')[0]}</sub>)"
+                else:
+                    html_text += word
+                    if word == ',':
+                        html_text += ';&nbsp;'
+            return html_text
+        else:
+            return 'no formula'
+
+    def get_radiation(self, cif: CifContainer) -> str:
+        rad_element, radtype, radline = format_radiation(cif['_diffrn_radiation_type'])
+        radiation = f'{rad_element}<i>{radtype}</i><i><sub>{radline}</sub></i>'
+        return radiation
+
+    def hkl_index_limits(self, cif: CifContainer) -> str:
+        limit_h_min = cif['_diffrn_reflns_limit_h_min']
+        limit_h_max = cif['_diffrn_reflns_limit_h_max']
+        limit_k_min = cif['_diffrn_reflns_limit_k_min']
+        limit_k_max = cif['_diffrn_reflns_limit_k_max']
+        limit_l_min = cif['_diffrn_reflns_limit_l_min']
+        limit_l_max = cif['_diffrn_reflns_limit_l_max']
+        return (f'{minus_sign if limit_h_min != "0" else ""}{limit_h_min.replace("-", "")} '
+                f'{less_or_equal} h {less_or_equal} {limit_h_max}<br>'
+                f'{minus_sign if limit_k_min != "0" else ""}{limit_k_min.replace("-", "")} '
+                f'{less_or_equal} k {less_or_equal} {limit_k_max}<br>'
+                f'{minus_sign if limit_l_min != "0" else ""}{limit_l_min.replace("-", "")} '
+                f'{less_or_equal} l {less_or_equal} {limit_l_max}')
+
+
+class RichTextFormatter(Formatter):
+
+    def __init__(self, options: Options, cif: CifContainer) -> None:
+        super().__init__(options, cif)
+
+    def get_bonds(self) -> List[Dict[str, RichText]]:
+        return self._bonds_angles.bonds_richtext
+
+    def get_angles(self) -> List[Dict[str, RichText]]:
+        return self._bonds_angles.angles_richtext
+
+    def get_torsion_angles(self) -> List[Dict[str, RichText]]:
+        return self._torsions.torsion_angles_as_richtext
+
+    def get_hydrogen_bonds(self) -> list[dict[str, RichText]]:
+        return self._hydrogens.hydrogen_bonds
+
+    def make_3d(self, cif: CifContainer, options: Options) -> str:
+        return '[3D representation not implemented for .docx files]'
+
+    def format_sum_formula(self, sum_formula: str) -> RichText:
+        sum_formula_group = [''.join(x[1]) for x in itertools.groupby(sum_formula, lambda x: x.isalpha())]
+        richtext = RichText('')
+        if sum_formula_group:
+            for _, word in enumerate(sum_formula_group):
+                if isnumeric(word):
+                    richtext.add(word, subscript=True)
+                elif ')' in word:
+                    richtext.add(word.split(')')[0], subscript=True)
+                    richtext.add(')')
+                elif ']' in word:
+                    richtext.add(word.split(']')[0], subscript=True)
+                    richtext.add(']')
+                else:
+                    richtext.add(word)
+                    if word == ',':
+                        richtext.add(' ')
+            return richtext
+        else:
+            return RichText('no formula')
+
+    @staticmethod
+    def space_group_subdoc(cif: CifContainer, tpl_doc: DocxTemplate) -> Subdoc:
+        """
+        Generates a Subdoc subdocument with the xml code for a math element in MSWord.
+        """
+        s = SpaceGroups()
+        try:
+            spgrxml = s.to_mathml(cif.space_group)
+        except KeyError:
+            spgrxml = '<math xmlns="http://www.w3.org/1998/Math/MathML">?</math>'
+        spgr_word = math_to_word(spgrxml)
+        # I have to create a subdocument in order to add the xml:
+        sd = tpl_doc.new_subdoc()
+        p: Paragraph = sd.add_paragraph()
+        p.alignment = WD_PARAGRAPH_ALIGNMENT.LEFT
+        p._element.append(spgr_word)
+        try:
+            p.add_run(f' ({cif.spgr_number})')
+        except AttributeError:
+            pass
+        return sd
+
+    def get_radiation(self, cif: CifContainer) -> RichText:
+        rad_element, radtype, radline = format_radiation(cif['_diffrn_radiation_type'])
+        radiation = RichText(rad_element)
+        radiation.add(radtype, italic=True)
+        radiation.add(radline, italic=True, subscript=True)
+        return radiation
 
     def make_picture(self, options: Options, picfile: Path, tpl_doc: DocxTemplate):
         if options.report_text and picfile and picfile.exists():
             return InlineImage(tpl_doc, str(picfile.resolve()), width=Cm(options.picture_width))
         return None
 
-    def make_templated_report(self, options: Options, cif: CifContainer, output_filename: str, picfile: Path,
-                              template_path: Path) -> bool:
+    def hkl_index_limits(self, cif: CifContainer) -> str:
+        limit_h_min = cif['_diffrn_reflns_limit_h_min']
+        limit_h_max = cif['_diffrn_reflns_limit_h_max']
+        limit_k_min = cif['_diffrn_reflns_limit_k_min']
+        limit_k_max = cif['_diffrn_reflns_limit_k_max']
+        limit_l_min = cif['_diffrn_reflns_limit_l_min']
+        limit_l_max = cif['_diffrn_reflns_limit_l_max']
+        return (f'{minus_sign if limit_h_min != "0" else ""}{limit_h_min.replace("-", "")} '
+                f'{less_or_equal} h {less_or_equal} {limit_h_max}\n'
+                f'{minus_sign if limit_k_min != "0" else ""}{limit_k_min.replace("-", "")} '
+                f'{less_or_equal} k {less_or_equal} {limit_k_max}\n'
+                f'{minus_sign if limit_l_min != "0" else ""}{limit_l_min.replace("-", "")} '
+                f'{less_or_equal} l {less_or_equal} {limit_l_max}')
+
+
+def text_factory(options: Options, cif: CifContainer) -> dict[ReportFormat, Formatter]:
+    factory = {
+        ReportFormat.RICHTEXT: RichTextFormatter(options, cif),
+        ReportFormat.HTML    : HtmlFormatter(options, cif),
+        # 'plaintext': StringFormatter(),
+    }
+    return factory
+
+
+class TemplatedReport():
+    def __init__(self, format: ReportFormat, options: Options, cif: CifContainer) -> None:
+        self.format = format
+        self.cif = cif
+        self.options = options
+        self.text_formatter = text_factory(options, cif)[self.format]
+
+    def make_templated_docx_report(self,
+                                   output_filename: str,
+                                   picfile: Path,
+                                   template_path: Path) -> bool:
         tpl_doc = DocxTemplate(template_path)
-        context, tpl_doc = self.prepare_report_data(cif, options, picfile, tpl_doc)
+        context, tpl_doc = self.prepare_report_data(self.cif, self.options, picfile, tpl_doc)
         # Filter definition for {{foobar|filter}} things:
         jinja_env = jinja2.Environment()
         jinja_env.filters['inv_article'] = get_inf_article
@@ -544,20 +728,43 @@ class TemplatedReport():
                                  info_text=str(e))
             return False
 
-    def prepare_report_data(self, cif: CifContainer, options: Options, picfile: Path, tpl_doc: DocxTemplate):
+    def make_templated_html_report(self,
+                                   output_filename: str = 'test.html',
+                                   picfile: Path = None,
+                                   template_path: Path = Path('.'),
+                                   template_file: str = "report.tmpl") -> bool:
+        context = self.get_context(self.cif, self.options, picfile, None)
+        jinja_env = jinja2.Environment(loader=jinja2.FileSystemLoader(searchpath=template_path.resolve()),
+                                       autoescape=False)
+        jinja_env.filters['inv_article'] = get_inf_article
+        template = jinja_env.get_template(template_file)
+        try:
+            with open(output_filename, encoding='utf-8', mode='w+t') as f:
+                outputText = template.render(context)
+                f.write(outputText)
+        except Exception as e:
+            show_general_warning(parent=None, window_title='Warning', warn_text='Document generation failed',
+                                 info_text=str(e))
+            return False
+        return True
+
+    def prepare_report_data(self, cif: CifContainer,
+                            options: Options,
+                            picfile: Path,
+                            tpl_doc: DocxTemplate | None) -> tuple[dict[str, Any], DocxTemplate]:
         maincontext = {}
         if not cif.is_multi_cif:
-            maincontext = self._get_context(cif, options, picfile, tpl_doc)
+            maincontext = self.get_context(cif, options, picfile, tpl_doc)
         else:
             current_block = cif.block.name
             current_file = cif.fileobj
-            maincontext.update(self._get_context(cif, options, picfile, tpl_doc))
+            maincontext.update(self.get_context(cif, options, picfile, tpl_doc))
             block_list = []
             blocks = {}
             for block in cif.doc:
                 cif2 = CifContainer(file=current_file)
                 cif2.load_block_by_name(block.name)
-                context = self._get_context(cif2, options, picfile, tpl_doc)
+                context = self.get_context(cif2, options, picfile, tpl_doc)
                 block_list.append(context)
                 blocks[block.name] = context
             maincontext['blocklist'] = block_list
@@ -565,20 +772,17 @@ class TemplatedReport():
             cif.load_block_by_name(current_block)
         return maincontext, tpl_doc
 
-    def _get_context(self, cif: CifContainer, options: Options, picfile: Path, tpl_doc: DocxTemplate):
-        ba = BondsAndAngles(cif, without_h=options.without_h)
-        t = TorsionAngles(cif, without_h=options.without_h)
-        h = HydrogenBonds(cif)
+    def get_context(self, cif: CifContainer, options: Options, picfile: Path, tpl_doc: DocxTemplate = None):
         context = {'options'                : options,
-                   # {'without_h': True, 'atoms_table': True, 'text': True, 'bonds_table': True},
                    'cif'                    : cif,
                    'name'                   : cif.block.name,
-                   'space_group'            : self.space_group_subdoc(tpl_doc, cif),
-                   'structure_figure'       : self.make_picture(options, picfile, tpl_doc),
-                   'crystallization_method' : self.get_crystallization_method(cif),
-                   'sum_formula'            : self.format_sum_formula(
+                   'space_group'            : self.text_formatter.space_group_subdoc(cif, tpl_doc),
+                   'structure_figure'       : self.text_formatter.make_picture(options, picfile, tpl_doc),
+                   '3d_structure'           : self.text_formatter.make_3d(cif, options),
+                   'crystallization_method' : self.text_formatter.get_crystallization_method(cif),
+                   'sum_formula'            : self.text_formatter.format_sum_formula(
                        cif['_chemical_formula_sum'].replace(" ", "")),
-                   'moiety_formula'         : self.format_sum_formula(
+                   'moiety_formula'         : self.text_formatter.format_sum_formula(
                        cif['_chemical_formula_moiety'].replace(" ", "")),
                    'itnum'                  : cif['_space_group_IT_number'],
                    'crystal_size'           : this_or_quest(cif['_exptl_crystal_size_min']) + timessym +
@@ -586,9 +790,9 @@ class TemplatedReport():
                                               this_or_quest(cif['_exptl_crystal_size_max']),
                    'crystal_colour'         : this_or_quest(cif['_exptl_crystal_colour']),
                    'crystal_shape'          : this_or_quest(cif['_exptl_crystal_description']),
-                   'radiation'              : self.get_radiation(cif),
+                   'radiation'              : self.text_formatter.get_radiation(cif),
                    'wavelength'             : cif['_diffrn_radiation_wavelength'],
-                   'theta_range'            : self.get_from_to_theta_range(cif),
+                   'theta_range'            : self.text_formatter.get_from_to_theta_range(cif),
                    'diffr_type'             : gstr(cif['_diffrn_measurement_device_type'])
                                               or '[No measurement device type given]',
                    'diffr_device'           : gstr(cif['_diffrn_measurement_device'])
@@ -600,47 +804,82 @@ class TemplatedReport():
                    'detector'               : gstr(cif['_diffrn_detector_type']) \
                                               or '[No detector type given]',
                    'lowtemp_dev'            : MachineType._get_cooling_device(cif),
-                   'index_ranges'           : self.hkl_index_limits(cif),
+                   'index_ranges'           : self.text_formatter.hkl_index_limits(cif),
                    'indepentent_refl'       : this_or_quest(cif['_reflns_number_total']),
                    'r_int'                  : this_or_quest(cif['_diffrn_reflns_av_R_equivalents']),
                    'r_sigma'                : this_or_quest(cif['_diffrn_reflns_av_unetI/netI']),
-                   'completeness'           : self.get_completeness(cif),
+                   'completeness'           : self.text_formatter.get_completeness(cif),
                    'theta_full'             : cif['_diffrn_reflns_theta_full'],
                    'data'                   : this_or_quest(cif['_refine_ls_number_reflns']),
                    'restraints'             : this_or_quest(cif['_refine_ls_number_restraints']),
                    'parameters'             : this_or_quest(cif['_refine_ls_number_parameters']),
                    'goof'                   : this_or_quest(cif['_refine_ls_goodness_of_fit_ref']),
-                   't_min'                  : self._tvalue(this_or_quest(cif['_exptl_absorpt_correction_T_min'])),
-                   't_max'                  : self._tvalue(this_or_quest(cif['_exptl_absorpt_correction_T_max'])),
+                   't_min'                  : self.text_formatter._tvalue(
+                       this_or_quest(cif['_exptl_absorpt_correction_T_min'])),
+                   't_max'                  : self.text_formatter._tvalue(
+                       this_or_quest(cif['_exptl_absorpt_correction_T_max'])),
                    'ls_R_factor_gt'         : this_or_quest(cif['_refine_ls_R_factor_gt']),
                    'ls_wR_factor_gt'        : this_or_quest(cif['_refine_ls_wR_factor_gt']),
                    'ls_R_factor_all'        : this_or_quest(cif['_refine_ls_R_factor_all']),
                    'ls_wR_factor_ref'       : this_or_quest(cif['_refine_ls_wR_factor_ref']),
-                   'diff_dens_min'          : self.get_diff_density_min(cif).replace('-', minus_sign),
-                   'diff_dens_max'          : self.get_diff_density_max(cif).replace('-', minus_sign),
-                   'exti'                   : self.get_exti(cif),
-                   'flack_x'                : self.get_flackx(cif),
-                   'integration_progr'      : self.get_integration_program(cif),
+                   'diff_dens_min'          : self.text_formatter.get_diff_density_min(cif).replace('-', minus_sign),
+                   'diff_dens_max'          : self.text_formatter.get_diff_density_max(cif).replace('-', minus_sign),
+                   'exti'                   : self.text_formatter.get_exti(cif),
+                   'flack_x'                : self.text_formatter.get_flackx(cif),
+                   'integration_progr'      : self.text_formatter.get_integration_program(cif),
                    'abstype'                : gstr(cif['_exptl_absorpt_correction_type']) or '??',
-                   'abs_details'            : self.get_absortion_correction_program(cif),
-                   'solution_method'        : self.solution_method(cif),
-                   'solution_program'       : self.solution_program(cif),
+                   'abs_details'            : self.text_formatter.get_absortion_correction_program(cif),
+                   'solution_method'        : self.text_formatter.solution_method(cif),
+                   'solution_program'       : self.text_formatter.solution_program(cif),
                    'refinement_details'     : ' '.join(
                        cif['_refine_special_details'].splitlines(keepends=False)).strip(),
-                   'refinement_prog'        : self.refinement_prog(cif),
-                   'atomic_coordinates'     : self.get_atomic_coordinates(cif),
-                   'displacement_parameters': self.get_displacement_parameters(cif),
-                   'bonds'                  : ba.bonds,
-                   'angles'                 : ba.angles,
-                   'ba_symminfo'            : ba.symminfo,
-                   'torsions'               : t.torsion_angles,
-                   'torsion_symminfo'       : t.symminfo,
-                   'hydrogen_bonds'         : h.hydrogen_bonds,
-                   'hydrogen_symminfo'      : h.symminfo,
-                   'literature'             : self.literature
+                   'refinement_prog'        : self.text_formatter.refinement_prog(cif),
+                   'atomic_coordinates'     : self.text_formatter.get_atomic_coordinates(cif),
+                   'displacement_parameters': self.text_formatter.get_displacement_parameters(cif),
+                   'bonds'                  : self.text_formatter.get_bonds(),
+                   'angles'                 : self.text_formatter.get_angles(),
+                   'ba_symminfo'            : self.text_formatter.get_bonds_angles_symminfo(),
+                   'torsions'               : self.text_formatter.get_torsion_angles(),
+                   'torsion_symminfo'       : self.text_formatter.get_torsion_symminfo(),
+                   'hydrogen_bonds'         : self.text_formatter.get_hydrogen_bonds(),
+                   'hydrogen_symminfo'      : self.text_formatter.get_hydrogen_symminfo(),
+                   'literature'             : self.text_formatter.literature,
+                   'bootstrap_css'          : Path('finalcif/template/bootstrap/bootstrap.min.css').read_text(
+                       encoding='utf-8'),
                    }
         return context
 
 
 if __name__ == '__main__':
-    pass
+    import subprocess
+
+    data = Path('tests')
+    testcif = Path(data / 'examples/1979688.cif').absolute()
+    # testcif = Path(r'test-data/p31c.cif').absolute()
+    cif = CifContainer(testcif)
+
+    pic = pathlib.Path("screenshots/finalcif_checkcif.png")
+
+    options = Options()
+    # Set options with leading underscore without settings parameter in Options:
+    # options._bonds_table = True
+    # options._report_adp = True
+    # options._without_h = True
+    # options._report_text = False
+    # options._hydrogen_bonds = True
+    # options._picture_width = '300'
+
+    t = TemplatedReport(format=ReportFormat.HTML, options=options, cif=cif)
+    work = Path('work').resolve()
+    work.mkdir(exist_ok=True)
+    output = work / 'test.html'
+    template_path = app_path.application_path / 'template'
+    ok = t.make_templated_html_report(output_filename=str(output), picfile=pic, template_path=template_path)
+    if ok:
+        print('HTML report successfully generated')
+    else:
+        print('HTML report failed')
+    if sys.platform == 'darwin':
+        subprocess.call(['open', output])
+    else:
+        subprocess.Popen(['explorer', output], shell=True)
diff -pruN 134+dfsg-1/finalcif/template/machines/D8_VENTURE.cif 137+dfsg-1/finalcif/template/machines/D8_VENTURE.cif
--- 134+dfsg-1/finalcif/template/machines/D8_VENTURE.cif	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/finalcif/template/machines/D8_VENTURE.cif	2024-04-19 19:04:23.000000000 +0000
@@ -0,0 +1,16 @@
+data_D8__VENTURE
+_diffrn_ambient_environment       N~2~
+_diffrn_radiation_monochromator   'mirror optics'
+_diffrn_measurement_ambient_temperature_device_make 'Oxford Cryostream 800'
+_diffrn_radiation_probe           x-ray
+_diffrn_source                    'microfocus sealed X-ray tube'
+_diffrn_source_type               'Incoatec I\ms'
+_diffrn_source_voltage            50
+_diffrn_source_current            1.40
+_diffrn_detector                  CPAD
+_diffrn_detector_type             'Bruker PHOTON III'
+_diffrn_detector_area_resol_mean  7.41
+_diffrn_measurement_device        'three-circle diffractometer'
+_diffrn_measurement_device_type   'Bruker D8 VENTURE dual wavelength Mo/Cu'
+_diffrn_measurement_method        '\w and \f scans'
+_diffrn_measurement_specimen_support 'MiTeGen micromount'
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/template/report.tmpl 137+dfsg-1/finalcif/template/report.tmpl
--- 134+dfsg-1/finalcif/template/report.tmpl	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/finalcif/template/report.tmpl	2024-04-19 19:04:23.000000000 +0000
@@ -0,0 +1,523 @@
+<!DOCTYPE html>
+<html lang="en">
+<head>
+    <meta charset="UTF-8">
+    <meta name="viewport" content="width=device-width, initial-scale=0.8">
+    <title>Structure Tables</title>
+    {# <link href="bootstrap.min.css" rel="stylesheet">  #}
+    <style>
+        #bibliography {
+            list-style-type: none;
+            padding-left: 0;
+        }
+
+        #residuals_table_header {
+            margin-top: 4rem;
+        }
+
+        #report_text {
+            text-align: justify;
+        }
+
+        h2 {
+            margin-top: 4rem;
+        }
+
+        h3 {
+            margin-top: 3rem;
+        }
+
+        h4 {
+            margin-top: 3rem;
+        }
+
+        img {
+            border-radius: 6px;
+        / / padding: 1 px;
+        }
+    </style>
+    <style>
+        {{ bootstrap_css }}
+    </style>
+</head>
+
+<body>
+<div class="container">
+
+    <div class="row">
+        {% if options.report_text %}
+            <div class="col">
+        {% else %}
+            <div class="col-5">
+        {% endif %}
+
+        <h2>Crystal Structure Report for {{ cif.block.name }}</h2>
+        {% if options.report_text %}
+
+            {% if structure_figure %}
+                <div class="card w-90 mt-4 mb-4">
+                    <!--suppress HtmlUnknownTarget -->
+                    <img alt="Structure Figure" src="{{ structure_figure }}" width="100%">
+                </div>
+            {% endif %}
+
+            <p id="report_text">
+                A {{ crystal_colour }}, {{ crystal_shape }} shaped crystal was mounted on
+                a {{ cif._diffrn_measurement_specimen_support }}
+                with perfluoroether oil. {{ crystallization_method }}. Data for {{ cif.block.name }}
+                were collected from a shock-cooled single crystal at {{ cif._diffrn_ambient_temperature }}&nbsp;K
+                on {{ diffr_type|inv_article }}
+                {{ diffr_type }} {{ diffr_device }} with {{ diffr_source|inv_article }} {{ diffr_source }}
+                using a {{ monochromator }} as monochromator and {{ detector|inv_article }} {{ detector }}
+                detector. The diffractometer
+                {% if lowtemp_dev %}was equipped with {{ lowtemp_dev|inv_article }} {{ lowtemp_dev }}
+                    low temperature device and
+                {% endif %}
+                used {{ radiation }} radiation {% if wavelength %}(λ = {{ wavelength }} Å){% endif %}.
+                All data were integrated with {{ integration_progr }} yielding {{ cif._diffrn_reflns_number }}
+                reflections of which {{ cif._reflns_number_total }} where independent and
+                {{ '%0.1f'| format((cif._reflns_number_gt|float() / cif._reflns_number_total|float()) * 100) }} %
+                were greater than 2σ(<i>F</i><sup>2</sup>).<sup>[1]</sup> A
+                {{ abstype }} absorption correction using {{ abs_details }} was applied.<sup>[2]</sup>
+                The structure was solved by
+                {{ solution_method }} methods with {{ solution_program }} and refined by full-matrix
+                least-squares methods against
+                <i>F</i><sup>2</sup> using {{ refinement_prog }}.<sup>[3,4]</sup> All non-hydrogen atoms
+                were refined with anisotropic displacement parameters.
+                {% if cif.hydrogen_atoms_present %}The hydrogen atoms were refined isotropically on
+                    calculated positions using a riding model with their <i>U</i><sub>iso</sub> values
+                    constrained to 1.5 times
+                    the <i>U</i><sub>eq</sub> of their pivot atoms for terminal sp<sup>3</sup> carbon atoms
+                    and 1.2 times for all other carbon atoms.
+                {% endif %}
+                Crystallographic data for the structures reported in this paper have been deposited
+                with the Cambridge Crystallographic Data Centre.<sup>[5]</sup> CCDC
+                {% if cif._database_code_depnum_ccdc_archive %}
+                    {{ cif._database_code_depnum_ccdc_archive|replace('CCDC ', '') }}{% else %}
+                    ??????
+                {% endif %}
+                contain the supplementary crystallographic data for this paper.
+                These data can be obtained free of charge from The Cambridge Crystallographic Data
+                Centre via <a href="www.ccdc.cam.ac.uk/structures">www.ccdc.cam.ac.uk/structures</a>.
+                This report and the CIF file were generated using FinalCif.<sup>[6]</sup>
+            </p>
+            {% if refinement_details %}
+                <h4>
+                    Refinement details for {{ cif.block.name }}
+                </h4>
+                <p>
+                    {{ refinement_details }}
+                </p>
+            {% endif %}
+        {% endif %}
+        {% if options.report_text %}
+            </div>
+            <div class="col-1">
+                {# Just an empty column to separate the other  #}
+            </div>
+            <div class="col">
+        {% endif %}
+        <h4 id="residuals_table_header">
+            Table 1. Crystal data and structure refinement for {{ cif.block.name }}
+        </h4>
+        <table class="table table-sm table-condensed table-hover">
+            <tbody>
+            <tr>
+                <td>CCDC number</td>
+                <td>{{ cif._database_code_depnum_ccdc_archive }}</td>
+            </tr>
+            <tr>
+                <td>Empirical formula</td>
+                <td>{{ sum_formula }}</td>
+            </tr>
+            <tr>
+                <td>Formula weight</td>
+                <td>{{ cif._chemical_formula_weight }}</td>
+            </tr>
+            <tr>
+                <td>Temperature [K]</td>
+                <td>{{ cif._diffrn_ambient_temperature }}</td>
+            </tr>
+            <tr>
+                <td>Crystal system</td>
+                <td>{{ cif._space_group_crystal_system }}</td>
+            </tr>
+            <tr>
+                <td>Space group (number)</td>
+                <td>{{ space_group }}</td>
+            </tr>
+            <tr>
+                <td><i>a</i> [Å]</td>
+                <td>{{ cif._cell_length_a }}</td>
+            </tr>
+            <tr>
+                <td><i>b</i> [Å]</td>
+                <td>{{ cif._cell_length_b }}</td>
+            </tr>
+            <tr>
+                <td><i>c</i> [Å]</td>
+                <td>{{ cif._cell_length_c }}</td>
+            </tr>
+            <tr>
+                <td><i>α</i> [°]</td>
+                <td>{{ cif._cell_angle_alpha }}</td>
+            </tr>
+            <tr>
+                <td><i>β</i> [°]</td>
+                <td>{{ cif._cell_angle_beta }}</td>
+            </tr>
+            <tr>
+                <td><i>γ</i> [°]</td>
+                <td>{{ cif._cell_angle_gamma }}</td>
+            </tr>
+            <tr>
+                <td>Volume [Å<sup>3</sup>]</td>
+                <td>{{ cif._cell_volume }}</td>
+            </tr>
+            <tr>
+                <td><i>Z</i></td>
+                <td>{{ cif._cell_formula_units_Z }}</td>
+            </tr>
+            <tr>
+                <td><i>ρ</i><sub>calc</sub> [gcm<sup>&minus;3</sup>]</td>
+                <td>{{ cif._exptl_crystal_density_diffrn }}</td>
+            </tr>
+            <tr>
+                <td><i>μ</i> [mm<sup>&minus;1</sup>]</td>
+                <td>{{ cif._exptl_absorpt_coefficient_mu }}</td>
+            </tr>
+            <tr>
+                <td><i>F</i>(000)</td>
+                <td>{{ cif._exptl_crystal_F_000 }}</td>
+            </tr>
+            <tr>
+                <td>Crystal size [mm<sup>3</sup>]</td>
+                <td>{{ crystal_size }}</td>
+            </tr>
+            <tr>
+                <td>Crystal colour</td>
+                <td>{{ crystal_colour }}</td>
+            </tr>
+            <tr>
+                <td>Crystal shape</td>
+                <td>{{ crystal_shape }}</td>
+            </tr>
+            <tr>
+                <td>Radiation</td>
+                <td>{{ radiation }}{% if wavelength %} (λ={{ wavelength }}&nbsp;Å){% endif %}</td>
+            </tr>
+            <tr>
+                <td>2θ range [°]</td>
+                <td>{{ theta_range }}</td>
+            </tr>
+            <tr>
+                <td>Index ranges</td>
+                <td>{{ index_ranges }}</td>
+            </tr>
+            <tr>
+                <td>Reflections collected</td>
+                <td>{{ cif._diffrn_reflns_number }}</td>
+            </tr>
+            <tr>
+                <td>Independent reflections</td>
+                <td>{{ indepentent_refl }}<br>
+                    Rint = {{ r_int }}<br>
+                    Rsigma = {{ r_sigma }}
+                </td>
+            </tr>
+            <tr>
+                <td>Completeness{% if theta_full %} to
+                    θ = {{ theta_full }}°{% endif %}
+                </td>
+                <td>{{ completeness }}</td>
+            </tr>
+            <tr>
+                <td>Data / Restraints / Parameters</td>
+                <td>{{ data }} / {{ restraints }} / {{ parameters }}</td>
+            </tr>
+            <tr>
+                <td>Absorption correction Tmin/Tmax (method)
+                </td>
+                <td>{{ t_min }} / {{ t_max }} {% if abstype %}({{ abstype }}){% endif %}</td>
+            </tr>
+            <tr>
+                <td>Goodness-of-fit on <i>F</i><sup>2</sup></td>
+                <td>{{ goof }}</td>
+            </tr>
+            <tr>
+                <td>Final R indexes<br>
+                    [I≥2σ(I)]
+                </td>
+                <td><i>R</i><sub>1</sub> = {{ ls_R_factor_gt }}<br>
+                    w<i>R</i><sub>2</sub> = {{ ls_wR_factor_gt }}
+                </td>
+            </tr>
+            <tr>
+                <td>Final R indexes<br>
+                    [all data]
+
+                </td>
+                <td><i>R</i><sub>1</sub> = {{ ls_R_factor_all }}<br>
+                    w<i>R</i><sub>2</sub> = {{ ls_wR_factor_ref }}
+                </td>
+            </tr>
+            <tr>
+                <td>Largest peak/hole [eÅ<sup>&minus;3</sup>]</td>
+                <td>{{ diff_dens_max }}/{{ diff_dens_min }}</td>
+            </tr>
+            {% if exti %}
+                <tr>
+                    <td>Extinction coefficient</td>
+                    <td>{{ exti }}</td>
+                </tr>
+            {% endif %}
+            {% if flack_x %}
+                <tr>
+                    <td>Flack X parameter</td>
+                    <td>{{ flack_x }}</td>
+                </tr>
+            {% endif %}
+            </tbody>
+        </table>
+        </div>
+        </div>
+
+        {% if atomic_coordinates %}
+            <h4>
+                Table 2. Atomic coordinates and <i>U</i><sub>eq</sub> [Å<sup>2</sup>]
+                for {{ cif.block.name }}
+            </h4>
+
+            <div class="row">
+                <div class="col-8">
+                    <table class="table table-sm table-condensed table-hover">
+                        <caption><i>U</i><sub>eq</sub> is defined as 1/3 of the trace of the orthogonalized
+                            <i>U</i><sub>ij</sub> tensor.
+                        </caption>
+                        <thead>
+                        <tr>
+                            <th>Atom</th>
+                            <th>x</th>
+                            <th>y</th>
+                            <th>z</th>
+                            <th><i>U</i><sub>eq</sub></th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                        {% for atom in atomic_coordinates %}
+                            <tr>
+                                <td>{{ atom.label }}</td>
+                                <td>{{ atom.x }}</td>
+                                <td>{{ atom.y }}</td>
+                                <td>{{ atom.z }}</td>
+                                <td>{{ atom.u_eq }}</td>
+                            </tr>
+                        {% endfor %}
+                        </tbody>
+                    </table>
+                </div>
+            </div>
+        {% endif %}
+
+
+        {% if displacement_parameters and options.report_adp %}
+            <h4>
+                Table 3. Anisotropic displacement parameters [Å<sup>2</sup>] for {{ cif.block.name }}.
+                The anisotropic displacement factor exponent takes the form:
+                −2π<sup>2</sup>[&thinsp;<i>h</i><sup>2</sup>(<i>a</i><sup>*</sup>)<sup>2</sup><i>U</i><sub>11</sub>&thinsp;+&thinsp;<i>k</i><sup>2</sup>(<i>b</i><sup>*</sup>)<sup>2</sup><i>U</i><sub>22</sub>&thinsp;+&thinsp;…&thinsp;+&thinsp;2<i>hka</i><sup>*</sup><i>b</i><sup>*</sup><i>U</i><sub>12</sub>&thinsp;]
+            </h4>
+
+            <div class="row">
+                <div class="col-8">
+                    <table class="table table-sm table-condensed table-hover">
+                        <caption><i>U</i><sub>eq</sub> is defined as 1/3 of the trace of the orthogonalized
+                            <i>U</i><sub>ij</sub> tensor.
+                        </caption>
+                        <thead>
+                        <tr>
+                            <th>Atom</th>
+                            <th><i>U</i><sub>11</sub></th>
+                            <th><i>U</i><sub>22</sub></th>
+                            <th><i>U</i><sub>33</sub></th>
+                            <th><i>U</i><sub>23</sub></th>
+                            <th><i>U</i><sub>13</sub></th>
+                            <th><i>U</i><sub>12</sub></th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                        {% for atom in displacement_parameters %}
+                            <tr>
+                                <td>{{ atom.label }}</td>
+                                <td>{{ atom.U11 }}</td>
+                                <td>{{ atom.U22 }}</td>
+                                <td>{{ atom.U33 }}</td>
+                                <td>{{ atom.U23 }}</td>
+                                <td>{{ atom.U13 }}</td>
+                                <td>{{ atom.U12 }}</td>
+                            </tr>
+                        {% endfor %}
+                        </tbody>
+                    </table>
+                </div>
+            </div>
+        {% endif %}
+
+        <div class="row justify-content-start">
+            <div class="col-5">
+                {# {% if options.bonds_table %} #}
+                {% if bonds %}
+                    <h4>
+                        Table 4. Bond lengths and angles for {{ cif.block.name }}
+                    </h4>
+                    <table class="table table-sm table-condensed table-hover">
+                        <caption>
+                            {% if ba_symminfo %}
+                                {{ ba_symminfo }}
+                            {% endif %}
+                            {% if options.without_h %}
+                                Bonds and angles to hydrogen atoms were omitted.
+                            {% endif %}
+                        </caption>
+                        <thead>
+                        <tr>
+                            <th>Atom–Atom</th>
+                            <th>Length [Å]</th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                        {% for b in bonds %}
+                            <tr>
+                                <td>{{ b.atoms }}<sup>{{ b.symm }}</sup></td>
+                                <td>{{ b.dist }}</td>
+                            </tr>
+                        {% endfor %}
+                        <tr>
+                            <td></td>
+                            <td></td>
+                        </tr>
+                        <tr>
+                            <th>
+                                Atom–Atom–Atom
+                            </th>
+                            <th>
+                                Angle [°]
+                            </th>
+                        </tr>
+                        {% for a in angles %}
+                            <tr>
+                                <td>{{ a.atom1 }}<sup>{{ a.symm1 }}</sup>{{ a.atom2 }}<sup>{{ a.symm2 }}</sup>
+                                </td>
+                                <td>{{ a.angle }}</td>
+                            </tr>
+                        {% endfor %}
+                        </tbody>
+                    </table>
+                {% endif %}
+                {# {% endif %} #}
+            </div>
+            <div class="col-1">
+                {# Just an empty column to separate the other  #}
+            </div>
+            <div class="col-5">
+                {% if torsions %}
+                    <h4>
+                        Table 5. Torsion angles for {{ cif.block.name }}
+                    </h4>
+                    <table class="table table-sm table-condensed table-hover">
+                        <caption>
+                            {% if torsion_symminfo %}
+                                {{ torsion_symminfo }}
+                            {% endif %}
+                            {% if options.without_h %}
+                                Bonds and angles to hydrogen atoms were omitted.
+                            {% endif %}
+                        </caption>
+                        <thead>
+                        <tr>
+                            <th>Atom–Atom–Atom–Atom</th>
+                            <th>Torsion Angle [°]</th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                        {% for t in torsions %}
+                            <tr>
+                                <td>
+                                    {{ t.atom1 }}<sup>{{ t.symm1 }}</sup>&ndash;{{ t.atom2 }}<sup>{{ t.symm2 }}</sup>&ndash;{{ t.atom3 }}<sup>{{ t.symm3 }}</sup>&ndash;{{ t.atom4 }}<sup>{{ t.symm4 }}</sup>
+                                </td>
+                                <td>
+                                    {{ t.angle }}
+                                </td>
+                            </tr>
+                        {% endfor %}
+                        </tbody>
+                    </table>
+                {% endif %}
+            </div>
+        </div>
+
+        {% if options.hydrogen_bonds and hydrogen_bonds %}
+            <h4>
+                Table 6. Hydrogen bonds for {{ cif.block.name }}
+            </h4>
+
+            <div class="row">
+                <div class="col-9">
+                    <table class="table table-sm table-condensed table-hover">
+                        <caption>
+                            {% if hydrogen_symminfo %}
+                                {{ hydrogen_symminfo }}
+                            {% endif %}
+                        </caption>
+                        <thead>
+                        <tr>
+                            <th>D–H⋯A [Å]</th>
+                            <th>d(D–H) [Å]</th>
+                            <th> d(H⋯A) [Å]</th>
+                            <th>d(D⋯A) [Å]</th>
+                            <th><(DHA) [°]</th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                        {% for h in hydrogen_bonds %}
+                            <tr>
+                                <td>
+                                    {{ h.atoms }}
+                                </td>
+                                <td>
+                                    {{ h.dist_dh }}
+                                </td>
+                                <td>
+                                    {{ h.dist_ha }}
+                                </td>
+                                <td>
+                                    {{ h.dist_da }}
+                                </td>
+                                <td>
+                                    {{ h.angle_dha }}
+                                </td>
+                            </tr>
+                        {% endfor %}
+                        </tbody>
+                    </table>
+                </div>
+            </div>
+        {% endif %}
+
+        <h4>
+            Bibliography
+        </h4>
+
+        <ol id="bibliography">
+            <li>[1] {{ literature.integration.html }}</li>
+            <li>[2] {{ literature.absorption.html }}</li>
+            <li>[3] {{ literature.solution.html }}</li>
+            <li>[4] {{ literature.refinement.html }}</li>
+            <li>[5] {{ literature.ccdc.html }}</li>
+            <li>[6] {{ literature.finalcif.html }}</li>
+        </ol>
+
+
+    </div>
+</div>
+</body>
+</html>
\ No newline at end of file
diff -pruN 134+dfsg-1/finalcif/template/templates.py 137+dfsg-1/finalcif/template/templates.py
--- 134+dfsg-1/finalcif/template/templates.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/template/templates.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,17 +1,16 @@
+from __future__ import annotations
 from contextlib import suppress
 from pathlib import Path
 from typing import List
+from typing import TYPE_CHECKING
 
 from PyQt5.QtCore import Qt
 from PyQt5.QtGui import QColor
 from PyQt5.QtWidgets import QFileDialog, QListWidgetItem
 
-from typing import TYPE_CHECKING
-
 if TYPE_CHECKING:
     from finalcif.appwindow import AppWindow
-
-from finalcif.tools.settings import FinalCifSettings
+    from finalcif.tools.settings import FinalCifSettings
 
 
 class ReportTemplates:
@@ -19,7 +18,7 @@ class ReportTemplates:
     Displays the list of report templates in the options menu.
     """
 
-    def __init__(self, app: 'AppWindow', settings: FinalCifSettings):
+    def __init__(self, app: AppWindow, settings: FinalCifSettings):
         self.app = app
         self.settings = settings
         self.lw = self.app.ui.docxTemplatesListWidget
@@ -33,16 +32,17 @@ class ReportTemplates:
 
     def add_new_template(self, templ_path: str = '') -> None:
         if not templ_path:
-            templ_path, _ = QFileDialog.getOpenFileName(filter="DOCX file (*.docx)", initialFilter="DOCX file (*.docx)",
-                                                        caption='Open a Report Template File')
+            templ_path, _ = QFileDialog.getOpenFileName(filter="DOCX file (*.docx);; html file (*.html *.tmpl)",
+                                                        initialFilter="DOCX file (*.docx)",
+                                                        caption='Open a Report Template File', parent=self.app)
         itemslist = self.get_templates_list_from_widget()
         self.app.status_bar.show_message('')
         if templ_path in itemslist:
             self.app.status_bar.show_message('This templates is already in the list.', 10)
             print('This templates is already in the list.')
             return
-        if not Path(templ_path).exists() or not Path(templ_path).is_file() \
-                or not Path(templ_path).name.endswith('.docx'):
+        if (not Path(templ_path).exists() or not Path(templ_path).is_file()
+                or not Path(templ_path).suffix in ('.docx', '.html', '.tmpl')):
             self.app.status_bar.show_message('This template does not exist or is unreadable.', 10)
             print('This template does not exist or is unreadable.', Path(templ_path).resolve())
             return
diff -pruN 134+dfsg-1/finalcif/tools/misc.py 137+dfsg-1/finalcif/tools/misc.py
--- 134+dfsg-1/finalcif/tools/misc.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/tools/misc.py	2024-04-19 19:04:23.000000000 +0000
@@ -260,6 +260,8 @@ def make_numbered(items):
 
 # '_space_group_centring_type',  # seems to be used nowere
 # '_exptl_absorpt_special_details',   # This is not official?!?
+
+# These keywords will end up in the CIF in any case:
 essential_keys = (
     # '_atom_sites_solution_secondary'
     # '_diffrn_measurement_specimen_adhesive'
@@ -298,10 +300,10 @@ essential_keys = (
     '_computing_data_collection',
     '_computing_data_reduction',
     '_computing_molecular_graphics',
-    '_computing_publication_material',
+    #'_computing_publication_material',
     '_computing_structure_refinement',
     '_computing_structure_solution',
-    '_diffrn_ambient_environment',
+    #'_diffrn_ambient_environment',
     '_diffrn_ambient_temperature',
     '_diffrn_detector',
     '_diffrn_detector_area_resol_mean',
diff -pruN 134+dfsg-1/finalcif/tools/options.py 137+dfsg-1/finalcif/tools/options.py
--- 134+dfsg-1/finalcif/tools/options.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/tools/options.py	2024-04-19 19:04:23.000000000 +0000
@@ -5,7 +5,11 @@ from finalcif.tools.settings import Fina
 
 
 class Options:
-    def __init__(self, ui: Ui_FinalCifWindow, settings: FinalCifSettings):
+    def __init__(self, ui: Ui_FinalCifWindow = None, settings: FinalCifSettings = None):
+        """
+        :param ui: UI of FinalCif
+        :param settings: Settings of FinalCif
+        """
         self.ui = ui
         self.settings = settings
         # initial default, otherwise we have width=0.0 and no picture visible:
@@ -64,9 +68,14 @@ class Options:
         return self.settings.load_options()[item]
 
     def _get_setting(self, setting: str, default: object):
-        with suppress(KeyError):
+        try:
             return self.settings.load_options()[setting]
-        return default
+        except KeyError:
+            return default
+        except AttributeError:
+            # Be able to set op._without_h = True and get its value without having settings attribute.
+            # Only for debugging!
+            return getattr(self, f'_{setting}', default)
 
     @property
     def report_text(self) -> bool:
@@ -110,7 +119,8 @@ class Options:
 
     def set_default_checkcif_url(self):
         url = 'https://checkcif.iucr.org/cgi-bin/checkcif_hkl.pl'
-        self.ui.CheckCIFServerURLTextedit.setText(url)
+        if self.ui:
+            self.ui.CheckCIFServerURLTextedit.setText(url)
         return url
 
     @property
@@ -126,5 +136,6 @@ class Options:
 
     def set_default_cod_url(self):
         url = 'https://www.crystallography.net/cod/cgi-bin/cif-deposit.pl'
-        self.ui.CODURLTextedit.setText(url)
+        if self.ui:
+            self.ui.CODURLTextedit.setText(url)
         return url
diff -pruN 134+dfsg-1/finalcif/tools/platon.py 137+dfsg-1/finalcif/tools/platon.py
--- 134+dfsg-1/finalcif/tools/platon.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/tools/platon.py	2024-04-19 19:04:23.000000000 +0000
@@ -5,6 +5,7 @@ import threading
 import time
 from contextlib import suppress
 from pathlib import Path
+from shutil import which
 
 from PyQt5 import QtCore
 from PyQt5.QtWidgets import QApplication, QMainWindow, QPushButton, QVBoxLayout, QWidget, QLabel, \
@@ -30,7 +31,7 @@ class PlatonRunner(QtCore.QObject):
 
     def run_process(self):
         self._origdir = os.curdir
-        #os.chdir(self.cif_file.parent)
+        # os.chdir(self.cif_file.parent)
         self.formula_moiety = ''
         self.Z = ''
         self.process = QtCore.QProcess()
@@ -44,7 +45,7 @@ class PlatonRunner(QtCore.QObject):
 
     def _onfinished(self):
         self._on_ready_read()
-        #os.chdir(self._origdir)
+        # os.chdir(self._origdir)
         self._parse_chk_file()
         self.output_widget.setPlainText(self.chk_file_text)
         self.finished.emit(True)
@@ -69,7 +70,7 @@ class PlatonRunner(QtCore.QObject):
 
     def _stop_program(self):
         self.is_stopped = True
-        #if self.process and self.process.state() == QProcess.Running:
+        # if self.process and self.process.state() == QProcess.Running:
         self.process.terminate()
         self.finished.emit(True)
 
@@ -87,13 +88,15 @@ class PlatonRunner(QtCore.QObject):
                 self.Z = line[19:24].strip(' ')
 
     @property
-    def platon_exe(self):
+    def platon_exe(self) -> str:
         if sys.platform.startswith('win'):
             in_pwt = r'C:\pwt\platon.exe'
         else:
             in_pwt = 'platon'
         if Path(in_pwt).exists():
             return in_pwt
+        elif which('platon'):
+            return which('platon')
         else:
             return 'platon'
 
diff -pruN 134+dfsg-1/finalcif/tools/settings.py 137+dfsg-1/finalcif/tools/settings.py
--- 134+dfsg-1/finalcif/tools/settings.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/tools/settings.py	2024-04-19 19:04:23.000000000 +0000
@@ -191,7 +191,9 @@ class FinalCifSettings():
             self.settings.beginGroup(property)
             try:
                 v = self.settings.value(item_name)
-            except TypeError:
+            except TypeError as e:
+                print(f"DBG> Item name '{item_name}' could not be loaded from settings.")
+                print(e)
                 v = None
             self.settings.endGroup()
             return v
diff -pruN 134+dfsg-1/finalcif/tools/space_groups.py 137+dfsg-1/finalcif/tools/space_groups.py
--- 134+dfsg-1/finalcif/tools/space_groups.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/finalcif/tools/space_groups.py	2024-04-19 19:04:23.000000000 +0000
@@ -65,8 +65,8 @@ class SpaceGroups():
     def to_html(self, space_group: str) -> str:
         if not space_group:
             return ''
-        txt = self._to_html_without_body(space_group)
-        return '<body style="">{} &thinsp;({})</body>'.format(txt, self.spgrps[space_group][1].get('itnumber'))
+        txt = self.to_html_without_body(space_group)
+        return f'<body style="">{txt} &thinsp;({self.spgrps[space_group][1].get("itnumber")})</body>'
 
     def to_plain_text(self, space_group: str) -> str:
         """
@@ -76,7 +76,7 @@ class SpaceGroups():
             return ''
         return ''.join([x[0] for x in self.spgrps[space_group][0]])
 
-    def _to_html_without_body(self, space_group: str) -> str:
+    def to_html_without_body(self, space_group: str) -> str:
         """
         Uses the general format dictionary in order to output a space group as html.
         """
diff -pruN 134+dfsg-1/scripts/_create_dist.bat 137+dfsg-1/scripts/_create_dist.bat
--- 134+dfsg-1/scripts/_create_dist.bat	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/scripts/_create_dist.bat	2024-04-19 19:04:23.000000000 +0000
@@ -3,7 +3,7 @@
 REM This script builds a working Python environment into ..\dist of the current file location.
 
 REM Set the Python version here:
-set PYTHON_VERSION=3.11.7
+set PYTHON_VERSION=3.11.8
 
 set PYTHON_URL=https://www.python.org/ftp/python/%PYTHON_VERSION%/python-%PYTHON_VERSION%-embed-amd64.zip
 
@@ -68,3 +68,5 @@ if %errorlevel% neq 0 (
 )
 
 cd %SCRIPT_DIR%\..
+
+python -m compile -q .
\ No newline at end of file
diff -pruN 134+dfsg-1/tests/test_loop_creator.py 137+dfsg-1/tests/test_loop_creator.py
--- 134+dfsg-1/tests/test_loop_creator.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_loop_creator.py	2024-04-19 19:04:23.000000000 +0000
@@ -74,7 +74,8 @@ class TestLoopCreator(unittest.TestCase)
         self.assertEqual(('<pre><h2>_atom_site_Cartn_x</h2> The atom-site coordinates in angstroms '
                           'specified according to a\n'
                           ' set of orthogonal Cartesian axes related to the cell axes as\n'
-                          ' specified by the _atom_sites_Cartn_transform_axes description.</pre>'),
+                          ' specified by the _atom_sites_Cartn_transform_axes description.</pre>\n'
+                          '<br><p><h4>Type:</h4> number (int or float)</p>'),
                          self.lc.availableKeysListWidget.item(2).toolTip())
 
     def test_save_to_cif(self):
diff -pruN 134+dfsg-1/tests/test_loops.py 137+dfsg-1/tests/test_loops.py
--- 134+dfsg-1/tests/test_loops.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_loops.py	2024-04-19 19:04:23.000000000 +0000
@@ -83,14 +83,24 @@ class TestLoops(unittest.TestCase):
     def test_loop_no_edit(self):
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('0.0181', c.loops[3].val(0, 2))
+        try:
+            val = c.loops[3].val(0, 2)
+        except AttributeError:
+            val = c.loops[3][0, 2]
+        self.assertEqual('0.0181', val)
 
     def test_loop_edit_one_single_field(self):
         model = self.myapp.ui.LoopsTabWidget.widget(self.get_index_of('Scattering')).model()
         model.setData(model.index(0, 2), 'foo bar', role=Qt.EditRole)
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('foo bar', as_string(c.loops[3].val(0, 2)))
+        try:
+            # gemmi pre-0.6.5:
+            result = as_string(c.loops[3].val(0, 2))
+        except AttributeError:
+            # gemmi post-0.6.5:
+            result = as_string(c.loops[3][0, 2])
+        self.assertEqual('foo bar', result)
 
 
 # noinspection PyMissingTypeHints
@@ -153,9 +163,14 @@ class TestLoopsMove(unittest.TestCase):
         view._row_down(None)
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
-        self.assertEqual('O', as_string(c.loops[3].val(1, 0)))
-        self.assertEqual('H', as_string(c.loops[3].val(2, 0)))
+        try:
+            self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
+            self.assertEqual('O', as_string(c.loops[3].val(1, 0)))
+            self.assertEqual('H', as_string(c.loops[3].val(2, 0)))
+        except AttributeError:
+            self.assertEqual('C', as_string(c.loops[3][0, 0]))
+            self.assertEqual('O', as_string(c.loops[3][1, 0]))
+            self.assertEqual('H', as_string(c.loops[3][2, 0]))
 
     def test_move_row_down_from_middle_save_and_load_again_for_angles(self):
         view = self.set_current_index_to_row_col(1, 0, tab='Angles')
@@ -178,9 +193,14 @@ class TestLoopsMove(unittest.TestCase):
         view._row_down(None)
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
-        self.assertEqual('H', as_string(c.loops[3].val(1, 0)))
-        self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        try:
+            self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
+            self.assertEqual('H', as_string(c.loops[3].val(1, 0)))
+            self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        except AttributeError:
+            self.assertEqual('C', as_string(c.loops[3][0, 0]))
+            self.assertEqual('H', as_string(c.loops[3][1, 0]))
+            self.assertEqual('O', as_string(c.loops[3][2, 0]))
 
     def test_move_row_up_from_middle(self):
         view = self.set_current_index_to_row_col(1, 0)
@@ -194,9 +214,14 @@ class TestLoopsMove(unittest.TestCase):
         view._row_up(None)
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('H', as_string(c.loops[3].val(0, 0)))
-        self.assertEqual('C', as_string(c.loops[3].val(1, 0)))
-        self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        try:
+            self.assertEqual('H', as_string(c.loops[3].val(0, 0)))
+            self.assertEqual('C', as_string(c.loops[3].val(1, 0)))
+            self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        except AttributeError:
+            self.assertEqual('H', as_string(c.loops[3][0, 0]))
+            self.assertEqual('C', as_string(c.loops[3][1, 0]))
+            self.assertEqual('O', as_string(c.loops[3][2, 0]))
 
     def test_move_row_up_from_start(self):
         view = self.set_current_index_to_row_col(0, 0)
@@ -210,6 +235,11 @@ class TestLoopsMove(unittest.TestCase):
         view._row_up(None)
         self.myapp.ui.SaveCifButton.click()
         c = CifContainer(self.myapp.cif.finalcif_file)
-        self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
-        self.assertEqual('H', as_string(c.loops[3].val(1, 0)))
-        self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        try:
+            self.assertEqual('C', as_string(c.loops[3].val(0, 0)))
+            self.assertEqual('H', as_string(c.loops[3].val(1, 0)))
+            self.assertEqual('O', as_string(c.loops[3].val(2, 0)))
+        except AttributeError:
+            self.assertEqual('C', as_string(c.loops[3][0, 0]))
+            self.assertEqual('H', as_string(c.loops[3][1, 0]))
+            self.assertEqual('O', as_string(c.loops[3][2, 0]))
diff -pruN 134+dfsg-1/tests/test_main_table.py 137+dfsg-1/tests/test_main_table.py
--- 134+dfsg-1/tests/test_main_table.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_main_table.py	2024-04-19 19:04:23.000000000 +0000
@@ -10,7 +10,6 @@ os.environ["RUNNING_TEST"] = 'True'
 import unittest
 from pathlib import Path
 
-import pytest
 from PyQt5.QtCore import Qt
 from PyQt5.QtGui import QColor
 
@@ -57,30 +56,16 @@ class TestMainTableFieldBehavior(unittes
 
     ######
 
-    def test_rowcounts(self):
-        self.assertEqual(139, self.myapp.ui.cif_main_table.rowCount())
-
     def test_delete_row(self):
+        rows = self.myapp.ui.cif_main_table.rowCount()
         self.myapp.ui.cif_main_table.delete_row(self.key_row('_audit_update_record'))
-        self.assertEqual(138, self.myapp.ui.cif_main_table.rowCount())
-
-    def test_delete_and_reappear(self):
-        self.assertEqual(139, self.myapp.ui.cif_main_table.rowCount())
-        self.myapp.ui.cif_main_table.delete_row(
-            self.myapp.ui.cif_main_table.row_from_key('_atom_sites_solution_primary'))
-        # One less than before:
-        self.assertEqual(138, self.myapp.ui.cif_main_table.rowCount())
-        # Line is deleted:
-        self.assertFalse('_atom_sites_solution_primary' in self.myapp.ui.cif_main_table.vheaderitems)
+        self.assertEqual(rows - 1, self.myapp.ui.cif_main_table.rowCount())
 
     def test_get_text_by_key(self):
         self.assertEqual('geom', self.cell_text('_atom_sites_solution_hydrogens', Column.CIF))
         self.assertEqual('', self.cell_text('_atom_sites_solution_hydrogens', Column.DATA))
         self.assertEqual('', self.cell_text('_atom_sites_solution_hydrogens', Column.EDIT))
 
-    def test_Crystallographer_in_equipment_list(self):
-        self.assertEqual('Crystallographer Details', self.myapp.ui.EquipmentTemplatesListWidget.item(1).text())
-
     def test_load_equipment(self):
         self.myapp.equipment.import_equipment_from_file(str(data.parent / 'test-data/Crystallographer_Details.cif'))
         # make sure contact author is selected
@@ -100,23 +85,10 @@ class TestMainTableFieldBehavior(unittes
         self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
                          str(self.myapp.ui.cif_main_table.widget_from_key('_atom_sites_solution_hydrogens',
                                                                           Column.CIF).__class__))
-
-    def test_combobox_field(self):
         self.assertEqual("<class 'finalcif.gui.combobox.MyComboBox'>",
                          str(self.myapp.ui.cif_main_table.widget_from_key('_atom_sites_solution_hydrogens',
                                                                           Column.EDIT).__class__))
 
-    def test_plaintextedit_field(self):
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
-                         str(self.myapp.ui.cif_main_table.widget_from_key('_audit_contact_author_address',
-                                                                          Column.CIF).__class__))
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
-                         str(self.myapp.ui.cif_main_table.widget_from_key('_audit_contact_author_address',
-                                                                          Column.DATA).__class__))
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
-                         str(self.myapp.ui.cif_main_table.widget_from_key('_audit_contact_author_address',
-                                                                          Column.EDIT).__class__))
-
     def test_multicif(self):
         self.assertEqual(False, self.myapp.cif.is_multi_cif)
         self.assertEqual(1, len(self.myapp.cif.doc))
diff -pruN 134+dfsg-1/tests/test_report_text.py 137+dfsg-1/tests/test_report_text.py
--- 134+dfsg-1/tests/test_report_text.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_report_text.py	2024-04-19 19:04:23.000000000 +0000
@@ -212,8 +212,9 @@ class TestTextParagraphs(unittest.TestCa
         }
         # noinspection PyTypeChecker
         DataReduction(cif, paragraph=self.paragraph, ref=self.reflist)
-        self.assertEqual(('All data were integrated with [unknown integration program] and a ?? '
-                          'absorption correction using [unknown program] was applied.[1,2]'), self.paragraph.text)
+        self.assertEqual(('All data were integrated with [No _computing_data_reduction given] and a ?? '
+                          'absorption correction using [Unknown scaling program] was applied.[1,2]'),
+                         self.paragraph.text)
         self.assertEqual(('[0] Unknown Reference, please add.\n'
                           '[1] Unknown Reference, please add.'), str(self.reflist))
 
diff -pruN 134+dfsg-1/tests/test_saint.py 137+dfsg-1/tests/test_saint.py
--- 134+dfsg-1/tests/test_saint.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_saint.py	2024-04-19 19:04:23.000000000 +0000
@@ -4,7 +4,6 @@
 #   this notice you can do whatever you want with this stuff. If we meet some day,
 #   and you think this stuff is worth it, you can buy me a beer in return.
 #   ----------------------------------------------------------------------------
-import os
 import unittest
 from pathlib import Path
 
@@ -13,6 +12,7 @@ from finalcif.tools.misc import unify_li
 
 data = Path('.')
 
+
 class MyTestCase(unittest.TestCase):
 
     def test_saint_repr(self):
diff -pruN 134+dfsg-1/tests/test_tables.py 137+dfsg-1/tests/test_tables.py
--- 134+dfsg-1/tests/test_tables.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_tables.py	2024-04-19 19:04:23.000000000 +0000
@@ -20,6 +20,7 @@ from finalcif import VERSION
 from finalcif.appwindow import AppWindow
 
 data = Path('tests')
+test_data = Path('test-data')
 
 
 class TablesTestCase(unittest.TestCase):
@@ -87,6 +88,14 @@ class TemplateReportWithoutAppTestCase(u
         table: Table = doc.tables[3]
         self.assertEqual('C1–H1', table.cell(row_idx=4, col_idx=0).text)
 
+    def test_option_without_h(self):
+        self.options.without_h = True
+        make_report_from(options=self.options, cif=self.cif,
+                         output_filename=str(self.reportdoc), picfile=self.report_pic)
+        doc = Document(self.reportdoc.absolute())
+        table: Table = doc.tables[3]
+        self.assertEqual('O1–C13', table.cell(row_idx=4, col_idx=0).text)
+
     def test_all_paragraphs(self):
         make_report_from(options=self.options, cif=self.cif,
                          output_filename=str(self.reportdoc), picfile=self.report_pic)
@@ -192,5 +201,33 @@ class TablesNoPictureTestCase(unittest.T
         self.assertEqual(1, len(shapes))
 
 
+class ReportWithsymmetryTestCase(unittest.TestCase):
+    def setUp(self) -> None:
+        self.testcif = (test_data / 'p31c.cif').resolve()
+        self.cif = CifContainer(self.testcif)
+        self.options = Mock()
+        self.options.without_h = False
+        self.reportdoc = self.cif.finalcif_file_prefixed(prefix='report_', suffix='-finalcif.docx')
+
+    def tearDown(self) -> None:
+        self.reportdoc.unlink(missing_ok=True)
+        self.cif.finalcif_file.unlink(missing_ok=True)
+
+    def test_symmetry_indicators(self):
+        make_report_from(options=self.options, cif=self.cif, output_filename=str(self.reportdoc), picfile=None)
+        doc = Document(self.reportdoc.absolute())
+        table: Table = doc.tables[3]
+        # Bond:
+        self.assertEqual('C2–C3#1', table.cell(row_idx=18, col_idx=0).text)
+        # Angle:
+        self.assertEqual("C3'#1–C2'–C3'", table.cell(row_idx=148, col_idx=0).text)
+        # Torsion angle:
+        table: Table = doc.tables[4]
+        self.assertEqual("C3#1–C2–C3–N1", table.cell(row_idx=6, col_idx=0).text)
+        # Hydrogen bond:
+        table: Table = doc.tables[5]
+        self.assertEqual("N1^a–H1^a⋯Cl1#1", table.cell(row_idx=1, col_idx=0).text)
+
+
 if __name__ == '__main__':
     unittest.main()
diff -pruN 134+dfsg-1/tests/test_templated_report.py 137+dfsg-1/tests/test_templated_report.py
--- 134+dfsg-1/tests/test_templated_report.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_templated_report.py	2024-04-19 19:04:23.000000000 +0000
@@ -1,6 +1,8 @@
 import os
 from unittest.mock import Mock
 
+from finalcif.tools.options import Options
+
 os.environ['RUNNING_TEST'] = 'True'
 import unittest
 from pathlib import Path
@@ -14,7 +16,7 @@ from docx.table import Table
 from finalcif import VERSION
 from finalcif.appwindow import AppWindow
 from finalcif.cif.cif_file_io import CifContainer
-from finalcif.report.templated_report import TemplatedReport
+from finalcif.report.templated_report import TemplatedReport, ReportFormat
 
 data = Path('tests')
 test_data = Path('test-data')
@@ -78,9 +80,9 @@ class TemplateReportWithoutAppTestCase(u
     def setUp(self) -> None:
         self.testcif = (data / 'examples/1979688.cif').absolute()
         cif = CifContainer(self.testcif)
-        self.options = Mock()
-        self.options.picture_width = 7.43
-        self.options.without_h = False
+        self.options = Options()
+        self.options._picture_width = 7.43
+        self.options._without_h = False
         self.text_template = Path('finalcif/template/template_text.docx').absolute()
         self.template_without_text = Path('finalcif/template/template_without_text.docx').absolute()
         self.reportdoc = cif.finalcif_file_prefixed(prefix='report_', suffix='-finalcif.docx')
@@ -92,12 +94,12 @@ class TemplateReportWithoutAppTestCase(u
         self.report_zip.unlink(missing_ok=True)
 
     def test_ccdc_num_in_table(self):
-        t = TemplatedReport()
-        ok = t.make_templated_report(options=self.options,
-                                     cif=CifContainer(self.testcif),
-                                     output_filename=self.reportdoc,
-                                     picfile=self.report_pic,
-                                     template_path=self.text_template)
+        t = TemplatedReport(options=self.options,
+                            cif=CifContainer(self.testcif),
+                            format=ReportFormat.RICHTEXT)
+        ok = t.make_templated_docx_report(output_filename=str(self.reportdoc),
+                                          picfile=self.report_pic,
+                                          template_path=self.text_template)
         self.assertTrue(ok)
         doc = Document(str(self.reportdoc.absolute()))
         table: Table = doc.tables[0]
@@ -109,12 +111,12 @@ class TemplateReportWithoutAppTestCase(u
         For this test, self.myapp.set_report_picture(Path('finalcif/icon/finalcif.png'))
         has to be set correctly.
         """
-        t = TemplatedReport()
-        ok = t.make_templated_report(options=self.options,
-                                     cif=CifContainer(self.testcif),
-                                     output_filename=self.reportdoc,
-                                     picfile=self.report_pic,
-                                     template_path=self.text_template)
+        t = TemplatedReport(options=self.options,
+                            cif=CifContainer(self.testcif),
+                            format=ReportFormat.RICHTEXT)
+        ok = t.make_templated_docx_report(output_filename=str(self.reportdoc),
+                                          picfile=self.report_pic,
+                                          template_path=self.text_template)
         self.assertTrue(ok)
         doc = Document(self.reportdoc.absolute())
         shapes: InlineShapes = doc.inline_shapes
@@ -122,16 +124,16 @@ class TemplateReportWithoutAppTestCase(u
         self.assertEqual(Cm(7.43).emu, shapes[0].width)
 
     def test_citations(self):
-        t = TemplatedReport()
-        t.make_templated_report(options=self.options,
-                                cif=CifContainer(self.testcif),
-                                output_filename=self.reportdoc,
-                                picfile=self.report_pic,
-                                template_path=self.text_template)
+        t = TemplatedReport(options=self.options,
+                            cif=CifContainer(self.testcif),
+                            format=ReportFormat.RICHTEXT)
+        t.make_templated_docx_report(output_filename=str(self.reportdoc),
+                                     picfile=self.report_pic,
+                                     template_path=self.text_template)
         doc = Document(self.reportdoc.absolute())
-        # for num, p in enumerate(doc.paragraphs):
+        #for num, p in enumerate(doc.paragraphs):
         #    print(num, p.text)
-        self.assertEqual('Bibliography', doc.paragraphs[20].text)
+        self.assertEqual('Bibliography', doc.paragraphs[17].text)
 
 
 class TestReportFromMultiCif(unittest.TestCase):
@@ -141,18 +143,19 @@ class TestReportFromMultiCif(unittest.Te
         self.docx_templ = test_data / 'templates/test_template_for_multitable_dist.docx'
         self.multi_cif = test_data / '1000007-multi.cif'
         self.cif = CifContainer(file=self.multi_cif)
+        self.options = Options()
 
     def tearDown(self):
         self.reportdoc.unlink(missing_ok=True)
 
     def test_get_distance_from_atoms(self):
-        t = TemplatedReport()
-        mock = Mock()
-        mock.without_h = False
-        mock.picture_width = 7.43
-        ok = t.make_templated_report(options=mock, cif=self.cif,
-                                     output_filename='test.docx', picfile=Path(),
-                                     template_path=self.docx_templ)
+        self.options._without_h = False
+        self.options._picture_width = 7.43
+        t = TemplatedReport(options=self.options,
+                            cif=self.cif,
+                            format=ReportFormat.RICHTEXT)
+        ok = t.make_templated_docx_report(output_filename='test.docx', picfile=Path(),
+                                          template_path=self.docx_templ)
         self.assertTrue(ok)
         doc = Document(self.reportdoc.resolve().__str__())
         self.assertEqual('C1-C2 in p-1 distance: 1.5123(17)', doc.paragraphs[0].text)
@@ -165,51 +168,50 @@ class TestData(unittest.TestCase):
     def setUp(self) -> None:
         # creating a new CIF with a new block:
         self.cif = CifContainer('foo.cif', 'testblock')
+        self.options = Options()
+        self.t = TemplatedReport(options=self.options,
+                                 cif=self.cif,
+                                 format=ReportFormat.RICHTEXT)
 
     def test_get_integration_program_with_spaces(self):
         # Here we have the special case, that there is no space character between the version number and the bracket.
         self.cif['_computing_data_reduction'] = 'CrysAlisPro 1.171.39.20a (Rigaku OD, 2015)'
         self.assertEqual('CrysAlisPro 1.171.39.20a (Rigaku OD, 2015)', self.cif['_computing_data_reduction'])
-        r = TemplatedReport()
-        result = r.get_integration_program(self.cif)
+        result = self.t.text_formatter.get_integration_program(self.cif)
         self.assertEqual('CrysAlisPro', result)
-        self.assertEqual('Crysalispro, 1.171.39.20a, 2015, Rigaku OD.', str(r.literature['integration']))
+        self.assertEqual('Crysalispro, 1.171.39.20a, 2015, Rigaku OD.', str(self.t.text_formatter.literature['integration']))
 
     def test_get_integration_program_with_line_break(self):
         # Here we have the special case, that there is no space character between the version number and the bracket.
         self.cif['_computing_data_reduction'] = "CrysAlisPro 1.171.39.20a\n" \
                                                 "(Rigaku OD, 2015)\n"
         self.assertEqual('CrysAlisPro 1.171.39.20a\n(Rigaku OD, 2015)\n', self.cif['_computing_data_reduction'])
-        r = TemplatedReport()
-        result = r.get_integration_program(self.cif)
+        result = self.t.text_formatter.get_integration_program(self.cif)
         self.assertEqual('CrysAlisPro', result)
-        self.assertEqual('Crysalispro, 1.171.39.20a, 2015, Rigaku OD.', str(r.literature['integration']))
+        self.assertEqual('Crysalispro, 1.171.39.20a, 2015, Rigaku OD.', str(self.t.text_formatter.literature['integration']))
 
     def test_get_integration_program_with_missing_information(self):
         # Here we have all in one line with spaces inbetween:
         self.cif['_computing_data_reduction'] = 'CrysAlisPro 1.171.39.20a (Rigaku OD)'
         self.assertEqual('CrysAlisPro 1.171.39.20a (Rigaku OD)', self.cif['_computing_data_reduction'])
-        r = TemplatedReport()
-        result = r.get_integration_program(self.cif)
+        result = self.t.text_formatter.get_integration_program(self.cif)
         self.assertEqual('CrysAlisPro', result)
-        self.assertEqual('Crysalispro, unknown version, Rigaku OD.', str(r.literature['integration']))
+        self.assertEqual('Crysalispro, unknown version, Rigaku OD.', str(self.t.text_formatter.literature['integration']))
 
     def test_get_integration_program_saint(self):
         # Here we have all in one line with spaces inbetween:
         self.cif['_computing_data_reduction'] = 'SAINT V8.40A'
-        r = TemplatedReport()
-        result = r.get_integration_program(self.cif)
+        result = self.t.text_formatter.get_integration_program(self.cif)
         self.assertEqual('SAINT V8.40A', result)
         self.assertEqual('Bruker, SAINT, V8.40A, Bruker AXS Inc., Madison, Wisconsin, USA.',
-                         str(r.literature['integration']))
+                         str(self.t.text_formatter.literature['integration']))
 
     def test_get_integration_program_saint_without_version(self):
         # Here we have all in one line with spaces inbetween:
         self.cif['_computing_data_reduction'] = 'SAINT'
-        r = TemplatedReport()
-        result = r.get_integration_program(self.cif)
+        result = self.t.text_formatter.get_integration_program(self.cif)
         self.assertEqual('SAINT', result)
-        self.assertEqual('Bruker, SAINT, Bruker AXS Inc., Madison, Wisconsin, USA.', str(r.literature['integration']))
+        self.assertEqual('Bruker, SAINT, Bruker AXS Inc., Madison, Wisconsin, USA.', str(self.t.text_formatter.literature['integration']))
 
 
 if __name__ == '__main__':
diff -pruN 134+dfsg-1/tests/test_validators.py 137+dfsg-1/tests/test_validators.py
--- 134+dfsg-1/tests/test_validators.py	1970-01-01 00:00:00.000000000 +0000
+++ 137+dfsg-1/tests/test_validators.py	2024-04-19 19:04:23.000000000 +0000
@@ -0,0 +1,42 @@
+import unittest
+
+from finalcif.gui.validators import validators
+
+
+class TestValidators(unittest.TestCase):
+    def test_integer_limits(self):
+        v = validators['_chemical_melting_point']
+        self.assertTrue(v.valid('5'))
+        self.assertFalse(v.valid('-5'))
+        self.assertEqual('Must be a positive decimal number between 0.0 and 5000.0.', v.help_text)
+
+    def test_diffrn_reflns_limit_h_min(self):
+        v = validators['_diffrn_reflns_limit_h_min']
+        self.assertEqual('Integerlimits', v.__class__.__name__)
+        self.assertTrue(v.valid('-5'))
+        self.assertFalse(v.valid('5'))
+        self.assertFalse(v.valid('-5.0'))
+        self.assertEqual("Must be a negative integer number between -inf and 0.", v.help_text)
+
+    def test_diffrn_reflns_Laue_measured_fraction_max(self):
+        v = validators['_diffrn_reflns_Laue_measured_fraction_max']
+        self.assertFalse(v.valid('-5'))
+        self.assertEqual('Floatlimits', v.__class__.__name__)
+        self.assertEqual('Must be a positive decimal number between 0.0 and 1.0.', v.help_text)
+
+    def test_refine_ls_number_restraints(self):
+        v = validators['_refine_ls_number_restraints']
+        self.assertFalse(v.valid('-5'))
+        self.assertEqual(v.help_text, "Must be a positive integer number between 0 and inf.")
+
+    def test_space_group_crystal_system(self):
+        v = validators['_space_group_crystal_system']
+        self.assertTrue(v.valid('Triclinic'))
+        self.assertFalse(v.valid('Tsdsfgf'))
+        self.assertEqual('Textlimits', v.__class__.__name__)
+        self.assertEqual(v.help_text, "Must be one of: triclinic, monoclinic, orthorhombic, "
+                                      "tetragonal, trigonal, hexagonal, cubic.")
+
+
+if __name__ == '__main__':
+    unittest.main()
diff -pruN 134+dfsg-1/tests/test_workfolder.py 137+dfsg-1/tests/test_workfolder.py
--- 134+dfsg-1/tests/test_workfolder.py	2024-02-11 18:12:32.000000000 +0000
+++ 137+dfsg-1/tests/test_workfolder.py	2024-04-19 19:04:23.000000000 +0000
@@ -18,6 +18,7 @@ from tests.helpers import addr
 
 data = Path('tests')
 
+
 class TestFileIsOpened(unittest.TestCase):
     """A CIF fle in a complete work folder"""
 
@@ -34,12 +35,12 @@ class TestFileIsOpened(unittest.TestCase
     def tearDown(self) -> None:
         Path('foo.cif').unlink(missing_ok=True)
         Path('tests/examples/work/cu_BruecknerJK_153F40_0m-finalcif.cif').unlink(missing_ok=True)
+        self.myapp.ui.trackChangesCifCheckBox.setChecked(False)
         self.myapp.close()
 
     def test_save_action(self):
         self.myapp.save_current_cif_file()
         self.assertEqual(True, (data / 'examples/work/cu_BruecknerJK_153F40_0m-finalcif.cif').exists())
-        self.myapp.ui.trackChangesCifCheckBox.setChecked(False)
 
 
 class TestWorkfolder(unittest.TestCase):
@@ -92,7 +93,7 @@ class TestWorkfolder(unittest.TestCase):
         self.myapp.ui.EquipmentTemplatesStackedWidget.setCurrentIndex(0)
         item = listw.findItems(field, Qt.MatchStartsWith)[0]
         listw.setCurrentItem(item)
-        self.assertEqual(field, item.text())
+        self.assertEqual(field.upper(), item.text().upper())
         rect = listw.visualItemRect(item)
         QTest.mouseDClick(listw.viewport(), Qt.LeftButton, Qt.NoModifier, rect.center())
         # This is necessary:
@@ -129,10 +130,6 @@ class TestWorkfolder(unittest.TestCase):
             self.cell_text('_publ_section_references', Column.DATA))
         self.assertEqual('geom', self.cell_text('_atom_sites_solution_hydrogens', 0))
         self.assertEqual('', self.cell_text('_atom_sites_solution_hydrogens', Column.DATA))
-        self.assertEqual(
-            """FinalCif V{} by Daniel Kratzert, Freiburg {}, https://dkratzert.de/finalcif.html""".format(VERSION,
-                                                                                                          datetime.now().year),
-            self.cell_text('_audit_creation_method', Column.DATA))
 
     def test_abs_configuration_combo(self):
         self.assertEqual(6, self.key_row('_chemical_absolute_configuration'))
@@ -141,7 +138,6 @@ class TestWorkfolder(unittest.TestCase):
                          self.cell_widget_class(6, Column.DATA))
         self.assertEqual("<class 'finalcif.gui.combobox.MyComboBox'>", self.cell_widget_class(6, Column.EDIT))
 
-    def test_diffrn_radiation_type_combo(self):
         row = self.key_row('_diffrn_radiation_type')
         self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
                          self.cell_widget_class(row, Column.CIF))
@@ -149,7 +145,6 @@ class TestWorkfolder(unittest.TestCase):
                          self.cell_widget_class(row, Column.DATA))
         self.assertEqual("<class 'finalcif.gui.combobox.MyComboBox'>", self.cell_widget_class(row, Column.EDIT))
 
-    def test_diffrn_ambient_temperature_combo(self):
         row = self.key_row('_diffrn_ambient_temperature')
         self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
                          self.cell_widget_class(row, Column.CIF))
@@ -157,33 +152,24 @@ class TestWorkfolder(unittest.TestCase):
                          self.cell_widget_class(row, Column.DATA))
         self.assertEqual("<class 'finalcif.gui.combobox.MyComboBox'>", self.cell_widget_class(row, Column.EDIT))
 
-    def test_combo_items_ambient_temp(self):
+    def test_combo_items(self):
         row = self.key_row('_diffrn_ambient_temperature')
         self.assertEqual(
             ['', '15(1)', '80(2)', '100(2)', '110(2)', '120(2)', '130(2)', '150(2)', '200(2)', '293.15(2)', '298(2)'],
             self.get_combobox_items(row, Column.EDIT))
 
-    def test_combo_items_radiation(self):
         row = self.key_row('_diffrn_radiation_type')
         self.assertEqual(['', 'Mo Kα', 'Cu Kα', 'Ag Kα', 'In Kα', 'Ga Kα', 'Fe Kα', 'W Kα'],
                          self.get_combobox_items(row, Column.EDIT))
 
-    def test_ambient_conditions_combo(self):
-        # Test if N~~2~ is correctly translated to N_2
-        row = self.key_row('_diffrn_ambient_environment')
-        self.assertEqual('N₂', self.get_combobox_items(row, Column.EDIT)[1])
-
-    def test_combo_items_exptl_crystal_description(self):
         row = self.key_row('_exptl_crystal_description')
         self.assertEqual(['', 'block', 'needle', 'plate', 'prism', 'sphere'], self.get_combobox_items(row, Column.EDIT))
 
-    def test_combo_items_atom_sites_solution_primary(self):
         row = self.key_row('_atom_sites_solution_primary')
         self.assertEqual(
             ['', 'direct', 'vecmap', 'heavy', 'difmap', 'geom', 'disper', 'isomor', 'notdet', 'dual', 'iterative',
              'other'], self.get_combobox_items(row, Column.EDIT))
 
-    def test_combo_items_exptl_crystal_colour(self):
         row = self.key_row('_exptl_crystal_colour')
         self.assertEqual(
             ['', 'colourless', 'white', 'black', 'yellow', 'red', 'blue', 'green', 'gray', 'pink', 'orange',
@@ -201,7 +187,6 @@ class TestWorkfolder(unittest.TestCase):
                          self.myapp.ui.cif_main_table.widget_from_key('_computing_data_reduction',
                                                                       Column.DATA).styleSheet())
 
-    def test_background_color_theta_max(self):
         self.assertEqual('', self.myapp.ui.cif_main_table.widget_from_key('_cell_measurement_theta_max',
                                                                           Column.CIF).styleSheet())
         self.assertEqual('background-color: #d9ffc9;',
@@ -210,18 +195,9 @@ class TestWorkfolder(unittest.TestCase):
         self.assertEqual('', self.myapp.ui.cif_main_table.widget_from_key('_cell_measurement_theta_max',
                                                                           Column.EDIT).styleSheet())
 
-    def test_color(self):
         self.assertEqual('', self.myapp.ui.cif_main_table.widget_from_key('_computing_molecular_graphics',
                                                                           Column.DATA).styleSheet())
 
-    def test_chemical_formula_moiety(self):
-        self.assertEqual('?',
-                         self.cell_text('_chemical_formula_moiety', Column.CIF))
-        self.assertEqual('',
-                         self.cell_text('_chemical_formula_moiety', Column.DATA))
-        self.assertEqual('',
-                         self.cell_text('_chemical_formula_moiety', Column.EDIT))
-
     def test_exptl_crystal_size(self):
         self.assertEqual('0.220', self.cell_text('_exptl_crystal_size_max', Column.DATA))
         self.assertEqual('0.100', self.cell_text('_exptl_crystal_size_mid', Column.DATA))
@@ -249,54 +225,11 @@ class TestWorkfolder(unittest.TestCase):
             self.assertEqual(r, self.cell_text(key, n))
 
     def test_equipment_click_machine(self):
-        self.equipment_click('APEX2 QUAZAR')
+        self.equipment_click('D8 VENTURE')
         self.allrows_test_key('_diffrn_measurement_method', ['?', 'ω and ϕ scans', 'ω and ϕ scans'])
         self.allrows_test_key('_diffrn_measurement_specimen_support',
                               ['?', 'MiTeGen micromount', 'MiTeGen micromount'])
 
-    # unittest.SkipTest('')
-    def test_equipment_click_machine_oxford_0(self):
-        self.equipment_click('APEX2 QUAZAR')
-        # We have a value which is new. So a row at start is created and only the CIF column is populated
-        self.assertEqual('?', self.cell_text('_diffrn_measurement_ambient_temperature_device_make', Column.CIF))
-
-    def test_equipment_click_machine_oxford_1(self):
-        self.equipment_click('APEX2 QUAZAR')
-        self.assertEqual('Oxford Cryostream 800',
-                         self.cell_text('_diffrn_measurement_ambient_temperature_device_make', Column.DATA))
-        self.assertEqual('Oxford Cryostream 800',
-                         self.cell_text('_diffrn_measurement_ambient_temperature_device_make', Column.EDIT))
-
-    def test_equipment_click_author_address_0(self):
-        # Check if click on author adds the address to second and third column:
-        self.equipment_click('Crystallographer Details')
-        self.assertEqual('?', self.cell_text('_audit_contact_author_address', Column.CIF))
-        self.assertEqual(unify_line_endings(addr), self.cell_text('_audit_contact_author_address', Column.DATA))
-        self.assertEqual(unify_line_endings(addr), self.cell_text('_audit_contact_author_address', Column.EDIT))
-
-    def test_contact_author_name_0(self):
-        self.equipment_click('Crystallographer Details')
-        self.assertEqual('?', self.cell_text('_audit_contact_author_name', Column.CIF))
-        self.assertEqual('Dr. Daniel Kratzert', self.cell_text('_audit_contact_author_name', Column.DATA))
-        self.assertEqual('Dr. Daniel Kratzert', self.cell_text('_audit_contact_author_name', Column.EDIT))
-
-    def test_contact_author_cellwidget_bevore_click(self):
-        self.assertEqual('_cell_measurement_theta_min', self.myapp.ui.cif_main_table.vheaderitems[5])
-        self.assertEqual('2.547', self.myapp.ui.cif_main_table.getText(5, Column.DATA))
-
-    def test_contact_author_cellwidget_after(self):
-        self.equipment_click('Crystallographer Details')
-        self.assertEqual(self.myapp.ui.cif_main_table.vheaderitems[5], '_audit_contact_author_name')
-        self.assertEqual('Dr. Daniel Kratzert', self.myapp.ui.cif_main_table.getText(5, Column.DATA))
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>", self.cell_widget_class(5, Column.CIF))
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
-                         self.cell_widget_class(5, Column.DATA))
-        self.assertEqual("<class 'finalcif.gui.plaintextedit.MyQPlainTextEdit'>",
-                         self.cell_widget_class(5, Column.EDIT))
-
-    def test_addr(self):
-        self.assertNotEqual(unify_line_endings(addr), self.cell_text('_audit_contact_author_address', Column.EDIT))
-
     def test_addr_after_author_click_0(self):
         self.equipment_click('Crystallographer Details')
         self.assertEqual(unify_line_endings(addr), self.cell_text('_audit_contact_author_address', Column.EDIT))
@@ -394,8 +327,6 @@ class TestWorkfolderOtherCifName(unittes
                          "G.M. (2015). Acta Cryst. C71, 3-8.", self.cell_text('_publ_section_references', Column.DATA))
         self.assertEqual('geom', self.cell_text('_atom_sites_solution_hydrogens', 0))
         self.assertEqual('', self.cell_text('_atom_sites_solution_hydrogens', Column.DATA))
-        self.assertEqual(f"FinalCif V{VERSION} by Daniel Kratzert, Freiburg {datetime.now().year}, "
-                         f"https://dkratzert.de/finalcif.html", self.cell_text('_audit_creation_method', Column.DATA))
 
 
 if __name__ == '__main__':
